<?php
/*
  $Id: balance_format.php,v 1.0 2005/15/02 16:23:08 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

////
// Class to balance format
// TABLES: balance_format
  class balance_format {
    var $balance_format;

// class constructor
    function balance_format() {
      $this->balance_format = array();
      $balance_format_query = tep_db_query("select code, title, symbol_left, symbol_right, decimal_point, thousands_point, decimal_places, value from " . TABLE_CURRENCIES);
      while ($balance_format = tep_db_fetch_array($balance_format_query)) {
	    $this->balance_format[$balance_format['code']] = array('title' => $balance_format['title'],
                                                       'symbol_left' => $balance_format['symbol_left'],
                                                       'symbol_right' => $balance_format['symbol_right'],
                                                       'decimal_point' => $balance_format['decimal_point'],
                                                       'thousands_point' => $balance_format['thousands_point'],
                                                       'decimal_places' => $balance_format['decimal_places'],
                                                       'value' => $balance_format['value']);
      }
    }

// class methods
    function format($number, $calculate_currency_value = true, $currency_type = DEFAULT_CURRENCY, $currency_value = '') {
      if ($calculate_currency_value) {
        $rate = ($currency_value) ? $currency_value : $this->balance_format[$currency_type]['value'];
        $format_string = $this->balance_format[$currency_type]['symbol_left'] . number_format($number * $rate, $this->balance_format[$currency_type]['decimal_places'], $this->balance_format[$currency_type]['decimal_point'], $this->balance_format[$currency_type]['thousands_point']) . $this->balance_format[$currency_type]['symbol_right'];
// if the selected currency is in the european euro-conversion and the default currency is euro,
// the currency will displayed in the national currency and euro currency
        if ( (DEFAULT_CURRENCY == 'EUR') && ($currency_type == 'DEM' || $currency_type == 'BEF' || $currency_type == 'LUF' || $currency_type == 'ESP' || $currency_type == 'FRF' || $currency_type == 'IEP' || $currency_type == 'ITL' || $currency_type == 'NLG' || $currency_type == 'ATS' || $currency_type == 'PTE' || $currency_type == 'FIM' || $currency_type == 'GRD') ) {
          $format_string .= ' <small>[' . $this->format($number, true, 'EUR') . ']</small>';
        }
      } else {
        $format_string = $this->balance_format[$currency_type]['symbol_left'] . number_format($number, $this->balance_format[$currency_type]['decimal_places'], $this->balance_format[$currency_type]['decimal_point'], $this->balance_format[$currency_type]['thousands_point']) . $this->balance_format[$currency_type]['symbol_right'];
      }

      return $format_string;
    }

    function get_value($code) {
      return $this->balance_format[$code]['value'];
    }

    function display_balance($products_price, $products_tax, $quantity = 1) {
      return $this->format(tep_add_tax($products_price, $products_tax) * $quantity);
    }
  }
?>
