<?php
/*=======================================================================*\
|| #################### //-- SCRIPT INFO --// ########################## ||
|| #	Script name: union_split_page_results.php 
|| #	Contribution: Union Query Product Listing
|| #	Version: 1.1
|| #	Date: 23 January 2004
|| # ------------------------------------------------------------------ # ||
|| #################### //-- COPYRIGHT INFO --// ######################## ||
|| #	Copyright (C) 2005 Bobby Easland								# ||
|| #	Internet moniker: Chemo											# ||	
|| #	Contact: chemo@mesoimpact.com									# ||
|| #	Commercial Site: http://gigabyte-hosting.com/					# ||
|| #	GPL Dev Server: http://mesoimpact.com/							# ||
|| #																	# ||
|| #	This script is free software; you can redistribute it and/or	# ||
|| #	modify it under the terms of the GNU General Public License		# ||
|| #	as published by the Free Software Foundation; either version 2	# ||
|| #	of the License, or (at your option) any later version.			# ||
|| #																	# ||
|| #	This script is distributed in the hope that it will be useful,	# ||
|| #	but WITHOUT ANY WARRANTY; without even the implied warranty of	# ||
|| #	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	# ||
|| #	GNU General Public License for more details.					# ||
|| #																	# ||
|| #	Script is intended to be used with:								# ||
|| #	osCommerce, Open Source E-Commerce Solutions					# ||
|| #	http://www.oscommerce.com										# ||
|| #	Copyright (c) 2003 osCommerce									# ||
|| ###################################################################### ||
\*========================================================================*/

class unionSplit{
	var $query, $num_rows, $page_number, $number_of_pages, $page_name;	
	var $offset, $limit;
	var $explain, $execution_time;

	function unionSplit($query, $max_rows, $page_number, $page_name = 'page', $do_explain = false){
		$this->page_name = $page_name;
		$this->page_number = ( !tep_not_null($page_number) || empty($page_number) || !is_numeric($page_number) ? 1 : $page_number );
		$replace = "SELECT SQL_CALC_FOUND_ROWS ";
		$explain_query = "EXPLAIN " . $query;
		$union_query = substr_replace($query, $replace, 0, 7);
		$this->limit = $max_rows;
		$this->offset = ($this->page_number - 1) * $this->limit;	
		$union_query .= " LIMIT " . $this->offset . ", " . $this->limit;
		$this->start($start); 	
		$this->query = tep_db_query($union_query);
		$this->stop($start, $this->execution_time);
		if ($do_explain) $this->explain = tep_db_fetch_array(tep_db_query($explain_query));	
		$rows = tep_db_fetch_array(tep_db_query('SELECT FOUND_ROWS() as count'));
		$this->num_rows = (int)$rows['count'];	
		$this->number_of_pages = ceil($this->num_rows / $this->limit);
	}

    function display_count($text_output) {
      $to_num = ($this->limit * $this->page_number);
      if ($to_num > $this->num_rows) $to_num = $this->num_rows;
      $from_num = ($this->limit * ($this->page_number - 1));
      if ($to_num == 0) {
        $from_num = 0;
      } else {
        $from_num++;
      }
      return sprintf($text_output, $from_num, $to_num, $this->num_rows);
    }

    function display_links($max_page_links, $parameters = '') {
      global $PHP_SELF, $request_type;

      $display_links_string = '';
      $class = 'class="pageResults"';
      if (tep_not_null($parameters) && (substr($parameters, -1) != '&')) $parameters .= '&';
      if ($this->page_number > 1) $display_links_string .= '<a href="' . tep_href_link(basename($PHP_SELF), $parameters . $this->page_name . '=' . ($this->page_number - 1), $request_type) . '" class="pageResults" title=" ' . PREVNEXT_TITLE_PREVIOUS_PAGE . ' "><u>' . PREVNEXT_BUTTON_PREV . '</u></a>&nbsp;&nbsp;';
      $cur_window_num = intval($this->page_number / $max_page_links);
      if ($this->page_number % $max_page_links) $cur_window_num++;
      $max_window_num = intval($this->number_of_pages / $max_page_links);
      if ($this->number_of_pages % $max_page_links) $max_window_num++;
      if ($cur_window_num > 1) $display_links_string .= '<a href="' . tep_href_link(basename($PHP_SELF), $parameters . $this->page_name . '=' . (($cur_window_num - 1) * $max_page_links), $request_type) . '" class="pageResults" title=" ' . sprintf(PREVNEXT_TITLE_PREV_SET_OF_NO_PAGE, $max_page_links) . ' ">...</a>';
      for ($jump_to_page = 1 + (($cur_window_num - 1) * $max_page_links); ($jump_to_page <= ($cur_window_num * $max_page_links)) && ($jump_to_page <= $this->number_of_pages); $jump_to_page++) {
        if ($jump_to_page == $this->page_number) {
          $display_links_string .= '&nbsp;<b>' . $jump_to_page . '</b>&nbsp;';
        } else {
          $display_links_string .= '&nbsp;<a href="' . tep_href_link(basename($PHP_SELF), $parameters . $this->page_name . '=' . $jump_to_page, $request_type) . '" class="pageResults" title=" ' . sprintf(PREVNEXT_TITLE_PAGE_NO, $jump_to_page) . ' "><u>' . $jump_to_page . '</u></a>&nbsp;';
        }
      }
      if ($cur_window_num < $max_window_num) $display_links_string .= '<a href="' . tep_href_link(basename($PHP_SELF), $parameters . $this->page_name . '=' . (($cur_window_num) * $max_page_links + 1), $request_type) . '" class="pageResults" title=" ' . sprintf(PREVNEXT_TITLE_NEXT_SET_OF_NO_PAGE, $max_page_links) . ' ">...</a>&nbsp;';
      if (($this->page_number < $this->number_of_pages) && ($this->number_of_pages != 1)) $display_links_string .= '&nbsp;<a href="' . tep_href_link(basename($PHP_SELF), $parameters . 'page=' . ($this->page_number + 1), $request_type) . '" class="pageResults" title=" ' . PREVNEXT_TITLE_NEXT_PAGE . ' "><u>' . PREVNEXT_BUTTON_NEXT . '</u></a>&nbsp;';

      return $display_links_string;
    }

	function start(&$start_time){
		$start_time = explode(' ', microtime());
	}
	
	function stop($start, &$time){
		$end = explode(' ', microtime());
		$time = number_format(($end[1] + $end[0] - ($start[1] + $start[0])), 8);
	}
	
} # end class
?>