<?php
  class ot_discount_quant {
    var $title, $output;

    function ot_discount_quant() {
      $this->code = 'ot_discount_quant';
      $this->title = MODULE_ORDER_TOTAL_DISCOUNT_QUANT_TITLE;
      $this->description = MODULE_ORDER_TOTAL_DISCOUNT_QUANT_DESCRIPTION;
      $this->enabled = ((MODULE_ORDER_TOTAL_DISCOUNT_QUANT_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_ORDER_TOTAL_DISCOUNT_QUANT_SORT_ORDER;

      $this->output = array();
    }

    function process() {
      global $order, $currencies, $discount_quant, $cart;
      //if the module is on, then apply a discount
      if(MODULE_ORDER_TOTAL_DISCOUNT_QUANT_STATUS == 'true'){
        if($cart->count_contents() >= MODULE_ORDER_TOTAL_DISCOUNT_QUANT_ITEMS){
          $discount_quant = $order->info['subtotal'] * MODULE_ORDER_TOTAL_DISCOUNT_QUANT_PERCENT / 100;
          $order->info['total'] -= $discount_quant;
          $this->output[] = array('title' => $this->title . ':',
                                  'text' => $currencies->format($discount_quant, true, $order->info['currency'], $order->info['currency_value']),
                                  'value' => $discount_quant);
        }
      }
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }

      return $this->_check;
    }

    function keys() {
      return array('MODULE_ORDER_TOTAL_DISCOUNT_QUANT_STATUS', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_SORT_ORDER' ,'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_ITEMS', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_PERCENT');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Discount per Quantity', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_STATUS', 'true', 'Do you want allow the discount per quantity?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_SORT_ORDER', '1', 'Sort order of display.', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Quantity Required', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_ITEMS', '6', 'The minimal amount of products to apply the discount.', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Discount Percentage', 'MODULE_ORDER_TOTAL_DISCOUNT_QUANT_PERCENT', '6', 'If the discounts are available, this indicates the porcentage to apply to the total amount.', '30', '4', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>
