<?php
/*
  $Id: ot_qty_discount.php,v 1.2 2002/07/22 07:36:01 amk Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2002 osCommerce

  Released under the GNU General Public License
*/

  class ot_qty_discount {
    var $title, $output;

    function ot_qty_discount() {
      $this->code = 'ot_qty_discount';
      $this->title = MODULE_QTY_DISCOUNT_TITLE;
      $this->description = MODULE_QTY_DISCOUNT_DESCRIPTION;
      $this->enabled = MODULE_QTY_DISCOUNT_STATUS;
      $this->sort_order = MODULE_QTY_DISCOUNT_SORT_ORDER;
      $this->include_shipping = MODULE_QTY_DISCOUNT_INC_SHIPPING;
      $this->include_tax = MODULE_QTY_DISCOUNT_INC_TAX;
      $this->calculate_tax = MODULE_QTY_DISCOUNT_CALC_TAX;
      $this->output = array();
    }

        function process()
        {
                global $order, $currencies, $cart, $ot_subtotal;
                if ($this->calculate_tax == 'true') {
                    $tod_amount = $this->calculate_discount($order->info['tax']);
                }
                $od_amount = $this->calculate_discount($this->get_order_total());
                if ($od_amount>0)
                {
                                     if (MODULE_QTY_DISCOUNT_RATE_TYPE == 'percentage') $title_ext = ' ('.$this->calculate_rate($cart->count_contents()).'%)';
                                            $this->deduction = $od_amount+$tod_amount;
                        $this->output[] = array('title' => $this->title . $title_ext . ':',
                                                'text' => '<b>-' . $currencies->format($od_amount) . '</b>',
                                                'value' => $od_amount);
                        $order->info['total'] = $order->info['total'] - $od_amount - $tod_amount;
                                    if ($this->sort_order < $ot_subtotal->sort_order) {
                                            $order->info['subtotal'] = $order->info['subtotal'] - $od_amount - $tod_amount;
                                    }
                        $order->info['tax'] = $order->info['tax'] - $tod_amount;
                }
        }

  function calculate_discount($amount) {
    global $qty_discount, $order_qty, $cart;

    $order_qty = $cart->count_contents();
    $od_amount=0;

        $qty_discount = $this->calculate_rate($order_qty);
    if ($qty_discount > 0) {
          if (MODULE_QTY_DISCOUNT_RATE_TYPE == 'percentage') {
      $od_amount = (round($amount*10)/10)*($qty_discount/100);
          } else {
      $od_amount = (round($qty_discount*10)/10);
          }
    }
    return $od_amount;
  }

  function calculate_rate($order_qty) {
          $discount_rate = split("[:,]" , MODULE_QTY_DISCOUNT_RATES);
      $size = sizeof($discount_rate);
      for ($i=0, $n=$size; $i<$n; $i+=2) {
        if ($order_qty >= $discount_rate[$i]) {
          $qty_discount = $discount_rate[$i+1];
        }
      }
    return $qty_discount;
  }


  function get_order_total() {
    global  $order;
    $order_total = $order->info['total'];
    if ($this->include_tax == 'false') $order_total=$order_total-$order->info['tax'];
    if ($this->include_shipping == 'false') $order_total=$order_total-$order->info['shipping_cost'];
    return $order_total;
  }

    function check() {
      if (!isset($this->check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_QTY_DISCOUNT_STATUS'");
        $this->check = tep_db_num_rows($check_query);
      }

      return $this->check;
    }

    function keys() {
      return array('MODULE_QTY_DISCOUNT_STATUS', 'MODULE_QTY_DISCOUNT_SORT_ORDER', 'MODULE_QTY_DISCOUNT_RATE_TYPE', 'MODULE_QTY_DISCOUNT_RATES', 'MODULE_QTY_DISCOUNT_INC_SHIPPING', 'MODULE_QTY_DISCOUNT_INC_TAX', 'MODULE_QTY_DISCOUNT_CALC_TAX');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('顯示在訂單總計', 'MODULE_QTY_DISCOUNT_STATUS', 'true', '啟動訂單總金額折扣?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('訂單排序順序', 'MODULE_QTY_DISCOUNT_SORT_ORDER', '999', '訂單排序', '6', '2', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('折扣方式', 'MODULE_QTY_DISCOUNT_RATE_TYPE', '百分比', '選擇計算折扣之方式 - percentage(百方比) or flat rate', '6', '3','tep_cfg_select_option(array(\'percentage\', \'flat rate\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('折扣比率計算', 'MODULE_QTY_DISCOUNT_RATES', '10:5,20:10', '以訂購總金額為計算方式.  例如: 10:5,20:10.. 10 或以上,以 5% or $5 折扣; 20或以上以 10% or $10 折扣; 取決於您設定的折扣方式.', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('包含運費?', 'MODULE_QTY_DISCOUNT_INC_SHIPPING', 'false', '要含運費計算?', '6', '5', 'tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('含稅計算', 'MODULE_QTY_DISCOUNT_INC_TAX', 'false', '消費總金額含稅計算.', '6', '6','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function ,date_added) values ('折扣後再含稅', 'MODULE_QTY_DISCOUNT_CALC_TAX', 'true', '折扣之後重新計算營業稅.', '6', '5','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
    }

    function remove() {
      $keys = '';
      $keys_array = $this->keys();
      for ($i=0; $i<sizeof($keys_array); $i++) {
        $keys .= "'" . $keys_array[$i] . "',";
      }
      $keys = substr($keys, 0, -1);

      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in (" . $keys . ")");
    }
  }
?>