<?php
  class ot_together {
    var $title, $output;

    function ot_together() {
      $this->code = 'ot_together';
      $this->title = MODULE_2GETHER_DISCOUNT_TITLE;
      $this->description = MODULE_2GETHER_DISCOUNT_DESCRIPTION;
      $this->enabled = ((MODULE_2GETHER_DISCOUNT_STATUS == 'true') ? true : false);
      $this->sort_order = MODULE_2GETHER_DISCOUNT_SORT_ORDER;
      $this->output = array();
    }
    
    function process() {
      global $order, $currencies, $ot_subtotal, $cart, $together_product_names;

      $od_amount = $this->calculate_2gether_discount();
      
      if ($od_amount > 0) {
        $this->deduction = $od_amount;
        $this->output[] = array('title' => sprintf(MODULE_2GETHER_DISCOUNT_FORMATED_TITLE, $together_product_names),
                                'text' => sprintf(MODULE_2GETHER_DISCOUNT_FORMATED_TEXT, $currencies->format($od_amount)),
                                'value' => $od_amount);
        $order->info['total'] -= $this->deduction;
        if ($this->sort_order < $ot_subtotal->sort_order) $order->info['subtotal'] -= $this->deduction;
      }
    }

    function calculate_2gether_discount() {
     global $cart, $together_product_names, $languages_id; 

     $together_product_names = '';
     $od_amount = 0; 
     $cart_products = $cart->get_products();
     $cart_size = sizeof($cart_products);
     $together_products_query = tep_db_query("select product_1_id, product_2_id, discount, type from " . TABLE_2GETHER . "  where status = 1");
     while 	($together_products = tep_db_fetch_array($together_products_query)) {
        if (($cart->in_cart($together_products['product_1_id'])) and ($cart->in_cart($together_products['product_2_id']))) {

          $q1 = $cart->get_quantity($together_products['product_1_id']);
          $q2 = $cart->get_quantity($together_products['product_2_id']);
          if ($q1 < $q2) {
            $together_qty = $q1;
          } else {
             $together_qty = $q2;
          }

          $together_price_query = tep_db_query("select p.products_price, p.products_tax_class_id, pd.products_name from " . TABLE_PRODUCTS . " p,  " . TABLE_PRODUCTS_DESCRIPTION . " pd where p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and p.products_id = " . $together_products['product_1_id']);
          $together_price = tep_db_fetch_array($together_price_query);
          $price1 = $together_price['products_price'];
          if (DISPLAY_PRICE_WITH_TAX) {
            $price1 = tep_add_tax($price1,tep_get_tax_rate($together_price['products_tax_class_id']));
          }
          $together_product_names .= '<br>' . $together_qty . ' x (' . $together_price['products_name'] . ' + ';

          $together_price_query = tep_db_query("select p.products_price, p.products_tax_class_id, pd.products_name from " . TABLE_PRODUCTS . " p,  " . TABLE_PRODUCTS_DESCRIPTION . " pd where p.products_id = pd.products_id and pd.language_id = '" . (int)$languages_id . "' and p.products_id = " . $together_products['product_2_id']);
          $together_price = tep_db_fetch_array($together_price_query);
          $price2 = $together_price['products_price'];
          if (DISPLAY_PRICE_WITH_TAX) {
            $price2 = tep_add_tax($price2,tep_get_tax_rate($together_price['products_tax_class_id']));
          }
          $together_product_names .= $together_price['products_name'] . ') ';
          if ($together_products['type'] == 'p') {
            $od_amount = $od_amount +
            ($price1 + $price2) * $together_qty * $together_products['discount'] / 100;
          }
          else {
            $od_amount = $od_amount + $together_products['discount'] * $together_qty ;
          }
        }
      }
      return $od_amount;
    }
  
    function check() {
      if (!isset($this->check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_2GETHER_DISCOUNT_STATUS'");
        $this->check = mysql_num_rows($check_query);
      }

      return $this->check;
    }

    function keys() {
      return array('MODULE_2GETHER_DISCOUNT_STATUS', 'MODULE_2GETHER_DISCOUNT_SORT_ORDER');
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values 
    ('Activate 2gether Discount', 'MODULE_2GETHER_DISCOUNT_STATUS', 'true', 'Do you want to enable the 2gether discount module?', '6', '1','tep_cfg_select_option(array(\'true\', \'false\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values 
    ('Sort Order', 'MODULE_2GETHER_DISCOUNT_SORT_ORDER', '2', 'Sort order of display.', '6', '2', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }
  }
?>