<?php
/*
  $Id: twtable.php,v 1.1.1.1 2003/08/14 08:01:11 nickle Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  class twtable {
    var $code, $title, $description, $icon, $enabled;

// class constructor
    function twtable() {
      global $order;

      $this->code = 'twtable';
      $this->title = MODULE_SHIPPING_TWTABLE_TEXT_TITLE;
      $this->description = MODULE_SHIPPING_TWTABLE_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_SHIPPING_TWTABLE_SORT_ORDER;
      $this->icon = '';
      $this->tax_class = MODULE_SHIPPING_TWTABLE_TAX_CLASS;
//      $this->enabled = ((MODULE_SHIPPING_TWTABLE_STATUS == 'True') ? true : false);
// START PAYMENT UNALLOWED
 if (tep_get_shipping_unallowed($this->code) ) {
     $this->enabled = ((MODULE_SHIPPING_TWTABLE_STATUS == 'True') ? true : false);
     }
// END PAYMENT UNALLOWED

      if ( ($this->enabled == true) && ((int)MODULE_SHIPPING_TWTABLE_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_SHIPPING_TWTABLE_ZONE . "' and zone_country_id = '" . $order->delivery['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->delivery['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

// class methods
    function quote($method = '') {
      global $order, $cart, $shipping_weight, $shipping_num_boxes;

      if (MODULE_SHIPPING_TWTABLE_MODE == 'price') {
        $order_total = $cart->show_total();
      } else {
        $order_total = $shipping_weight;
      }

      $table_cost = split("[:,]" , MODULE_SHIPPING_TWTABLE_COST);
      $size = sizeof($table_cost);
      for ($i=0, $n=$size; $i<$n; $i+=2) {
        if ($order_total <= $table_cost[$i]) {
          $shipping = $table_cost[$i+1];
          break;
        }
      }

      if (MODULE_SHIPPING_TWTABLE_MODE == 'weight') {
        $shipping = $shipping * $shipping_num_boxes;
      }

      $this->quotes = array('id' => $this->code,
                            'module' => MODULE_SHIPPING_TWTABLE_TEXT_TITLE,
                            'methods' => array(array('id' => $this->code,
                                                     'title' => MODULE_SHIPPING_TWTABLE_TEXT_WAY,
                                                     'cost' => $shipping + MODULE_SHIPPING_TWTABLE_HANDLING)));

      if ($this->tax_class > 0) {
        $this->quotes['tax'] = tep_get_tax_rate($this->tax_class, $order->delivery['country']['id'], $order->delivery['zone_id']);
      }

      if (tep_not_null($this->icon)) $this->quotes['icon'] = tep_image($this->icon, $this->title);

      return $this->quotes;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_SHIPPING_TWTABLE_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) VALUES ('啟動一般運費表?', 'MODULE_SHIPPING_TWTABLE_STATUS', 'True', '你要啟動一般運費表計費方式?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('一般運費表', 'MODULE_SHIPPING_TWTABLE_COST', '25:8.50,50:5.50,10000:0.00', '本收費表以交易總金額或總重量為計算基礎. 例如: 25:8.50,50:5.50,etc.. 超過 25 收費 8.50, 50以內收費 5.50, etc', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('計費方式', 'MODULE_SHIPPING_TWTABLE_MODE', 'weight', '選擇以交易總金額(cost)或總重量(weight)為計算方式.', '6', '0', 'tep_cfg_select_option(array(\'weight\', \'price\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('每級收費', 'MODULE_SHIPPING_TWTABLE_HANDLING', '0', '收費表每級費用.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('稅別', 'MODULE_SHIPPING_TWTABLE_TAX_CLASS', '0', '使用下列稅別.', '6', '0', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('實施收費表地區', 'MODULE_SHIPPING_TWTABLE_ZONE', '0', '如果選擇地區，則只有該地區可以使用這個收費表模組.', '6', '0', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort Order', 'MODULE_SHIPPING_TWTABLE_SORT_ORDER', '0', 'Sort order of display.', '6', '0', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_SHIPPING_TWTABLE_STATUS', 'MODULE_SHIPPING_TWTABLE_COST', 'MODULE_SHIPPING_TWTABLE_MODE', 'MODULE_SHIPPING_TWTABLE_HANDLING', 'MODULE_SHIPPING_TWTABLE_TAX_CLASS', 'MODULE_SHIPPING_TWTABLE_ZONE', 'MODULE_SHIPPING_TWTABLE_SORT_ORDER');
    }
  }
?>