# $Id: tchinese.sql 2006-12-07
#
# Released under the GNU General Public License
#
# NOTE: * Please make any modifications to this file by hand!
#       * DO NOT use a mysqldump created file for new changes!
#       * Please take note of the table structure, and use this
#         structure as a standard for future modifications!
#       * Any tables you add here should be added in admin/backup.php
#         and in catalog/install/includes/functions/database.php
#       * To see the 'diff'erence between MySQL databases, use
#         the mysqldiff perl script located in the extras
#         directory of the 'catalog' module.
#       * Comments should be like these, full line comments.
#         (don't use inline comments)

DROP TABLE IF EXISTS additional_images;
CREATE TABLE additional_images (
  additional_images_id int(11) NOT NULL auto_increment,
  products_id int(11) NOT NULL default '0',
  images_description varchar(64) default NULL,
  medium_images varchar(64) default NULL,
  popup_images varchar(64) default NULL,
  PRIMARY KEY  (additional_images_id),
  KEY products_id (products_id)
);

DROP TABLE IF EXISTS address_book;
CREATE TABLE address_book (
  address_book_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  entry_username varchar(32) NOT NULL,
  entry_gender char(1) NOT NULL,
  entry_company varchar(40) default NULL,
  entry_company_tax_id varchar(32) default NULL,
  entry_firstname varchar(32) NOT NULL,
  entry_lastname varchar(32) NOT NULL,
  entry_street_address varchar(64) NOT NULL,
  entry_suburb varchar(32) default NULL,
  entry_postcode varchar(10) NOT NULL,
  entry_city varchar(32) NOT NULL,
  entry_state varchar(32) default NULL,
  entry_country_id int(11) NOT NULL default '0',
  entry_zone_id int(11) NOT NULL default '0',
  PRIMARY KEY  (address_book_id),
  KEY idx_address_book_customers_id (customers_id)
);

DROP TABLE IF EXISTS address_format;
CREATE TABLE address_format (
  address_format_id int(11) NOT NULL auto_increment,
  address_format varchar(128) NOT NULL,
  address_summary varchar(48) NOT NULL,
  PRIMARY KEY  (address_format_id)
);


INSERT INTO address_format VALUES (1, '$firstname$cr$postcode$cr$country,$state$city$streets', '$country');
INSERT INTO address_format VALUES (2, '$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country', '$city, $state / $country');
INSERT INTO address_format VALUES (3, '$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country', '$state / $country');
INSERT INTO address_format VALUES (4, '$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country', '$postcode / $country');
INSERT INTO address_format VALUES (5, '$firstname $lastname$cr$streets$cr$postcode $city$cr$country', '$city / $country');
INSERT INTO address_format VALUES (6, '$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country', '$city / $country');

DROP TABLE IF EXISTS admin;
CREATE TABLE admin (
  admin_id int(11) NOT NULL auto_increment,
  admin_groups_id int(11) default NULL,
  admin_firstname varchar(32) NOT NULL,
  admin_lastname varchar(32) default NULL,
  admin_email_address varchar(96) NOT NULL,
  admin_password varchar(40) NOT NULL,
  admin_created datetime default NULL,
  admin_modified datetime NOT NULL default '0000-00-00 00:00:00',
  admin_logdate datetime default NULL,
  admin_lognum int(11) NOT NULL default '0',
  admin_cat_access text NOT NULL,
  admin_right_access text NOT NULL,
  PRIMARY KEY  (admin_id),
  UNIQUE KEY admin_email_address (admin_email_address)
);

INSERT INTO admin VALUES (1, 1, 'AdminFirstname', 'AdminLastname', 'admin@localhost', '351683ea4e19efe34874b501fdbf9792:9b', now(), '0000-00-00 00:00:00', null, 0, 'ALL', '');

DROP TABLE IF EXISTS admin_files;
CREATE TABLE admin_files (
  admin_files_id int(11) NOT NULL auto_increment,
  admin_files_name varchar(64) NOT NULL,
  admin_files_is_boxes tinyint(5) NOT NULL default '0',
  admin_files_to_boxes int(11) NOT NULL default '0',
  admin_groups_id set('1','2') NOT NULL default '1',
  PRIMARY KEY  (admin_files_id)
);

INSERT INTO admin_files VALUES (1, 'administrator.php', 1, 0, '1');
INSERT INTO admin_files VALUES (2, 'configuration.php', 1, 0, '1');
INSERT INTO admin_files VALUES (3, 'catalog.php', 1, 0, '1');
INSERT INTO admin_files VALUES (4, 'modules.php', 1, 0, '1');
INSERT INTO admin_files VALUES (5, 'customers.php', 1, 0, '1');
INSERT INTO admin_files VALUES (6, 'taxes.php', 1, 0, '1');
INSERT INTO admin_files VALUES (7, 'localization.php', 1, 0, '1');
INSERT INTO admin_files VALUES (8, 'reports.php', 1, 0, '1');
INSERT INTO admin_files VALUES (9, 'tools.php', 1, 0, '1');
INSERT INTO admin_files VALUES (10, 'admin_members.php', 0, 1, '1');
INSERT INTO admin_files VALUES (11, 'admin_files.php', 0, 1, '1');
INSERT INTO admin_files VALUES (12, 'configuration.php', 0, 2, '1');
INSERT INTO admin_files VALUES (13, 'categories.php', 0, 3, '1');
INSERT INTO admin_files VALUES (14, 'products_attributes.php', 0, 3, '1');
INSERT INTO admin_files VALUES (15, 'manufacturers.php', 0, 3, '1');
INSERT INTO admin_files VALUES (198, 'products_sorter.php', 0, 186, '1');
INSERT INTO admin_files VALUES (17, 'specials.php', 0, 3, '1');
INSERT INTO admin_files VALUES (19, 'modules.php', 0, 4, '1');
INSERT INTO admin_files VALUES (20, 'customers.php', 0, 5, '1');
INSERT INTO admin_files VALUES (21, 'orders.php', 0, 5, '1');
INSERT INTO admin_files VALUES (22, 'countries.php', 0, 6, '1');
INSERT INTO admin_files VALUES (23, 'zones.php', 0, 6, '1');
INSERT INTO admin_files VALUES (24, 'geo_zones.php', 0, 6, '1');
INSERT INTO admin_files VALUES (25, 'tax_classes.php', 0, 6, '1');
INSERT INTO admin_files VALUES (26, 'tax_rates.php', 0, 6, '1');
INSERT INTO admin_files VALUES (27, 'currencies.php', 0, 7, '1');
INSERT INTO admin_files VALUES (28, 'languages.php', 0, 7, '1');
INSERT INTO admin_files VALUES (29, 'orders_status.php', 0, 7, '1');
INSERT INTO admin_files VALUES (30, 'stats_products_viewed.php', 0, 8, '1');
INSERT INTO admin_files VALUES (31, 'stats_products_purchased.php', 0, 8, '1');
INSERT INTO admin_files VALUES (32, 'stats_customers.php', 0, 8, '1');
INSERT INTO admin_files VALUES (33, 'backup.php', 0, 9, '1');
INSERT INTO admin_files VALUES (34, 'banner_manager.php', 0, 9, '1');
INSERT INTO admin_files VALUES (35, 'cache.php', 0, 9, '1');
INSERT INTO admin_files VALUES (36, 'define_language.php', 0, 9, '1');
INSERT INTO admin_files VALUES (37, 'file_manager.php', 0, 9, '1');
INSERT INTO admin_files VALUES (77, 'edit_orders.php', 0, 5, '1');
INSERT INTO admin_files VALUES (40, 'server_info.php', 0, 9, '1');
INSERT INTO admin_files VALUES (41, 'whos_online.php', 0, 9, '1');
INSERT INTO admin_files VALUES (42, 'banner_statistics.php', 0, 9, '1');
INSERT INTO admin_files VALUES (43, 'customers_groups.php', 0, 5, '1');
INSERT INTO admin_files VALUES (44, 'members.php', 0, 5, '1');
INSERT INTO admin_files VALUES (190, 'header_tags_fill_tags.php', 0, 187, '1');
INSERT INTO admin_files VALUES (201, 'sitemap.php', 0, 9, '1');
INSERT INTO admin_files VALUES (60, 'products_attributes_copier.php', 0, 3, '1');
INSERT INTO admin_files VALUES (61, 'xsell.php', 0, 3, '1');
INSERT INTO admin_files VALUES (169, 'popup_help.php', 0, 67, '1');
INSERT INTO admin_files VALUES (67, 'newsletters.php', 1, 0, '1');
INSERT INTO admin_files VALUES (68, 'mails.php', 0, 67, '1');
INSERT INTO admin_files VALUES (69, 'newsletters_extra_default.php', 0, 67, '1');
INSERT INTO admin_files VALUES (70, 'newsletters_extra_infos.php', 0, 67, '1');
INSERT INTO admin_files VALUES (72, 'newsletters_subscribers_view.php', 0, 67, '1');
INSERT INTO admin_files VALUES (130, 'visitors.php', 0, 8, '1');
INSERT INTO admin_files VALUES (74, 'stats_customers_per_product.php', 0, 9, '1');
INSERT INTO admin_files VALUES (78, 'mail.php', 0, 67, '1');
INSERT INTO admin_files VALUES (79, 'newsletters.php', 0, 67, '1');
INSERT INTO admin_files VALUES (80, 'gv_admin.php', 1, 0, '1');
INSERT INTO admin_files VALUES (81, 'coupon_admin.php', 0, 80, '1');
INSERT INTO admin_files VALUES (82, 'gv_mail.php', 0, 80, '1');
INSERT INTO admin_files VALUES (83, 'gv_queue.php', 0, 80, '1');
INSERT INTO admin_files VALUES (84, 'gv_sent.php', 0, 80, '1');
INSERT INTO admin_files VALUES (85, 'listcategories.php', 0, 80, '1');
INSERT INTO admin_files VALUES (86, 'listproducts.php', 0, 80, '1');
INSERT INTO admin_files VALUES (88, 'stats_inactive_user.php', 0, 8, '1');
INSERT INTO admin_files VALUES (89, 'stats_low_stock.php', 0, 8, '1');
INSERT INTO admin_files VALUES (90, 'stats_sales_report.php', 0, 8, '1');
INSERT INTO admin_files VALUES (91, 'stats_sales_report2.php', 0, 8, '1');
INSERT INTO admin_files VALUES (92, 'stats_unsold_carts.php', 0, 8, '1');
INSERT INTO admin_files VALUES (93, 'validcategories.php', 0, 80, '1');
INSERT INTO admin_files VALUES (94, 'validproducts.php', 0, 80, '1');
INSERT INTO admin_files VALUES (97, 'quick_updates.php', 0, 3, '1');
INSERT INTO admin_files VALUES (100, 'product_thumb.php', 0, 3, '1');
INSERT INTO admin_files VALUES (193, 'forbiden.php', 0, 1, '1');
INSERT INTO admin_files VALUES (187, 'header_tags_controller.php', 1, 0, '1');
INSERT INTO admin_files VALUES (105, 'customers_balance_history.php', 0, 5, '1');
INSERT INTO admin_files VALUES (111, 'all_customers.php', 0, 8, '1');
INSERT INTO admin_files VALUES (112, 'product_extra_fields.php', 0, 3, '1');
INSERT INTO admin_files VALUES (113, 'specialsbycategory.php', 0, 3, '1');
INSERT INTO admin_files VALUES (125, 'blacklist.php', 1, 0, '1');
INSERT INTO admin_files VALUES (126, 'blacklist.php', 0, 125, '1');
INSERT INTO admin_files VALUES (128, 'products_attributes_sets.php', 0, 3, '1');
INSERT INTO admin_files VALUES (129, 'products_attributes_sets_edit.php', 0, 3, '1');
INSERT INTO admin_files VALUES (131, 'treeview.php', 0, 80, '1');
INSERT INTO admin_files VALUES (132, 'mail_count.php', 0, 67, '1');
INSERT INTO admin_files VALUES (133, 'stats_credits.php', 0, 8, '1');
INSERT INTO admin_files VALUES (134, 'customers_points.php', 0, 5, '1');
INSERT INTO admin_files VALUES (135, 'customers_points_pending.php', 0, 5, '1');
INSERT INTO admin_files VALUES (137, 'email_batch_send.php', 0, 9, '1');
INSERT INTO admin_files VALUES (138, 'email_queue.php', 0, 9, '1');
INSERT INTO admin_files VALUES (140, 'gift_add.php', 0, 3, '1');
INSERT INTO admin_files VALUES (188, 'header_tags_controller.php', 0, 187, '1');
INSERT INTO admin_files VALUES (189, 'header_tags_english.php', 0, 187, '1');
INSERT INTO admin_files VALUES (186, 'catalog_info.php', 1, 0, '1');
INSERT INTO admin_files VALUES (194, 'featured.php', 0, 186, '1');
INSERT INTO admin_files VALUES (154, '2gether.php', 0, 3, '1');
INSERT INTO admin_files VALUES (192, 'header_tags_popup_help.php', 0, 187, '1');
INSERT INTO admin_files VALUES (166, 'extra_fields.php', 0, 5, '1');
INSERT INTO admin_files VALUES (170, 'newsdesk.php', 1, 0, '1');
INSERT INTO admin_files VALUES (171, 'newsdesk.php', 0, 170, '1');
INSERT INTO admin_files VALUES (172, 'newsdesk_configuration.php', 0, 170, '1');
INSERT INTO admin_files VALUES (173, 'newsdesk_reviews.php', 0, 170, '1');
INSERT INTO admin_files VALUES (174, 'birthday.php', 0, 5, '1');
INSERT INTO admin_files VALUES (197, 'products_expected.php', 0, 186, '1');
INSERT INTO admin_files VALUES (196, 'star_product.php', 0, 186, '1');
INSERT INTO admin_files VALUES (199, 'reviews.php', 0, 186, '1');
INSERT INTO admin_files VALUES (200, 'extra_info_pages.php', 0, 67, '1');
INSERT INTO admin_files VALUES (202, 'links.php', 1, 0, '1');
INSERT INTO admin_files VALUES (203, 'link_categories.php', 0, 202, '1');
INSERT INTO admin_files VALUES (204, 'links.php', 0, 202, '1');
INSERT INTO admin_files VALUES (205, 'links_check.php', 0, 202, '1');
INSERT INTO admin_files VALUES (206, 'links_contact.php', 0, 202, '1');
INSERT INTO admin_files VALUES (207, 'links_featured.php', 0, 202, '1');
INSERT INTO admin_files VALUES (208, 'links_status.php', 0, 202, '1');
INSERT INTO admin_files VALUES (211, 'SearchSuggest.php', 0, 5, '1');

DROP TABLE IF EXISTS admin_groups;
CREATE TABLE admin_groups (
  admin_groups_id int(11) NOT NULL auto_increment,
  admin_groups_name varchar(64) default NULL,
  PRIMARY KEY  (admin_groups_id),
  UNIQUE KEY admin_groups_name (admin_groups_name)
);

INSERT INTO admin_groups VALUES (1, '高階管理');
INSERT INTO admin_groups VALUES (2, '行銷部門');

DROP TABLE IF EXISTS banners;
CREATE TABLE banners (
  banners_id int(11) NOT NULL auto_increment,
  banners_title varchar(64) NOT NULL,
  banners_url varchar(255) NOT NULL,
  banners_image varchar(64) NOT NULL,
  banners_group varchar(25) NOT NULL,
  banners_html_text text,
  expires_impressions int(7) default '0',
  expires_date datetime default NULL,
  date_scheduled datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  date_status_change datetime default NULL,
  status int(1) NOT NULL default '1',
  banners_open_new_windows tinyint(1) NOT NULL default '1',
  banners_on_ssl tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (banners_id)
);

INSERT INTO banners VALUES (1, 'osCommerce', 'http://www.oscommerce.com', 'banners/oscommerce.gif', '468x50', '', NULL, NULL, NULL, '2004-04-01 10:14:44', NULL, 1, 1, 0);

DROP TABLE IF EXISTS banners_history;
CREATE TABLE banners_history (
  banners_history_id int(11) NOT NULL auto_increment,
  banners_id int(11) NOT NULL default '0',
  banners_shown int(5) NOT NULL default '0',
  banners_clicked int(5) NOT NULL default '0',
  banners_history_date datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (banners_history_id)
);

DROP TABLE IF EXISTS blacklist;
CREATE TABLE blacklist (
  customers_id int(13) NOT NULL default '0',
  ban_customer tinyint(1) NOT NULL default '0',
  attempted_use tinyint(1) NOT NULL default '0',
  description varchar(255) default NULL,
  entry_street_address varchar(64) NOT NULL,
  entry_suburb varchar(32) default NULL,
  entry_postcode varchar(10) NOT NULL,
  entry_city varchar(32) NOT NULL,
  entry_state varchar(32) default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00'
);

DROP TABLE IF EXISTS carriers;
CREATE TABLE carriers (
  carrier_id int(11) NOT NULL default '0',
  carrier_name varchar(32) NOT NULL
);

INSERT INTO carriers VALUES (1, '郵局');
INSERT INTO carriers VALUES (2, '新竹貨運');
INSERT INTO carriers VALUES (3, '宅急便');
INSERT INTO carriers VALUES (4, '其他');
INSERT INTO carriers VALUES (5, 'Download(線上下載)');
INSERT INTO carriers VALUES (6, 'USPS');
INSERT INTO carriers VALUES (7, 'UPS');
INSERT INTO carriers VALUES (8, 'Fedex');
INSERT INTO carriers VALUES (9, 'DHL');

DROP TABLE IF EXISTS categories;
CREATE TABLE categories (
  categories_id int(11) NOT NULL auto_increment,
  categories_image varchar(64) default NULL,
  parent_id int(11) NOT NULL default '0',
  sort_order int(3) default NULL,
  date_added datetime default NULL,
  last_modified datetime default NULL,
  categories_status tinyint(1) unsigned NOT NULL default '1',
  categories_hide_from_groups varchar(255) NOT NULL default '@',
  PRIMARY KEY  (categories_id),
  KEY idx_categories_parent_id (parent_id)
);

DROP TABLE IF EXISTS categories_description;
CREATE TABLE categories_description (
  categories_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  categories_name varchar(32) NOT NULL,
  categories_heading_title varchar(64) default NULL,
  categories_description text,
  categories_htc_title_tag varchar(80) default NULL,
  categories_htc_desc_tag longtext,
  categories_htc_keywords_tag longtext,
  categories_htc_description longtext,
  PRIMARY KEY  (categories_id,language_id),
  KEY idx_categories_name (categories_name)
);

DROP TABLE IF EXISTS configuration;
CREATE TABLE configuration (
  configuration_id int(11) NOT NULL auto_increment,
  configuration_title varchar(64) NOT NULL,
  configuration_key varchar(64) NOT NULL,
  configuration_value varchar(255) NOT NULL,
  configuration_description varchar(255) NOT NULL,
  configuration_group_id int(11) NOT NULL default '0',
  sort_order int(5) default NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  use_function varchar(255) default NULL,
  set_function varchar(255) default NULL,
  PRIMARY KEY  (configuration_id)
);

INSERT INTO configuration VALUES ('', '商店名稱', 'STORE_NAME', 'OSC', '商店名稱', 1, 1, '2006-12-07 11:21:02', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '商店擁有人', 'STORE_OWNER', 'OSC', '商店擁有人', 1, 2, '2006-09-01 15:00:06', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '電子郵件', 'STORE_OWNER_EMAIL_ADDRESS', 'admin@admin.com', '商店擁有人的電子郵件', 1, 3, '2006-12-06 21:29:23', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '商店寄件人', 'EMAIL_FROM', 'xxx<xxx@admin.com.tw>', '訂單郵件寄件人', 1, 4, '2006-09-01 15:00:18', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '電子報寄件人', 'NEWSLETTER_EMAIL_FROM', 'osc電子報<xxx@osc.com.tw>', '電子報傳送回覆郵件地址', 1, 5, '2006-09-01 15:00:34', '2006-01-30 13:30:00', NULL, NULL);
INSERT INTO configuration VALUES ('', '國別', 'STORE_COUNTRY', '206', '商店所在國 <br><br><b>注意： 請記得更新商店地區</b>', 1, 6, NULL, '2004-04-01 10:14:44', 'tep_get_country_name', 'tep_cfg_pull_down_country_list(');
INSERT INTO configuration VALUES ('', '地區', 'STORE_ZONE', '189', '商店所在地區', 1, 7, '2004-04-02 01:52:03', '2004-04-01 10:14:44', 'tep_cfg_get_zone_name', 'tep_cfg_pull_down_zone_list(');
INSERT INTO configuration VALUES ('', '預計上市商品順序排序', 'EXPECTED_PRODUCTS_SORT', 'desc', '預計上市商品排序方式遞增或遞減', 1, 8, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''asc'', ''desc''),');
INSERT INTO configuration VALUES ('', '預計上市商品欄位排序', 'EXPECTED_PRODUCTS_FIELD', 'date_expected', '預計上市商品排序依欄位排序', 1, 9, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''products_name'', ''date_expected''),');
INSERT INTO configuration VALUES ('', '語系與貨幣同步', 'USE_DEFAULT_LANGUAGE_CURRENCY', 'false', '變更語系時，自動切換至該語系之貨幣', 1, 10, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '新訂單郵件額外通知', 'SEND_EXTRA_ORDER_EMAILS_TO', 'yogo1122@ms4.hinet.net', '有新訂單時額外通知的電子郵件地址，兩個郵件地址間以逗號隔開，格式如下: Name1<email@address1>,Name2<email@address2>', 1, 11, '2004-04-02 01:52:48', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '使用搜尋引擎儲存連結 (開發中)', 'SEARCH_ENGINE_FRIENDLY_URLS', 'false', '使用搜尋引擎儲存所有網站的連結', 1, 12, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '購買商品後顯示購物車', 'DISPLAY_CART', 'true', '購買商品後立刻顯示購物車(或留在原來的位置)', 1, 14, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '非會員可否推薦商品', 'ALLOW_GUEST_TO_TELL_A_FRIEND', 'false', '非會員可否推薦商品給親友', 1, 15, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '預設的搜尋運算元', 'ADVANCED_SEARCH_DEFAULT_OPERATOR', 'and', '預設的搜尋運算元', 1, 17, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''and'', ''or''),');
INSERT INTO configuration VALUES ('', '商店地址與電話', 'STORE_NAME_ADDRESS', '', '商店名稱、地址與電話，用於文件列印及線上顯示', 1, 18, '2006-12-06 21:29:39', '2004-04-01 10:14:44', NULL, 'tep_cfg_textarea(');
INSERT INTO configuration VALUES ('', 'Order Editor付款方式選單', 'DISPLAY_PAYMENT_METHOD_DROPDOWN', 'true', '管理平台訂單編輯在付款方式使用下拉式選單，選單方式(true)或輸入欄位(false)', 1, 23, '2006-09-28 10:27:58', '2006-04-02 11:51:01', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '稅金取小數點後幾位', 'TAX_DECIMAL_PLACES', '0', '設定稅金取到小數點後第幾位', 1, 20, '2004-04-02 01:55:03', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示含稅金額', 'DISPLAY_PRICE_WITH_TAX', 'false', '顯示含稅金額(true) 或將稅金加於尾端(false)', 1, 21, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');

INSERT INTO configuration VALUES ('', 'Show捲動跑馬燈', 'SCROLL_MARQUEE', 'true', '使用捲動跑馬燈(scrolling marquee)?', 1, 37, '2006-11-18 11:32:55', '2006-08-26 15:45:53', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''false'', ''true''),');
INSERT INTO configuration VALUES ('', '捲動跑馬燈文字內容', 'TEXT_TO_DISPLAY', '加入會員立即享九折優惠折扣...', '顯示在跑馬燈的文字資訊', 1, 40, '2006-11-18 11:33:12', '2006-08-26 15:45:53', 'tep_cfg_get_zone_name', 'tep_cfg_textarea(');

INSERT INTO configuration VALUES ('', '中文名稱', 'ENTRY_FIRST_NAME_MIN_LENGTH', '2', '中文名稱最少字數', 2, 1, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '英文名稱', 'ENTRY_LAST_NAME_MIN_LENGTH', '2', '英文名稱最少字數', 2, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '生日', 'ENTRY_DOB_MIN_LENGTH', '10', '生日最少字數', 2, 3, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '電子郵件地址', 'ENTRY_EMAIL_ADDRESS_MIN_LENGTH', '6', '電子郵件地址最少字數', 2, 4, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '街道門牌號碼', 'ENTRY_STREET_ADDRESS_MIN_LENGTH', '5', '街道門牌號碼最少字數', 2, 5, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '公司', 'ENTRY_COMPANY_MIN_LENGTH', '2', '公司名稱最少字數', 2, 6, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '郵遞區號', 'ENTRY_POSTCODE_MIN_LENGTH', '3', '郵遞區號最少字數', 2, 7, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '鎮鄉村', 'ENTRY_CITY_MIN_LENGTH', '2', '鄉鎮最少字數', 2, 8, '2004-04-02 01:48:51', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '縣市', 'ENTRY_STATE_MIN_LENGTH', '2', '縣市最少字數', 2, 9, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '電話號碼', 'ENTRY_TELEPHONE_MIN_LENGTH', '6', '電話號碼最少字數', 2, 10, '2004-04-02 01:48:31', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '密碼', 'ENTRY_PASSWORD_MIN_LENGTH', '5', '密碼最少字數', 2, 11, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '持卡人姓名', 'CC_OWNER_MIN_LENGTH', '3', '持卡人姓名最少字數', 2, 12, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '信用卡卡號', 'CC_NUMBER_MIN_LENGTH', '10', '信用卡卡號最少字數', 2, 13, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '評論文字', 'REVIEW_TEXT_MIN_LENGTH', '50', '商品評論最少字數', 2, 14, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '暢銷商品', 'MIN_DISPLAY_BESTSELLERS', '1', '暢銷商品最少顯示數量', 2, 15, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '建議購買商品', 'MIN_DISPLAY_ALSO_PURCHASED', '1', '建議客戶購買商品區塊所能顯示的最少數目', 2, 16, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '帳號名稱', 'ENTRY_USERNAME_MIN_LENGTH', '3', 'Minimum lenght for the username field', 2, 17, '2006-08-23 13:57:09', '0000-00-00 00:00:00', NULL, NULL);

INSERT INTO configuration VALUES ('', '訂單最低訂購金額', 'MIN_ORDER_AMOUNT', '', '每張訂單必須達最小限購金額才能結帳<BR>空白表示沒有限制最小訂購量。', 2, 23, '2006-10-03 17:27:34', '2006-06-22 19:54:22', '', '');
INSERT INTO configuration VALUES ('', '訂單最低訂購數量', 'MIN_TOTAL_ORDER_QUANTITY', '', '每張訂單必須達最低訂購數量，才能夠結帳。 <br>僅用於須要設定最低訂購項目。如果空白表示沒有限制.', 2, 23, '2006-10-03 17:27:46', '2006-06-23 08:36:24', '', '');

INSERT INTO configuration VALUES ('', '通訊錄筆數', 'MAX_ADDRESS_BOOK_ENTRIES', '3', '每位顧客擁有通訊錄的最大筆數', 3, 1, '2006-10-26 20:42:55', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '搜尋結果', 'MAX_DISPLAY_SEARCH_RESULTS', '20', '搜尋產品列表最大數量', 3, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '網頁最大連結數', 'MAX_DISPLAY_PAGE_LINKS', '5', '每一網頁可連結最大數目', 3, 3, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '特價商品', 'MAX_DISPLAY_SPECIAL_PRODUCTS', '9', '特價商品最大顯示數量', 3, 4, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '新上市商品模組', 'MAX_DISPLAY_NEW_PRODUCTS', '9', '商品目錄中新上市商品最大顯示數量', 3, 5, '2006-08-26 18:45:48', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品上市預告', 'MAX_DISPLAY_UPCOMING_PRODUCTS', '10', '商品上市預告最大顯示數量', 3, 6, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '製造廠商列表', 'MAX_DISPLAY_MANUFACTURERS_IN_A_LIST', '0', '用於製造廠商區塊; 當製造廠商數超過這個數量，預設的清單會取代下拉式清單', 3, 7, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '製造廠商選取格式', 'MAX_MANUFACTURERS_LIST', '1', '用於製造廠商區塊; 如果這個值是''1'' 則顯示下拉式選單，否則會依這個數值作為製造廠商列表的列數，例如，數值 3 則會出現 3 列的製造廠商列表，而不會出現下拉式選單', 3, 7, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '製造廠商名稱字數', 'MAX_DISPLAY_MANUFACTURER_NAME_LEN', '15', '用於製造廠商區塊; 名稱顯示的最多字數', 3, 8, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '新的評論', 'MAX_DISPLAY_NEW_REVIEWS', '6', '商品新增評論顯示的最大數量', 3, 9, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品評論隨機選取', 'MAX_RANDOM_SELECT_REVIEWS', '10', '從多少筆資料中隨機選取一筆商品評論？', 3, 10, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '新上市商品隨機選取', 'MAX_RANDOM_SELECT_NEW', '10', '從多少筆記錄中隨機選取一筆新上市資料', 3, 11, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '特價商品隨機選取', 'MAX_RANDOM_SELECT_SPECIALS', '10', '從多少筆資料中選取一筆特價商品資料', 3, 12, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品目錄-每列的數目', 'MAX_DISPLAY_CATEGORIES_PER_ROW', '3', '每一列可列多少個商品目錄', 3, 13, '2006-09-28 10:32:39', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '新上市商品列表', 'MAX_DISPLAY_PRODUCTS_NEW', '10', '新上市商品每頁可顯示最大數量', 3, 14, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '暢銷商品數', 'MAX_DISPLAY_BESTSELLERS', '10', '暢銷商品最大顯示數量', 3, 15, '2006-09-28 10:33:06', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '建議購買商品', 'MAX_DISPLAY_ALSO_PURCHASED', '6', '建議客戶購買商品區塊所能顯示的最大數目', 3, 16, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顧客訂單記錄區塊', 'MAX_DISPLAY_PRODUCTS_IN_ORDER_HISTORY_BOX', '6', '顧客訂單記錄區塊中，顯示已購買商品的最大數量', 3, 17, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '訂單記錄', 'MAX_DISPLAY_ORDER_HISTORY', '10', '訂單記錄每頁可顯示的最大訂單記錄數量', 3, 18, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '電子報單次最大發送數', 'NEWSLETTERS_LIMIT', '200', '設定電子報單次最大發送數<br>※提示：輸入 <font color=red>0</font> 表示不設限，全部寄送。<br>當您的會員數達1000人以上，為了避免寄送郵件時發生time out錯誤而中止寄送，請設定適當的單次寄送量', 3, 20, '2006-09-28 10:37:53', '0000-00-00 00:00:00', '', '');
INSERT INTO configuration VALUES ('', '電子報發送間隔秒數', 'NEWSLETTERS_INTERVAL', '1', '設定電子報發送間隔秒數<br>※提示：輸入 <font color=red>0</font> 表示不設限。<br>設定適當的發送間隔秒數，可以避免短時間內大幅增加主機商mailserver的負擔，也可以減少收件方ISP擋信的機率。', 3, 20, '2006-09-28 10:34:18', '0000-00-00 00:00:00', '', '');
INSERT INTO configuration VALUES ('', '管理頁--每頁商品數', 'MAX_PROD_ADMIN_SIDE', '30', 'Maximum number of products per page in administration panel', 3, 0, '2006-11-05 14:29:07', '2003-11-10 14:54:12', '', '');

INSERT INTO configuration VALUES ('', '小圖片寬度', 'SMALL_IMAGE_WIDTH', '70', '小圖片寬度(畫素)', 4, 1, '2006-09-28 10:26:50', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '小圖片高度', 'SMALL_IMAGE_HEIGHT', '70', '小圖片高度(畫素)', 4, 2, '2006-09-28 10:26:59', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '標題列圖片寬度', 'HEADING_IMAGE_WIDTH', '60', '標題列圖片寬度(畫素)', 4, 3, '2006-09-28 10:27:07', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '標題列圖片高度', 'HEADING_IMAGE_HEIGHT', '60', '標題列圖片高度(畫素)', 4, 4, '2006-09-28 10:27:15', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '子目錄圖片寬度', 'SUBCATEGORY_IMAGE_WIDTH', '64', '子目錄圖片寬度(畫素)', 4, 5, '2006-09-28 10:27:22', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '子目錄圖片高度', 'SUBCATEGORY_IMAGE_HEIGHT', '64', '子目錄圖片高度(畫素)', 4, 6, '2006-09-28 10:27:29', '2004-04-01 10:14:44', '', '');
INSERT INTO configuration VALUES ('', '計算圖檔大小', 'CONFIG_CALCULATE_IMAGE_SIZE', 'true', '計算圖檔大小？', 4, 7, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示圖片', 'IMAGE_REQUIRED', 'true', '可以顯示失去連結的圖片，以利除錯', 4, 8, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '暢銷商品圖片寬度', 'BESTSELLER_IMAGE_WIDTH', '80', '<b>暢銷商品</b> 圖片寬度', 4, 9, '2005-01-07 11:11:28', '2005-01-07 11:11:28', NULL, NULL);
INSERT INTO configuration VALUES ('', '暢銷商品圖片高度', 'BESTSELLER_IMAGE_HEIGHT', '80', '<b>暢銷商品</b>圖片高度', 4, 10, '2005-01-07 11:11:28', '2005-01-07 11:11:28', NULL, NULL);
INSERT INTO configuration VALUES ('', 'Product Info縮圖寬度', 'PRODUCT_INFO_IMAGE_WIDTH', '200', 'The pixel width of images shown on your product information page', 4, 11, '2006-09-23 19:05:50', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'Product Info縮圖高度', 'PRODUCT_INFO_IMAGE_HEIGHT', '200', 'The pixel height of images shown on your product information page', 4, 11, '2006-09-23 19:11:32', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'product info主縮圖寬度', 'MAIN_IMAGE_WIDTH', '300', 'product info主圖(第一圖)縮圖寬度', 4, 12, '2006-09-26 11:01:50', '2006-09-08 18:13:17', '', '');
INSERT INTO configuration VALUES ('', 'product info主縮圖高度', 'MAIN_IMAGE_HEIGHT', '300', 'product info主圖(第一圖)縮圖高度', 4, 12, '2006-09-26 11:02:00', '2006-09-08 18:14:50', '', '');
INSERT INTO configuration VALUES ('', 'Product info彈出圖片寬度', 'POPUP_IMAGE_WIDTH', '500', '<b>popup</b>圖片寬度(pixes).勿空白!', 4, 13, '2006-09-28 10:24:41', '2005-01-07 11:11:49', '', '');
INSERT INTO configuration VALUES ('', 'Product info彈出圖片高度', 'POPUP_IMAGE_HEIGHT', '500', '<b>popup</b>圖片高度()pixes). 勿空白!', 4, 13, '2006-09-28 10:24:30', '2005-01-07 11:11:49', '', '');
INSERT INTO configuration VALUES ('', 'Gifts-圖片寬度', 'GIFTS_IMAGE_WIDTH', '80', 'The pixel width of heading images', 4, 15, '2006-09-28 10:26:15', '2006-03-30 14:30:16', '', '');
INSERT INTO configuration VALUES ('', 'Gifts-圖片高度', 'GIFTS_IMAGE_HEIGHT', '80', 'The pixel height of heading images', 4, 15, '2006-09-28 10:26:22', '2006-03-30 14:30:16', '', '');

INSERT INTO configuration VALUES ('', '性別', 'ACCOUNT_GENDER', 'true', '客戶帳號內顯示性別，true=顯示，false=不顯示', 5, 1, '2005-01-07 13:16:39', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '帳號名稱', 'ACCOUNT_USERNAME', 'true', 'Display Username in the customers account', 5, 2, '2006-10-26 20:36:17', '0000-00-00 00:00:00', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '生日', 'ACCOUNT_DOB', 'true', '客戶帳號內顯示生日，true=顯示，false=不顯示', 5, 3, '2006-10-26 20:36:32', '2004-04-01 10:14:44', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '公司', 'ACCOUNT_COMPANY', 'true', '客戶帳號內顯示公司名稱，true=顯示，false=不顯示', 5, 3, '2004-04-02 01:56:13', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '公司統一編號', 'ACCOUNT_CF', 'true', 'Show Tax Identification Number', 5, 4, '2006-09-21 19:53:57', '2003-06-01 17:41:12', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '必須公司統一編號', 'ACCOUNT_CF_REQ', 'false', 'Is Tax Identification Number required?', 5, 4, '2006-09-21 19:53:46', '2003-06-01 17:41:12', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '里鄰', 'ACCOUNT_SUBURB', 'false', '客戶帳號內顯示里鄰，true=顯示，false=不顯示', 5, 5, '2006-09-21 19:54:15', '2004-04-01 10:14:44', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '縣市', 'ACCOUNT_STATE', 'true', '客戶帳號內顯示縣市，true=顯示，false=不顯示', 5, 6, '2006-09-21 19:54:37', '2004-04-01 10:14:44', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '會員認證', 'MEMBER', 'true', '認證選擇:<br>\r\n如果要設定等級(true) 不設等級Free account (false)', 5, 13, '2006-09-21 20:00:36', '2004-02-26 19:30:00', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '線上訪客, 時間計算', 'WHOS_ONLINE_AGO', '300', '設定經過幾秒計算一次?', 5, 21, '2006-10-28 11:04:25', '2004-03-17 04:04:04', '', '');
INSERT INTO configuration VALUES ('', '線上訪客, 名單', 'WHOS_ONLINE_LIST', 'yes', '顯示訪客登入名單?', 5, 22, '2006-10-28 11:16:49', '2004-03-17 04:04:04', '', 'tep_cfg_select_option(array(''yes'', ''no''),');

INSERT INTO configuration VALUES ('', '預設貨幣', 'DEFAULT_CURRENCY', 'TWD', '預設的貨幣', 6, 0, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '預設語系', 'DEFAULT_LANGUAGE', 'tw', '預設的語系', 6, 0, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '新訂單的預設狀態', 'DEFAULT_ORDERS_STATUS_ID', '1', '當新訂單產生時指定的訂單狀態', 6, 0, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '訂單總計模組顯示運費', 'MODULE_ORDER_TOTAL_SHIPPING_STATUS', 'true', '要顯示訂單運費？', 6, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訂單總計模組運費顯示順序', 'MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER', '2', '顯示時的順序', 6, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '訂單總計模組啟用免運費', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING', 'false', '要啟動免費費設定？', 6, 3, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訂單總計模組免運費，當訂單金額大於', 'MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER', '1500', '設定免運費金額', 6, 4, NULL, '2004-04-01 10:14:44', 'currencies->format', NULL);
INSERT INTO configuration VALUES ('', '免運費設定', 'MODULE_ORDER_TOTAL_SHIPPING_DESTINATION', 'national', '設定提供免運費的地區', 6, 5, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''national'', ''international'', ''both''),');
INSERT INTO configuration VALUES ('', '訂單總計模組顯示小計', 'MODULE_ORDER_TOTAL_SUBTOTAL_STATUS', 'true', '顯示訂單小計？', 6, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訂單總計模組小計顯示順序', 'MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER', '1', '顯示時的順序', 6, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '訂單總計模組顯示稅金', 'MODULE_ORDER_TOTAL_TAX_STATUS', 'true', '顯示訂單稅金？', 6, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訂單總計模組稅金顯示順序', 'MODULE_ORDER_TOTAL_TAX_SORT_ORDER', '3', '顯示時的順序', 6, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '訂單總計模組顯示總計', 'MODULE_ORDER_TOTAL_TOTAL_STATUS', 'true', '顯示全部訂單金額？', 6, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訂單總計模組總計顯示順序', 'MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER', '900', '顯示時的順序', 6, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);

INSERT INTO configuration VALUES ('', '啟用 2gether 折扣', 'MODULE_2GETHER_DISCOUNT_STATUS', 'true', 'Do you want to enable the 2gether discount module?', 6, 1, NULL, '2006-08-24 19:46:23', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '順序', 'MODULE_2GETHER_DISCOUNT_SORT_ORDER', '5', 'Sort order of display.', 6, 2, NULL, '2006-08-24 19:46:23', NULL, NULL);

INSERT INTO configuration VALUES ('', '折扣券兌換密碼', 'NEW_SIGNUP_DISCOUNT_COUPON', '', '折價券兌換瑪: 當客戶建立帳號時若不想傳送折價券..請保持空白，若要啟用請自行輸入兌換碼', 1, 34, NULL, '2003-12-05 05:01:41', NULL, NULL);
INSERT INTO configuration VALUES ('', '稅率', 'MODULE_ORDER_TOTAL_COUPON_TAX_CLASS', '0', '在Credit Note模式下處理折價券兌換時使用以下之稅率', 6, 0, NULL, '2006-10-30 15:45:39', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(');
INSERT INTO configuration VALUES ('', '重新計算稅額', 'MODULE_ORDER_TOTAL_COUPON_CALC_TAX', 'None', '重新計算稅金', 6, 7, NULL, '2006-10-30 15:45:39', NULL, 'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO configuration VALUES ('', '含稅', 'MODULE_ORDER_TOTAL_COUPON_INC_TAX', 'true', '含稅計算.', 6, 6, NULL, '2006-10-30 15:45:39', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '順序', 'MODULE_ORDER_TOTAL_COUPON_SORT_ORDER', '9', '顯示順序.', 6, 2, NULL, '2006-10-30 15:45:39', NULL, NULL);
INSERT INTO configuration VALUES ('', '含運費', 'MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING', 'true', '含運費計算', 6, 5, NULL, '2006-10-30 15:45:39', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '折扣金額', 'MODULE_ORDER_TOTAL_COUPON_STATUS', 'true', '顯示折價券金額?', 6, 1, NULL, '2006-10-30 15:45:39', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '稅率', 'MODULE_ORDER_TOTAL_GV_TAX_CLASS', '0', '在Credit Note模式下處理禮券兌換時使用以下之稅率', 6, 0, NULL, '2006-10-30 15:44:30', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(');
INSERT INTO configuration VALUES ('', '重新計算稅額', 'MODULE_ORDER_TOTAL_GV_CALC_TAX', 'None', '重新計算稅額', 6, 7, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''), ');
INSERT INTO configuration VALUES ('', '含稅', 'MODULE_ORDER_TOTAL_GV_INC_TAX', 'true', '含稅金計算', 6, 6, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '順序', 'MODULE_ORDER_TOTAL_GV_SORT_ORDER', '740', '顯示的順序', 6, 2, NULL, '2006-10-30 15:44:30', NULL, NULL);
INSERT INTO configuration VALUES ('', '排入購買禮券', 'MODULE_ORDER_TOTAL_GV_QUEUE', 'true', '要排入購買禮券嗎?', 6, 3, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '含運費', 'MODULE_ORDER_TOTAL_GV_INC_SHIPPING', 'true', '含運費計算', 6, 5, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '顯示總金額', 'MODULE_ORDER_TOTAL_GV_STATUS', 'true', '顯示禮券金額嗎?', 6, 1, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', '帳款結餘', 'MODULE_ORDER_TOTAL_ACCOUNT_BALANCE_STATUS', 'true', '要顯示客戶的帳款結餘金額嗎?  適合使用在折價券/禮券方面.', 6, 1, NULL, '2005-01-07 13:30:41', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '順序', 'MODULE_ORDER_TOTAL_ACCOUNT_BALANCE_SORT_ORDER', '899', '顯示順序', 6, 2, NULL, '2005-01-07 13:30:41', NULL, NULL);
INSERT INTO configuration VALUES ('', '稅別', 'MODULE_ORDER_TOTAL_ACCOUNT_BALANCE_TAX_CLASS', '0', '在(帳款餘額)account balance使用以下稅率', 6, 7, NULL, '2005-01-07 13:30:41', 'tep_get_tax_class_title', 'tep_cfg_pull_down_tax_classes(');
INSERT INTO configuration VALUES ('', '順序', 'MODULE_ORDER_TOTAL_REDEMPTIONS_SORT_ORDER', '4', 'Sort order of display.', 6, 2, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '順序', 'MODULE_PAYMENT_CCERR_SORT_ORDER', '99', 'Sort order of display. Lowest is displayed first.', 6, 0, NULL, '2006-11-08 18:58:33', NULL, NULL);
INSERT INTO configuration VALUES ('', '禮券兌換含稅', 'MODULE_ORDER_TOTAL_GV_CREDIT_TAX', 'false', '禮券兌換是否加稅金入帳?', 6, 8, NULL, '2006-10-30 15:44:30', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');

INSERT INTO configuration VALUES ('', '出貨國', 'SHIPPING_ORIGIN_COUNTRY', '206', '出貨單上商店國別', 7, 1, NULL, '2004-04-01 10:14:44', 'tep_get_country_name', 'tep_cfg_pull_down_country_list(');
INSERT INTO configuration VALUES ('', '郵遞區號', 'SHIPPING_ORIGIN_ZIP', '40153', '出貨單上商店所在郵遞區號', 7, 2, '2006-08-11 10:48:30', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '輸入運送包裝的最大重量', 'SHIPPING_MAX_WEIGHT', '20', '運送時，通常會有單一包裝的重量限制。', 7, 3, '2006-08-11 11:16:37', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '包裝重量', 'SHIPPING_BOX_WEIGHT', '0.2', '中小型包裝的代表性重量', 7, 4, '2006-08-11 11:27:32', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '大包裝-百分比增加', 'SHIPPING_BOX_PADDING', '10', '輸入 10 代表 10%', 7, 5, NULL, '2004-04-01 10:14:44', NULL, NULL);

INSERT INTO configuration VALUES ('', '顯示商品圖片', 'PRODUCT_LIST_IMAGE', '1', '是否顯示商品圖片？', 8, 1, '2006-08-28 09:59:50', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品製造廠商', 'PRODUCT_LIST_MANUFACTURER', '0', '是否顯示商品製造廠商？', 8, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品型號', 'PRODUCT_LIST_MODEL', '4', '是否顯示商品型號？', 8, 3, '2006-08-28 10:00:31', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示品名', 'PRODUCT_LIST_NAME', '2', '是否顯示商品名稱？', 8, 4, '2006-08-28 10:00:17', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品價格', 'PRODUCT_LIST_PRICE', '5', '是否顯示商品價格', 8, 5, '2006-08-28 10:00:41', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品數量', 'PRODUCT_LIST_QUANTITY', '0', '是否顯示商品數量？', 8, 6, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品重量', 'PRODUCT_LIST_WEIGHT', '0', '是否顯示商品數量', 8, 7, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示馬上買', 'PRODUCT_LIST_BUY_NOW', '8', '是否顯示買上買？', 8, 8, '2006-08-28 10:00:57', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品目錄/製造廠商篩選(0=不啟動; 1=啟動)', 'PRODUCT_LIST_FILTER', '1', '是否顯示商品目錄/製造廠商篩選？', 8, 9, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '上頁/下頁 導覽列位置(1-上 2-下 3-兩者)', 'PREV_NEXT_BAR_LOCATION', '2', '設定導覽列位置', 8, 10, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示商品欄位排序', 'PRODUCT_SORT_ORDER', '', '顯示商品欄位排序?', 8, 29, '2006-08-28 09:59:34', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品列表方式', 'PRODUCT_LISTING_DISPLAY_STYLE', 'list', '選擇你喜歡的商品排列方式.<br><br>list或column', 8, 0, '2005-12-09 21:35:03', '2005-01-07 11:12:20', '', 'tep_cfg_select_option(array(''list'', ''columns''),');
INSERT INTO configuration VALUES ('', '每列商品數', 'PRODUCT_LIST_COL_NUM', '1', '輸入每列要顯示的商品數', 8, 1, '2005-01-22 22:41:05', '2005-01-07 11:12:20', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示Product Info', 'PRODUCT_LIST_INFO', '3', '設定0為不啟動, 1-99 為啟動', 8, 11, '2006-08-28 10:00:24', '2005-01-19 14:58:55', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品最低訂購量', 'PRODUCT_LIST_MINORDER', '6', '在首頁顯示商品最低訂購量?0: 隱藏 x:顯示在x欄位', 8, 11, '2006-08-28 10:00:48', '2006-03-27 09:50:07', NULL, NULL);
INSERT INTO configuration VALUES ('', '商品最大限購量', 'PRODUCT_LIST_maxorder', '', '商品最大限購數量', 8, 12, '2006-08-24 13:57:37', '0000-00-00 00:00:00', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示放大圖片 icon', 'PRODUCT_LIST_ENLARGE_ICON', '7', '你要在product listing顯示放大圖片的icon嗎?', 8, 8, '2006-08-28 10:01:01', '2006-08-27 11:26:22', NULL, NULL);

INSERT INTO configuration VALUES ('', '檢查庫存量水準', 'STOCK_CHECK', 'true', '是否檢查庫存不足', 9, 1, '2006-10-30 16:23:16', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '庫存自動扣除', 'STOCK_LIMITED', 'true', '依顧客訂單數量自動扣除庫存量', 9, 2, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '可以結帳', 'STOCK_ALLOW_CHECKOUT', 'false', '當庫存量不足時，仍然可以讓顧客結帳', 9, 3, '2005-01-07 14:28:54', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '缺貨標示', 'STOCK_MARK_PRODUCT_OUT_OF_STOCK', '***', '缺貨時會顯示這個標示，讓顧客知道哪一項商品已缺貨', 9, 4, '2006-08-23 15:29:25', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '安全庫存量', 'STOCK_REORDER_LEVEL', '3', '低於安全庫存量時進貨', 9, 5, '2005-01-07 14:29:00', '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '最低訂購量', 'MINIMUM_ORDERS', 'true', '設定商品最低訂購量', 9, 9, '2005-10-12 11:45:18', '2005-10-12 11:45:18', NULL, NULL);
INSERT INTO configuration VALUES ('', '最大訂購量', 'MAXIMUM_ORDERS', 'true', 'Whether or not to enforce MAXIMUM orders', 9, 10, '2006-04-10 08:44:44', '2006-04-10 08:44:44', NULL, NULL);

INSERT INTO configuration VALUES ('', '儲存頁面解析時間', 'STORE_PAGE_PARSE_TIME', 'false', '儲存解析一頁所花費的時間', 10, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '紀錄檔位置', 'STORE_PAGE_PARSE_TIME_LOG', '/var/log/www/tep/page_parse_time.log', '頁解析時間紀錄檔的資料夾與檔名', 10, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '紀錄檔日期格式', 'STORE_PARSE_DATE_TIME_FORMAT', '%d/%m/%Y %H:%M:%S', '日期格式', 10, 3, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '顯示頁解析時間', 'DISPLAY_PAGE_PARSE_TIME', 'true', '顯示頁解析時間(儲存頁解析時間必須啟動)', 10, 4, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '儲存資料庫查詢', 'STORE_DB_TRANSACTIONS', 'false', '儲存每頁查詢資料庫的解析時間紀錄(僅適用PHP4)', 10, 5, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');

INSERT INTO configuration VALUES ('', '使用快取', 'USE_CACHE', 'false', '使用快取', 11, 1, '2006-12-08 09:37:45', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '快取目錄', 'DIR_FS_CACHE', '/tmp/', '快取檔案儲存的目錄', 11, 2, '2006-12-08 09:36:25', '2004-04-01 10:14:44', NULL, NULL);

INSERT INTO configuration VALUES ('', '電子郵件寄信方式', 'EMAIL_TRANSPORT', 'sendmail', '定義使用本地主機(Unix-like) sendmail 或經由 TCP/IP 連接的網路 SMTP 主機送信，如果您的主機是運作在 Windows 或是 MacOS 底下，請設定為 SMTP.', 12, 1, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''sendmail'', ''smtp''),');
INSERT INTO configuration VALUES ('', '電子郵件換行', 'EMAIL_LINEFEED', 'LF', '定義電子郵件表頭所使用的換行字元', 12, 2, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''LF'', ''CRLF''),');
INSERT INTO configuration VALUES ('', '使用 MIME HTML 格式寄電子郵件', 'EMAIL_USE_HTML', 'true', '傳送 HTML 格式的電子郵件', 12, 3, '2006-03-13 10:00:40', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '利用 DNS 檢查電子郵件地址', 'ENTRY_EMAIL_ADDRESS_CHECK', 'true', '利用 DNS 主機檢查電子郵件地址', 12, 4, '2004-04-02 02:00:46', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '傳送電子郵件', 'SEND_EMAILS', 'true', '寄出電子郵件', 12, 5, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '使用電子郵件總管', 'USE_EMAIL_QUEUE', 'true', '由Email Queue管理郵電子郵件', 12, 6, '2006-03-16 13:57:05', '0000-00-00 00:00:00', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '儲存 特定Email內容', 'HOLD_EMAIL_QUEUE', 'true', 'Hold all emails in the Email Queue', 12, 7, '2006-03-16 13:54:08', '0000-00-00 00:00:00', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');

INSERT INTO configuration VALUES ('', '啟動下載', 'DOWNLOAD_ENABLED', 'true', '啟動產品下載', 13, 1, '2006-03-28 10:40:08', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '轉址下載', 'DOWNLOAD_BY_REDIRECT', 'false', '使用瀏覽器轉向下載，非 Unix 系統無法使用', 13, 2, '2006-11-09 11:39:52', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '到期日(天數)', 'DOWNLOAD_MAX_DAYS', '7', '設定下載過期天數，輸入 0 代表沒有期限', 13, 3, NULL, '2004-04-01 10:14:44', NULL, '');
INSERT INTO configuration VALUES ('', '最大下載數', 'DOWNLOAD_MAX_COUNT', '3', '設定最大下載數，輸入 0 代表不可下載', 13, 4, '2006-10-30 15:55:25', '2004-04-01 10:14:44', NULL, '');
INSERT INTO configuration VALUES ('', '下載控制-更新狀態值', 'DOWNLOADS_ORDERS_STATUS_UPDATED_VALUE', '4', '訂單狀態重心心設定下載到期天數和最大下載數 - 預設為4', 13, 90, '2006-11-01 18:09:18', '0000-00-00 00:00:00', '', '');
INSERT INTO configuration VALUES ('', '下載控制-下載指定訊息', 'DOWNLOADS_CONTROLLER_ON_HOLD_MSG', '<BR><font color=FF0000>註: 必須確認已付款才能下載檔案</font>', '下載控制-下載指定訊息', 13, 91, '2006-11-01 18:12:18', '0000-00-00 00:00:00', '', '');
INSERT INTO configuration VALUES ('', '下載控制-訂單狀態值', 'DOWNLOADS_CONTROLLER_ORDERS_STATUS', '2', '下載控制-訂單狀態值 - Default=2', 13, 92, '2006-11-01 18:13:14', '0000-00-00 00:00:00', '', '');

INSERT INTO configuration VALUES ('', '使用 GZip 壓縮', 'GZIP_COMPRESSION', 'true', '使用 HTTP GZip 壓縮', 14, 1, '2006-08-23 15:33:31', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '壓縮等級', 'GZIP_LEVEL', '5', '使用的壓縮等級 0-9 (0 = 最小, 9 = 最大).', 14, 2, NULL, '2004-04-01 10:14:44', NULL, NULL);

INSERT INTO configuration VALUES ('', 'Session 儲存目錄', 'SESSION_WRITE_DIRECTORY', '/tmp', '如果你的 session 是儲存於檔案，則會放到此目錄', 15, 1, NULL, '2004-04-01 10:14:44', NULL, NULL);
INSERT INTO configuration VALUES ('', '強迫 Cookie 使用', 'SESSION_FORCE_COOKIE_USE', 'False', '當只有 cookie 啟動時，強迫使用 session', 15, 2, '2006-04-13 14:04:43', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '檢查 SSL Session ID', 'SESSION_CHECK_SSL_SESSION_ID', 'False', '在每一個加密網頁(https)確認 SSL_SESSION_ID', 15, 3, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '檢查使用者瀏覽器種類', 'SESSION_CHECK_USER_AGENT', 'True', '每一網頁確認瀏覽器種類', 15, 4, '2006-01-06 14:08:06', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '檢查 IP 位址', 'SESSION_CHECK_IP_ADDRESS', 'False', '每一網頁檢查使用者 IP 位址', 15, 5, '2006-04-11 19:09:25', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '拒絕搜尋引擎機器人建立 Sessions', 'SESSION_BLOCK_SPIDERS', 'True', '拒絕已知搜尋引擎之機器人(spiders or robots)建立 session，如 google)', 15, 6, '2006-02-16 18:38:49', '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '重新建立 Session', 'SESSION_RECREATE', 'False', '當使用者登入或新增帳號時，重建 session 以新增 session ID (PHP 版本必須為 4.1 以上).', 15, 7, NULL, '2004-04-01 10:14:44', NULL, 'tep_cfg_select_option(array(''True'', ''False''),');

INSERT INTO configuration VALUES ('', '電子報--WYSIWYG', 'WYSIWYG_NEWSLETTERS', 'Enable', 'newsletters使用所見即所得編輯', 21, 3, '2006-11-18 13:44:49', '2006-11-18 13:41:20', '', 'tep_cfg_select_option(array(''Enable'', ''Disable''),');
INSERT INTO configuration VALUES ('', '商品分類--WYSIWYG', 'WYSIWYG_CATEGORY', 'Disable', '商品分類使用所見即所得編輯', 21, 4, NULL, '2006-11-18 13:44:36', '', 'tep_cfg_select_option(array(''Enable'', ''Disable''),');
INSERT INTO configuration VALUES ('', '商品詳細說明--WYSIWYG', 'WYSIWYG_PRODUCTS_DESC', 'Disable', '商品說明使用WYSIWYG編輯', 21, 5, '2006-11-18 14:19:36', '2006-11-18 13:47:21', '', 'tep_cfg_select_option(array(''Enable'', ''Disable''),');
INSERT INTO configuration VALUES ('', '商品簡介--WYSIWYG', 'WYSIWYG_PRODUCTS_INFO', 'Disable', '商品簡介使用WYSIWYG編輯', 21, 6, '2006-11-18 14:19:49', '2006-11-18 14:16:11', '', 'tep_cfg_select_option(array(''Enable'', ''Disable''),');
INSERT INTO configuration VALUES ('', 'Email--WYSIWYG', 'WYSIWYG_EMAIL', 'Enable', 'Email使用WYSIWYG編輯', 21, 1, '2006-11-18 14:19:31', '2006-11-18 11:27:26', '', 'tep_cfg_select_option(array(''Enable'', ''Disable''),');

INSERT INTO configuration VALUES ('', '啟動紅利點數系統', 'USE_POINTS_SYSTEM', 'true', '是否允許客戶購物後可以累積紅利點數?', 22, 1, '2006-03-21 16:21:34', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '啟動紅利點數兌換系統', 'USE_REDEEM_SYSTEM', 'true', '是否允許客戶購物可以使用紅利點數來結帳?', 22, 2, '2006-03-21 16:21:29', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '每購買一元折換點數', 'POINTS_PER_AMOUNT_PURCHASE', '0.1', '每消費一元折換點數.<br>(目前以系統預設貨幣計算)', 22, 3, '2006-02-27 15:49:30', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '每一點可以折抵多少元', 'REDEEM_POINT_VALUE', '0.2', '每一點可以折抵多少元<br>(設定買家訂單每一個點數可以抵扣多少現金.<br>(依照預設貨幣定義)', 22, 4, '2006-12-02 10:35:01', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '自動換算積點(Credit Pending Points)', 'POINTS_AUTO_ON', 'false', '啟用自動換算積點(Auto Credit Pending Points)?<br>處裡中的點數會在結帳完成(可能還沒付款)自動累進。', 22, 5, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '運費是否列入計算點數', 'USE_POINTS_FOR_SHIPPING', 'false', '啟用客戶可以從運費獲得積點?', 22, 6, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '營業稅是否列入計算點數', 'USE_POINTS_FOR_TAX', 'false', 'Enable customers to earn points for Tax?', 22, 7, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '特價品是否可以再列入計算點數', 'USE_POINTS_FOR_SPECIALS', 'true', 'Enable customers to earn points for items already discounted?<br>When set to false, Points awarded only on items with full price', 22, 8, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '使用點數購買後是否可再計算累積點數', 'USE_POINTS_FOR_REDEEMED', 'true', '當消費扣除點數後,剩餘的自付額是否可以再列入計算?<br>如果設定為否,只有訂單內有使用到點數,則全部不再列入計算', 22, 9, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '商品限制', 'REDEMPTION_RESTRICTION', 'false', '啟用商品限制?(是:true，否:false)', 22, 10, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '如果啟動商品限制,哪些商品型號可以使用點數', 'RESTRICTION_MODEL', '', '限制可使用點數之商品型號.<br>如果要限制商品，請指定型號', 22, 11, '2006-02-25 14:33:07', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '如果啟動商品限制,哪些商品編號可以使用點數', 'RESTRICTION_PID', '', '可以使用點數的商品編號<br>商品編號之間請用comma分開。(不要與商品型號混用)如果以商品型號作為限制條件，本欄請空白', 22, 12, '2006-02-25 14:33:40', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '如果啟動商品限制,哪些目錄ID可以使用點數', 'RESTRICTION_PATH', '', '哪些目錄ID可以使用點數.<br>商品編號請以comma分隔。如果由商品型號設定，本欄請空白', 22, 13, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '已折扣商品不計點', 'REDEMPTION_DISCOUNTED', 'true', '當客戶使用紅利點數,你要排除已經折扣的項目嗎 ?<br>若啟用，則僅有不打折的商品才能計點', 22, 14, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '客戶使用之最低點數', 'POINTS_LIMIT_VALUE', '0', '這個設定可以限制顧客結帳時使用點數的最小兌換值', 22, 15, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '每次訂購可以兌換的最高紅利點數', 'POINTS_MAX_VALUE', '1000', '這個設定可以限制顧客結帳時使用點數的最大兌換值', 22, 16, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '啟動固定兌換點數', 'POINTS_LIMIT_EXACT', 'false', '這個設定可以使顧客結帳使用點數是依照我們所設定的固定兌換值去兌換(一但啟動後顧客結帳時無法自行決定要使用多少兌換點數)?', 22, 17, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '要顧客兌換點數的固定點數值', 'POINTS_EXACT_VALUE', '50', '這個設定可以使顧客結帳使用點數是依照我們所設定的固定兌換值去兌換<br>請設定固定兌換數值', 22, 18, '2006-03-21 16:22:09', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '可以兌換紅利點數之最小購買金額', 'POINTS_MIN_AMOUNT', '', '輸入最小購買金額(total cart contain) 才能使用紅利點數對換.<br>不限定請留空白', 22, 19, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '新註冊客戶贈送點數', 'NEW_SIGNUP_POINT_AMOUNT', '0', '設置新註冊客戶贈送多少點數。如果不希望贈送則設置0', 22, 20, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '每頁顯示多少筆點數紀錄', 'MAX_DISPLAY_POINTS_RECORD', '20', '設置每頁顯示多少筆點數紀錄', 22, 21, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, NULL);
INSERT INTO configuration VALUES ('', '在商品資訊頁面顯示紅利點數資訊', 'DISPLAY_POINTS_INFO', 'true', '要在商品描述頁面顯示紅利點數資訊嗎?', 22, 22, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '使用點數時保留資料記錄', 'DISPLAY_POINTS_REDEEMED', 'true', '要保留顧客使用點數的資料紀錄嗎?', 22, 23, '0000-00-00 00:00:00', '2006-02-24 20:49:02', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');

INSERT INTO configuration VALUES ('', 'Show《精選商品》Featured Products', 'FEATURED_PRODUCTS_DISPLAY', 'true', '設定為true 或 false 以決定要不要顯示featured.', 29, 1, '2006-09-28 10:21:31', '2006-07-21 16:31:05', 'tep_cfg_get_zone_name', '');
INSERT INTO configuration VALUES ('', '精選商品-Featured商品數', 'MAX_DISPLAY_FEATURED_PRODUCTS', '10', '設定在前台最多要選示多少商品項目.', 29, 2, '2006-09-28 10:21:02', '2006-07-21 16:31:05', 'tep_cfg_get_zone_name', '');
INSERT INTO configuration VALUES ('', 'Show特價-在catalog', 'SHOW_PRODUCT_SPECIALS_ON_CATALOG', 'true', 'Show Product Specials at the bottom of the Main Catalog Page', 29, 5, '2006-09-28 10:05:18', '2006-08-26 14:11:30', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '限制Specials顯現場所', 'LIMIT_PRODUCT_SPECIALS_SCOPE', 'true', '僅在在目前目錄階層之下顯現Product Specials', 29, 4, '2006-09-09 10:35:09', '2006-08-26 14:11:30', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show特價-在商品分類頁面', 'SHOW_PRODUCT_SPECIALS_ON_CATEGORIES', 'true', 'Show Product Specials at the bottom of the Categories Page. Shown only on pages without a products list also.', 29, 5, '2006-09-28 10:05:07', '2006-08-26 14:11:30', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show特價-在Products Info', 'SHOW_PRODUCT_SPECIALS_ON_PRODUCTS', 'true', 'Show Product Specials at the bottom of the Products Info pages.', 29, 6, '2006-09-28 10:05:32', '2006-08-26 14:11:30', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show特價-在Products List', 'SHOW_PRODUCT_SPECIALS_ON_PRODUCTS_LIST', 'true', 'Show Product Specials at the bottom of the Products List pages. This is best suited for column/row product list pages.', 29, 7, '2006-09-28 10:02:45', '2006-08-26 14:11:30', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show特價-商品數(scroll)', 'MAX_DISPLAY_PRODUCT_SPECIALS', '9', '顯示特價商品數(scroll)', 29, 8, '2006-09-28 10:05:45', '2006-08-26 14:11:30', 'tep_cfg_get_zone_name', '');
INSERT INTO configuration VALUES ('', 'Show特價-到期日', 'SPECIALS_LIST_EXP_DATE', 'true', '顯示特價到期日?', 29, 9, '2006-09-28 10:05:55', '2004-10-01 12:28:32', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show明星商品', 'SHOW_STARPRODUCT', 'false', '秀出特選明星商品', 29, 10, '2006-09-28 10:10:26', '2004-10-01 12:28:32', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show多圖片-在 products_info', 'DISPLAY_ADDITIONAL_IMAGES', 'true', '在products info 顯示多圖片', 29, 11, '2006-10-01 20:13:44', '2005-10-20 17:40:05', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''false'', ''true''),');
INSERT INTO configuration VALUES ('', 'Show-彈出之廣告訊息', 'POPUPMESSAGE', '特別商品廣告', '輸入你要彈出之訊息', 29, 16, '2006-09-28 10:11:41', '0000-00-00 00:00:00', 'tep_cfg_get_zone_name', 'tep_cfg_textarea(');
INSERT INTO configuration VALUES ('', 'Show彈出圖片-在cacalog', 'POPUP', 'false', '啟動主頁面可以彈出圖片', 29, 17, '2006-09-28 10:22:37', '0000-00-00 00:00:00', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '彈出目標-頁面名稱', 'POPLAND', '', '輸入你要使用彈出效果的頁面名稱', 29, 18, '2006-09-28 10:14:38', '0000-00-00 00:00:00', 'tep_cfg_get_zone_name', '');
INSERT INTO configuration VALUES ('', '特價中間區塊-圖片數', 'DISPLAY_SCROLLING_HEADER_PRODUCTS', '5', '在頁面header之顯示 scrolling 之商品數', 29, 20, '2006-09-28 10:20:43', '2006-08-26 16:14:30', 'tep_cfg_get_zone_name', '');
INSERT INTO configuration VALUES ('', 'Show《商品分類-商品》', 'SHOW_COUNTS', 'true', '計算並顯示每一個商品目錄內的商品數量', 29, 21, '2006-09-28 10:23:01', '2004-04-01 10:14:44', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show-商品分類說明', 'ALLOW_CATEGORY_DESCRIPTIONS', 'true', '開放商品分類使用文字說明', 29, 26, '2006-09-28 10:23:14', '2005-01-07 11:12:27', 'tep_cfg_get_zone_name', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '次目錄-說明長度', 'SUB_CATEGORY_DESCRIPTION_DISPLAY_LEN', '300', '次目錄說明顯示的字數長度? (<0: 不顯示次目錄說明; 0: 顯示全部說明; >0: 要顯示的字數', 29, 27, '2006-09-28 09:52:11', '2006-08-08 16:18:05', 'tep_cfg_get_zone_name', '');

INSERT INTO configuration VALUES ('', '顯示型號.', 'DISPLAY_MODEL', 'true', '顯示商品型號', 300, 1, '2003-06-04 05:04:11', '2003-06-04 04:18:06', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修型號', 'MODIFY_MODEL', 'true', '是否開放編修型號?', 300, 2, '2003-06-04 05:04:07', '2003-06-04 04:25:57', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品名稱', 'MODIFY_NAME', 'true', '是否開放編修商品名稱?', 300, 3, '2003-06-04 05:04:01', '2003-06-04 04:30:31', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品狀態', 'DISPLAY_STATUT', 'true', '是否開放編修商品狀態?', 300, 4, '2003-06-04 05:07:11', '2003-06-04 05:00:58', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品重量', 'DISPLAY_WEIGHT', 'true', '是否開放編修商品重量?', 300, 5, '2003-06-04 05:06:44', '2003-06-04 04:33:16', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品數量', 'DISPLAY_QUANTITY', 'true', '是否開放編修商品數量?', 300, 6, '2003-06-04 05:06:48', '2003-06-04 04:34:34', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品圖片', 'DISPLAY_IMAGE', 'true', '是否開放編修商品圖片?', 300, 7, '2003-06-04 05:06:52', '2003-06-04 04:36:57', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修製造廠商', 'MODIFY_MANUFACTURER', 'true', '開放編修製造廠商?', 300, 8, '2003-06-04 05:06:57', '2003-06-04 04:37:40', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '編修商品稅別', 'MODIFY_TAX', 'false', '開放編修及顯示商品稅別?', 300, 9, '2005-12-24 15:46:46', '2003-06-04 04:31:53', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示含稅價', 'DISPLAY_TVA_OVER', 'false', '開放商品顯示含稅價', 300, 10, '2005-12-24 15:42:24', '2003-06-04 04:38:45', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '現在含稅價', 'DISPLAY_TVA_UP', 'false', '當你輸入價格時顯示商品含稅價', 300, 11, '2005-12-24 15:43:27', '2003-06-04 04:40:12', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示商品連結頁', 'DISPLAY_PREVIEW', 'true', '開放顯示商品連結頁', 300, 12, '2003-06-04 05:19:13', '2003-06-04 05:15:50', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '可編修商品之連結頁', 'DISPLAY_EDIT', 'true', '你能夠編修商品時顯示商品連結頁', 300, 13, '2003-06-04 05:19:08', '2003-06-04 05:17:05', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示製造廠商', 'DISPLAY_MANUFACTURER', 'false', '顯示製造廠商 ?', 300, 7, '2003-06-04 05:19:08', '2003-06-04 05:17:05', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示稅額', 'DISPLAY_TAX', 'false', 'Do you want just display the tax ?', 300, 8, '2003-06-04 05:19:08', '2003-06-04 05:17:05', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '顯示營業利潤', 'ACTIVATE_COMMERCIAL_MARGIN', 'true', '顯示營業利潤 ?', 300, 14, '2003-06-04 05:19:08', '2003-06-04 05:17:05', NULL, 'tep_cfg_select_option(array(''true'', ''false''),');

INSERT INTO configuration VALUES ('', '圖片魔術師-主開關', 'CFG_MASTER_SWITCH', 'On', 'Switch OSC Image Magic on or off', 333, 3, '2006-09-28 10:44:19', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''On'', ''Off''),');
INSERT INTO configuration VALUES ('', '對已登入客戶使用圖片加密', 'CFG_REGISTERED_WATERMARKS', 'Yes', 'If this option is set to no, all image security features will be disabled when a registered customer is browsing your site', 333, 4, '2006-09-28 10:47:27', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '全部圖片都使用Graphics', 'CFG_PROCESS_GRAPHICS', 'False', 'If this is set to true, ALL store graphics will be processed and cached, including buttons, clip art etc. The default, recommended setting for this is False', 333, 6, '2006-09-28 10:49:22', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '自動清除Cache', 'CFG_CACHE_AUTO_CLEAN', 'True', 'If selected, the cache will automatically be cleared of un-needed items. Set to true if you want to sacrifice a small amount of performance for server disk space saving', 333, 9, '2006-09-28 10:49:54', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '圖片檔名加密', 'CFG_ENCRYPT_FILENAMES', 'False', '如果選擇true則全部的圖片名稱都會加密而不顯示. Use it in combination with image watermarking to prevent theft of your images.', 333, 12, '2006-09-28 10:56:03', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '檔名加密Key', 'CFG_ENCRYPTION_KEY', '', 'If you have switched on image filename encryption, then enter a string here to be used as the encryption key', 333, 15, '2006-09-28 10:56:36', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'IE瀏覽器使用PNG透明效果?', 'CFG_PNG_BUG', 'True', '本選項可以使PNG alpha 透明嘯果正確顯示在Internet Explorer<br><b>Note:</b> Two files need to be modified to enable this - See readme.', 333, 18, '2006-09-28 11:00:12', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '圖片重新取樣', 'CFG_USE_RESAMPLING', 'True', 'If selected, thumbnails will be resampled rather than resized. Resampling creates much higher quality thumbnails.', 333, 21, '2006-09-28 11:01:55', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '建立Truecolour縮圖', 'CFG_CREATE_TRUECOLOR', 'True', 'Create True color Thumbnails? Better quality overall but set to false if you have GD version < 2.01 or if creating transparent thumbnails.', 333, 24, '2006-09-28 11:02:23', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', 'GIFs輸出支援JPEGs', 'CFG_GIFS_AS_JPEGS', 'True', 'Set this option true if you have GD version > 1.6 and want to output GIFs as JPGs. Note that transparencies will not be retained (set matte colour below). If you have GD Library < 1.6 with GIF create support, GIFs will be output as GIFs.', 333, 27, '2006-09-28 11:04:02', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', 'GIF as JPEG使用背景色(HEX)', 'CFG_MATTE_COLOR', 'FFFFFF', 'Enter the HEX colour value that transparent backgrounds will be converted to if GIFs output as JPGs', 333, 28, '2006-09-28 11:05:15', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '建立縮圖快取-Server', 'CFG_TN_SERVER_CACHE', 'True', 'Set to true if you want to cache previously processed thumbnails on disk. This will add to disk space but will save your processor from having to create a new thumbnail for every visitor. (recommended)', 333, 30, '2006-09-28 11:11:29', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '建立縮圖快取-每位使用者瀏覽', 'CFG_TN_BROWSER_CACHE', 'True', 'Set to true if you want browsers to be able to cache viewed thumbnails in their own cache. This will save bandwidth for every visitor that views the same thumbnail again. (recommended)', 333, 31, '2006-09-28 11:11:12', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '縮圖快取目錄', 'CFG_TN_CACHE_DIRECTORY', '/images/thumbnails', 'Directory where cached thumbnails will be stored. <br><b>Note:</b> This directory should be automatically created, if not, do so manually and chmod it to 777', 333, 33, '2006-09-28 11:11:58', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '使用404 Response(如果沒有圖片)', 'CFG_USE_404', 'True', 'If set to true a 404 (not found) response will be sent (broken image), otherwise a small error picture will be shown', 333, 36, '2006-09-28 11:12:44', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '允許縮圖大於原圖片', 'CFG_ALLOW_LARGER', 'True', 'Set to true if you want to allow scaling UP of source image files.', 333, 45, '2006-09-28 11:13:38', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '縮圖如果大於原圖則置中', 'CFG_CENTER_THUMB', 'True', 'If your source is smaller than the thumbnail, should it be centered on the larger thumbnail rather than resized?<br><b>Note:</b> ''Allow thumbnails larger than original'' (above) must be set to true', 333, 46, '2006-09-28 11:15:04', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', 'JPEG Quality - Pop-up圖片', 'POPUP_JPEG_QUALITY', '100', 'The output quality of JPEG pop-up images.', 333, 48, '2006-09-28 11:15:37', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'JPEG Quality - Product Info縮圖', 'PRODUCT_JPEG_QUALITY', '100', 'The output quality of JPEG thumbnails displayed on your product information page', 333, 51, '2006-09-28 11:15:52', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'JPEG Quality - Category縮圖', 'CATEGORY_JPEG_QUALITY', '100', 'The output quality of category JPEG thumbnails', 333, 52, '2006-09-28 11:16:06', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'JPEG Quality - Heading縮圖', 'HEADING_JPEG_QUALITY', '100', 'The output quality of heading JPEG thumbnails', 333, 53, '2006-09-28 11:16:28', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'JPEG Quality - 小縮圖', 'SMALL_JPEG_QUALITY', '100', 'The output quality of your small sized JPEG thumbnails', 333, 55, '2006-09-28 11:21:15', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '植入Watermark - Pop-up圖片', 'USE_WATERMARK_IMAGE_POPUP', 'No', 'Do you wish to use a watermark image in your pop-up product image?<br><b>Note:</b>Graphic Watermarks will NOT be added to GIF images', 333, 57, '2006-09-28 11:20:13', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '植入Watermark - Product Info縮圖', 'USE_WATERMARK_IMAGE_PRODUCT', 'No', 'Do you wish to use a watermark image in your product information thumbnails?<br><b>Note:</b>Graphic Watermarks will NOT be added to GIF images', 333, 58, '2006-09-28 11:20:24', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '植入Watermark -Category縮圖', 'USE_WATERMARK_IMAGE_CATEGORY', 'No', 'Do you wish to use a watermark image in your category thumbnails?<br><b>Note:</b>Graphic Watermarks will NOT be added to GIF images', 333, 59, '2006-09-28 11:19:36', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '植入Watermark - Heading縮圖', 'USE_WATERMARK_IMAGE_HEADING', 'No', 'Do you wish to use a watermark image in your heading thumbnails?<br><b>Note:</b>Graphic Watermarks will NOT be added to GIF images', 333, 60, '2006-09-28 11:20:00', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '植入Watermark - 小縮圖', 'USE_WATERMARK_IMAGE_SMALL', 'No', 'Do you wish to use a watermark image in your small thumbnails<br><b>Note:</b>Graphic Watermarks will NOT be added to GIF images?', 333, 61, '2006-09-28 11:21:03', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', 'Watermark 圖片檔名', 'WATERMARK_IMAGE', '', '選擇要植入watermark 的圖片檔名<br><br>新的 watermark圖片儲存在:<br><b>/catalog/includes/imagemagic/watermarks/</b><br>directory<br>', 333, 66, '2006-09-28 11:23:15', '2005-01-06 20:24:30', '', 'tep_cfg_pull_down_installed_watermarks(');
INSERT INTO configuration VALUES ('', 'Watermark 圖片透明度', 'WATERMARK_IMAGE_OPACITY', '20', '數值介於0 - 100 to 之間 (0=transparent, 100=opaque)', 333, 69, '2006-09-28 11:25:43', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'Watermark 圖片植入位置', 'WATERMARK_IMAGE_POSITION', 'Top', 'Select where you would like your watermark image to be positioned on your thumbnail', 333, 71, '2006-09-28 11:25:28', '2005-01-06 20:24:30', '', 'tep_cfg_pull_down_watermark_alignment(');
INSERT INTO configuration VALUES ('', 'Watermark 圖片邊界', 'WATERMARK_IMAGE_MARGIN', '0', 'Enter the offset in pixels where you would like your watermark image to be positioned', 333, 72, '2006-09-28 11:26:51', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'Resize Watermark 圖片', 'CFG_RESIZE_WATERMARK', 'True', 'If selected, your watermark image will be resized in the same ratio as your source image, otherwise the watermark image will always be added full-sized', 333, 73, '2006-09-28 11:28:23', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '文字Watermark - Pop-up圖片', 'USE_WATERMARK_TEXT_POPUP', 'No', 'Do you wish to use watermark text in your pop-up product images?<br><b>Note:</b>Text Watermarks do not work well with GIF images', 333, 75, '2006-09-28 11:29:41', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '文字Watermark - Product Info縮圖', 'USE_WATERMARK_TEXT_PRODUCT', 'No', 'Do you wish to use watermark text in your product information thumbnails?<br><b>Note:</b>Text Watermarks do not work well with GIF images', 333, 76, '2006-09-28 11:30:08', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '文字Watermark - Category縮圖', 'USE_WATERMARK_TEXT_CATEGORY', 'No', 'Do you wish to use watermark text in your category thumbnails?<br><b>Note:</b>Text Watermarks do not work well with GIF images', 333, 77, '2006-09-28 11:30:45', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '文字Watermark - Heading縮圖', 'USE_WATERMARK_TEXT_HEADING', 'No', 'Do you wish to use watermark text in your heading thumbnails?<br><b>Note:</b>Text Watermarks do not work well with GIF images', 333, 78, '2006-09-28 11:31:07', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '文字Watermark - 小縮圖', 'USE_WATERMARK_TEXT_SMALL', 'No', 'Do you wish to use watermark text in your small thumbnails?<br><b>Note:</b>Text Watermarks do not work well with GIF images', 333, 79, '2006-09-28 11:31:42', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', 'Watermark 文字', 'WATERMARK_TEXT', 'Sample', 'Enter the text you wish to appear in your thumbnails as a watermark', 333, 84, '2006-09-28 11:32:15', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '文字Watermark 字型名稱', 'WATERMARK_TEXT_FONT', 'arial.ttf', '選擇watermark文字..要使用的字型檔名<br><br>TTF 字型存放於:<br><b>/catalog/includes/imagemagic/fonts/</b><br>directory<br>', 333, 87, '2006-09-28 11:34:43', '2005-01-06 20:24:30', '', 'tep_cfg_pull_down_installed_fonts(');
INSERT INTO configuration VALUES ('', '文字Watermark 字號大小', 'WATERMARK_TEXT_SIZE', '10', 'Enter the font point size of your text watermark', 333, 90, '2006-09-28 11:35:50', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '文字Watermark 顏色 (HEX)', 'WATERMARK_TEXT_COLOR', '000000', 'Enter the hex value for the colour of your text watermark', 333, 93, '2006-09-28 11:36:16', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '文字Watermark 透明度', 'WATERMARK_TEXT_OPACITY', '20', '透明度數值介於0 - 100 之間(0=transparent, 100=opaque)', 333, 96, '2006-09-28 11:37:27', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '文字Watermark 位置', 'WATERMARK_TEXT_POSITION', 'Top', 'Select where you would like your watermark text to be positioned on your thumbnails', 333, 99, '2006-09-28 11:37:50', '2005-01-06 20:24:30', '', 'tep_cfg_pull_down_watermark_alignment(');
INSERT INTO configuration VALUES ('', '文字Watermark 邊界', 'WATERMARK_TEXT_MARGIN', '0', 'Enter the offset in pixels where you would like your watermark text to be positioned', 333, 102, '2006-09-28 11:38:21', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '文字Watermark 角度', 'WATERMARK_TEXT_ANGLE', '0', 'Enter the counter-clockwise angle of the text watermark', 333, 105, '2006-09-28 11:39:09', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '自動調整亮度', 'BRIGHTNESS_ADJUST', '0', 'Enter an amount between -255 and 255 which your thumbnail brightness will be adjusted by<br><b>Note:</b> This will not work with GIF images', 333, 108, '2006-09-28 11:40:00', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '自動調整對比', 'CONTRAST_ADJUST', '0', 'Enter an amount between -255 and 255 which your thumbnail contrast will be adjusted by<br><b>Note:</b> This will not work with GIF images', 333, 111, '2006-09-28 11:40:25', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '加框 - Pop-up圖片', 'FRAME_POPUP', 'No', 'Do you want to include a frame around your pop-up product images?', 333, 114, '2006-09-28 11:41:54', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '加框 - Product Info縮圖', 'FRAME_PRODUCT', 'No', 'Do you want to include a frame around your product information thumbnails?', 333, 115, '2006-09-28 11:41:35', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '加框 - Category縮圖', 'FRAME_CATEGORY', 'No', 'Do you want to include a frame around your category thumbnails?', 333, 116, '2006-09-28 11:42:18', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '加框 - Heading縮圖', 'FRAME_HEADING', 'No', 'Do you want to include a frame around your heading thumbnails?', 333, 117, '2006-09-28 11:42:43', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '加框 - 小縮圖', 'FRAME_SMALL', 'No', 'Do you want to include a frame around your small thumbnails?', 333, 118, '2006-09-28 11:43:05', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '邊框 - 寬度', 'FRAME_WIDTH', '4', 'Enter the width in pixels of the thumbnail frame', 333, 120, '2006-09-28 11:43:34', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '邊框 - 深度', 'FRAME_EDGE_WIDTH', '4', 'Enter the 3D depth of the frame in pixels', 333, 123, '2006-09-28 11:43:52', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '邊框 - 色彩 (HEX)', 'FRAME_COLOR', 'CCCCCC', 'Enter the HEX colour of the thumbnail frame', 333, 126, '2006-09-28 11:44:06', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '邊框 - 3D 高亮度顏色 (HEX)', 'FRAME_INSIDE_COLOR1', 'FFFFFF', 'Enter the colour (in hex) you wish the frame''s inside higlight colour to be', 333, 129, '2006-09-28 11:45:11', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '邊框 - 3D 陰影顏色(HEX)', 'FRAME_INSIDE_COLOR2', '000000', 'Enter the colour (in hex) you wish the frame''s inside shadow colour to be', 333, 132, '2006-09-28 11:45:49', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '按鈕化 Pop-up圖片', 'BEVEL_POPUP', 'No', 'Do you want to add a 3D button effect to your pop-up images?', 333, 133, '2006-09-28 11:51:21', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '按鈕化 Product Info縮圖', 'BEVEL_PRODUCT', 'No', 'Do you want to add a 3D button effect to your product information thumbnails?', 333, 134, '2006-09-28 11:50:42', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '按鈕化 Category縮圖', 'BEVEL_CATEGORY', 'No', 'Do you want to add a 3D button effect to your category thumbnails?', 333, 135, '2006-09-28 11:51:07', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '按鈕化 Heading縮圖', 'BEVEL_HEADING', 'No', 'Do you want to add a 3D button effect to your heading thumbnails?', 333, 136, '2006-09-28 11:51:38', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '按鈕化 Small縮圖', 'BEVEL_SMALL', 'No', 'Do you want to add a 3D button effect to your small thumbnails?', 333, 137, '2006-09-28 11:52:01', '2005-01-06 20:24:30', '', 'tep_cfg_select_option(array(''Yes'', ''No''),');
INSERT INTO configuration VALUES ('', '按鈕高度', 'BEVEL_HEIGHT', '4', 'Enter the height in pixels of the 3D button effect', 333, 144, '2006-09-28 11:52:47', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '按鈕高亮度色彩 (HEX)', 'BEVEL_HIGHLIGHT', 'CCCCCC', 'Enter the colour (in hex) you wish the button''s higlight colour to be', 333, 147, '2006-09-28 11:53:29', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', '按鈕陰影顏色 (HEX)', 'BEVEL_SHADOW', '000000', 'Enter the colour (in hex) you wish the button''s shadow colour to be', 333, 150, '2006-09-28 11:53:58', '2005-01-06 20:24:30', '', '');
INSERT INTO configuration VALUES ('', 'Last Hash (System Use - Read Only)', 'LAST_HASH', 'bf5c2243e70c1b5ffa07fc5596079452', 'Stores the last hash value of the thumbnail configuration settings.  This will allow the script to detect when they have changed and maintain the cache.', 333, 153, NULL, '2005-01-06 20:24:30', NULL, 'tep_cfg_readonly(');

INSERT INTO configuration VALUES ('', 'Show 訪客網站', 'VWS_SHOW_VISITOR_HOST', 'true', 'Set to true to display the hostname under the visitor ip', 700, 0, NULL, '2006-11-02 16:32:40', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Show訪客國旗', 'VWS_SHOW_FLAG', 'true', 'Set to true to display the Visitor Country Flag', 700, 0, NULL, '2006-11-02 16:32:40', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '訪客資料儲存天數', 'VWS_TRACE_DAYS', '30', 'Time in days for Visitors Trace Data to be available', 700, 0, NULL, '2006-11-02 16:32:40', '', '');
INSERT INTO configuration VALUES ('', 'Use cookies ?', 'VWS_USE_COOKIES', 'true', 'Use cookies ?', 700, 0, NULL, '2006-11-02 16:32:40', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', 'Initial Chart to show', 'VWS_DEFAULT_REPORT', '2', 'Initial Chart to show', 700, 0, NULL, '2006-11-02 16:32:40', '', '');
INSERT INTO configuration VALUES ('', '使用GD Libray繪圖?', 'VWS_GD_SUPPORT', 'true', 'Use the GD Libray to build graphs ?', 700, 0, NULL, '2006-11-02 16:32:40', '', 'tep_cfg_select_option(array(''true'', ''false''),');
INSERT INTO configuration VALUES ('', '線條背景顏色', 'VWS_LINE_BACKGROUND', 'gray', 'Chose the lines background color', 700, 0, NULL, '2006-11-02 16:32:40', '', '');
INSERT INTO configuration VALUES ('', '繪圖線條背景色', 'VWS_INTERLINE_BACKGROUND', 'gray', 'Chose the lines background color', 700, 0, NULL, '2006-11-02 16:32:40', '', '');
INSERT INTO configuration VALUES ('', 'X軸標題背景色', 'STATISTICS_HEADING_X_BACKGROUND', 'yellow', 'Chose the lines background color', 700, 0, NULL, '2006-11-02 16:32:40', '', '');
INSERT INTO configuration VALUES ('', 'Y軸線條背景色', 'STATISTICS_HEADING_Y_BACKGROUND', 'yellow', 'Chose the lines background color', 700, 0, NULL, '2006-11-02 16:32:40', '', '');

INSERT INTO configuration VALUES ('', 'Ajax搜尋: enabled', 'AJAX_ENHANCED_SEARCH_ACTIVE', 'true', 'Ajax enhanced search<br>(true=enabled false=disabled)', 10020, 1, '2006-07-17 10:49:47', '2006-07-17 10:22:28', NULL, 'tep_cfg_select_option(array(''true'', ''false''), ');
INSERT INTO configuration VALUES ('', 'Ajax搜尋: Search results limit', 'AJAX_ENHANCED_SEARCH_LIMIT', '25', 'Ajax enhanced search: Search results limit', 10020, 2, NULL, '2006-07-17 10:22:28', NULL, '');

INSERT INTO configuration VALUES ('', '<font color=blue>點閱數</font>', 'ENABLE_LINKS_COUNT', 'True', '啟甕連結點閱計數', 10021, 1, '2006-11-10 19:56:54', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=blue>搜尋引擎連結</font>', 'ENABLE_SPIDER_FRIENDLY_LINKS', 'True', '允許 spider 友善連結(建議).', 10021, 2, '2006-11-10 20:40:11', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=blue>連結圖片寬度</font>', 'LINKS_IMAGE_WIDTH', '120', 'Maximum width of the links image.', 10021, 3, '2006-11-10 19:59:09', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=blue>連結圖片高度</font>', 'LINKS_IMAGE_HEIGHT', '60', 'Maximum height of the links image.', 10021, 4, '2006-11-10 19:59:30', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=green>顯示連結圖片</font>', 'LINK_LIST_IMAGE', '1', 'Do you want to display the Link Image?', 10021, 5, '2006-11-10 20:00:30', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=green>顯示連結網址</font>', 'LINK_LIST_URL', '4', 'Do you want to display the Link URL?', 10021, 6, '2006-11-10 20:01:14', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=green>顯示連結網站名稱</font>', 'LINK_LIST_TITLE', '2', 'Do you want to display the Link Title?', 10021, 7, '2006-11-10 20:01:59', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=green>顯示連結網站簡介</font>', 'LINK_LIST_DESCRIPTION', '3', 'Do you want to display the Link Description?', 10021, 8, '2006-11-10 20:02:58', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=green>顯示連結點閱數</font>', 'LINK_LIST_COUNT', '5', 'Do you want to display the Link Click Count?', 10021, 9, '2006-11-10 20:03:50', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=fuchsia>顯示英文連結</font>', 'LINKS_DISPLAY_ENGLISH', 'False', 'Display links in this language in the shop.', 10021, 10, '2006-11-10 20:11:05', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=fuchsia>顯示中文tw連結</font>', 'LINKS_DISPLAY_TCHINESE', 'True', 'Display links in this language in the shop.', 10021, 11, '2006-11-10 20:11:00', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=Brown>以網站名稱連結</font>', 'TITLES_AS_LINKS', 'False', 'Make the links title a link.', 10021, 14, '2006-11-10 20:11:59', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=Brown>顯示分類圖片</font>', 'SHOW_LINKS_CATEGORIES_IMAGE', 'True', 'Display the images for the Links Categories.', 10021, 15, '2006-11-10 20:13:05', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=Brown>以標準格式顯示</font>', 'LINKS_DISPLAY_FORMAT_STANDARD', 'True', '以標準方式顯示 (true) 或以垂直列表顯示 (false).', 10021, 16, '2006-11-11 09:45:13', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=Brown>顯示指定連結</font>', 'LINKS_FEATURED_LINK', 'True', 'Display a randomly selected link.', 10021, 17, '2006-11-10 20:14:07', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=Brown>Display in standard format</font>', 'LINKS_DISPLAY_FORMAT_STANDARD', 'True', '以標準方式顯示 (true) 或以垂直列表顯示 (false).', 10021, 18, '2006-11-11 09:45:31', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '<font color=purple>連結名稱最少字數</font>', 'ENTRY_LINKS_TITLE_MIN_LENGTH', '2', 'Minimum length of link title.', 10021, 19, '2006-11-10 20:20:23', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=purple>連結網址最少字數</font>', 'ENTRY_LINKS_URL_MIN_LENGTH', '10', 'Minimum length of link URL.', 10021, 20, '2006-11-10 20:20:34', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=purple>連結簡介最少字數</font>', 'ENTRY_LINKS_DESCRIPTION_MIN_LENGTH', '10', 'Minimum length of link description.', 10021, 21, '2006-11-10 20:21:08', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=purple>連結簡介最多字數</font>', 'ENTRY_LINKS_DESCRIPTION_MAX_LENGTH', '200', 'Maximum length of link description.', 10021, 22, '2006-11-10 20:19:04', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=purple>連絡人姓名最少字數</font>', 'ENTRY_LINKS_CONTACT_NAME_MIN_LENGTH', '2', 'Minimum length of link contact name.', 10021, 23, '2006-11-10 20:20:12', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '<font color=purple>要顯示之最大連結數</font>', 'MAX_LINKS_DISPLAY', '20', 'How many links should be displayed per page?', 10021, 24, '2006-11-10 20:22:48', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '連結檢查片語', 'LINKS_CHECK_PHRASE', 'www.yago.com.tw', '當你執行連結檢查時.尋找之語。 可以輸入一個以上片語。請用逗號(comma)分開,舉例:片語A, 片語B, 片語C', 10021, 25, '2006-11-10 20:31:07', '2006-11-08 20:21:31', '', '');
INSERT INTO configuration VALUES ('', '編輯時順便檢查連結', 'LINKS_CHECK_ON_EDIT', 'True', 'Check if a reciprocol link is valid when Edit is clicked. This will slow down the loading of the edit page a little.', 10021, 26, '2006-11-10 20:32:02', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '連結時開新視窗', 'LINKS_OPEN_NEW_PAGE', 'True', 'Open links in new page when clicked.', 10021, 27, '2006-11-10 20:33:06', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '必須填寫交換的網址', 'LINKS_RECIPROCAL_REQUIRED', 'True', 'A reciprocal link is required when a link is submitted.', 10021, 28, '2006-11-10 20:37:20', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '檢查重複的連結', 'LINKS_CHECK_DUPLICATE', 'True', 'Check if the submitted link is already on file.', 10021, 29, '2006-11-10 20:34:09', '2006-11-08 20:21:31', '', 'tep_cfg_select_option(array(''True'', ''False''),');
INSERT INTO configuration VALUES ('', '接受的運送模組.', 'MODULE_PAYMENT_FREECHARGER_SHIPPING', 'freecharger', '填入接受的運費模組名稱, 以;隔開(例: zones;table). 空白表示全部接受', 6, 0, NULL, '2006-11-26 17:07:33', NULL, NULL);
INSERT INTO configuration VALUES ('', '每列顯示的目錄數量', 'MAX_DISPLAY_CATEGORIES_PER_ROW', '3', 'How many Link categories to list per row', 10021, 20, '2006-12-10 15:10:49', '2003-07-19 00:52:14', NULL, NULL);


DROP TABLE IF EXISTS configuration_group;
CREATE TABLE configuration_group (
  configuration_group_id int(11) NOT NULL auto_increment,
  configuration_group_title varchar(64) NOT NULL,
  configuration_group_description varchar(255) NOT NULL,
  sort_order int(5) default NULL,
  visible int(1) default '1',
  PRIMARY KEY  (configuration_group_id)
);

INSERT INTO configuration_group VALUES (1, '我的商店', '商店基本資料', 1, 1);
INSERT INTO configuration_group VALUES (2, '最小值設定', '相關欄位/資料 最小值設定', 2, 1);
INSERT INTO configuration_group VALUES (3, '最大值設定', '相關欄位/資料 最大值設定', 3, 1);
INSERT INTO configuration_group VALUES (4, '圖片', '圖片參數', 4, 1);
INSERT INTO configuration_group VALUES (5, '客戶帳號資訊', '客戶帳號設定', 5, 1);
INSERT INTO configuration_group VALUES (6, '模組選項', 'Hidden from configuration', 6, 1);
INSERT INTO configuration_group VALUES (7, '運送/包裝', '運送選項設定', 7, 1);
INSERT INTO configuration_group VALUES (8, '商品列表', '商品列表設定', 8, 1);
INSERT INTO configuration_group VALUES (9, '庫存', '庫存選項設定', 9, 1);
INSERT INTO configuration_group VALUES (10, '登入', '登入選項設定', 10, 1);
INSERT INTO configuration_group VALUES (11, '快取', '快取選項設定', 11, 1);
INSERT INTO configuration_group VALUES (12, '電子郵件選項', '電子郵件設定', 12, 1);
INSERT INTO configuration_group VALUES (13, '下載', '商品下載選項設定', 13, 1);
INSERT INTO configuration_group VALUES (14, 'GZip 壓縮', 'GZip 壓縮選項', 14, 1);
INSERT INTO configuration_group VALUES (15, 'Sessions', 'Session 選項', 15, 1);
INSERT INTO configuration_group VALUES (21, 'WYSIWYG', 'HTML所見即所得編輯器', 23, 1);
INSERT INTO configuration_group VALUES (29, '商品資訊', 'Product info Options', 21, 1);
INSERT INTO configuration_group VALUES (300, '商品快速更新', '使用Quick Updates快速更新商品', 20, 1);
INSERT INTO configuration_group VALUES (22, '紅利點數V1.60', 'Points/Rewards System Configuration', 22, 1);
INSERT INTO configuration_group VALUES (10020, 'Ajax搜尋', 'Ajax enhanced search configuration', 25, 1);
INSERT INTO configuration_group VALUES (333, '圖片魔術師', 'Configuration options for the OSC Image Magic contribution', 16, 1);
INSERT INTO configuration_group VALUES (700, '訪客統計分析', 'Visitor Web Stats', 40, 1);
INSERT INTO configuration_group VALUES (10021, '友好連結', 'Links Manager configuration options', 30, 1);

DROP TABLE IF EXISTS counter;
CREATE TABLE counter (
  startdate char(8) default NULL,
  counter int(12) default NULL
);

DROP TABLE IF EXISTS counter_history;
CREATE TABLE counter_history (
  month char(8) default NULL,
  counter int(12) default NULL
);

DROP TABLE IF EXISTS countries;
CREATE TABLE countries (
  countries_id int(11) NOT NULL auto_increment,
  countries_name varchar(64) NOT NULL,
  countries_iso_code_2 char(2) NOT NULL,
  countries_iso_code_3 char(3) NOT NULL,
  address_format_id int(11) NOT NULL default '0',
  PRIMARY KEY  (countries_id),
  KEY IDX_COUNTRIES_NAME (countries_name)
);

INSERT INTO countries VALUES (1, 'Afghanistan', 'AF', 'AFG', 1);
INSERT INTO countries VALUES (2, 'Albania', 'AL', 'ALB', 1);
INSERT INTO countries VALUES (3, 'Algeria', 'DZ', 'DZA', 1);
INSERT INTO countries VALUES (4, 'American Samoa', 'AS', 'ASM', 1);
INSERT INTO countries VALUES (5, 'Andorra', 'AD', 'AND', 1);
INSERT INTO countries VALUES (6, 'Angola', 'AO', 'AGO', 1);
INSERT INTO countries VALUES (7, 'Anguilla', 'AI', 'AIA', 1);
INSERT INTO countries VALUES (8, 'Antarctica', 'AQ', 'ATA', 1);
INSERT INTO countries VALUES (9, 'Antigua and Barbuda', 'AG', 'ATG', 1);
INSERT INTO countries VALUES (10, 'Argentina', 'AR', 'ARG', 1);
INSERT INTO countries VALUES (11, 'Armenia', 'AM', 'ARM', 1);
INSERT INTO countries VALUES (12, 'Aruba', 'AW', 'ABW', 1);
INSERT INTO countries VALUES (13, 'Australia', 'AU', 'AUS', 1);
INSERT INTO countries VALUES (14, 'Austria', 'AT', 'AUT', 5);
INSERT INTO countries VALUES (15, 'Azerbaijan', 'AZ', 'AZE', 1);
INSERT INTO countries VALUES (16, 'Bahamas', 'BS', 'BHS', 1);
INSERT INTO countries VALUES (17, 'Bahrain', 'BH', 'BHR', 1);
INSERT INTO countries VALUES (18, 'Bangladesh', 'BD', 'BGD', 1);
INSERT INTO countries VALUES (19, 'Barbados', 'BB', 'BRB', 1);
INSERT INTO countries VALUES (20, 'Belarus', 'BY', 'BLR', 1);
INSERT INTO countries VALUES (21, 'Belgium', 'BE', 'BEL', 1);
INSERT INTO countries VALUES (22, 'Belize', 'BZ', 'BLZ', 1);
INSERT INTO countries VALUES (23, 'Benin', 'BJ', 'BEN', 1);
INSERT INTO countries VALUES (24, 'Bermuda', 'BM', 'BMU', 1);
INSERT INTO countries VALUES (25, 'Bhutan', 'BT', 'BTN', 1);
INSERT INTO countries VALUES (26, 'Bolivia', 'BO', 'BOL', 1);
INSERT INTO countries VALUES (27, 'Bosnia and Herzegowina', 'BA', 'BIH', 1);
INSERT INTO countries VALUES (28, 'Botswana', 'BW', 'BWA', 1);
INSERT INTO countries VALUES (29, 'Bouvet Island', 'BV', 'BVT', 1);
INSERT INTO countries VALUES (30, 'Brazil', 'BR', 'BRA', 1);
INSERT INTO countries VALUES (31, 'British Indian Ocean Territory', 'IO', 'IOT', 1);
INSERT INTO countries VALUES (32, 'Brunei Darussalam', 'BN', 'BRN', 1);
INSERT INTO countries VALUES (33, 'Bulgaria', 'BG', 'BGR', 1);
INSERT INTO countries VALUES (34, 'Burkina Faso', 'BF', 'BFA', 1);
INSERT INTO countries VALUES (35, 'Burundi', 'BI', 'BDI', 1);
INSERT INTO countries VALUES (36, 'Cambodia', 'KH', 'KHM', 1);
INSERT INTO countries VALUES (37, 'Cameroon', 'CM', 'CMR', 1);
INSERT INTO countries VALUES (38, 'Canada', 'CA', 'CAN', 1);
INSERT INTO countries VALUES (39, 'Cape Verde', 'CV', 'CPV', 1);
INSERT INTO countries VALUES (40, 'Cayman Islands', 'KY', 'CYM', 1);
INSERT INTO countries VALUES (41, 'Central African Republic', 'CF', 'CAF', 1);
INSERT INTO countries VALUES (42, 'Chad', 'TD', 'TCD', 1);
INSERT INTO countries VALUES (43, 'Chile', 'CL', 'CHL', 1);
INSERT INTO countries VALUES (44, 'China', 'CN', 'CHN', 1);
INSERT INTO countries VALUES (45, 'Christmas Island', 'CX', 'CXR', 1);
INSERT INTO countries VALUES (46, 'Cocos (Keeling) Islands', 'CC', 'CCK', 1);
INSERT INTO countries VALUES (47, 'Colombia', 'CO', 'COL', 1);
INSERT INTO countries VALUES (48, 'Comoros', 'KM', 'COM', 1);
INSERT INTO countries VALUES (49, 'Congo', 'CG', 'COG', 1);
INSERT INTO countries VALUES (50, 'Cook Islands', 'CK', 'COK', 1);
INSERT INTO countries VALUES (51, 'Costa Rica', 'CR', 'CRI', 1);
INSERT INTO countries VALUES (52, 'Cote D''Ivoire', 'CI', 'CIV', 1);
INSERT INTO countries VALUES (53, 'Croatia', 'HR', 'HRV', 1);
INSERT INTO countries VALUES (54, 'Cuba', 'CU', 'CUB', 1);
INSERT INTO countries VALUES (55, 'Cyprus', 'CY', 'CYP', 1);
INSERT INTO countries VALUES (56, 'Czech Republic', 'CZ', 'CZE', 1);
INSERT INTO countries VALUES (57, 'Denmark', 'DK', 'DNK', 1);
INSERT INTO countries VALUES (58, 'Djibouti', 'DJ', 'DJI', 1);
INSERT INTO countries VALUES (59, 'Dominica', 'DM', 'DMA', 1);
INSERT INTO countries VALUES (60, 'Dominican Republic', 'DO', 'DOM', 1);
INSERT INTO countries VALUES (61, 'East Timor', 'TP', 'TMP', 1);
INSERT INTO countries VALUES (62, 'Ecuador', 'EC', 'ECU', 1);
INSERT INTO countries VALUES (63, 'Egypt', 'EG', 'EGY', 1);
INSERT INTO countries VALUES (64, 'El Salvador', 'SV', 'SLV', 1);
INSERT INTO countries VALUES (65, 'Equatorial Guinea', 'GQ', 'GNQ', 1);
INSERT INTO countries VALUES (66, 'Eritrea', 'ER', 'ERI', 1);
INSERT INTO countries VALUES (67, 'Estonia', 'EE', 'EST', 1);
INSERT INTO countries VALUES (68, 'Ethiopia', 'ET', 'ETH', 1);
INSERT INTO countries VALUES (69, 'Falkland Islands (Malvinas)', 'FK', 'FLK', 1);
INSERT INTO countries VALUES (70, 'Faroe Islands', 'FO', 'FRO', 1);
INSERT INTO countries VALUES (71, 'Fiji', 'FJ', 'FJI', 1);
INSERT INTO countries VALUES (72, 'Finland', 'FI', 'FIN', 1);
INSERT INTO countries VALUES (73, 'France', 'FR', 'FRA', 1);
INSERT INTO countries VALUES (74, 'France, Metropolitan', 'FX', 'FXX', 1);
INSERT INTO countries VALUES (75, 'French Guiana', 'GF', 'GUF', 1);
INSERT INTO countries VALUES (76, 'French Polynesia', 'PF', 'PYF', 1);
INSERT INTO countries VALUES (77, 'French Southern Territories', 'TF', 'ATF', 1);
INSERT INTO countries VALUES (78, 'Gabon', 'GA', 'GAB', 1);
INSERT INTO countries VALUES (79, 'Gambia', 'GM', 'GMB', 1);
INSERT INTO countries VALUES (80, 'Georgia', 'GE', 'GEO', 1);
INSERT INTO countries VALUES (81, 'Germany', 'DE', 'DEU', 5);
INSERT INTO countries VALUES (82, 'Ghana', 'GH', 'GHA', 1);
INSERT INTO countries VALUES (83, 'Gibraltar', 'GI', 'GIB', 1);
INSERT INTO countries VALUES (84, 'Greece', 'GR', 'GRC', 1);
INSERT INTO countries VALUES (85, 'Greenland', 'GL', 'GRL', 1);
INSERT INTO countries VALUES (86, 'Grenada', 'GD', 'GRD', 1);
INSERT INTO countries VALUES (87, 'Guadeloupe', 'GP', 'GLP', 1);
INSERT INTO countries VALUES (88, 'Guam', 'GU', 'GUM', 1);
INSERT INTO countries VALUES (89, 'Guatemala', 'GT', 'GTM', 1);
INSERT INTO countries VALUES (90, 'Guinea', 'GN', 'GIN', 1);
INSERT INTO countries VALUES (91, 'Guinea-bissau', 'GW', 'GNB', 1);
INSERT INTO countries VALUES (92, 'Guyana', 'GY', 'GUY', 1);
INSERT INTO countries VALUES (93, 'Haiti', 'HT', 'HTI', 1);
INSERT INTO countries VALUES (94, 'Heard and Mc Donald Islands', 'HM', 'HMD', 1);
INSERT INTO countries VALUES (95, 'Honduras', 'HN', 'HND', 1);
INSERT INTO countries VALUES (96, 'Hong Kong', 'HK', 'HKG', 1);
INSERT INTO countries VALUES (97, 'Hungary', 'HU', 'HUN', 1);
INSERT INTO countries VALUES (98, 'Iceland', 'IS', 'ISL', 1);
INSERT INTO countries VALUES (99, 'India', 'IN', 'IND', 1);
INSERT INTO countries VALUES (100, 'Indonesia', 'ID', 'IDN', 1);
INSERT INTO countries VALUES (101, 'Iran (Islamic Republic of)', 'IR', 'IRN', 1);
INSERT INTO countries VALUES (102, 'Iraq', 'IQ', 'IRQ', 1);
INSERT INTO countries VALUES (103, 'Ireland', 'IE', 'IRL', 1);
INSERT INTO countries VALUES (104, 'Israel', 'IL', 'ISR', 1);
INSERT INTO countries VALUES (105, 'Italy', 'IT', 'ITA', 1);
INSERT INTO countries VALUES (106, 'Jamaica', 'JM', 'JAM', 1);
INSERT INTO countries VALUES (107, 'Japan', 'JP', 'JPN', 1);
INSERT INTO countries VALUES (108, 'Jordan', 'JO', 'JOR', 1);
INSERT INTO countries VALUES (109, 'Kazakhstan', 'KZ', 'KAZ', 1);
INSERT INTO countries VALUES (110, 'Kenya', 'KE', 'KEN', 1);
INSERT INTO countries VALUES (111, 'Kiribati', 'KI', 'KIR', 1);
INSERT INTO countries VALUES (112, 'Korea, Democratic People''s Republic of', 'KP', 'PRK', 1);
INSERT INTO countries VALUES (113, 'Korea, Republic of', 'KR', 'KOR', 1);
INSERT INTO countries VALUES (114, 'Kuwait', 'KW', 'KWT', 1);
INSERT INTO countries VALUES (115, 'Kyrgyzstan', 'KG', 'KGZ', 1);
INSERT INTO countries VALUES (116, 'Lao People''s Democratic Republic', 'LA', 'LAO', 1);
INSERT INTO countries VALUES (117, 'Latvia', 'LV', 'LVA', 1);
INSERT INTO countries VALUES (118, 'Lebanon', 'LB', 'LBN', 1);
INSERT INTO countries VALUES (119, 'Lesotho', 'LS', 'LSO', 1);
INSERT INTO countries VALUES (120, 'Liberia', 'LR', 'LBR', 1);
INSERT INTO countries VALUES (121, 'Libyan Arab Jamahiriya', 'LY', 'LBY', 1);
INSERT INTO countries VALUES (122, 'Liechtenstein', 'LI', 'LIE', 1);
INSERT INTO countries VALUES (123, 'Lithuania', 'LT', 'LTU', 1);
INSERT INTO countries VALUES (124, 'Luxembourg', 'LU', 'LUX', 1);
INSERT INTO countries VALUES (125, 'Macau', 'MO', 'MAC', 1);
INSERT INTO countries VALUES (126, 'Macedonia, The Former Yugoslav Republic of', 'MK', 'MKD', 1);
INSERT INTO countries VALUES (127, 'Madagascar', 'MG', 'MDG', 1);
INSERT INTO countries VALUES (128, 'Malawi', 'MW', 'MWI', 1);
INSERT INTO countries VALUES (129, 'Malaysia', 'MY', 'MYS', 1);
INSERT INTO countries VALUES (130, 'Maldives', 'MV', 'MDV', 1);
INSERT INTO countries VALUES (131, 'Mali', 'ML', 'MLI', 1);
INSERT INTO countries VALUES (132, 'Malta', 'MT', 'MLT', 1);
INSERT INTO countries VALUES (133, 'Marshall Islands', 'MH', 'MHL', 1);
INSERT INTO countries VALUES (134, 'Martinique', 'MQ', 'MTQ', 1);
INSERT INTO countries VALUES (135, 'Mauritania', 'MR', 'MRT', 1);
INSERT INTO countries VALUES (136, 'Mauritius', 'MU', 'MUS', 1);
INSERT INTO countries VALUES (137, 'Mayotte', 'YT', 'MYT', 1);
INSERT INTO countries VALUES (138, 'Mexico', 'MX', 'MEX', 1);
INSERT INTO countries VALUES (139, 'Micronesia, Federated States of', 'FM', 'FSM', 1);
INSERT INTO countries VALUES (140, 'Moldova, Republic of', 'MD', 'MDA', 1);
INSERT INTO countries VALUES (141, 'Monaco', 'MC', 'MCO', 1);
INSERT INTO countries VALUES (142, 'Mongolia', 'MN', 'MNG', 1);
INSERT INTO countries VALUES (143, 'Montserrat', 'MS', 'MSR', 1);
INSERT INTO countries VALUES (144, 'Morocco', 'MA', 'MAR', 1);
INSERT INTO countries VALUES (145, 'Mozambique', 'MZ', 'MOZ', 1);
INSERT INTO countries VALUES (146, 'Myanmar', 'MM', 'MMR', 1);
INSERT INTO countries VALUES (147, 'Namibia', 'NA', 'NAM', 1);
INSERT INTO countries VALUES (148, 'Nauru', 'NR', 'NRU', 1);
INSERT INTO countries VALUES (149, 'Nepal', 'NP', 'NPL', 1);
INSERT INTO countries VALUES (150, 'Netherlands', 'NL', 'NLD', 1);
INSERT INTO countries VALUES (151, 'Netherlands Antilles', 'AN', 'ANT', 1);
INSERT INTO countries VALUES (152, 'New Caledonia', 'NC', 'NCL', 1);
INSERT INTO countries VALUES (153, 'New Zealand', 'NZ', 'NZL', 1);
INSERT INTO countries VALUES (154, 'Nicaragua', 'NI', 'NIC', 1);
INSERT INTO countries VALUES (155, 'Niger', 'NE', 'NER', 1);
INSERT INTO countries VALUES (156, 'Nigeria', 'NG', 'NGA', 1);
INSERT INTO countries VALUES (157, 'Niue', 'NU', 'NIU', 1);
INSERT INTO countries VALUES (158, 'Norfolk Island', 'NF', 'NFK', 1);
INSERT INTO countries VALUES (159, 'Northern Mariana Islands', 'MP', 'MNP', 1);
INSERT INTO countries VALUES (160, 'Norway', 'NO', 'NOR', 1);
INSERT INTO countries VALUES (161, 'Oman', 'OM', 'OMN', 1);
INSERT INTO countries VALUES (162, 'Pakistan', 'PK', 'PAK', 1);
INSERT INTO countries VALUES (163, 'Palau', 'PW', 'PLW', 1);
INSERT INTO countries VALUES (164, 'Panama', 'PA', 'PAN', 1);
INSERT INTO countries VALUES (165, 'Papua New Guinea', 'PG', 'PNG', 1);
INSERT INTO countries VALUES (166, 'Paraguay', 'PY', 'PRY', 1);
INSERT INTO countries VALUES (167, 'Peru', 'PE', 'PER', 1);
INSERT INTO countries VALUES (168, 'Philippines', 'PH', 'PHL', 1);
INSERT INTO countries VALUES (169, 'Pitcairn', 'PN', 'PCN', 1);
INSERT INTO countries VALUES (170, 'Poland', 'PL', 'POL', 1);
INSERT INTO countries VALUES (171, 'Portugal', 'PT', 'PRT', 1);
INSERT INTO countries VALUES (172, 'Puerto Rico', 'PR', 'PRI', 1);
INSERT INTO countries VALUES (173, 'Qatar', 'QA', 'QAT', 1);
INSERT INTO countries VALUES (174, 'Reunion', 'RE', 'REU', 1);
INSERT INTO countries VALUES (175, 'Romania', 'RO', 'ROM', 1);
INSERT INTO countries VALUES (176, 'Russian Federation', 'RU', 'RUS', 1);
INSERT INTO countries VALUES (177, 'Rwanda', 'RW', 'RWA', 1);
INSERT INTO countries VALUES (178, 'Saint Kitts and Nevis', 'KN', 'KNA', 1);
INSERT INTO countries VALUES (179, 'Saint Lucia', 'LC', 'LCA', 1);
INSERT INTO countries VALUES (180, 'Saint Vincent and the Grenadines', 'VC', 'VCT', 1);
INSERT INTO countries VALUES (181, 'Samoa', 'WS', 'WSM', 1);
INSERT INTO countries VALUES (182, 'San Marino', 'SM', 'SMR', 1);
INSERT INTO countries VALUES (183, 'Sao Tome and Principe', 'ST', 'STP', 1);
INSERT INTO countries VALUES (184, 'Saudi Arabia', 'SA', 'SAU', 1);
INSERT INTO countries VALUES (185, 'Senegal', 'SN', 'SEN', 1);
INSERT INTO countries VALUES (186, 'Seychelles', 'SC', 'SYC', 1);
INSERT INTO countries VALUES (187, 'Sierra Leone', 'SL', 'SLE', 1);
INSERT INTO countries VALUES (188, 'Singapore', 'SG', 'SGP', 4);
INSERT INTO countries VALUES (189, 'Slovakia (Slovak Republic)', 'SK', 'SVK', 1);
INSERT INTO countries VALUES (190, 'Slovenia', 'SI', 'SVN', 1);
INSERT INTO countries VALUES (191, 'Solomon Islands', 'SB', 'SLB', 1);
INSERT INTO countries VALUES (192, 'Somalia', 'SO', 'SOM', 1);
INSERT INTO countries VALUES (193, 'South Africa', 'ZA', 'ZAF', 1);
INSERT INTO countries VALUES (194, 'South Georgia and the South Sandwich Islands', 'GS', 'SGS', 1);
INSERT INTO countries VALUES (195, 'Spain', 'ES', 'ESP', 3);
INSERT INTO countries VALUES (196, 'Sri Lanka', 'LK', 'LKA', 1);
INSERT INTO countries VALUES (197, 'St. Helena', 'SH', 'SHN', 1);
INSERT INTO countries VALUES (198, 'St. Pierre and Miquelon', 'PM', 'SPM', 1);
INSERT INTO countries VALUES (199, 'Sudan', 'SD', 'SDN', 1);
INSERT INTO countries VALUES (200, 'Suriname', 'SR', 'SUR', 1);
INSERT INTO countries VALUES (201, 'Svalbard and Jan Mayen Islands', 'SJ', 'SJM', 1);
INSERT INTO countries VALUES (202, 'Swaziland', 'SZ', 'SWZ', 1);
INSERT INTO countries VALUES (203, 'Sweden', 'SE', 'SWE', 1);
INSERT INTO countries VALUES (204, 'Switzerland', 'CH', 'CHE', 1);
INSERT INTO countries VALUES (205, 'Syrian Arab Republic', 'SY', 'SYR', 1);
INSERT INTO countries VALUES (206, '台灣', 'TW', 'TWN', 1);
INSERT INTO countries VALUES (207, 'Tajikistan', 'TJ', 'TJK', 1);
INSERT INTO countries VALUES (208, 'Tanzania, United Republic of', 'TZ', 'TZA', 1);
INSERT INTO countries VALUES (209, 'Thailand', 'TH', 'THA', 1);
INSERT INTO countries VALUES (210, 'Togo', 'TG', 'TGO', 1);
INSERT INTO countries VALUES (211, 'Tokelau', 'TK', 'TKL', 1);
INSERT INTO countries VALUES (212, 'Tonga', 'TO', 'TON', 1);
INSERT INTO countries VALUES (213, 'Trinidad and Tobago', 'TT', 'TTO', 1);
INSERT INTO countries VALUES (214, 'Tunisia', 'TN', 'TUN', 1);
INSERT INTO countries VALUES (215, 'Turkey', 'TR', 'TUR', 1);
INSERT INTO countries VALUES (216, 'Turkmenistan', 'TM', 'TKM', 1);
INSERT INTO countries VALUES (217, 'Turks and Caicos Islands', 'TC', 'TCA', 1);
INSERT INTO countries VALUES (218, 'Tuvalu', 'TV', 'TUV', 1);
INSERT INTO countries VALUES (219, 'Uganda', 'UG', 'UGA', 1);
INSERT INTO countries VALUES (220, 'Ukraine', 'UA', 'UKR', 1);
INSERT INTO countries VALUES (221, 'United Arab Emirates', 'AE', 'ARE', 1);
INSERT INTO countries VALUES (222, 'United Kingdom', 'GB', 'GBR', 1);
INSERT INTO countries VALUES (223, 'United States', 'US', 'USA', 2);
INSERT INTO countries VALUES (224, 'United States Minor Outlying Islands', 'UM', 'UMI', 1);
INSERT INTO countries VALUES (225, 'Uruguay', 'UY', 'URY', 1);
INSERT INTO countries VALUES (226, 'Uzbekistan', 'UZ', 'UZB', 1);
INSERT INTO countries VALUES (227, 'Vanuatu', 'VU', 'VUT', 1);
INSERT INTO countries VALUES (228, 'Vatican City State (Holy See)', 'VA', 'VAT', 1);
INSERT INTO countries VALUES (229, 'Venezuela', 'VE', 'VEN', 1);
INSERT INTO countries VALUES (230, 'Viet Nam', 'VN', 'VNM', 1);
INSERT INTO countries VALUES (231, 'Virgin Islands (British)', 'VG', 'VGB', 1);
INSERT INTO countries VALUES (232, 'Virgin Islands (U.S.)', 'VI', 'VIR', 1);
INSERT INTO countries VALUES (233, 'Wallis and Futuna Islands', 'WF', 'WLF', 1);
INSERT INTO countries VALUES (234, 'Western Sahara', 'EH', 'ESH', 1);
INSERT INTO countries VALUES (235, 'Yemen', 'YE', 'YEM', 1);
INSERT INTO countries VALUES (236, 'Yugoslavia', 'YU', 'YUG', 1);
INSERT INTO countries VALUES (237, 'Zaire', 'ZR', 'ZAR', 1);
INSERT INTO countries VALUES (238, 'Zambia', 'ZM', 'ZMB', 1);
INSERT INTO countries VALUES (239, 'Zimbabwe', 'ZW', 'ZWE', 1);

DROP TABLE IF EXISTS coupon_email_track;
CREATE TABLE coupon_email_track (
  unique_id int(11) NOT NULL auto_increment,
  coupon_id int(11) NOT NULL default '0',
  customer_id_sent int(11) NOT NULL default '0',
  sent_firstname varchar(32) default NULL,
  sent_lastname varchar(32) default NULL,
  emailed_to varchar(32) default NULL,
  date_sent datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (unique_id)
);

DROP TABLE IF EXISTS coupon_gv_customer;
CREATE TABLE coupon_gv_customer (
  customer_id int(5) NOT NULL default '0',
  amount decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (customer_id),
  KEY customer_id (customer_id)
);

DROP TABLE IF EXISTS coupon_gv_queue;
CREATE TABLE coupon_gv_queue (
  unique_id int(5) NOT NULL auto_increment,
  customer_id int(5) NOT NULL default '0',
  order_id int(5) NOT NULL default '0',
  amount decimal(8,4) NOT NULL default '0.0000',
  date_created datetime NOT NULL default '0000-00-00 00:00:00',
  ipaddr varchar(32) NOT NULL,
  release_flag char(1) NOT NULL default 'N',
  PRIMARY KEY  (unique_id),
  KEY uid (unique_id,customer_id,order_id)
);

DROP TABLE IF EXISTS coupon_redeem_track;
CREATE TABLE coupon_redeem_track (
  unique_id int(11) NOT NULL auto_increment,
  coupon_id int(11) NOT NULL default '0',
  customer_id int(11) NOT NULL default '0',
  redeem_date datetime NOT NULL default '0000-00-00 00:00:00',
  redeem_ip varchar(32) NOT NULL,
  order_id int(11) NOT NULL default '0',
  PRIMARY KEY  (unique_id)
);

DROP TABLE IF EXISTS coupons;
CREATE TABLE coupons (
  coupon_id int(11) NOT NULL auto_increment,
  coupon_type char(1) NOT NULL default 'F',
  coupon_code varchar(32) NOT NULL,
  coupon_amount decimal(8,4) NOT NULL default '0.0000',
  coupon_minimum_order decimal(8,4) NOT NULL default '0.0000',
  coupon_start_date datetime NOT NULL default '0000-00-00 00:00:00',
  coupon_expire_date datetime NOT NULL default '0000-00-00 00:00:00',
  uses_per_coupon int(5) NOT NULL default '1',
  uses_per_user int(5) NOT NULL default '0',
  restrict_to_products varchar(255) default NULL,
  restrict_to_categories varchar(255) default NULL,
  restrict_to_customers text,
  coupon_active char(1) NOT NULL default 'Y',
  date_created datetime NOT NULL default '0000-00-00 00:00:00',
  date_modified datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (coupon_id)
);

DROP TABLE IF EXISTS coupons_description;
CREATE TABLE coupons_description (
  coupon_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '0',
  coupon_name varchar(32) NOT NULL,
  coupon_description text,
  KEY coupon_id (coupon_id)
);

DROP TABLE IF EXISTS currencies;
CREATE TABLE currencies (
  currencies_id int(11) NOT NULL auto_increment,
  title varchar(32) NOT NULL,
  code char(3) NOT NULL,
  symbol_left varchar(12) default NULL,
  symbol_right varchar(12) default NULL,
  decimal_point char(1) default NULL,
  thousands_point char(1) default NULL,
  decimal_places char(1) default NULL,
  value float(13,8) default NULL,
  last_updated datetime default NULL,
  PRIMARY KEY  (currencies_id)
);

INSERT INTO currencies VALUES (1, 'US Dollar', 'USD', '$', '', '.', ',', '2', 0.03083000, '2006-02-25 14:47:59');
INSERT INTO currencies VALUES (2, 'Euro', 'EUR', '', 'EUR', '.', ',', '2', 0.02589000, '2006-02-25 14:48:01');
INSERT INTO currencies VALUES (3, 'Spanish Peseta', 'ESP', '', 'Pts', '.', ',', '0', 4.31035995, '2006-02-25 14:48:05');
INSERT INTO currencies VALUES (4, '新台幣', 'TWD', 'NT$', '', '.', ',', '1', 1.00000000, '2006-02-25 14:48:05');

DROP TABLE IF EXISTS customers;
CREATE TABLE customers (
  customers_id int(11) NOT NULL auto_increment,
  customers_username varchar(32) NOT NULL,
  customers_gender char(1) NOT NULL,
  customers_firstname varchar(32) NOT NULL,
  customers_lastname varchar(32) NOT NULL,
  customers_dob datetime NOT NULL default '0000-00-00 00:00:00',
  customers_email_address varchar(96) NOT NULL,
  customers_default_address_id int(11) default NULL,
  customers_telephone varchar(32) NOT NULL,
  customers_fax varchar(32) default NULL,
  customers_password varchar(40) NOT NULL,
  customers_newsletter char(1) default NULL,
  customers_group_id int(11) NOT NULL default '0',
  member_level int(5) NOT NULL default '0',
  customers_account_balance decimal(5,2) default NULL,
  customers_group_ra enum('0','1') NOT NULL default '0',
  customers_payment_allowed varchar(255) NOT NULL,
  customers_shipment_allowed varchar(255) NOT NULL,
  confirm int(1) NOT NULL default '0',
  customers_shopping_points decimal(15,2) NOT NULL default '0.00',
  PRIMARY KEY  (customers_id)
);

DROP TABLE IF EXISTS customers_balance_history;
CREATE TABLE customers_balance_history (
  orders_id int(11) NOT NULL default '0',
  customers_id int(11) NOT NULL default '0',
  customers_firstname char(20) default NULL,
  customers_lastname char(20) default NULL,
  date_customers_balance datetime NOT NULL default '0000-00-00 00:00:00',
  amount_customer_balance decimal(15,4) default '0.0000',
  type_customer_balance char(20) default NULL,
  desc_customer_balance char(64) default NULL
);

DROP TABLE IF EXISTS customers_basket;
CREATE TABLE customers_basket (
  customers_basket_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  products_id tinytext NOT NULL,
  customers_basket_quantity int(2) NOT NULL default '0',
  final_price decimal(15,4) default NULL,
  customers_basket_date_added varchar(8) default NULL,
  PRIMARY KEY  (customers_basket_id)
);

DROP TABLE IF EXISTS customers_basket_attributes;
CREATE TABLE customers_basket_attributes (
  customers_basket_attributes_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  products_id tinytext NOT NULL,
  products_options_id int(11) NOT NULL default '0',
  products_options_value_id int(11) NOT NULL default '0',
  products_options_value_text text,
  PRIMARY KEY  (customers_basket_attributes_id)
);

DROP TABLE IF EXISTS customers_groups;
CREATE TABLE customers_groups (
  customers_group_id smallint(5) unsigned NOT NULL default '0',
  customers_group_name varchar(32) NOT NULL,
  customers_group_discount decimal(11,2) NOT NULL default '0.00',
  color_bar varchar(8) NOT NULL default '#FFFFFF',
  group_payment_unallowed varchar(255) NOT NULL default 'cc',
  group_tax varchar(5) NOT NULL default 'false',
  group_shipping_unallowed varchar(255) NOT NULL default 'flat',
  customers_group_show_tax enum('1','0') NOT NULL default '1',
  customers_group_tax_exempt enum('0','1') NOT NULL default '0',
  group_payment_allowed varchar(255) NOT NULL,
  group_shipment_allowed varchar(255) NOT NULL,
  PRIMARY KEY  (customers_group_id)
);

INSERT INTO customers_groups VALUES (0, '新會員', 0.00, '#EEEEEE', '', '1', '', '1', '', '', '');
INSERT INTO customers_groups VALUES (1, '會員', 10.00, '#FFFFFF', '', '1', '', '1', '0', '', '');

DROP TABLE IF EXISTS customers_info;
CREATE TABLE customers_info (
  customers_info_id int(11) NOT NULL default '0',
  customers_info_date_of_last_logon datetime default NULL,
  customers_info_number_of_logons int(5) default NULL,
  customers_info_date_account_created datetime default NULL,
  customers_info_date_account_last_modified datetime default NULL,
  global_product_notifications int(1) default '0',
  PRIMARY KEY  (customers_info_id)
);

DROP TABLE IF EXISTS customers_points_pending;
CREATE TABLE customers_points_pending (
  unique_id int(11) NOT NULL auto_increment,
  customer_id int(11) NOT NULL default '0',
  orders_id int(11) NOT NULL default '0',
  points_pending decimal(15,2) NOT NULL default '0.00',
  comment varchar(200) default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  status int(3) NOT NULL default '0',
  PRIMARY KEY  (unique_id)
);

DROP TABLE IF EXISTS customers_temp;
CREATE TABLE customers_temp (
  customers_id int(11) NOT NULL auto_increment,
  customers_firstname varchar(32) NOT NULL,
  customers_lastname varchar(32) NOT NULL,
  customers_email_address varchar(96) NOT NULL,
  PRIMARY KEY  (customers_id)
);

DROP TABLE IF EXISTS customers_to_extra_fields;
CREATE TABLE customers_to_extra_fields (
  customers_id int(11) NOT NULL default '0',
  fields_id int(11) NOT NULL default '0',
  value text
);

DROP TABLE IF EXISTS email_batch;
CREATE TABLE email_batch (
  id int(5) unsigned NOT NULL auto_increment,
  charset varchar(20) default NULL,
  send char(2) default NULL,
  to_name varchar(50) NOT NULL,
  to_address varchar(50) NOT NULL,
  subject varchar(100) NOT NULL,
  text text NOT NULL,
  from_name varchar(50) default NULL,
  from_address varchar(50) default NULL,
  last_updated datetime default NULL,
  created datetime default NULL,
  hold char(2) default NULL,
  ip varchar(15) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY email_id (id),
  KEY email_id_2 (id),
  KEY send (send),
  KEY hold (hold)
);

DROP TABLE IF EXISTS email_batch_a;
CREATE TABLE email_batch_a (
  id int(5) unsigned NOT NULL default '0',
  charset varchar(20) default NULL,
  send char(2) default NULL,
  to_name varchar(50) NOT NULL,
  to_address varchar(50) NOT NULL,
  subject varchar(100) NOT NULL,
  text text NOT NULL,
  from_name varchar(50) default NULL,
  from_address varchar(50) default NULL,
  last_updated datetime default NULL,
  created datetime default NULL,
  hold char(2) default NULL,
  ip varchar(15) default NULL,
  PRIMARY KEY  (id),
  UNIQUE KEY email_id (id),
  KEY email_id_2 (id)
);

DROP TABLE IF EXISTS extra_fields;
CREATE TABLE extra_fields (
  fields_id int(11) NOT NULL auto_increment,
  fields_input_type tinyint(2) NOT NULL default '0',
  fields_status tinyint(2) NOT NULL default '0',
  fields_required_status tinyint(2) NOT NULL default '0',
  fields_size int(5) NOT NULL default '0',
  PRIMARY KEY  (fields_id)
);

DROP TABLE IF EXISTS extra_fields_info;
CREATE TABLE extra_fields_info (
  fields_id int(11) NOT NULL default '0',
  languages_id int(11) NOT NULL default '0',
  fields_name varchar(32) NOT NULL
);

DROP TABLE IF EXISTS featured;
CREATE TABLE featured (
  featured_id int(11) NOT NULL auto_increment,
  products_id int(11) NOT NULL default '0',
  featured_date_added datetime default NULL,
  featured_last_modified datetime default NULL,
  expires_date datetime default NULL,
  date_status_change datetime default NULL,
  status int(1) default '1',
  valid_from_date datetime default NULL,
  PRIMARY KEY  (featured_id)
);

DROP TABLE IF EXISTS free_gifts;
CREATE TABLE free_gifts (
  gift_id tinyint(4) NOT NULL auto_increment,
  threshold mediumint(9) NOT NULL default '0',
  products_id mediumint(9) NOT NULL default '0',
  PRIMARY KEY  (gift_id)
);

DROP TABLE IF EXISTS geo_zones;
CREATE TABLE geo_zones (
  geo_zone_id int(11) NOT NULL auto_increment,
  geo_zone_name varchar(32) NOT NULL,
  geo_zone_description varchar(255) NOT NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (geo_zone_id)
);

DROP TABLE IF EXISTS groups_to_categories;
CREATE TABLE groups_to_categories (
  customers_group_id int(11) NOT NULL default '0',
  categories_id int(11) NOT NULL default '0',
  discount decimal(11,2) NOT NULL default '0.00',
  PRIMARY KEY  (customers_group_id,categories_id)
);

DROP TABLE IF EXISTS languages;
CREATE TABLE languages (
  languages_id int(11) NOT NULL auto_increment,
  name varchar(32) NOT NULL,
  code char(2) NOT NULL,
  image varchar(64) default NULL,
  directory varchar(32) default NULL,
  sort_order int(3) default NULL,
  PRIMARY KEY  (languages_id),
  KEY IDX_LANGUAGES_NAME (name)
);

INSERT INTO languages VALUES (1, 'English', 'en', 'icon.gif', 'english', 1);
INSERT INTO languages VALUES (4, 'tchinese', 'tw', 'flag_tw.gif', 'tchinese', 0);

DROP TABLE IF EXISTS link_categories;
CREATE TABLE link_categories (
  link_categories_id int(11) NOT NULL auto_increment,
  link_categories_image varchar(64) default NULL,
  link_categories_sort_order int(3) default NULL,
  link_categories_date_added datetime default NULL,
  link_categories_last_modified datetime default NULL,
  link_categories_status tinyint(1) NOT NULL,
  PRIMARY KEY  (link_categories_id),
  KEY idx_link_categories_date_added (link_categories_date_added)
);

DROP TABLE IF EXISTS link_categories_description;
CREATE TABLE link_categories_description (
  link_categories_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  link_categories_name varchar(32) NOT NULL,
  link_categories_description text,
  PRIMARY KEY  (link_categories_id,language_id),
  KEY idx_link_categories_name (link_categories_name)
);

DROP TABLE IF EXISTS links;
CREATE TABLE links (
  links_id int(11) NOT NULL auto_increment,
  links_url varchar(255) default NULL,
  links_reciprocal_url varchar(255) default NULL,
  links_image_url varchar(255) default NULL,
  links_contact_name varchar(64) default NULL,
  links_contact_email varchar(96) default NULL,
  links_date_added datetime NOT NULL,
  links_last_modified datetime default NULL,
  links_status tinyint(1) NOT NULL,
  links_clicked int(11) NOT NULL default '0',
  links_category_suggest varchar(32) default NULL,
  links_rating tinyint(1) NOT NULL,
  PRIMARY KEY  (links_id),
  KEY idx_links_date_added (links_date_added)
);

DROP TABLE IF EXISTS links_check;
CREATE TABLE links_check (
  links_id int(11) NOT NULL auto_increment,
  date_last_checked datetime default NULL,
  link_found tinyint(1) NOT NULL,
  PRIMARY KEY  (links_id)
);

DROP TABLE IF EXISTS links_description;
CREATE TABLE links_description (
  links_id int(11) NOT NULL auto_increment,
  language_id int(11) NOT NULL default '1',
  links_title varchar(64) NOT NULL default '',
  links_description text,
  PRIMARY KEY  (links_id,language_id),
  KEY links_title (links_title)
);

DROP TABLE IF EXISTS links_featured;
CREATE TABLE links_featured (
  links_id int(11) NOT NULL auto_increment,
  date_added datetime default NULL,
  expires_date datetime default NULL,
  PRIMARY KEY  (links_id)
);

DROP TABLE IF EXISTS links_status;
CREATE TABLE links_status (
  links_status_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  links_status_name varchar(32) NOT NULL,
  PRIMARY KEY  (links_status_id,language_id),
  KEY idx_links_status_name (links_status_name)
);

INSERT INTO links_status VALUES (1, 4, '待處理');
INSERT INTO links_status VALUES (2, 4, '已通過');
INSERT INTO links_status VALUES (3, 4, '沒設連結');
INSERT INTO links_status VALUES (4, 4, '等待複驗');
INSERT INTO links_status VALUES (1, 1, 'Pending');
INSERT INTO links_status VALUES (2, 1, 'Approved');
INSERT INTO links_status VALUES (3, 1, 'Disabled');
INSERT INTO links_status VALUES (4, 1, 'Waiting');

DROP TABLE IF EXISTS links_to_link_categories;
CREATE TABLE links_to_link_categories (
  links_id int(11) NOT NULL,
  link_categories_id int(11) NOT NULL,
  PRIMARY KEY  (links_id,link_categories_id)
);

DROP TABLE IF EXISTS manufacturers;
CREATE TABLE manufacturers (
  manufacturers_id int(11) NOT NULL auto_increment,
  manufacturers_name varchar(32) NOT NULL,
  manufacturers_image varchar(64) default NULL,
  date_added datetime default NULL,
  last_modified datetime default NULL,
  PRIMARY KEY  (manufacturers_id),
  KEY IDX_MANUFACTURERS_NAME (manufacturers_name)
);

DROP TABLE IF EXISTS manufacturers_info;
CREATE TABLE manufacturers_info (
  manufacturers_id int(11) NOT NULL default '0',
  languages_id int(11) NOT NULL default '0',
  manufacturers_url varchar(255) NOT NULL,
  url_clicked int(5) NOT NULL default '0',
  date_last_click datetime default NULL,
  manufacturers_htc_title_tag varchar(80) default NULL,
  manufacturers_htc_desc_tag longtext,
  manufacturers_htc_keywords_tag longtext,
  manufacturers_htc_description longtext,
  PRIMARY KEY  (manufacturers_id,languages_id)
);

DROP TABLE IF EXISTS newsdesk;
CREATE TABLE newsdesk (
  newsdesk_id int(11) NOT NULL auto_increment,
  newsdesk_image varchar(64) default NULL,
  newsdesk_image_two varchar(64) default NULL,
  newsdesk_image_three varchar(64) default NULL,
  newsdesk_date_added datetime NOT NULL default '0000-00-00 00:00:00',
  newsdesk_last_modified datetime default NULL,
  newsdesk_date_available datetime default NULL,
  newsdesk_status tinyint(1) NOT NULL default '0',
  newsdesk_sticky tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (newsdesk_id),
  KEY idx_newsdesk_date_added (newsdesk_date_added)
);

DROP TABLE IF EXISTS newsdesk_categories;
CREATE TABLE newsdesk_categories (
  categories_id int(11) NOT NULL auto_increment,
  categories_image varchar(64) default NULL,
  parent_id int(11) NOT NULL default '0',
  sort_order int(3) default NULL,
  date_added datetime default NULL,
  last_modified datetime default NULL,
  catagory_status tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (categories_id),
  KEY idx_categories_parent_id (parent_id)
);

DROP TABLE IF EXISTS newsdesk_categories_description;
CREATE TABLE newsdesk_categories_description (
  categories_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  categories_name varchar(32) NOT NULL,
  PRIMARY KEY  (categories_id,language_id),
  KEY idx_categories_name (categories_name)
);

DROP TABLE IF EXISTS newsdesk_configuration;
CREATE TABLE newsdesk_configuration (
  configuration_id int(11) NOT NULL auto_increment,
  configuration_title varchar(64) NOT NULL,
  configuration_key varchar(64) NOT NULL,
  configuration_value varchar(255) NOT NULL,
  configuration_description varchar(255) NOT NULL,
  configuration_group_id int(11) NOT NULL default '0',
  sort_order int(5) default NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  use_function varchar(255) default NULL,
  set_function varchar(255) default NULL,
  PRIMARY KEY  (configuration_id)
);

INSERT INTO newsdesk_configuration VALUES (1, '搜尋結果筆數', 'MAX_DISPLAY_NEWSDESK_SEARCH_RESULTS', '20', 'How many articles do you want to list?', 1, 1, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (2, '連結頁數', 'MAX_DISPLAY_NEWSDESK_PAGE_LINKS', '5', 'Number of links to use for page-sets', 1, 2, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (3, '顯示標題', 'NEWSDESK_ARTICLE_NAME', '2', 'Do you want to display the headline? (0=disable; 1=enable)', 1, 3, '2004-05-10 13:28:31', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (4, '顯示摘要', 'NEWSDESK_ARTICLE_SHORTTEXT', '1', 'Do you want to display the summary? (0=disable; 1=enable)', 1, 4, '2006-11-21 19:08:18', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (5, '顯示內容', 'NEWSDESK_ARTICLE_DESCRIPTION', '0', 'Do you want to display the content? (0=disable; 1=enable)', 1, 5, '2004-05-10 13:28:43', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (6, '顯示時間', 'NEWSDESK_DATE_AVAILABLE', '1', 'Do you want to display the date? (0=disable; 1=enable)', 1, 6, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (7, '顯示外部網址', 'NEWSDESK_ARTICLE_URL', '0', 'Do you want to display the outside resource URL? (0=disable; 1=enable)', 1, 7, '2006-11-21 19:09:56', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (8, '顯示外部網站名稱', 'NEWSDESK_ARTICLE_URL_NAME', '3', 'Do you want to display the outside resource URL Name (0=disable; 1=enable)', 1, 8, '2004-05-26 17:08:00', '2004-05-26 17:07:00', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (9, '顯示狀態', 'NEWSDESK_STATUS', '0', 'Do you want to display the status for the article? (0=disable; 1=enable)', 1, 9, '2004-05-10 13:28:52', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (10, '顯示圖片1', 'NEWSDESK_IMAGE', '0', 'Do you want to display image 1 for the article? (0=disable; 1=enable)', 1, 10, '2004-05-10 13:28:57', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (11, '顯示圖片2', 'NEWSDESK_IMAGE_TWO', '0', 'Do you want to display image 2 for the article? (0=disable; 1=enable)', 1, 11, '2004-05-10 13:29:01', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (12, '顯示圖片3', 'NEWSDESK_IMAGE_THREE', '0', 'Do you want to display image 3 for the article? (0=disable; 1=enable)', 1, 12, '2004-05-10 13:29:06', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (14, 'Prev/Next導覽列位置', 'NEWSDESK_PREV_NEXT_BAR_LOCATION', '3', 'Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)', 1, 14, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (15, '顯示新聞則數', 'MAX_DISPLAY_NEWSDESK_NEWS', '3', 'How many articles do you want to display on the top page?', 2, 1, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (16, '最新消息區塊-新聞數', 'LATEST_DISPLAY_NEWSDESK_NEWS', '5', 'How many articles do you want to display in the Latest News Box?', 2, 2, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (17, '顯示最新快訊', 'DISPLAY_LATEST_NEWS_BOX', '1', 'Do you want to display the Latest News Box? (0=disable; 1=enable)', 2, 3, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (18, '顯示新聞分類區塊', 'DISPLAY_NEWS_CATAGORY_BOX', '1', 'Do you want to display the News Catagory Box? (0=disable; 1=enable)', 2, 4, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (19, '顯示觀看數', 'DISPLAY_NEWSDESK_VIEWCOUNT', '1', 'Do you want to display View Counts? (0=disable; 1=enable)', 2, 5, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (20, '顯示[更多新聞]', 'DISPLAY_NEWSDESK_READMORE', '1', 'Do you want to display Read More? (0=disable; 1=enable)', 2, 6, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (21, '顯示摘要', 'DISPLAY_NEWSDESK_SUMMARY', '1', 'Do you want to display the News Summary? (0=disable; 1=enable)', 2, 7, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (22, '顯示標題', 'DISPLAY_NEWSDESK_HEADLINE', '1', 'Do you want to display the News Headline? (0=disable; 1=enable)', 2, 8, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (23, '顯示日期', 'DISPLAY_NEWSDESK_DATE', '1', 'Do you want to display the News Date? (0=disable; 1=enable)', 2, 9, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (24, '顯示圖片1', 'DISPLAY_NEWSDESK_IMAGE', '1', 'Do you want to display image 1 for the article? (0=disable; 1=enable)', 2, 10, NULL, '2003-03-03 11:59:47', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (25, '顯示圖片2', 'DISPLAY_NEWSDESK_IMAGE_TWO', '1', 'Do you want to display image 2 for the article? (0=disable; 1=enable)', 2, 11, '2003-03-03 12:08:55', '2003-03-03 11:59:47', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (26, '顯示圖片3', 'DISPLAY_NEWSDESK_IMAGE_THREE', '1', 'Do you want to display image 3 for the article? (0=disable; 1=enable)', 2, 12, '2003-03-03 12:09:16', '2003-03-03 11:59:47', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (27, '顯示評論', 'DISPLAY_NEWSDESK_REVIEWS', '1', 'Do you want to display News Reviews? (0=disable; 1=enable)', 3, 1, '2004-05-18 15:39:09', '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (28, '顯示評論則數', 'MAX_DISPLAY_NEW_REVIEWS', '10', 'Maximum number of new reviews to display', 3, 2, NULL, '2003-02-16 02:08:36', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (29, '顯示標題', 'STICKY_ARTICLE_NAME', '1', 'Do you want to display the headline? (0=disable; 1=enable)', 4, 1, NULL, '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (30, '顯示摘要', 'STICKY_ARTICLE_SHORTTEXT', '1', 'Do you want to display the summary? (0=disable; 1=enable)', 4, 2, NULL, '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (31, '顯示內容', 'STICKY_ARTICLE_DESCRIPTION', '0', 'Do you want to display the content? (0=disable; 1=enable)', 4, 3, '2006-11-21 19:07:19', '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (32, '顯示觀看數', 'STICKY_NEWSDESK_VIEWCOUNT', '1', 'Do you want to display View Counts? (0=disable; 1=enable)', 4, 4, NULL, '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (33, '顯示[更多新聞]...', 'STICKY_NEWSDESK_READMORE', '1', 'Do you want to display Read More? (0=disable; 1=enable)', 4, 5, NULL, '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (34, '顯示日期', 'STICKY_DATE_ADDED', '1', 'Do you want to display the date? (0=disable; 1=enable)', 4, 6, '2003-03-02 00:49:54', '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (35, '顯示外部網址', 'STICKY_ARTICLE_URL', '0', 'Do you want to display the outside resource URL? (0=disable; 1=enable)', 4, 7, '2004-05-26 17:13:50', '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (36, '顯示外部網站名稱', 'STICKY_ARTICLE_URL_NAME', '1', 'Do you want to display the outside resource URL Name (0=disable; 1=enable)', 4, 8, '2003-03-02 00:51:00', '2003-03-02 00:50:00', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (37, '顯示圖片1', 'STICKY_IMAGE', '1', 'Do you want to display image 1 for the article? (0=disable; 1=enable)', 4, 9, '2003-03-02 00:50:14', '2003-03-02 00:47:21', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (38, '顯示圖片2', 'STICKY_IMAGE_TWO', '1', 'Do you want to display image 2for the article? (0=disable; 1=enable)', 4, 10, NULL, '2003-03-03 23:10:34', NULL, NULL);
INSERT INTO newsdesk_configuration VALUES (39, '顯示圖片3', 'STICKY_IMAGE_THREE', '1', 'Do you want to display image 3 for the article? (0=disable; 1=enable)', 4, 11, NULL, '2003-03-03 23:10:34', NULL, NULL);

DROP TABLE IF EXISTS newsdesk_configuration_group;
CREATE TABLE newsdesk_configuration_group (
  configuration_group_id int(11) NOT NULL auto_increment,
  configuration_group_title varchar(64) NOT NULL,
  configuration_group_description varchar(255) NOT NULL,
  sort_order int(5) default NULL,
  visible int(1) default '1',
  PRIMARY KEY  (configuration_group_id)
);

INSERT INTO newsdesk_configuration_group VALUES (1, '排列方式', 'Listing Page configuration options', 1, 1);
INSERT INTO newsdesk_configuration_group VALUES (2, '前台設定', 'Front Page configuration options', 1, 1);
INSERT INTO newsdesk_configuration_group VALUES (3, '評論設定', 'Reviews configuration options', 1, 1);
INSERT INTO newsdesk_configuration_group VALUES (4, '新聞發表設定', 'Reviews configuration options', 1, 1);

DROP TABLE IF EXISTS newsdesk_description;
CREATE TABLE newsdesk_description (
  newsdesk_id int(11) NOT NULL auto_increment,
  language_id int(11) NOT NULL default '1',
  newsdesk_article_name varchar(64) NOT NULL,
  newsdesk_article_description text,
  newsdesk_article_shorttext text,
  newsdesk_article_url varchar(255) default NULL,
  newsdesk_article_url_name varchar(255) default NULL,
  newsdesk_article_viewed int(5) default '0',
  newsdesk_image_text text,
  newsdesk_image_text_two text,
  newsdesk_image_text_three text,
  PRIMARY KEY  (newsdesk_id,language_id),
  KEY newsdesk_article_name (newsdesk_article_name)
);

DROP TABLE IF EXISTS newsdesk_reviews;
CREATE TABLE newsdesk_reviews (
  reviews_id int(11) NOT NULL auto_increment,
  newsdesk_id int(11) NOT NULL default '0',
  customers_id int(11) default NULL,
  customers_name varchar(64) NOT NULL,
  reviews_rating int(1) default NULL,
  date_added datetime default NULL,
  last_modified datetime default NULL,
  reviews_read int(5) NOT NULL default '0',
  approved tinyint(3) unsigned default '0',
  PRIMARY KEY  (reviews_id)
);

DROP TABLE IF EXISTS newsdesk_reviews_description;
CREATE TABLE newsdesk_reviews_description (
  reviews_id int(11) NOT NULL default '0',
  languages_id int(11) NOT NULL default '0',
  reviews_text text NOT NULL,
  PRIMARY KEY  (reviews_id,languages_id)
);

DROP TABLE IF EXISTS newsdesk_to_categories;
CREATE TABLE newsdesk_to_categories (
  newsdesk_id int(11) NOT NULL default '0',
  categories_id int(11) NOT NULL default '0',
  PRIMARY KEY  (newsdesk_id,categories_id)
);

DROP TABLE IF EXISTS newsletters;
CREATE TABLE newsletters (
  newsletters_id int(11) NOT NULL auto_increment,
  title varchar(255) NOT NULL,
  content text NOT NULL,
  module varchar(255) NOT NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  date_sent datetime default NULL,
  status int(1) default NULL,
  locked int(1) default '0',
  last_counts int(6) NOT NULL default '0',
  customers_id int(11) NOT NULL default '0',
  last_email varchar(45) NOT NULL,
  status1 tinyint(1) default NULL,
  PRIMARY KEY  (newsletters_id)
);

DROP TABLE IF EXISTS optimize_check;
CREATE TABLE optimize_check (
  counter int(11) NOT NULL auto_increment,
  start_date date NOT NULL default '0000-00-00',
  PRIMARY KEY  (counter)
);

DROP TABLE IF EXISTS orders;
CREATE TABLE orders (
  orders_id int(11) NOT NULL,
  customers_id int(11) NOT NULL default '0',
  customers_name varchar(64) NOT NULL,
  customers_company varchar(32) default NULL,
  customers_street_address varchar(64) NOT NULL,
  customers_suburb varchar(32) default NULL,
  customers_city varchar(32) NOT NULL,
  customers_postcode varchar(10) NOT NULL,
  customers_state varchar(32) default NULL,
  customers_country varchar(32) NOT NULL,
  customers_telephone varchar(32) NOT NULL,
  customers_email_address varchar(96) NOT NULL,
  customers_address_format_id int(5) NOT NULL default '0',
  delivery_name varchar(64) NOT NULL,
  delivery_company varchar(32) default NULL,
  delivery_street_address varchar(64) NOT NULL,
  delivery_suburb varchar(32) default NULL,
  delivery_city varchar(32) NOT NULL,
  delivery_postcode varchar(10) NOT NULL,
  delivery_state varchar(32) default NULL,
  delivery_country varchar(32) NOT NULL,
  delivery_address_format_id int(5) NOT NULL default '0',
  billing_name varchar(64) NOT NULL,
  billing_company varchar(32) default NULL,
  billing_cf varchar(16) default NULL,
  billing_street_address varchar(64) NOT NULL,
  billing_suburb varchar(32) default NULL,
  billing_city varchar(32) NOT NULL,
  billing_postcode varchar(10) NOT NULL,
  billing_state varchar(32) default NULL,
  billing_country varchar(32) NOT NULL,
  billing_address_format_id int(5) NOT NULL default '0',
  payment_method varchar(32) NOT NULL,
  cc_type varchar(20) default NULL,
  cc_owner varchar(64) default NULL,
  cc_number varchar(32) default NULL,
  cc_expires varchar(4) default NULL,
  last_modified datetime default NULL,
  date_purchased datetime default NULL,
  orders_status int(5) NOT NULL default '0',
  orders_date_finished datetime default NULL,
  currency char(3) default NULL,
  currency_value decimal(14,6) default NULL,
  customers_group_id int(11) NOT NULL default '0',
  purchased_without_account tinyint(1) unsigned NOT NULL default '0',
  shipping_tax decimal(7,4) NOT NULL default '0.0000',
  tracking_no text,
  ship_date text,
  delivery_date text,
  carrier_id text,
  PRIMARY KEY  (orders_id)
);

DROP TABLE IF EXISTS orders_products;
CREATE TABLE orders_products (
  orders_products_id int(11) NOT NULL auto_increment,
  orders_id int(11) NOT NULL default '0',
  products_id int(11) NOT NULL default '0',
  products_model varchar(12) default NULL,
  products_name varchar(64) NOT NULL,
  products_price decimal(15,4) NOT NULL default '0.0000',
  final_price decimal(15,4) NOT NULL default '0.0000',
  products_tax decimal(7,4) NOT NULL default '0.0000',
  products_quantity int(2) NOT NULL default '0',
  products_serial_number varchar(128) default NULL,
  PRIMARY KEY  (orders_products_id)
);

DROP TABLE IF EXISTS orders_products_attributes;
CREATE TABLE orders_products_attributes (
  orders_products_attributes_id int(11) NOT NULL auto_increment,
  orders_id int(11) NOT NULL default '0',
  orders_products_id int(11) NOT NULL default '0',
  products_options varchar(32) NOT NULL,
  products_options_values varchar(32) NOT NULL,
  options_values_price decimal(15,4) NOT NULL default '0.0000',
  price_prefix char(1) NOT NULL,
  PRIMARY KEY  (orders_products_attributes_id)
);

DROP TABLE IF EXISTS orders_products_download;
CREATE TABLE orders_products_download (
  orders_products_download_id int(11) NOT NULL auto_increment,
  orders_id int(11) NOT NULL default '0',
  orders_products_id int(11) NOT NULL default '0',
  orders_products_filename varchar(255) NOT NULL,
  download_maxdays int(2) NOT NULL default '0',
  download_count int(2) NOT NULL default '0',
  PRIMARY KEY  (orders_products_download_id)
);

DROP TABLE IF EXISTS orders_status;
CREATE TABLE orders_status (
  orders_status_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  orders_status_name varchar(32) NOT NULL,
  PRIMARY KEY  (orders_status_id,language_id),
  KEY idx_orders_status_name (orders_status_name)
);

INSERT INTO orders_status VALUES (1, 1, 'Pending');
INSERT INTO orders_status VALUES (2, 1, 'Processing');
INSERT INTO orders_status VALUES (3, 1, 'In Transit');
INSERT INTO orders_status VALUES (4, 1, 'Delivered');
INSERT INTO orders_status VALUES (1, 4, '等待處理');
INSERT INTO orders_status VALUES (2, 4, '處理中..');
INSERT INTO orders_status VALUES (3, 4, '已出貨');
INSERT INTO orders_status VALUES (4, 4, '已送達');

DROP TABLE IF EXISTS orders_status_history;
CREATE TABLE orders_status_history (
  orders_status_history_id int(11) NOT NULL auto_increment,
  orders_id int(11) NOT NULL default '0',
  orders_status_id int(5) NOT NULL default '0',
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  customer_notified int(1) default '0',
  comments text,
  PRIMARY KEY  (orders_status_history_id)
);

DROP TABLE IF EXISTS orders_total;
CREATE TABLE orders_total (
  orders_total_id int(10) unsigned NOT NULL auto_increment,
  orders_id int(11) NOT NULL default '0',
  title varchar(255) NOT NULL,
  text varchar(255) NOT NULL,
  value decimal(15,4) NOT NULL default '0.0000',
  class varchar(32) NOT NULL,
  sort_order int(11) NOT NULL default '0',
  PRIMARY KEY  (orders_total_id),
  KEY idx_orders_total_orders_id (orders_id)
);

DROP TABLE IF EXISTS pages;
CREATE TABLE pages (
  pages_id int(11) NOT NULL auto_increment,
  sort_order int(3) default NULL,
  status int(1) NOT NULL default '1',
  page_type char(1) default NULL,
  PRIMARY KEY  (pages_id)
);

INSERT INTO pages VALUES (1, 0, 1, '1');
INSERT INTO pages VALUES (2, 1, 1, '2');

DROP TABLE IF EXISTS pages_description;
CREATE TABLE pages_description (
  id int(11) NOT NULL auto_increment,
  pages_id int(11) default NULL,
  pages_title varchar(64) NOT NULL default '',
  pages_html_text text,
  intorext char(1) default NULL,
  externallink varchar(255) default NULL,
  link_target char(1) default NULL,
  language_id int(3) default NULL,
  PRIMARY KEY  (id)
);

INSERT INTO pages_description VALUES (1, 1, 'Index', '', '0', '', '0', 1);
INSERT INTO pages_description VALUES (2, 1, 'Index', '<li> 這是首頁編輯處喔！', '0', '', '0', 4);
INSERT INTO pages_description VALUES (3, 2, 'Contact Us', '', '0', '', '0', 1);
INSERT INTO pages_description VALUES (4, 2, '．聯絡方式', '<strong>歡迎來電TEL:04-xxxxxx(週一～週五9:00～20:00)</strong><br />\r\n或由此mail給我們', '0', '', '0', 4);

DROP TABLE IF EXISTS popup_help;
CREATE TABLE popup_help (
  help_id int(11) NOT NULL auto_increment,
  help_number int(11) NOT NULL default '0',
  help_class varchar(25) NOT NULL,
  help_module varchar(25) NOT NULL,
  help_file_name varchar(50) NOT NULL,
  help_title varchar(45) NOT NULL,
  help_text longtext NOT NULL,
  help_version varchar(12) NOT NULL,
  UNIQUE KEY help_number (help_number),
  KEY help_id (help_id)
);

INSERT INTO popup_help VALUES (1, 1, 'process', 'newsletter', '', '', 'test help', '1.00');
INSERT INTO popup_help VALUES (2, 2, 'field_description', 'newsletter', '', '<b>Header/Footer Infos</b>', 'This screen allow you to add DYNAMIC headers and footers  to your newsletters.\r\n<br>\r\nIn this configuration , the <b>Header </b>contains just Dear \r\n<br><br>\r\nIn the newsletter sent , we add the first name of the client just after the header before the body of the newsletter. \r\n<br>\r\nie Dear XXX.\r\n<br><br>\r\n<b>In the Unsubscribe Part 1</b>  we add dynamically the link information + the email address of  the user in order to link directly to an unsubscribe utility  insterted at the bottom of the newsletter.\r\nThis unsubscribe utility link will direct the user to a page where he can choose to subscribe or unsubscribe from the newsletter.\r\n\r\n<br><br>\r\n<b>In the Unsubscribe Part 2</b>  we end the unsubscribe text with whatever text you want to add to explain the process\r\n<br><br>\r\n<b>In the Footer field</b>  we add  the store informations and contacts. (or whatever you want to add: thank you note, special offer.....)\r\n\r\nit will come at the very bottom of the newsletter sent.\r\n<br><br>\r\n\r\n<b>MARKETING TIP</b>: it is good practice to add to every documents sent your contacts: email, phone , fax , web site adress.\r\n\r\nThis way a potential client or actual client does not have to search for your contact details . Everything is mentionned in all your communication.\r\n\r\n<br><br>', '1.0');

DROP TABLE IF EXISTS products;
CREATE TABLE products (
  products_id int(11) NOT NULL auto_increment,
  products_quantity int(4) NOT NULL default '0',
  products_reorder int(4) default '0',
  products_reorder_to int(4) default '0',
  products_model varchar(12) default NULL,
  products_image varchar(64) default NULL,
  products_price decimal(15,4) NOT NULL default '0.0000',
  products_date_added datetime NOT NULL default '0000-00-00 00:00:00',
  products_last_modified datetime default NULL,
  products_date_available datetime default NULL,
  products_weight decimal(5,2) NOT NULL default '0.00',
  products_status tinyint(1) NOT NULL default '0',
  products_carrot tinyint(1) default '0',
  products_tax_class_id int(11) NOT NULL default '0',
  manufacturers_id int(11) default NULL,
  products_ordered int(11) NOT NULL default '0',
  products_percentage tinyint(1) NOT NULL default '1',
  products_sort_order int(3) default NULL,
  minorder int(4) NOT NULL default '1',
  products_price1 decimal(15,4) NOT NULL default '0.0000',
  products_price2 decimal(15,4) NOT NULL default '0.0000',
  products_price3 decimal(15,4) NOT NULL default '0.0000',
  products_price4 decimal(15,4) NOT NULL default '0.0000',
  products_price5 decimal(15,4) NOT NULL default '0.0000',
  products_price6 decimal(15,4) NOT NULL default '0.0000',
  products_price7 decimal(15,4) NOT NULL default '0.0000',
  products_price8 decimal(15,4) NOT NULL default '0.0000',
  products_price1_qty int(11) NOT NULL default '0',
  products_price2_qty int(11) NOT NULL default '0',
  products_price3_qty int(11) NOT NULL default '0',
  products_price4_qty int(11) NOT NULL default '0',
  products_price5_qty int(11) NOT NULL default '0',
  products_price6_qty int(11) NOT NULL default '0',
  products_price7_qty int(11) NOT NULL default '0',
  products_price8_qty int(11) NOT NULL default '0',
  products_qty_blocks int(11) NOT NULL default '1',
  products_hide_from_groups varchar(255) NOT NULL default '@',
  maxorder int(4) default NULL,
  PRIMARY KEY  (products_id),
  KEY idx_products_date_added (products_date_added)
);

DROP TABLE IF EXISTS products_2gether;
CREATE TABLE products_2gether (
  tid int(11) unsigned NOT NULL auto_increment,
  product_1_id int(11) unsigned NOT NULL default '0',
  product_2_id int(11) unsigned NOT NULL default '0',
  discount float NOT NULL default '5',
  type char(1) NOT NULL default 'p',
  status int(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (tid),
  KEY producta (product_1_id,product_2_id,status)
);

DROP TABLE IF EXISTS products_attributes;
CREATE TABLE products_attributes (
  products_attributes_id int(11) NOT NULL auto_increment,
  products_id int(11) NOT NULL default '0',
  options_id int(11) NOT NULL default '0',
  options_values_id int(11) NOT NULL default '0',
  options_values_price decimal(15,4) NOT NULL default '0.0000',
  price_prefix char(1) NOT NULL,
  sort_order int(11) default '0',
  PRIMARY KEY  (products_attributes_id)
);

DROP TABLE IF EXISTS products_attributes_download;
CREATE TABLE products_attributes_download (
  products_attributes_id int(11) NOT NULL default '0',
  products_attributes_filename varchar(255) NOT NULL,
  products_attributes_maxdays int(2) default '0',
  products_attributes_maxcount int(2) default '0',
  PRIMARY KEY  (products_attributes_id)
);

DROP TABLE IF EXISTS products_attributes_sets;
CREATE TABLE products_attributes_sets (
  products_attributes_sets_id int(11) NOT NULL auto_increment,
  products_attributes_sets_name varchar(50) NOT NULL,
  products_options_id int(11) NOT NULL default '0',
  PRIMARY KEY  (products_attributes_sets_id)
);

DROP TABLE IF EXISTS products_attributes_sets_elements;
CREATE TABLE products_attributes_sets_elements (
  products_attributes_sets_elements_id int(11) NOT NULL auto_increment,
  products_attributes_sets_id int(11) NOT NULL default '0',
  options_values_id int(11) NOT NULL default '0',
  options_values_price decimal(15,4) NOT NULL default '0.0000',
  price_prefix char(1) NOT NULL default '+',
  sort_order int(11) NOT NULL default '1',
  PRIMARY KEY  (products_attributes_sets_elements_id)
);

DROP TABLE IF EXISTS products_attributes_sets_to_products;
CREATE TABLE products_attributes_sets_to_products (
  products_attributes_sets_to_products int(11) NOT NULL auto_increment,
  products_attributes_sets_id int(11) NOT NULL default '0',
  products_id int(11) NOT NULL default '0',
  PRIMARY KEY  (products_attributes_sets_to_products)
);

DROP TABLE IF EXISTS products_description;
CREATE TABLE products_description (
  products_id int(11) NOT NULL auto_increment,
  language_id int(11) NOT NULL default '1',
  products_name varchar(64) NOT NULL,
  products_description text,
  products_url varchar(255) default NULL,
  products_viewed int(5) default '0',
  products_info text NOT NULL,
  products_head_title_tag varchar(80) default NULL,
  products_head_desc_tag longtext,
  products_head_keywords_tag longtext,
  PRIMARY KEY  (products_id,language_id),
  KEY products_name (products_name)
);

DROP TABLE IF EXISTS products_extra_fields;
CREATE TABLE products_extra_fields (
  products_extra_fields_id int(11) NOT NULL auto_increment,
  products_extra_fields_name varchar(64) NOT NULL,
  products_extra_fields_order int(3) NOT NULL default '0',
  products_extra_fields_status tinyint(1) NOT NULL default '1',
  languages_id int(11) NOT NULL default '0',
  PRIMARY KEY  (products_extra_fields_id)
);

DROP TABLE IF EXISTS products_groups;
CREATE TABLE products_groups (
  customers_group_id smallint(5) unsigned NOT NULL default '0',
  customers_group_price decimal(15,4) NOT NULL default '0.0000',
  products_id int(11) NOT NULL default '0',
  products_price decimal(15,2) NOT NULL default '0.00',
  products_price1 decimal(15,4) NOT NULL default '0.0000',
  products_price2 decimal(15,4) NOT NULL default '0.0000',
  products_price3 decimal(15,4) NOT NULL default '0.0000',
  products_price4 decimal(15,4) NOT NULL default '0.0000',
  products_price5 decimal(15,4) NOT NULL default '0.0000',
  products_price6 decimal(15,4) NOT NULL default '0.0000',
  products_price7 decimal(15,4) NOT NULL default '0.0000',
  products_price8 decimal(15,4) NOT NULL default '0.0000',
  products_price1_qty int(11) NOT NULL default '0',
  products_price2_qty int(11) NOT NULL default '0',
  products_price3_qty int(11) NOT NULL default '0',
  products_price4_qty int(11) NOT NULL default '0',
  products_price5_qty int(11) NOT NULL default '0',
  products_price6_qty int(11) NOT NULL default '0',
  products_price7_qty int(11) NOT NULL default '0',
  products_price8_qty int(11) NOT NULL default '0',
  products_qty_blocks int(11) NOT NULL default '1',
  PRIMARY KEY  (customers_group_id,products_id)
);

DROP TABLE IF EXISTS products_notifications;
CREATE TABLE products_notifications (
  products_id int(11) NOT NULL default '0',
  customers_id int(11) NOT NULL default '0',
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (products_id,customers_id)
);

DROP TABLE IF EXISTS products_options;
CREATE TABLE products_options (
  products_options_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  products_options_name varchar(32) NOT NULL,
  products_options_type int(5) NOT NULL default '0',
  products_options_length smallint(2) NOT NULL default '32',
  products_options_comment varchar(32) default NULL,
  PRIMARY KEY  (products_options_id,language_id)
);

DROP TABLE IF EXISTS products_options_values;
CREATE TABLE products_options_values (
  products_options_values_id int(11) NOT NULL default '0',
  language_id int(11) NOT NULL default '1',
  products_options_values_name varchar(64) NOT NULL,
  PRIMARY KEY  (products_options_values_id,language_id)
);

DROP TABLE IF EXISTS products_options_values_to_products_options;
CREATE TABLE products_options_values_to_products_options (
  products_options_values_to_products_options_id int(11) NOT NULL auto_increment,
  products_options_id int(11) NOT NULL default '0',
  products_options_values_id int(11) NOT NULL default '0',
  PRIMARY KEY  (products_options_values_to_products_options_id)
);

DROP TABLE IF EXISTS products_to_categories;
CREATE TABLE products_to_categories (
  products_id int(11) NOT NULL default '0',
  categories_id int(11) NOT NULL default '0',
  PRIMARY KEY  (products_id,categories_id)
);

DROP TABLE IF EXISTS products_to_products_extra_fields;
CREATE TABLE products_to_products_extra_fields (
  products_id int(11) NOT NULL default '0',
  products_extra_fields_id int(11) NOT NULL default '0',
  products_extra_fields_value varchar(64) default NULL,
  PRIMARY KEY  (products_id,products_extra_fields_id)
);

DROP TABLE IF EXISTS products_xsell;
CREATE TABLE products_xsell (
  ID int(10) NOT NULL auto_increment,
  products_id int(10) unsigned NOT NULL default '1',
  xsell_id int(10) unsigned NOT NULL default '1',
  sort_order int(10) unsigned NOT NULL default '1',
  PRIMARY KEY  (ID)
);

DROP TABLE IF EXISTS reviews;
CREATE TABLE reviews (
  reviews_id int(11) NOT NULL auto_increment,
  products_id int(11) NOT NULL default '0',
  customers_id int(11) default NULL,
  customers_name varchar(64) NOT NULL,
  reviews_rating int(1) default NULL,
  date_added datetime default NULL,
  last_modified datetime default NULL,
  reviews_read int(5) NOT NULL default '0',
  PRIMARY KEY  (reviews_id)
);

DROP TABLE IF EXISTS reviews_description;
CREATE TABLE reviews_description (
  reviews_id int(11) NOT NULL default '0',
  languages_id int(11) NOT NULL default '0',
  reviews_text text NOT NULL,
  PRIMARY KEY  (reviews_id,languages_id)
);

DROP TABLE IF EXISTS sessions;
CREATE TABLE sessions (
  sesskey varchar(32) NOT NULL,
  expiry int(11) unsigned NOT NULL default '0',
  value text NOT NULL,
  PRIMARY KEY  (sesskey)
);

DROP TABLE IF EXISTS sitemap_exclude;
CREATE TABLE sitemap_exclude (
  exclude_id int(11) NOT NULL auto_increment,
  exclude_file varchar(255) NOT NULL,
  exclude_type int(2) NOT NULL default '0',
  is_box int(1) NOT NULL default '0',
  PRIMARY KEY  (exclude_id)
);

DROP TABLE IF EXISTS specials;
CREATE TABLE specials (
  specials_id int(11) NOT NULL auto_increment,
  products_id int(11) NOT NULL default '0',
  specials_new_products_price decimal(15,4) NOT NULL default '0.0000',
  specials_date_added datetime default NULL,
  specials_last_modified datetime default NULL,
  valid_from_date datetime default NULL,
  expires_date datetime default NULL,
  date_status_change datetime default NULL,
  status int(1) NOT NULL default '1',
  customers_group_id smallint(5) unsigned NOT NULL default '0',
  status_happy_hours int(1) NOT NULL default '1',
  happy_hours_beginning_date date NOT NULL default '0000-00-00',
  happy_hours_end_date date NOT NULL default '0000-00-00',
  happy_hours_beginning_time time NOT NULL default '00:00:00',
  happy_hours_end_time time NOT NULL default '00:00:00',
  specials_price_happy_hours decimal(15,4) NOT NULL default '0.0000',
  date_status_change_happy_hours datetime default NULL,
  PRIMARY KEY  (specials_id)
);

DROP TABLE IF EXISTS specials_retail_prices;
CREATE TABLE specials_retail_prices (
  products_id int(11) NOT NULL default '0',
  specials_new_products_price decimal(15,4) NOT NULL default '0.0000',
  status tinyint(4) default NULL,
  customers_group_id smallint(6) default NULL,
  PRIMARY KEY  (products_id)
);

DROP TABLE IF EXISTS star_product;
CREATE TABLE star_product (
  product_id varchar(11) NOT NULL default '0'
);

INSERT INTO star_product VALUES ('1');

DROP TABLE IF EXISTS subscribers;
CREATE TABLE subscribers (
  subscribers_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  subscribers_email_address varchar(80) NOT NULL,
  subscribers_firstname varchar(40) default NULL,
  subscribers_lastname varchar(40) default NULL,
  subscribers_city varchar(40) default NULL,
  subscribers_state varchar(20) default NULL,
  subscribers_zip varchar(20) default NULL,
  subscribers_country_id int(5) default '0',
  subscribers_zone_id int(4) NOT NULL default '0',
  subscribers_default_address_id int(11) NOT NULL default '0',
  language varchar(30) default NULL,
  birthdate varchar(20) default NULL,
  subscribers_gender char(1) default NULL,
  subscribers_email_type varchar(5) default NULL,
  entry_date date default '0000-00-00',
  undeliverable_count mediumint(11) default '0',
  mail_details_customers_id int(5) default '0',
  list_number int(5) default '0',
  source_import varchar(70) default NULL,
  date_account_created datetime default '0000-00-00 00:00:00',
  date_account_last_modified datetime default '0000-00-00 00:00:00',
  customers_newsletter int(4) default NULL,
  subscribers_blacklist int(2) default '0',
  subscription_date datetime default '0000-00-00 00:00:00',
  status_sent1 int(2) default '0',
  ip_address varchar(20) default NULL,
  host_name varchar(25) default NULL,
  hardiness_zone char(3) default NULL,
  PRIMARY KEY  (subscribers_id),
  KEY list_number (list_number)
);

DROP TABLE IF EXISTS subscribers_default;
CREATE TABLE subscribers_default (
  news_id int(11) NOT NULL auto_increment,
  module_subscribers varchar(255) NOT NULL,
  header text NOT NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  status tinyint(1) NOT NULL default '0',
  news_order int(2) NOT NULL default '0',
  unsubscribea longtext NOT NULL,
  unsubscribeb longtext NOT NULL,
  PRIMARY KEY  (news_id)
);

INSERT INTO subscribers_default VALUES (1, 'Module newsletter_subscribers', '<DIV>xx電子報--</DIV>', '2002-11-28 09:31:06', 1, 0, '<DIV>本電子報中心定期提供下列新知： \r\n<LI>健康、環保、消費......等生活快訊 \r\n<LI>產品快訊、特價活動、贈送活動 \r\n<LI>限時超低價活動快訊 \r\n<LI>創業</LI></DIV>退報連結:', '有任何指教email: <A href=mailto:service@yago.com.tw>service@yago.com.tw</A>');
INSERT INTO subscribers_default VALUES (2, 'Module newsletter', '<DIV>Hi!xx的會員們:</DIV>', '2005-01-04 03:51:20', 1, 0, '<DIV>電子報退報連結:</DIV>', '<DIV>有任何指教email: <A href=mailto:service@yago.com.tw>service@yago.com.tw</A> </DIV>');
INSERT INTO subscribers_default VALUES (4, 'Module \r\n\r\nnewsletter_bulk', 'xx電子報', '2006-01-04 14:25:20', 1, 0, '<DIV>退報連結:</DIV>', '<DIV>All content Copyright ?nbsp;yago.com.tw </DIV>');
INSERT INTO subscribers_default VALUES (3, 'Module product_notification', '<DIV>xx電子報--新產品上市特別通知</DIV>', '2005-01-04 03:53:10', 1, 0, '<DIV>退訂連結:</DIV>', '<DIV>&nbsp;有任何指教email: <A href=mailto:service@yago.com.tw>service@yago.com.tw</A> </DIV>');

DROP TABLE IF EXISTS subscribers_infos;
CREATE TABLE subscribers_infos (
  news_id int(11) NOT NULL auto_increment,
  newsletters_id int(11) NOT NULL default '0',
  module_subscribers varchar(255) NOT NULL,
  header text NOT NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  status tinyint(1) NOT NULL default '0',
  news_order int(2) NOT NULL default '0',
  unsubscribea longtext NOT NULL,
  unsubscribeb longtext NOT NULL,
  PRIMARY KEY  (news_id)
);

INSERT INTO subscribers_infos VALUES (1, 1, 'newsletter_subscribers', '<P>雅格印刷電子報</P>', '2006-01-04 14:54:49', 1, 0, '<P>本電子報中心定期提供下列新知:</P>\r\n<LI>健康、環保、消費......等生活快訊 \r\n<LI>產品快訊、特價活動、贈送活動 \r\n<LI>限時超低價活動快訊 \r\n<LI>創業&nbsp;</LI>\r\n<P>退報連結:</P>', '<DIV>有任何指教email: <A href=mailto:service@yago.com.tw><FONT color=#606420>service@yago.com.tw</FONT></A> </DIV>\r\n<DIV>All contents Copyright by yago.com.tw </DIV>');
INSERT INTO subscribers_infos VALUES (2, 2, 'newsletter_subscribers', '<DIV>Hi!雅格印刷的會員們:</DIV>', '2006-01-08 21:21:44', 1, 0, '<DIV>電子報退報連結:</DIV>', '<DIV>有任何指教email: <A href=mailto:service@yago.com.tw>service@yago.com.tw</A> </DIV>');

DROP TABLE IF EXISTS tax_class;
CREATE TABLE tax_class (
  tax_class_id int(11) NOT NULL auto_increment,
  tax_class_title varchar(32) NOT NULL,
  tax_class_description varchar(255) NOT NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (tax_class_id)
);

INSERT INTO tax_class VALUES (1, '營業稅', '營業稅', '2005-01-07 11:30:46', '2004-04-01 10:14:45');

DROP TABLE IF EXISTS tax_rates;
CREATE TABLE tax_rates (
  tax_rates_id int(11) NOT NULL auto_increment,
  tax_zone_id int(11) NOT NULL default '0',
  tax_class_id int(11) NOT NULL default '0',
  tax_priority int(5) default '1',
  tax_rate decimal(7,4) NOT NULL default '0.0000',
  tax_description varchar(255) NOT NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (tax_rates_id)
);

INSERT INTO tax_rates VALUES (1, 1, 1, 1, 5.0000, '營業稅5%', '2005-01-07 11:31:13', '2004-04-01 10:14:45');

DROP TABLE IF EXISTS visitors;
CREATE TABLE visitors (
  browser_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  date datetime NOT NULL default '0000-00-00 00:00:00',
  online datetime NOT NULL default '0000-00-00 00:00:00',
  counter int(12) NOT NULL default '1',
  browser_ip varchar(15) NOT NULL,
  browser_language varchar(32) NOT NULL,
  language varchar(16) NOT NULL,
  referer varchar(255) NOT NULL,
  uri varchar(255) NOT NULL,
  PRIMARY KEY  (browser_id)
);

DROP TABLE IF EXISTS visitors_trace;
CREATE TABLE visitors_trace (
  trace_id int(11) NOT NULL auto_increment,
  customers_id int(11) NOT NULL default '0',
  browser_ip varchar(15) NOT NULL,
  uri varchar(255) NOT NULL,
  date datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (trace_id)
);

DROP TABLE IF EXISTS visual_verify_code;
CREATE TABLE visual_verify_code (
  oscsid varchar(32) NOT NULL,
  code varchar(6) NOT NULL,
  dt timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  PRIMARY KEY  (oscsid)
);

DROP TABLE IF EXISTS whos_online;
CREATE TABLE whos_online (
  customer_id int(11) default NULL,
  full_name varchar(64) NOT NULL,
  session_id varchar(128) NOT NULL,
  ip_address varchar(15) NOT NULL,
  time_entry varchar(14) NOT NULL,
  time_last_click varchar(14) NOT NULL,
  last_page_url varchar(255) NOT NULL,
  http_referer varchar(255) NOT NULL,
  user_agent varchar(255) NOT NULL
);

DROP TABLE IF EXISTS zones;
CREATE TABLE zones (
  zone_id int(11) NOT NULL auto_increment,
  zone_country_id int(11) NOT NULL default '0',
  zone_code varchar(32) NOT NULL,
  zone_name varchar(32) NOT NULL,
  PRIMARY KEY  (zone_id)
);

INSERT INTO zones VALUES (1, 223, 'AL', 'Alabama');
INSERT INTO zones VALUES (2, 223, 'AK', 'Alaska');
INSERT INTO zones VALUES (3, 223, 'AS', 'American Samoa');
INSERT INTO zones VALUES (4, 223, 'AZ', 'Arizona');
INSERT INTO zones VALUES (5, 223, 'AR', 'Arkansas');
INSERT INTO zones VALUES (6, 223, 'AF', 'Armed Forces Africa');
INSERT INTO zones VALUES (7, 223, 'AA', 'Armed Forces Americas');
INSERT INTO zones VALUES (8, 223, 'AC', 'Armed Forces Canada');
INSERT INTO zones VALUES (9, 223, 'AE', 'Armed Forces Europe');
INSERT INTO zones VALUES (10, 223, 'AM', 'Armed Forces Middle East');
INSERT INTO zones VALUES (11, 223, 'AP', 'Armed Forces Pacific');
INSERT INTO zones VALUES (12, 223, 'CA', 'California');
INSERT INTO zones VALUES (13, 223, 'CO', 'Colorado');
INSERT INTO zones VALUES (14, 223, 'CT', 'Connecticut');
INSERT INTO zones VALUES (15, 223, 'DE', 'Delaware');
INSERT INTO zones VALUES (16, 223, 'DC', 'District of Columbia');
INSERT INTO zones VALUES (17, 223, 'FM', 'Federated States Of Micronesia');
INSERT INTO zones VALUES (18, 223, 'FL', 'Florida');
INSERT INTO zones VALUES (19, 223, 'GA', 'Georgia');
INSERT INTO zones VALUES (20, 223, 'GU', 'Guam');
INSERT INTO zones VALUES (21, 223, 'HI', 'Hawaii');
INSERT INTO zones VALUES (22, 223, 'ID', 'Idaho');
INSERT INTO zones VALUES (23, 223, 'IL', 'Illinois');
INSERT INTO zones VALUES (24, 223, 'IN', 'Indiana');
INSERT INTO zones VALUES (25, 223, 'IA', 'Iowa');
INSERT INTO zones VALUES (26, 223, 'KS', 'Kansas');
INSERT INTO zones VALUES (27, 223, 'KY', 'Kentucky');
INSERT INTO zones VALUES (28, 223, 'LA', 'Louisiana');
INSERT INTO zones VALUES (29, 223, 'ME', 'Maine');
INSERT INTO zones VALUES (30, 223, 'MH', 'Marshall Islands');
INSERT INTO zones VALUES (31, 223, 'MD', 'Maryland');
INSERT INTO zones VALUES (32, 223, 'MA', 'Massachusetts');
INSERT INTO zones VALUES (33, 223, 'MI', 'Michigan');
INSERT INTO zones VALUES (34, 223, 'MN', 'Minnesota');
INSERT INTO zones VALUES (35, 223, 'MS', 'Mississippi');
INSERT INTO zones VALUES (36, 223, 'MO', 'Missouri');
INSERT INTO zones VALUES (37, 223, 'MT', 'Montana');
INSERT INTO zones VALUES (38, 223, 'NE', 'Nebraska');
INSERT INTO zones VALUES (39, 223, 'NV', 'Nevada');
INSERT INTO zones VALUES (40, 223, 'NH', 'New Hampshire');
INSERT INTO zones VALUES (41, 223, 'NJ', 'New Jersey');
INSERT INTO zones VALUES (42, 223, 'NM', 'New Mexico');
INSERT INTO zones VALUES (43, 223, 'NY', 'New York');
INSERT INTO zones VALUES (44, 223, 'NC', 'North Carolina');
INSERT INTO zones VALUES (45, 223, 'ND', 'North Dakota');
INSERT INTO zones VALUES (46, 223, 'MP', 'Northern Mariana Islands');
INSERT INTO zones VALUES (47, 223, 'OH', 'Ohio');
INSERT INTO zones VALUES (48, 223, 'OK', 'Oklahoma');
INSERT INTO zones VALUES (49, 223, 'OR', 'Oregon');
INSERT INTO zones VALUES (50, 223, 'PW', 'Palau');
INSERT INTO zones VALUES (51, 223, 'PA', 'Pennsylvania');
INSERT INTO zones VALUES (52, 223, 'PR', 'Puerto Rico');
INSERT INTO zones VALUES (53, 223, 'RI', 'Rhode Island');
INSERT INTO zones VALUES (54, 223, 'SC', 'South Carolina');
INSERT INTO zones VALUES (55, 223, 'SD', 'South Dakota');
INSERT INTO zones VALUES (56, 223, 'TN', 'Tennessee');
INSERT INTO zones VALUES (57, 223, 'TX', 'Texas');
INSERT INTO zones VALUES (58, 223, 'UT', 'Utah');
INSERT INTO zones VALUES (59, 223, 'VT', 'Vermont');
INSERT INTO zones VALUES (60, 223, 'VI', 'Virgin Islands');
INSERT INTO zones VALUES (61, 223, 'VA', 'Virginia');
INSERT INTO zones VALUES (62, 223, 'WA', 'Washington');
INSERT INTO zones VALUES (63, 223, 'WV', 'West Virginia');
INSERT INTO zones VALUES (64, 223, 'WI', 'Wisconsin');
INSERT INTO zones VALUES (65, 223, 'WY', 'Wyoming');
INSERT INTO zones VALUES (66, 38, 'AB', 'Alberta');
INSERT INTO zones VALUES (67, 38, 'BC', 'British Columbia');
INSERT INTO zones VALUES (68, 38, 'MB', 'Manitoba');
INSERT INTO zones VALUES (69, 38, 'NF', 'Newfoundland');
INSERT INTO zones VALUES (70, 38, 'NB', 'New Brunswick');
INSERT INTO zones VALUES (71, 38, 'NS', 'Nova Scotia');
INSERT INTO zones VALUES (72, 38, 'NT', 'Northwest Territories');
INSERT INTO zones VALUES (73, 38, 'NU', 'Nunavut');
INSERT INTO zones VALUES (74, 38, 'ON', 'Ontario');
INSERT INTO zones VALUES (75, 38, 'PE', 'Prince Edward Island');
INSERT INTO zones VALUES (76, 38, 'QC', 'Quebec');
INSERT INTO zones VALUES (77, 38, 'SK', 'Saskatchewan');
INSERT INTO zones VALUES (78, 38, 'YT', 'Yukon Territory');
INSERT INTO zones VALUES (79, 81, 'NDS', 'Niedersachsen');
INSERT INTO zones VALUES (80, 81, 'BAW', 'Baden-Wttemberg');
INSERT INTO zones VALUES (81, 81, 'BAY', 'Bayern');
INSERT INTO zones VALUES (82, 81, 'BER', 'Berlin');
INSERT INTO zones VALUES (83, 81, 'BRG', 'Brandenburg');
INSERT INTO zones VALUES (84, 81, 'BRE', 'Bremen');
INSERT INTO zones VALUES (85, 81, 'HAM', 'Hamburg');
INSERT INTO zones VALUES (86, 81, 'HES', 'Hessen');
INSERT INTO zones VALUES (87, 81, 'MEC', 'Mecklenburg-Vorpommern');
INSERT INTO zones VALUES (88, 81, 'NRW', 'Nordrhein-Westfalen');
INSERT INTO zones VALUES (89, 81, 'RHE', 'Rheinland-Pfalz');
INSERT INTO zones VALUES (90, 81, 'SAR', 'Saarland');
INSERT INTO zones VALUES (91, 81, 'SAS', 'Sachsen');
INSERT INTO zones VALUES (92, 81, 'SAC', 'Sachsen-Anhalt');
INSERT INTO zones VALUES (93, 81, 'SCN', 'Schleswig-Holstein');
INSERT INTO zones VALUES (94, 81, 'THE', 'Thingen');
INSERT INTO zones VALUES (95, 14, 'WI', 'Wien');
INSERT INTO zones VALUES (96, 14, 'NO', 'Nieder飉terreich');
INSERT INTO zones VALUES (97, 14, 'OO', 'Ober飉terreich');
INSERT INTO zones VALUES (98, 14, 'SB', 'Salzburg');
INSERT INTO zones VALUES (99, 14, 'KN', 'K酺nten');
INSERT INTO zones VALUES (100, 14, 'ST', 'Steiermark');
INSERT INTO zones VALUES (101, 14, 'TI', 'Tirol');
INSERT INTO zones VALUES (102, 14, 'BL', 'Burgenland');
INSERT INTO zones VALUES (103, 14, 'VB', 'Voralberg');
INSERT INTO zones VALUES (104, 204, 'AG', 'Aargau');
INSERT INTO zones VALUES (105, 204, 'AI', 'Appenzell Innerrhoden');
INSERT INTO zones VALUES (106, 204, 'AR', 'Appenzell Ausserrhoden');
INSERT INTO zones VALUES (107, 204, 'BE', 'Bern');
INSERT INTO zones VALUES (108, 204, 'BL', 'Basel-Landschaft');
INSERT INTO zones VALUES (109, 204, 'BS', 'Basel-Stadt');
INSERT INTO zones VALUES (110, 204, 'FR', 'Freiburg');
INSERT INTO zones VALUES (111, 204, 'GE', 'Genf');
INSERT INTO zones VALUES (112, 204, 'GL', 'Glarus');
INSERT INTO zones VALUES (113, 204, 'JU', 'Graubden');
INSERT INTO zones VALUES (114, 204, 'JU', 'Jura');
INSERT INTO zones VALUES (115, 204, 'LU', 'Luzern');
INSERT INTO zones VALUES (116, 204, 'NE', 'Neuenburg');
INSERT INTO zones VALUES (117, 204, 'NW', 'Nidwalden');
INSERT INTO zones VALUES (118, 204, 'OW', 'Obwalden');
INSERT INTO zones VALUES (119, 204, 'SG', 'St. Gallen');
INSERT INTO zones VALUES (120, 204, 'SH', 'Schaffhausen');
INSERT INTO zones VALUES (121, 204, 'SO', 'Solothurn');
INSERT INTO zones VALUES (122, 204, 'SZ', 'Schwyz');
INSERT INTO zones VALUES (123, 204, 'TG', 'Thurgau');
INSERT INTO zones VALUES (124, 204, 'TI', 'Tessin');
INSERT INTO zones VALUES (125, 204, 'UR', 'Uri');
INSERT INTO zones VALUES (126, 204, 'VD', 'Waadt');
INSERT INTO zones VALUES (127, 204, 'VS', 'Wallis');
INSERT INTO zones VALUES (128, 204, 'ZG', 'Zug');
INSERT INTO zones VALUES (129, 204, 'ZH', 'Zich');
INSERT INTO zones VALUES (130, 195, 'A Coru鎙', 'A Coru鎙');
INSERT INTO zones VALUES (131, 195, 'Alava', 'Alava');
INSERT INTO zones VALUES (132, 195, 'Albacete', 'Albacete');
INSERT INTO zones VALUES (133, 195, 'Alicante', 'Alicante');
INSERT INTO zones VALUES (134, 195, 'Almeria', 'Almeria');
INSERT INTO zones VALUES (135, 195, 'Asturias', 'Asturias');
INSERT INTO zones VALUES (136, 195, 'Avila', 'Avila');
INSERT INTO zones VALUES (137, 195, 'Badajoz', 'Badajoz');
INSERT INTO zones VALUES (138, 195, 'Baleares', 'Baleares');
INSERT INTO zones VALUES (139, 195, 'Barcelona', 'Barcelona');
INSERT INTO zones VALUES (140, 195, 'Burgos', 'Burgos');
INSERT INTO zones VALUES (141, 195, 'Caceres', 'Caceres');
INSERT INTO zones VALUES (142, 195, 'Cadiz', 'Cadiz');
INSERT INTO zones VALUES (143, 195, 'Cantabria', 'Cantabria');
INSERT INTO zones VALUES (144, 195, 'Castellon', 'Castellon');
INSERT INTO zones VALUES (145, 195, 'Ceuta', 'Ceuta');
INSERT INTO zones VALUES (146, 195, 'Ciudad Real', 'Ciudad Real');
INSERT INTO zones VALUES (147, 195, 'Cordoba', 'Cordoba');
INSERT INTO zones VALUES (148, 195, 'Cuenca', 'Cuenca');
INSERT INTO zones VALUES (149, 195, 'Girona', 'Girona');
INSERT INTO zones VALUES (150, 195, 'Granada', 'Granada');
INSERT INTO zones VALUES (151, 195, 'Guadalajara', 'Guadalajara');
INSERT INTO zones VALUES (152, 195, 'Guipuzcoa', 'Guipuzcoa');
INSERT INTO zones VALUES (153, 195, 'Huelva', 'Huelva');
INSERT INTO zones VALUES (154, 195, 'Huesca', 'Huesca');
INSERT INTO zones VALUES (155, 195, 'Jaen', 'Jaen');
INSERT INTO zones VALUES (156, 195, 'La Rioja', 'La Rioja');
INSERT INTO zones VALUES (157, 195, 'Las Palmas', 'Las Palmas');
INSERT INTO zones VALUES (158, 195, 'Leon', 'Leon');
INSERT INTO zones VALUES (159, 195, 'Lleida', 'Lleida');
INSERT INTO zones VALUES (160, 195, 'Lugo', 'Lugo');
INSERT INTO zones VALUES (161, 195, 'Madrid', 'Madrid');
INSERT INTO zones VALUES (162, 195, 'Malaga', 'Malaga');
INSERT INTO zones VALUES (163, 195, 'Melilla', 'Melilla');
INSERT INTO zones VALUES (164, 195, 'Murcia', 'Murcia');
INSERT INTO zones VALUES (165, 195, 'Navarra', 'Navarra');
INSERT INTO zones VALUES (166, 195, 'Ourense', 'Ourense');
INSERT INTO zones VALUES (167, 195, 'Palencia', 'Palencia');
INSERT INTO zones VALUES (168, 195, 'Pontevedra', 'Pontevedra');
INSERT INTO zones VALUES (169, 195, 'Salamanca', 'Salamanca');
INSERT INTO zones VALUES (170, 195, 'Santa Cruz de Tenerife', 'Santa Cruz de Tenerife');
INSERT INTO zones VALUES (171, 195, 'Segovia', 'Segovia');
INSERT INTO zones VALUES (172, 195, 'Sevilla', 'Sevilla');
INSERT INTO zones VALUES (173, 195, 'Soria', 'Soria');
INSERT INTO zones VALUES (174, 195, 'Tarragona', 'Tarragona');
INSERT INTO zones VALUES (175, 195, 'Teruel', 'Teruel');
INSERT INTO zones VALUES (176, 195, 'Toledo', 'Toledo');
INSERT INTO zones VALUES (177, 195, 'Valencia', 'Valencia');
INSERT INTO zones VALUES (178, 195, 'Valladolid', 'Valladolid');
INSERT INTO zones VALUES (179, 195, 'Vizcaya', 'Vizcaya');
INSERT INTO zones VALUES (180, 195, 'Zamora', 'Zamora');
INSERT INTO zones VALUES (181, 195, 'Zaragoza', 'Zaragoza');
INSERT INTO zones VALUES (182, 206, '台北市', '台北市');
INSERT INTO zones VALUES (183, 206, '台北縣', '台北縣');
INSERT INTO zones VALUES (184, 206, '基隆市', '基隆市');
INSERT INTO zones VALUES (185, 206, '桃園縣', '桃園縣');
INSERT INTO zones VALUES (186, 206, '新竹市', '新竹市');
INSERT INTO zones VALUES (187, 206, '新竹縣', '新竹縣');
INSERT INTO zones VALUES (188, 206, '苗栗縣', '苗栗縣');
INSERT INTO zones VALUES (189, 206, '台中市', '台中市');
INSERT INTO zones VALUES (190, 206, '台中縣', '台中縣');
INSERT INTO zones VALUES (191, 206, '彰化縣', '彰化縣');
INSERT INTO zones VALUES (192, 206, '南投縣', '南投縣');
INSERT INTO zones VALUES (193, 206, '雲林縣', '雲林縣');
INSERT INTO zones VALUES (194, 206, '嘉義市', '嘉義市');
INSERT INTO zones VALUES (195, 206, '嘉義縣', '嘉義縣');
INSERT INTO zones VALUES (196, 206, '台南市', '台南市');
INSERT INTO zones VALUES (197, 206, '台南縣', '台南縣');
INSERT INTO zones VALUES (198, 206, '高雄市', '高雄市');
INSERT INTO zones VALUES (199, 206, '高雄縣', '高雄縣');
INSERT INTO zones VALUES (200, 206, '屏東縣', '屏東縣');
INSERT INTO zones VALUES (201, 206, '台東縣', '台東縣');
INSERT INTO zones VALUES (202, 206, '花蓮縣', '花蓮縣');
INSERT INTO zones VALUES (203, 206, '宜蘭縣', '宜蘭縣');
INSERT INTO zones VALUES (204, 206, '澎湖縣', '澎湖縣');
INSERT INTO zones VALUES (205, 206, '金門縣', '金門縣');
INSERT INTO zones VALUES (206, 206, '連江縣', '連江縣');
INSERT INTO zones VALUES (207, 44, 'BJ', '北京');
INSERT INTO zones VALUES (208, 44, 'SH', '上海');
INSERT INTO zones VALUES (209, 44, 'TJ', '天津');
INSERT INTO zones VALUES (210, 44, 'CQ', '重庆');
INSERT INTO zones VALUES (211, 44, 'AH', '安徽');
INSERT INTO zones VALUES (212, 44, 'FJ', '福建');
INSERT INTO zones VALUES (213, 44, 'GD', '广东');
INSERT INTO zones VALUES (214, 44, 'GS', '甘肃');
INSERT INTO zones VALUES (215, 44, 'GX', '广西');
INSERT INTO zones VALUES (216, 44, 'GZ', '贵州');
INSERT INTO zones VALUES (217, 44, 'HA', '河南');
INSERT INTO zones VALUES (218, 44, 'HB', '湖北');
INSERT INTO zones VALUES (219, 44, 'HE', '河北');
INSERT INTO zones VALUES (220, 44, 'HI', '海南');
INSERT INTO zones VALUES (221, 44, 'HK', '香港');
INSERT INTO zones VALUES (222, 44, 'HL', '黑龙江');
INSERT INTO zones VALUES (223, 44, 'HN', '湖南');
INSERT INTO zones VALUES (224, 44, 'JL', '吉林');
INSERT INTO zones VALUES (225, 44, 'JS', '江苏');
INSERT INTO zones VALUES (226, 44, 'JX', '江西');
INSERT INTO zones VALUES (227, 44, 'LN', '辽宁');
INSERT INTO zones VALUES (228, 44, 'MO', '澳门');
INSERT INTO zones VALUES (229, 44, 'NM', '内蒙');
INSERT INTO zones VALUES (230, 44, 'NX', '宁夏');
INSERT INTO zones VALUES (231, 44, 'QH', '青海');
INSERT INTO zones VALUES (232, 44, 'SC', '四川');
INSERT INTO zones VALUES (233, 44, 'SD', '山东');
INSERT INTO zones VALUES (234, 44, 'SN', '陕西');
INSERT INTO zones VALUES (235, 44, 'SX', '山西');
INSERT INTO zones VALUES (236, 44, 'TW', '台湾');
INSERT INTO zones VALUES (237, 44, 'XJ', '新疆');
INSERT INTO zones VALUES (238, 44, 'XZ', '西藏');
INSERT INTO zones VALUES (239, 44, 'YN', '云南');
INSERT INTO zones VALUES (240, 44, 'ZJ', '浙江');
INSERT INTO zones VALUES (241, 1, 'BDS', 'Badakhshan');
INSERT INTO zones VALUES (242, 1, 'BDG', 'Badghis');
INSERT INTO zones VALUES (243, 1, 'BGL', 'Baghlan');
INSERT INTO zones VALUES (244, 1, 'BAL', 'Balkh');
INSERT INTO zones VALUES (245, 1, 'BAM', 'Bamian');
INSERT INTO zones VALUES (246, 1, 'FRA', 'Farah');
INSERT INTO zones VALUES (247, 1, 'FYB', 'Faryab');
INSERT INTO zones VALUES (248, 1, 'GHA', 'Ghazni');
INSERT INTO zones VALUES (249, 1, 'GHO', 'Ghowr');
INSERT INTO zones VALUES (250, 1, 'HEL', 'Helmand');
INSERT INTO zones VALUES (251, 1, 'HER', 'Herat');
INSERT INTO zones VALUES (252, 1, 'JOW', 'Jowzjan');
INSERT INTO zones VALUES (253, 1, 'KAB', 'Kabul');
INSERT INTO zones VALUES (254, 1, 'KAN', 'Kandahar');
INSERT INTO zones VALUES (255, 1, 'KAP', 'Kapisa');
INSERT INTO zones VALUES (256, 1, 'KHO', 'Khost');
INSERT INTO zones VALUES (257, 1, 'KNR', 'Konar');
INSERT INTO zones VALUES (258, 1, 'KDZ', 'Kondoz');
INSERT INTO zones VALUES (259, 1, 'LAG', 'Laghman');
INSERT INTO zones VALUES (260, 1, 'LOW', 'Lowgar');
INSERT INTO zones VALUES (261, 1, 'NAN', 'Nangrahar');
INSERT INTO zones VALUES (262, 1, 'NIM', 'Nimruz');
INSERT INTO zones VALUES (263, 1, 'NUR', 'Nurestan');
INSERT INTO zones VALUES (264, 1, 'ORU', 'Oruzgan');
INSERT INTO zones VALUES (265, 1, 'PIA', 'Paktia');
INSERT INTO zones VALUES (266, 1, 'PKA', 'Paktika');
INSERT INTO zones VALUES (267, 1, 'PAR', 'Parwan');
INSERT INTO zones VALUES (268, 1, 'SAM', 'Samangan');
INSERT INTO zones VALUES (269, 1, 'SAR', 'Sar-e Pol');
INSERT INTO zones VALUES (270, 1, 'TAK', 'Takhar');
INSERT INTO zones VALUES (271, 1, 'WAR', 'Wardak');
INSERT INTO zones VALUES (272, 1, 'ZAB', 'Zabol');
INSERT INTO zones VALUES (273, 2, 'BR', 'Berat');
INSERT INTO zones VALUES (274, 2, 'BU', 'Bulqize');
INSERT INTO zones VALUES (275, 2, 'DL', 'Delvine');
INSERT INTO zones VALUES (276, 2, 'DV', 'Devoll');
INSERT INTO zones VALUES (277, 2, 'DI', 'Diber');
INSERT INTO zones VALUES (278, 2, 'DR', 'Durres');
INSERT INTO zones VALUES (279, 2, 'EL', 'Elbasan');
INSERT INTO zones VALUES (280, 2, 'ER', 'Kolonje');
INSERT INTO zones VALUES (281, 2, 'FR', 'Fier');
INSERT INTO zones VALUES (282, 2, 'GJ', 'Gjirokaster');
INSERT INTO zones VALUES (283, 2, 'GR', 'Gramsh');
INSERT INTO zones VALUES (284, 2, 'HA', 'Has');
INSERT INTO zones VALUES (285, 2, 'KA', 'Kavaje');
INSERT INTO zones VALUES (286, 2, 'KB', 'Kurbin');
INSERT INTO zones VALUES (287, 2, 'KC', 'Kucove');
INSERT INTO zones VALUES (288, 2, 'KO', 'Korce');
INSERT INTO zones VALUES (289, 2, 'KR', 'Kruje');
INSERT INTO zones VALUES (290, 2, 'KU', 'Kukes');
INSERT INTO zones VALUES (291, 2, 'LB', 'Librazhd');
INSERT INTO zones VALUES (292, 2, 'LE', 'Lezhe');
INSERT INTO zones VALUES (293, 2, 'LU', 'Lushnje');
INSERT INTO zones VALUES (294, 2, 'MM', 'Malesi e Madhe');
INSERT INTO zones VALUES (295, 2, 'MK', 'Mallakaster');
INSERT INTO zones VALUES (296, 2, 'MT', 'Mat');
INSERT INTO zones VALUES (297, 2, 'MR', 'Mirdite');
INSERT INTO zones VALUES (298, 2, 'PQ', 'Peqin');
INSERT INTO zones VALUES (299, 2, 'PR', 'Permet');
INSERT INTO zones VALUES (300, 2, 'PG', 'Pogradec');
INSERT INTO zones VALUES (301, 2, 'PU', 'Puke');
INSERT INTO zones VALUES (302, 2, 'SH', 'Shkoder');
INSERT INTO zones VALUES (303, 2, 'SK', 'Skrapar');
INSERT INTO zones VALUES (304, 2, 'SR', 'Sarande');
INSERT INTO zones VALUES (305, 2, 'TE', 'Tepelene');
INSERT INTO zones VALUES (306, 2, 'TP', 'Tropoje');
INSERT INTO zones VALUES (307, 2, 'TR', 'Tirane');
INSERT INTO zones VALUES (308, 2, 'VL', 'Vlore');
INSERT INTO zones VALUES (309, 3, 'ADR', 'Adrar');
INSERT INTO zones VALUES (310, 3, 'ADE', 'Ain Defla');
INSERT INTO zones VALUES (311, 3, 'ATE', 'Ain Temouchent');
INSERT INTO zones VALUES (312, 3, 'ALG', 'Alger');
INSERT INTO zones VALUES (313, 3, 'ANN', 'Annaba');
INSERT INTO zones VALUES (314, 3, 'BAT', 'Batna');
INSERT INTO zones VALUES (315, 3, 'BEC', 'Bechar');
INSERT INTO zones VALUES (316, 3, 'BEJ', 'Bejaia');
INSERT INTO zones VALUES (317, 3, 'BIS', 'Biskra');
INSERT INTO zones VALUES (318, 3, 'BLI', 'Blida');
INSERT INTO zones VALUES (319, 3, 'BBA', 'Bordj Bou Arreridj');
INSERT INTO zones VALUES (320, 3, 'BOA', 'Bouira');
INSERT INTO zones VALUES (321, 3, 'BMD', 'Boumerdes');
INSERT INTO zones VALUES (322, 3, 'CHL', 'Chlef');
INSERT INTO zones VALUES (323, 3, 'CON', 'Constantine');
INSERT INTO zones VALUES (324, 3, 'DJE', 'Djelfa');
INSERT INTO zones VALUES (325, 3, 'EBA', 'El Bayadh');
INSERT INTO zones VALUES (326, 3, 'EOU', 'El Oued');
INSERT INTO zones VALUES (327, 3, 'ETA', 'El Tarf');
INSERT INTO zones VALUES (328, 3, 'GHA', 'Ghardaia');
INSERT INTO zones VALUES (329, 3, 'GUE', 'Guelma');
INSERT INTO zones VALUES (330, 3, 'ILL', 'Illizi');
INSERT INTO zones VALUES (331, 3, 'JIJ', 'Jijel');
INSERT INTO zones VALUES (332, 3, 'KHE', 'Khenchela');
INSERT INTO zones VALUES (333, 3, 'LAG', 'Laghouat');
INSERT INTO zones VALUES (334, 3, 'MUA', 'Muaskar');
INSERT INTO zones VALUES (335, 3, 'MED', 'Medea');
INSERT INTO zones VALUES (336, 3, 'MIL', 'Mila');
INSERT INTO zones VALUES (337, 3, 'MOS', 'Mostaganem');
INSERT INTO zones VALUES (338, 3, 'MSI', 'M''Sila');
INSERT INTO zones VALUES (339, 3, 'NAA', 'Naama');
INSERT INTO zones VALUES (340, 3, 'ORA', 'Oran');
INSERT INTO zones VALUES (341, 3, 'OUA', 'Ouargla');
INSERT INTO zones VALUES (342, 3, 'OEB', 'Oum el-Bouaghi');
INSERT INTO zones VALUES (343, 3, 'REL', 'Relizane');
INSERT INTO zones VALUES (344, 3, 'SAI', 'Saida');
INSERT INTO zones VALUES (345, 3, 'SET', 'Setif');
INSERT INTO zones VALUES (346, 3, 'SBA', 'Sidi Bel Abbes');
INSERT INTO zones VALUES (347, 3, 'SKI', 'Skikda');
INSERT INTO zones VALUES (348, 3, 'SAH', 'Souk Ahras');
INSERT INTO zones VALUES (349, 3, 'TAM', 'Tamanghasset');
INSERT INTO zones VALUES (350, 3, 'TEB', 'Tebessa');
INSERT INTO zones VALUES (351, 3, 'TIA', 'Tiaret');
INSERT INTO zones VALUES (352, 3, 'TIN', 'Tindouf');
INSERT INTO zones VALUES (353, 3, 'TIP', 'Tipaza');
INSERT INTO zones VALUES (354, 3, 'TIS', 'Tissemsilt');
INSERT INTO zones VALUES (355, 3, 'TOU', 'Tizi Ouzou');
INSERT INTO zones VALUES (356, 3, 'TLE', 'Tlemcen');
INSERT INTO zones VALUES (357, 4, 'E', 'Eastern');
INSERT INTO zones VALUES (358, 4, 'M', 'Manu''a');
INSERT INTO zones VALUES (359, 4, 'R', 'Rose Island');
INSERT INTO zones VALUES (360, 4, 'S', 'Swains Island');
INSERT INTO zones VALUES (361, 4, 'W', 'Western');
INSERT INTO zones VALUES (362, 5, 'ALV', 'Andorra la Vella');
INSERT INTO zones VALUES (363, 5, 'CAN', 'Canillo');
INSERT INTO zones VALUES (364, 5, 'ENC', 'Encamp');
INSERT INTO zones VALUES (365, 5, 'ESE', 'Escaldes-Engordany');
INSERT INTO zones VALUES (366, 5, 'LMA', 'La Massana');
INSERT INTO zones VALUES (367, 5, 'ORD', 'Ordino');
INSERT INTO zones VALUES (368, 5, 'SJL', 'Sant Julia de L㳩a');
INSERT INTO zones VALUES (369, 6, 'BGO', 'Bengo');
INSERT INTO zones VALUES (370, 6, 'BGU', 'Benguela');
INSERT INTO zones VALUES (371, 6, 'BIE', 'Bie');
INSERT INTO zones VALUES (372, 6, 'CAB', 'Cabinda');
INSERT INTO zones VALUES (373, 6, 'CCU', 'Cuando-Cubango');
INSERT INTO zones VALUES (374, 6, 'CNO', 'Cuanza Norte');
INSERT INTO zones VALUES (375, 6, 'CUS', 'Cuanza Sul');
INSERT INTO zones VALUES (376, 6, 'CNN', 'Cunene');
INSERT INTO zones VALUES (377, 6, 'HUA', 'Huambo');
INSERT INTO zones VALUES (378, 6, 'HUI', 'Huila');
INSERT INTO zones VALUES (379, 6, 'LUA', 'Luanda');
INSERT INTO zones VALUES (380, 6, 'LNO', 'Lunda Norte');
INSERT INTO zones VALUES (381, 6, 'LSU', 'Lunda Sul');
INSERT INTO zones VALUES (382, 6, 'MAL', 'Malange');
INSERT INTO zones VALUES (383, 6, 'MOX', 'Moxico');
INSERT INTO zones VALUES (384, 6, 'NAM', 'Namibe');
INSERT INTO zones VALUES (385, 6, 'UIG', 'Uige');
INSERT INTO zones VALUES (386, 6, 'ZAI', 'Zaire');
INSERT INTO zones VALUES (387, 9, 'ASG', 'Saint George');
INSERT INTO zones VALUES (388, 9, 'ASJ', 'Saint John');
INSERT INTO zones VALUES (389, 9, 'ASM', 'Saint Mary');
INSERT INTO zones VALUES (390, 9, 'ASL', 'Saint Paul');
INSERT INTO zones VALUES (391, 9, 'ASR', 'Saint Peter');
INSERT INTO zones VALUES (392, 9, 'ASH', 'Saint Philip');
INSERT INTO zones VALUES (393, 9, 'BAR', 'Barbuda');
INSERT INTO zones VALUES (394, 9, 'RED', 'Redonda');
INSERT INTO zones VALUES (395, 10, 'AN', 'Antartida e Islas del Atlantico ');
INSERT INTO zones VALUES (396, 10, 'BA', 'Buenos Aires');
INSERT INTO zones VALUES (397, 10, 'CA', 'Catamarca');
INSERT INTO zones VALUES (398, 10, 'CH', 'Chaco');
INSERT INTO zones VALUES (399, 10, 'CU', 'Chubut');
INSERT INTO zones VALUES (400, 10, 'CO', 'Cordoba');
INSERT INTO zones VALUES (401, 10, 'CR', 'Corrientes');
INSERT INTO zones VALUES (402, 10, 'DF', 'Distrito Federal');
INSERT INTO zones VALUES (403, 10, 'ER', 'Entre Rios');
INSERT INTO zones VALUES (404, 10, 'FO', 'Formosa');
INSERT INTO zones VALUES (405, 10, 'JU', 'Jujuy');
INSERT INTO zones VALUES (406, 10, 'LP', 'La Pampa');
INSERT INTO zones VALUES (407, 10, 'LR', 'La Rioja');
INSERT INTO zones VALUES (408, 10, 'ME', 'Mendoza');
INSERT INTO zones VALUES (409, 10, 'MI', 'Misiones');
INSERT INTO zones VALUES (410, 10, 'NE', 'Neuquen');
INSERT INTO zones VALUES (411, 10, 'RN', 'Rio Negro');
INSERT INTO zones VALUES (412, 10, 'SA', 'Salta');
INSERT INTO zones VALUES (413, 10, 'SJ', 'San Juan');
INSERT INTO zones VALUES (414, 10, 'SL', 'San Luis');
INSERT INTO zones VALUES (415, 10, 'SC', 'Santa Cruz');
INSERT INTO zones VALUES (416, 10, 'SF', 'Santa Fe');
INSERT INTO zones VALUES (417, 10, 'SD', 'Santiago del Estero');
INSERT INTO zones VALUES (418, 10, 'TF', 'Tierra del Fuego');
INSERT INTO zones VALUES (419, 10, 'TU', 'Tucuman');
INSERT INTO zones VALUES (420, 11, 'AGT', 'Aragatsotn');
INSERT INTO zones VALUES (421, 11, 'ARR', 'Ararat');
INSERT INTO zones VALUES (422, 11, 'ARM', 'Armavir');
INSERT INTO zones VALUES (423, 11, 'GEG', 'Geghark''unik''');
INSERT INTO zones VALUES (424, 11, 'KOT', 'Kotayk''');
INSERT INTO zones VALUES (425, 11, 'LOR', 'Lorri');
INSERT INTO zones VALUES (426, 11, 'SHI', 'Shirak');
INSERT INTO zones VALUES (427, 11, 'SYU', 'Syunik''');
INSERT INTO zones VALUES (428, 11, 'TAV', 'Tavush');
INSERT INTO zones VALUES (429, 11, 'VAY', 'Vayots'' Dzor');
INSERT INTO zones VALUES (430, 11, 'YER', 'Yerevan');
INSERT INTO zones VALUES (431, 13, 'ACT', 'Australian Capitol Territory');
INSERT INTO zones VALUES (432, 13, 'NSW', 'New South Wales');
INSERT INTO zones VALUES (433, 13, 'NT', 'Northern Territory');
INSERT INTO zones VALUES (434, 13, 'QLD', 'Queensland');
INSERT INTO zones VALUES (435, 13, 'SA', 'South Australia');
INSERT INTO zones VALUES (436, 13, 'TAS', 'Tasmania');
INSERT INTO zones VALUES (437, 13, 'VIC', 'Victoria');
INSERT INTO zones VALUES (438, 13, 'WA', 'Western Australia');
INSERT INTO zones VALUES (439, 14, 'BUR', 'Burgenland');
INSERT INTO zones VALUES (440, 14, 'KAR', 'K&auml;rnten');
INSERT INTO zones VALUES (441, 14, 'NOS', 'Nieder&ouml;esterreich');
INSERT INTO zones VALUES (442, 14, 'OOS', 'Ober&ouml;esterreich');
INSERT INTO zones VALUES (443, 14, 'SAL', 'Salzburg');
INSERT INTO zones VALUES (444, 14, 'STE', 'Steiermark');
INSERT INTO zones VALUES (445, 14, 'TIR', 'Tirol');
INSERT INTO zones VALUES (446, 14, 'VOR', 'Vorarlberg');
INSERT INTO zones VALUES (447, 14, 'WIE', 'Wien');
INSERT INTO zones VALUES (448, 15, 'AB', 'Ali Bayramli');
INSERT INTO zones VALUES (449, 15, 'ABS', 'Abseron');
INSERT INTO zones VALUES (450, 15, 'AGC', 'AgcabAdi');
INSERT INTO zones VALUES (451, 15, 'AGM', 'Agdam');
INSERT INTO zones VALUES (452, 15, 'AGS', 'Agdas');
INSERT INTO zones VALUES (453, 15, 'AGA', 'Agstafa');
INSERT INTO zones VALUES (454, 15, 'AGU', 'Agsu');
INSERT INTO zones VALUES (455, 15, 'AST', 'Astara');
INSERT INTO zones VALUES (456, 15, 'BA', 'Baki');
INSERT INTO zones VALUES (457, 15, 'BAB', 'BabAk');
INSERT INTO zones VALUES (458, 15, 'BAL', 'BalakAn');
INSERT INTO zones VALUES (459, 15, 'BAR', 'BArdA');
INSERT INTO zones VALUES (460, 15, 'BEY', 'Beylaqan');
INSERT INTO zones VALUES (461, 15, 'BIL', 'Bilasuvar');
INSERT INTO zones VALUES (462, 15, 'CAB', 'Cabrayil');
INSERT INTO zones VALUES (463, 15, 'CAL', 'Calilabab');
INSERT INTO zones VALUES (464, 15, 'CUL', 'Culfa');
INSERT INTO zones VALUES (465, 15, 'DAS', 'Daskasan');
INSERT INTO zones VALUES (466, 15, 'DAV', 'Davaci');
INSERT INTO zones VALUES (467, 15, 'FUZ', 'Fuzuli');
INSERT INTO zones VALUES (468, 15, 'GA', 'Ganca');
INSERT INTO zones VALUES (469, 15, 'GAD', 'Gadabay');
INSERT INTO zones VALUES (470, 15, 'GOR', 'Goranboy');
INSERT INTO zones VALUES (471, 15, 'GOY', 'Goycay');
INSERT INTO zones VALUES (472, 15, 'HAC', 'Haciqabul');
INSERT INTO zones VALUES (473, 15, 'IMI', 'Imisli');
INSERT INTO zones VALUES (474, 15, 'ISM', 'Ismayilli');
INSERT INTO zones VALUES (475, 15, 'KAL', 'Kalbacar');
INSERT INTO zones VALUES (476, 15, 'KUR', 'Kurdamir');
INSERT INTO zones VALUES (477, 15, 'LA', 'Lankaran');
INSERT INTO zones VALUES (478, 15, 'LAC', 'Lacin');
INSERT INTO zones VALUES (479, 15, 'LAN', 'Lankaran');
INSERT INTO zones VALUES (480, 15, 'LER', 'Lerik');
INSERT INTO zones VALUES (481, 15, 'MAS', 'Masalli');
INSERT INTO zones VALUES (482, 15, 'MI', 'Mingacevir');
INSERT INTO zones VALUES (483, 15, 'NA', 'Naftalan');
INSERT INTO zones VALUES (484, 15, 'NEF', 'Neftcala');
INSERT INTO zones VALUES (485, 15, 'OGU', 'Oguz');
INSERT INTO zones VALUES (486, 15, 'ORD', 'Ordubad');
INSERT INTO zones VALUES (487, 15, 'QAB', 'Qabala');
INSERT INTO zones VALUES (488, 15, 'QAX', 'Qax');
INSERT INTO zones VALUES (489, 15, 'QAZ', 'Qazax');
INSERT INTO zones VALUES (490, 15, 'QOB', 'Qobustan');
INSERT INTO zones VALUES (491, 15, 'QBA', 'Quba');
INSERT INTO zones VALUES (492, 15, 'QBI', 'Qubadli');
INSERT INTO zones VALUES (493, 15, 'QUS', 'Qusar');
INSERT INTO zones VALUES (494, 15, 'SA', 'Saki');
INSERT INTO zones VALUES (495, 15, 'SAT', 'Saatli');
INSERT INTO zones VALUES (496, 15, 'SAB', 'Sabirabad');
INSERT INTO zones VALUES (497, 15, 'SAD', 'Sadarak');
INSERT INTO zones VALUES (498, 15, 'SAH', 'Sahbuz');
INSERT INTO zones VALUES (499, 15, 'SAK', 'Saki');
INSERT INTO zones VALUES (500, 15, 'SAL', 'Salyan');
INSERT INTO zones VALUES (501, 15, 'SM', 'Sumqayit');
INSERT INTO zones VALUES (502, 15, 'SMI', 'Samaxi');
INSERT INTO zones VALUES (503, 15, 'SKR', 'Samkir');
INSERT INTO zones VALUES (504, 15, 'SMX', 'Samux');
INSERT INTO zones VALUES (505, 15, 'SAR', 'Sarur');
INSERT INTO zones VALUES (506, 15, 'SIY', 'Siyazan');
INSERT INTO zones VALUES (507, 15, 'SS', 'Susa');
INSERT INTO zones VALUES (508, 15, 'SUS', 'Susa');
INSERT INTO zones VALUES (509, 15, 'TAR', 'Tartar');
INSERT INTO zones VALUES (510, 15, 'TOV', 'Tovuz');
INSERT INTO zones VALUES (511, 15, 'UCA', 'Ucar');
INSERT INTO zones VALUES (512, 15, 'XA', 'Xankandi');
INSERT INTO zones VALUES (513, 15, 'XAC', 'Xacmaz');
INSERT INTO zones VALUES (514, 15, 'XAN', 'Xanlar');
INSERT INTO zones VALUES (515, 15, 'XIZ', 'Xizi');
INSERT INTO zones VALUES (516, 15, 'XCI', 'Xocali');
INSERT INTO zones VALUES (517, 15, 'XVD', 'Xocavand');
INSERT INTO zones VALUES (518, 15, 'YAR', 'Yardimli');
INSERT INTO zones VALUES (519, 15, 'YEV', 'Yevlax');
INSERT INTO zones VALUES (520, 15, 'ZAN', 'Zangilan');
INSERT INTO zones VALUES (521, 15, 'ZAQ', 'Zaqatala');
INSERT INTO zones VALUES (522, 15, 'ZAR', 'Zardab');
INSERT INTO zones VALUES (523, 15, 'NX', 'Naxcivan');
INSERT INTO zones VALUES (524, 16, 'ACK', 'Acklins');
INSERT INTO zones VALUES (525, 16, 'BER', 'Berry Islands');
INSERT INTO zones VALUES (526, 16, 'BIM', 'Bimini');
INSERT INTO zones VALUES (527, 16, 'BLK', 'Black Point');
INSERT INTO zones VALUES (528, 16, 'CAT', 'Cat Island');
INSERT INTO zones VALUES (529, 16, 'CAB', 'Central Abaco');
INSERT INTO zones VALUES (530, 16, 'CAN', 'Central Andros');
INSERT INTO zones VALUES (531, 16, 'CEL', 'Central Eleuthera');
INSERT INTO zones VALUES (532, 16, 'FRE', 'City of Freeport');
INSERT INTO zones VALUES (533, 16, 'CRO', 'Crooked Island');
INSERT INTO zones VALUES (534, 16, 'EGB', 'East Grand Bahama');
INSERT INTO zones VALUES (535, 16, 'EXU', 'Exuma');
INSERT INTO zones VALUES (536, 16, 'GRD', 'Grand Cay');
INSERT INTO zones VALUES (537, 16, 'HAR', 'Harbour Island');
INSERT INTO zones VALUES (538, 16, 'HOP', 'Hope Town');
INSERT INTO zones VALUES (539, 16, 'INA', 'Inagua');
INSERT INTO zones VALUES (540, 16, 'LNG', 'Long Island');
INSERT INTO zones VALUES (541, 16, 'MAN', 'Mangrove Cay');
INSERT INTO zones VALUES (542, 16, 'MAY', 'Mayaguana');
INSERT INTO zones VALUES (543, 16, 'MOO', 'Moore''s Island');
INSERT INTO zones VALUES (544, 16, 'NAB', 'North Abaco');
INSERT INTO zones VALUES (545, 16, 'NAN', 'North Andros');
INSERT INTO zones VALUES (546, 16, 'NEL', 'North Eleuthera');
INSERT INTO zones VALUES (547, 16, 'RAG', 'Ragged Island');
INSERT INTO zones VALUES (548, 16, 'RUM', 'Rum Cay');
INSERT INTO zones VALUES (549, 16, 'SAL', 'San Salvador');
INSERT INTO zones VALUES (550, 16, 'SAB', 'South Abaco');
INSERT INTO zones VALUES (551, 16, 'SAN', 'South Andros');
INSERT INTO zones VALUES (552, 16, 'SEL', 'South Eleuthera');
INSERT INTO zones VALUES (553, 16, 'SWE', 'Spanish Wells');
INSERT INTO zones VALUES (554, 16, 'WGB', 'West Grand Bahama');
INSERT INTO zones VALUES (555, 17, 'CAP', 'Capital');
INSERT INTO zones VALUES (556, 17, 'CEN', 'Central');
INSERT INTO zones VALUES (557, 17, 'MUH', 'Muharraq');
INSERT INTO zones VALUES (558, 17, 'NOR', 'Northern');
INSERT INTO zones VALUES (559, 17, 'SOU', 'Southern');
INSERT INTO zones VALUES (560, 18, 'BAR', 'Barisal');
INSERT INTO zones VALUES (561, 18, 'CHI', 'Chittagong');
INSERT INTO zones VALUES (562, 18, 'DHA', 'Dhaka');
INSERT INTO zones VALUES (563, 18, 'KHU', 'Khulna');
INSERT INTO zones VALUES (564, 18, 'RAJ', 'Rajshahi');
INSERT INTO zones VALUES (565, 18, 'SYL', 'Sylhet');
INSERT INTO zones VALUES (566, 19, 'CC', 'Christ Church');
INSERT INTO zones VALUES (567, 19, 'AND', 'Saint Andrew');
INSERT INTO zones VALUES (568, 19, 'GEO', 'Saint George');
INSERT INTO zones VALUES (569, 19, 'JAM', 'Saint James');
INSERT INTO zones VALUES (570, 19, 'JOH', 'Saint John');
INSERT INTO zones VALUES (571, 19, 'JOS', 'Saint Joseph');
INSERT INTO zones VALUES (572, 19, 'LUC', 'Saint Lucy');
INSERT INTO zones VALUES (573, 19, 'MIC', 'Saint Michael');
INSERT INTO zones VALUES (574, 19, 'PET', 'Saint Peter');
INSERT INTO zones VALUES (575, 19, 'PHI', 'Saint Philip');
INSERT INTO zones VALUES (576, 19, 'THO', 'Saint Thomas');
INSERT INTO zones VALUES (577, 20, 'BR', 'Brestskaya (Brest)');
INSERT INTO zones VALUES (578, 20, 'HO', 'Homyel''skaya (Homyel'')');
INSERT INTO zones VALUES (579, 20, 'HM', 'Horad Minsk');
INSERT INTO zones VALUES (580, 20, 'HR', 'Hrodzyenskaya (Hrodna)');
INSERT INTO zones VALUES (581, 20, 'MA', 'Mahilyowskaya (Mahilyow)');
INSERT INTO zones VALUES (582, 20, 'MI', 'Minskaya');
INSERT INTO zones VALUES (583, 20, 'VI', 'Vitsyebskaya (Vitsyebsk)');
INSERT INTO zones VALUES (584, 21, 'VAN', 'Antwerpen');
INSERT INTO zones VALUES (585, 21, 'WBR', 'Brabant Wallon');
INSERT INTO zones VALUES (586, 21, 'WHT', 'Hainaut');
INSERT INTO zones VALUES (587, 21, 'WLG', 'Liege');
INSERT INTO zones VALUES (588, 21, 'VLI', 'Limburg');
INSERT INTO zones VALUES (589, 21, 'WLX', 'Luxembourg');
INSERT INTO zones VALUES (590, 21, 'WNA', 'Namur');
INSERT INTO zones VALUES (591, 21, 'VOV', 'Oost-Vlaanderen');
INSERT INTO zones VALUES (592, 21, 'VBR', 'Vlaams Brabant');
INSERT INTO zones VALUES (593, 21, 'VWV', 'West-Vlaanderen');
INSERT INTO zones VALUES (594, 22, 'BZ', 'Belize');
INSERT INTO zones VALUES (595, 22, 'CY', 'Cayo');
INSERT INTO zones VALUES (596, 22, 'CR', 'Corozal');
INSERT INTO zones VALUES (597, 22, 'OW', 'Orange Walk');
INSERT INTO zones VALUES (598, 22, 'SC', 'Stann Creek');
INSERT INTO zones VALUES (599, 22, 'TO', 'Toledo');
INSERT INTO zones VALUES (600, 23, 'AL', 'Alibori');
INSERT INTO zones VALUES (601, 23, 'AK', 'Atakora');
INSERT INTO zones VALUES (602, 23, 'AQ', 'Atlantique');
INSERT INTO zones VALUES (603, 23, 'BO', 'Borgou');
INSERT INTO zones VALUES (604, 23, 'CO', 'Collines');
INSERT INTO zones VALUES (605, 23, 'DO', 'Donga');
INSERT INTO zones VALUES (606, 23, 'KO', 'Kouffo');
INSERT INTO zones VALUES (607, 23, 'LI', 'Littoral');
INSERT INTO zones VALUES (608, 23, 'MO', 'Mono');
INSERT INTO zones VALUES (609, 23, 'OU', 'Oueme');
INSERT INTO zones VALUES (610, 23, 'PL', 'Plateau');
INSERT INTO zones VALUES (611, 23, 'ZO', 'Zou');
INSERT INTO zones VALUES (612, 24, 'DS', 'Devonshire');
INSERT INTO zones VALUES (613, 24, 'HC', 'Hamilton City');
INSERT INTO zones VALUES (614, 24, 'HA', 'Hamilton');
INSERT INTO zones VALUES (615, 24, 'PG', 'Paget');
INSERT INTO zones VALUES (616, 24, 'PB', 'Pembroke');
INSERT INTO zones VALUES (617, 24, 'GC', 'Saint George City');
INSERT INTO zones VALUES (618, 24, 'SG', 'Saint George''s');
INSERT INTO zones VALUES (619, 24, 'SA', 'Sandys');
INSERT INTO zones VALUES (620, 24, 'SM', 'Smith''s');
INSERT INTO zones VALUES (621, 24, 'SH', 'Southampton');
INSERT INTO zones VALUES (622, 24, 'WA', 'Warwick');
INSERT INTO zones VALUES (623, 25, 'BUM', 'Bumthang');
INSERT INTO zones VALUES (624, 25, 'CHU', 'Chukha');
INSERT INTO zones VALUES (625, 25, 'DAG', 'Dagana');
INSERT INTO zones VALUES (626, 25, 'GAS', 'Gasa');
INSERT INTO zones VALUES (627, 25, 'HAA', 'Haa');
INSERT INTO zones VALUES (628, 25, 'LHU', 'Lhuntse');
INSERT INTO zones VALUES (629, 25, 'MON', 'Mongar');
INSERT INTO zones VALUES (630, 25, 'PAR', 'Paro');
INSERT INTO zones VALUES (631, 25, 'PEM', 'Pemagatshel');
INSERT INTO zones VALUES (632, 25, 'PUN', 'Punakha');
INSERT INTO zones VALUES (633, 25, 'SJO', 'Samdrup Jongkhar');
INSERT INTO zones VALUES (634, 25, 'SAT', 'Samtse');
INSERT INTO zones VALUES (635, 25, 'SAR', 'Sarpang');
INSERT INTO zones VALUES (636, 25, 'THI', 'Thimphu');
INSERT INTO zones VALUES (637, 25, 'TRG', 'Trashigang');
INSERT INTO zones VALUES (638, 25, 'TRY', 'Trashiyangste');
INSERT INTO zones VALUES (639, 25, 'TRO', 'Trongsa');
INSERT INTO zones VALUES (640, 25, 'TSI', 'Tsirang');
INSERT INTO zones VALUES (641, 25, 'WPH', 'Wangdue Phodrang');
INSERT INTO zones VALUES (642, 25, 'ZHE', 'Zhemgang');
INSERT INTO zones VALUES (643, 26, 'BEN', 'Beni');
INSERT INTO zones VALUES (644, 26, 'CHU', 'Chuquisaca');
INSERT INTO zones VALUES (645, 26, 'COC', 'Cochabamba');
INSERT INTO zones VALUES (646, 26, 'LPZ', 'La Paz');
INSERT INTO zones VALUES (647, 26, 'ORU', 'Oruro');
INSERT INTO zones VALUES (648, 26, 'PAN', 'Pando');
INSERT INTO zones VALUES (649, 26, 'POT', 'Potosi');
INSERT INTO zones VALUES (650, 26, 'SCZ', 'Santa Cruz');
INSERT INTO zones VALUES (651, 26, 'TAR', 'Tarija');
INSERT INTO zones VALUES (652, 27, 'BRO', 'Brcko district');
INSERT INTO zones VALUES (653, 27, 'FUS', 'Unsko-Sanski Kanton');
INSERT INTO zones VALUES (654, 27, 'FPO', 'Posavski Kanton');
INSERT INTO zones VALUES (655, 27, 'FTU', 'Tuzlanski Kanton');
INSERT INTO zones VALUES (656, 27, 'FZE', 'Zenicko-Dobojski Kanton');
INSERT INTO zones VALUES (657, 27, 'FBP', 'Bosanskopodrinjski Kanton');
INSERT INTO zones VALUES (658, 27, 'FSB', 'Srednjebosanski Kanton');
INSERT INTO zones VALUES (659, 27, 'FHN', 'Hercegovacko-neretvanski Kanton');
INSERT INTO zones VALUES (660, 27, 'FZH', 'Zapadnohercegovacka Zupanija');
INSERT INTO zones VALUES (661, 27, 'FSA', 'Kanton Sarajevo');
INSERT INTO zones VALUES (662, 27, 'FZA', 'Zapadnobosanska');
INSERT INTO zones VALUES (663, 27, 'SBL', 'Banja Luka');
INSERT INTO zones VALUES (664, 27, 'SDO', 'Doboj');
INSERT INTO zones VALUES (665, 27, 'SBI', 'Bijeljina');
INSERT INTO zones VALUES (666, 27, 'SVL', 'Vlasenica');
INSERT INTO zones VALUES (667, 27, 'SSR', 'Sarajevo-Romanija or Sokolac');
INSERT INTO zones VALUES (668, 27, 'SFO', 'Foca');
INSERT INTO zones VALUES (669, 27, 'STR', 'Trebinje');
INSERT INTO zones VALUES (670, 28, 'CE', 'Central');
INSERT INTO zones VALUES (671, 28, 'GH', 'Ghanzi');
INSERT INTO zones VALUES (672, 28, 'KD', 'Kgalagadi');
INSERT INTO zones VALUES (673, 28, 'KT', 'Kgatleng');
INSERT INTO zones VALUES (674, 28, 'KW', 'Kweneng');
INSERT INTO zones VALUES (675, 28, 'NG', 'Ngamiland');
INSERT INTO zones VALUES (676, 28, 'NE', 'North East');
INSERT INTO zones VALUES (677, 28, 'NW', 'North West');
INSERT INTO zones VALUES (678, 28, 'SE', 'South East');
INSERT INTO zones VALUES (679, 28, 'SO', 'Southern');
INSERT INTO zones VALUES (680, 30, 'AC', 'Acre');
INSERT INTO zones VALUES (681, 30, 'AL', 'Alagoas');
INSERT INTO zones VALUES (682, 30, 'AP', 'Amapa');
INSERT INTO zones VALUES (683, 30, 'AM', 'Amazonas');
INSERT INTO zones VALUES (684, 30, 'BA', 'Bahia');
INSERT INTO zones VALUES (685, 30, 'CE', 'Ceara');
INSERT INTO zones VALUES (686, 30, 'DF', 'Distrito Federal');
INSERT INTO zones VALUES (687, 30, 'ES', 'Espirito Santo');
INSERT INTO zones VALUES (688, 30, 'GO', 'Goias');
INSERT INTO zones VALUES (689, 30, 'MA', 'Maranhao');
INSERT INTO zones VALUES (690, 30, 'MT', 'Mato Grosso');
INSERT INTO zones VALUES (691, 30, 'MS', 'Mato Grosso do Sul');
INSERT INTO zones VALUES (692, 30, 'MG', 'Minas Gerais');
INSERT INTO zones VALUES (693, 30, 'PA', 'Para');
INSERT INTO zones VALUES (694, 30, 'PB', 'Paraiba');
INSERT INTO zones VALUES (695, 30, 'PR', 'Parana');
INSERT INTO zones VALUES (696, 30, 'PE', 'Pernambuco');
INSERT INTO zones VALUES (697, 30, 'PI', 'Piaui');
INSERT INTO zones VALUES (698, 30, 'RJ', 'Rio de Janeiro');
INSERT INTO zones VALUES (699, 30, 'RN', 'Rio Grande do Norte');
INSERT INTO zones VALUES (700, 30, 'RS', 'Rio Grande do Sul');
INSERT INTO zones VALUES (701, 30, 'RO', 'Rondonia');
INSERT INTO zones VALUES (702, 30, 'RR', 'Roraima');
INSERT INTO zones VALUES (703, 30, 'SC', 'Santa Catarina');
INSERT INTO zones VALUES (704, 30, 'SP', 'Sao Paulo');
INSERT INTO zones VALUES (705, 30, 'SE', 'Sergipe');
INSERT INTO zones VALUES (706, 30, 'TO', 'Tocantins');
INSERT INTO zones VALUES (707, 31, 'PB', 'Peros Banhos');
INSERT INTO zones VALUES (708, 31, 'SI', 'Salomon Islands');
INSERT INTO zones VALUES (709, 31, 'NI', 'Nelsons Island');
INSERT INTO zones VALUES (710, 31, 'TB', 'Three Brothers');
INSERT INTO zones VALUES (711, 31, 'EA', 'Eagle Islands');
INSERT INTO zones VALUES (712, 31, 'DI', 'Danger Island');
INSERT INTO zones VALUES (713, 31, 'EG', 'Egmont Islands');
INSERT INTO zones VALUES (714, 31, 'DG', 'Diego Garcia');
INSERT INTO zones VALUES (715, 32, 'BEL', 'Belait');
INSERT INTO zones VALUES (716, 32, 'BRM', 'Brunei and Muara');
INSERT INTO zones VALUES (717, 32, 'TEM', 'Temburong');
INSERT INTO zones VALUES (718, 32, 'TUT', 'Tutong');
INSERT INTO zones VALUES (719, 33, '', 'Blagoevgrad');
INSERT INTO zones VALUES (720, 33, '', 'Burgas');
INSERT INTO zones VALUES (721, 33, '', 'Dobrich');
INSERT INTO zones VALUES (722, 33, '', 'Gabrovo');
INSERT INTO zones VALUES (723, 33, '', 'Haskovo');
INSERT INTO zones VALUES (724, 33, '', 'Kardjali');
INSERT INTO zones VALUES (725, 33, '', 'Kyustendil');
INSERT INTO zones VALUES (726, 33, '', 'Lovech');
INSERT INTO zones VALUES (727, 33, '', 'Montana');
INSERT INTO zones VALUES (728, 33, '', 'Pazardjik');
INSERT INTO zones VALUES (729, 33, '', 'Pernik');
INSERT INTO zones VALUES (730, 33, '', 'Pleven');
INSERT INTO zones VALUES (731, 33, '', 'Plovdiv');
INSERT INTO zones VALUES (732, 33, '', 'Razgrad');
INSERT INTO zones VALUES (733, 33, '', 'Shumen');
INSERT INTO zones VALUES (734, 33, '', 'Silistra');
INSERT INTO zones VALUES (735, 33, '', 'Sliven');
INSERT INTO zones VALUES (736, 33, '', 'Smolyan');
INSERT INTO zones VALUES (737, 33, '', 'Sofia');
INSERT INTO zones VALUES (738, 33, '', 'Sofia - town');
INSERT INTO zones VALUES (739, 33, '', 'Stara Zagora');
INSERT INTO zones VALUES (740, 33, '', 'Targovishte');
INSERT INTO zones VALUES (741, 33, '', 'Varna');
INSERT INTO zones VALUES (742, 33, '', 'Veliko Tarnovo');
INSERT INTO zones VALUES (743, 33, '', 'Vidin');
INSERT INTO zones VALUES (744, 33, '', 'Vratza');
INSERT INTO zones VALUES (745, 33, '', 'Yambol');
INSERT INTO zones VALUES (746, 34, 'BAL', 'Bale');
INSERT INTO zones VALUES (747, 34, 'BAM', 'Bam');
INSERT INTO zones VALUES (748, 34, 'BAN', 'Banwa');
INSERT INTO zones VALUES (749, 34, 'BAZ', 'Bazega');
INSERT INTO zones VALUES (750, 34, 'BOR', 'Bougouriba');
INSERT INTO zones VALUES (751, 34, 'BLG', 'Boulgou');
INSERT INTO zones VALUES (752, 34, 'BOK', 'Boulkiemde');
INSERT INTO zones VALUES (753, 34, 'COM', 'Comoe');
INSERT INTO zones VALUES (754, 34, 'GAN', 'Ganzourgou');
INSERT INTO zones VALUES (755, 34, 'GNA', 'Gnagna');
INSERT INTO zones VALUES (756, 34, 'GOU', 'Gourma');
INSERT INTO zones VALUES (757, 34, 'HOU', 'Houet');
INSERT INTO zones VALUES (758, 34, 'IOA', 'Ioba');
INSERT INTO zones VALUES (759, 34, 'KAD', 'Kadiogo');
INSERT INTO zones VALUES (760, 34, 'KEN', 'Kenedougou');
INSERT INTO zones VALUES (761, 34, 'KOD', 'Komondjari');
INSERT INTO zones VALUES (762, 34, 'KOP', 'Kompienga');
INSERT INTO zones VALUES (763, 34, 'KOS', 'Kossi');
INSERT INTO zones VALUES (764, 34, 'KOL', 'Koulpelogo');
INSERT INTO zones VALUES (765, 34, 'KOT', 'Kouritenga');
INSERT INTO zones VALUES (766, 34, 'KOW', 'Kourweogo');
INSERT INTO zones VALUES (767, 34, 'LER', 'Leraba');
INSERT INTO zones VALUES (768, 34, 'LOR', 'Loroum');
INSERT INTO zones VALUES (769, 34, 'MOU', 'Mouhoun');
INSERT INTO zones VALUES (770, 34, 'NAH', 'Nahouri');
INSERT INTO zones VALUES (771, 34, 'NAM', 'Namentenga');
INSERT INTO zones VALUES (772, 34, 'NAY', 'Nayala');
INSERT INTO zones VALUES (773, 34, 'NOU', 'Noumbiel');
INSERT INTO zones VALUES (774, 34, 'OUB', 'Oubritenga');
INSERT INTO zones VALUES (775, 34, 'OUD', 'Oudalan');
INSERT INTO zones VALUES (776, 34, 'PAS', 'Passore');
INSERT INTO zones VALUES (777, 34, 'PON', 'Poni');
INSERT INTO zones VALUES (778, 34, 'SAG', 'Sanguie');
INSERT INTO zones VALUES (779, 34, 'SAM', 'Sanmatenga');
INSERT INTO zones VALUES (780, 34, 'SEN', 'Seno');
INSERT INTO zones VALUES (781, 34, 'SIS', 'Sissili');
INSERT INTO zones VALUES (782, 34, 'SOM', 'Soum');
INSERT INTO zones VALUES (783, 34, 'SOR', 'Sourou');
INSERT INTO zones VALUES (784, 34, 'TAP', 'Tapoa');
INSERT INTO zones VALUES (785, 34, 'TUY', 'Tuy');
INSERT INTO zones VALUES (786, 34, 'YAG', 'Yagha');
INSERT INTO zones VALUES (787, 34, 'YAT', 'Yatenga');
INSERT INTO zones VALUES (788, 34, 'ZIR', 'Ziro');
INSERT INTO zones VALUES (789, 34, 'ZOD', 'Zondoma');
INSERT INTO zones VALUES (790, 34, 'ZOW', 'Zoundweogo');
INSERT INTO zones VALUES (791, 35, 'BB', 'Bubanza');
INSERT INTO zones VALUES (792, 35, 'BJ', 'Bujumbura');
INSERT INTO zones VALUES (793, 35, 'BR', 'Bururi');
INSERT INTO zones VALUES (794, 35, 'CA', 'Cankuzo');
INSERT INTO zones VALUES (795, 35, 'CI', 'Cibitoke');
INSERT INTO zones VALUES (796, 35, 'GI', 'Gitega');
INSERT INTO zones VALUES (797, 35, 'KR', 'Karuzi');
INSERT INTO zones VALUES (798, 35, 'KY', 'Kayanza');
INSERT INTO zones VALUES (799, 35, 'KI', 'Kirundo');
INSERT INTO zones VALUES (800, 35, 'MA', 'Makamba');
INSERT INTO zones VALUES (801, 35, 'MU', 'Muramvya');
INSERT INTO zones VALUES (802, 35, 'MY', 'Muyinga');
INSERT INTO zones VALUES (803, 35, 'MW', 'Mwaro');
INSERT INTO zones VALUES (804, 35, 'NG', 'Ngozi');
INSERT INTO zones VALUES (805, 35, 'RT', 'Rutana');
INSERT INTO zones VALUES (806, 35, 'RY', 'Ruyigi');
INSERT INTO zones VALUES (807, 36, 'PP', 'Phnom Penh');
INSERT INTO zones VALUES (808, 36, 'PS', 'Preah Seihanu (Kompong Som or Si');
INSERT INTO zones VALUES (809, 36, 'PA', 'Pailin');
INSERT INTO zones VALUES (810, 36, 'KB', 'Keb');
INSERT INTO zones VALUES (811, 36, 'BM', 'Banteay Meanchey');
INSERT INTO zones VALUES (812, 36, 'BA', 'Battambang');
INSERT INTO zones VALUES (813, 36, 'KM', 'Kampong Cham');
INSERT INTO zones VALUES (814, 36, 'KN', 'Kampong Chhnang');
INSERT INTO zones VALUES (815, 36, 'KU', 'Kampong Speu');
INSERT INTO zones VALUES (816, 36, 'KO', 'Kampong Som');
INSERT INTO zones VALUES (817, 36, 'KT', 'Kampong Thom');
INSERT INTO zones VALUES (818, 36, 'KP', 'Kampot');
INSERT INTO zones VALUES (819, 36, 'KL', 'Kandal');
INSERT INTO zones VALUES (820, 36, 'KK', 'Kaoh Kong');
INSERT INTO zones VALUES (821, 36, 'KR', 'Kratie');
INSERT INTO zones VALUES (822, 36, 'MK', 'Mondul Kiri');
INSERT INTO zones VALUES (823, 36, 'OM', 'Oddar Meancheay');
INSERT INTO zones VALUES (824, 36, 'PU', 'Pursat');
INSERT INTO zones VALUES (825, 36, 'PR', 'Preah Vihear');
INSERT INTO zones VALUES (826, 36, 'PG', 'Prey Veng');
INSERT INTO zones VALUES (827, 36, 'RK', 'Ratanak Kiri');
INSERT INTO zones VALUES (828, 36, 'SI', 'Siemreap');
INSERT INTO zones VALUES (829, 36, 'ST', 'Stung Treng');
INSERT INTO zones VALUES (830, 36, 'SR', 'Svay Rieng');
INSERT INTO zones VALUES (831, 36, 'TK', 'Takeo');
INSERT INTO zones VALUES (832, 37, 'ADA', 'Adamawa (Adamaoua)');
INSERT INTO zones VALUES (833, 37, 'CEN', 'Centre');
INSERT INTO zones VALUES (834, 37, 'EST', 'East (Est)');
INSERT INTO zones VALUES (835, 37, 'EXN', 'Extreme North (Extr뮥-Nord)');
INSERT INTO zones VALUES (836, 37, 'LIT', 'Littoral');
INSERT INTO zones VALUES (837, 37, 'NOR', 'North (Nord)');
INSERT INTO zones VALUES (838, 37, 'NOT', 'Northwest (Nord-Ouest)');
INSERT INTO zones VALUES (839, 37, 'OUE', 'West (Ouest)');
INSERT INTO zones VALUES (840, 37, 'SUD', 'South (Sud)');
INSERT INTO zones VALUES (841, 37, 'SOU', 'Southwest (Sud-Ouest).');
INSERT INTO zones VALUES (842, 38, 'AB', 'Alberta');
INSERT INTO zones VALUES (843, 38, 'BC', 'British Columbia');
INSERT INTO zones VALUES (844, 38, 'MB', 'Manitoba');
INSERT INTO zones VALUES (845, 38, 'NB', 'New Brunswick');
INSERT INTO zones VALUES (846, 38, 'NL', 'Newfoundland and Labrador');
INSERT INTO zones VALUES (847, 38, 'NT', 'Northwest Territories');
INSERT INTO zones VALUES (848, 38, 'NS', 'Nova Scotia');
INSERT INTO zones VALUES (849, 38, 'NU', 'Nunavut');
INSERT INTO zones VALUES (850, 38, 'ON', 'Ontario');
INSERT INTO zones VALUES (851, 38, 'PE', 'Prince Edward Island');
INSERT INTO zones VALUES (852, 38, 'QC', 'Qu&eacute;bec');
INSERT INTO zones VALUES (853, 38, 'SK', 'Saskatchewan');
INSERT INTO zones VALUES (854, 38, 'YT', 'Yukon Territory');
INSERT INTO zones VALUES (855, 39, 'BV', 'Boa Vista');
INSERT INTO zones VALUES (856, 39, 'BR', 'Brava');
INSERT INTO zones VALUES (857, 39, 'CS', 'Calheta de Sao Miguel');
INSERT INTO zones VALUES (858, 39, 'MA', 'Maio');
INSERT INTO zones VALUES (859, 39, 'MO', 'Mosteiros');
INSERT INTO zones VALUES (860, 39, 'PA', 'Paul');
INSERT INTO zones VALUES (861, 39, 'PN', 'Porto Novo');
INSERT INTO zones VALUES (862, 39, 'PR', 'Praia');
INSERT INTO zones VALUES (863, 39, 'RG', 'Ribeira Grande');
INSERT INTO zones VALUES (864, 39, 'SL', 'Sal');
INSERT INTO zones VALUES (865, 39, 'CA', 'Santa Catarina');
INSERT INTO zones VALUES (866, 39, 'CR', 'Santa Cruz');
INSERT INTO zones VALUES (867, 39, 'SD', 'Sao Domingos');
INSERT INTO zones VALUES (868, 39, 'SF', 'Sao Filipe');
INSERT INTO zones VALUES (869, 39, 'SN', 'Sao Nicolau');
INSERT INTO zones VALUES (870, 39, 'SV', 'Sao Vicente');
INSERT INTO zones VALUES (871, 39, 'TA', 'Tarrafal');
INSERT INTO zones VALUES (872, 40, 'CR', 'Creek');
INSERT INTO zones VALUES (873, 40, 'EA', 'Eastern');
INSERT INTO zones VALUES (874, 40, 'ML', 'Midland');
INSERT INTO zones VALUES (875, 40, 'ST', 'South Town');
INSERT INTO zones VALUES (876, 40, 'SP', 'Spot Bay');
INSERT INTO zones VALUES (877, 40, 'SK', 'Stake Bay');
INSERT INTO zones VALUES (878, 40, 'WD', 'West End ');
INSERT INTO zones VALUES (879, 40, 'WN', 'Western');
INSERT INTO zones VALUES (880, 41, 'BBA', 'Bamingui-Bangoran');
INSERT INTO zones VALUES (881, 41, 'BKO', 'Basse-Kotto');
INSERT INTO zones VALUES (882, 41, 'HKO', 'Haute-Kotto');
INSERT INTO zones VALUES (883, 41, 'HMB', 'Haut-Mbomou');
INSERT INTO zones VALUES (884, 41, 'KEM', 'Kemo');
INSERT INTO zones VALUES (885, 41, 'LOB', 'Lobaye');
INSERT INTO zones VALUES (886, 41, 'MKD', 'Mambere-Kade');
INSERT INTO zones VALUES (887, 41, 'MBO', 'Mbomou');
INSERT INTO zones VALUES (888, 41, 'NMM', 'Nana-Mambere');
INSERT INTO zones VALUES (889, 41, 'OMP', 'Ombella-MPoko');
INSERT INTO zones VALUES (890, 41, 'OUK', 'Ouaka');
INSERT INTO zones VALUES (891, 41, 'OUH', 'Ouham');
INSERT INTO zones VALUES (892, 41, 'OPE', 'Ouham-Pende');
INSERT INTO zones VALUES (893, 41, 'VAK', 'Vakaga');
INSERT INTO zones VALUES (894, 41, 'NGR', 'Nana-Grebizi');
INSERT INTO zones VALUES (895, 41, 'SMB', 'Sangha-Mbaere');
INSERT INTO zones VALUES (896, 41, 'BAN', 'Bangui');
INSERT INTO zones VALUES (897, 42, 'BA', 'Batha');
INSERT INTO zones VALUES (898, 42, 'BI', 'Biltine');
INSERT INTO zones VALUES (899, 42, 'BE', 'Borkou-Ennedi-Tibesti');
INSERT INTO zones VALUES (900, 42, 'CB', 'Chari-Baguirmi');
INSERT INTO zones VALUES (901, 42, 'GU', 'Guera');
INSERT INTO zones VALUES (902, 42, 'KA', 'Kanem');
INSERT INTO zones VALUES (903, 42, 'LA', 'Lac');
INSERT INTO zones VALUES (904, 42, 'LC', 'Logone Occidental');
INSERT INTO zones VALUES (905, 42, 'LR', 'Logone Oriental');
INSERT INTO zones VALUES (906, 42, 'MK', 'Mayo-Kebbi');
INSERT INTO zones VALUES (907, 42, 'MC', 'Moyen-Chari');
INSERT INTO zones VALUES (908, 42, 'OU', 'Ouaddai');
INSERT INTO zones VALUES (909, 42, 'SA', 'Salamat');
INSERT INTO zones VALUES (910, 42, 'TA', 'Tandjile');
INSERT INTO zones VALUES (911, 43, 'AI', 'Aisen del General Carlos Ibanez ');
INSERT INTO zones VALUES (912, 43, 'AN', 'Antofagasta');
INSERT INTO zones VALUES (913, 43, 'AR', 'Araucania');
INSERT INTO zones VALUES (914, 43, 'AT', 'Atacama');
INSERT INTO zones VALUES (915, 43, 'BI', 'Bio-Bio');
INSERT INTO zones VALUES (916, 43, 'CO', 'Coquimbo');
INSERT INTO zones VALUES (917, 43, 'LI', 'Libertador General Bernardo O''Hi');
INSERT INTO zones VALUES (918, 43, 'LL', 'Los Lagos');
INSERT INTO zones VALUES (919, 43, 'MA', 'Magallanes y de la Antartica Chi');
INSERT INTO zones VALUES (920, 43, 'ML', 'Maule');
INSERT INTO zones VALUES (921, 43, 'RM', 'Region Metropolitana');
INSERT INTO zones VALUES (922, 43, 'TA', 'Tarapaca');
INSERT INTO zones VALUES (923, 43, 'VS', 'Valparaiso');
INSERT INTO zones VALUES (924, 46, 'D', 'Direction Island');
INSERT INTO zones VALUES (925, 46, 'H', 'Home Island');
INSERT INTO zones VALUES (926, 46, 'O', 'Horsburgh Island');
INSERT INTO zones VALUES (927, 46, 'S', 'South Island');
INSERT INTO zones VALUES (928, 46, 'W', 'West Island');
INSERT INTO zones VALUES (929, 47, 'AMZ', 'Amazonas');
INSERT INTO zones VALUES (930, 47, 'ANT', 'Antioquia');
INSERT INTO zones VALUES (931, 47, 'ARA', 'Arauca');
INSERT INTO zones VALUES (932, 47, 'ATL', 'Atlantico');
INSERT INTO zones VALUES (933, 47, 'BDC', 'Bogota D.C.');
INSERT INTO zones VALUES (934, 47, 'BOL', 'Bolivar');
INSERT INTO zones VALUES (935, 47, 'BOY', 'Boyaca');
INSERT INTO zones VALUES (936, 47, 'CAL', 'Caldas');
INSERT INTO zones VALUES (937, 47, 'CAQ', 'Caqueta');
INSERT INTO zones VALUES (938, 47, 'CAS', 'Casanare');
INSERT INTO zones VALUES (939, 47, 'CAU', 'Cauca');
INSERT INTO zones VALUES (940, 47, 'CES', 'Cesar');
INSERT INTO zones VALUES (941, 47, 'CHO', 'Choco');
INSERT INTO zones VALUES (942, 47, 'COR', 'Cordoba');
INSERT INTO zones VALUES (943, 47, 'CAM', 'Cundinamarca');
INSERT INTO zones VALUES (944, 47, 'GNA', 'Guainia');
INSERT INTO zones VALUES (945, 47, 'GJR', 'Guajira');
INSERT INTO zones VALUES (946, 47, 'GVR', 'Guaviare');
INSERT INTO zones VALUES (947, 47, 'HUI', 'Huila');
INSERT INTO zones VALUES (948, 47, 'MAG', 'Magdalena');
INSERT INTO zones VALUES (949, 47, 'MET', 'Meta');
INSERT INTO zones VALUES (950, 47, 'NAR', 'Narino');
INSERT INTO zones VALUES (951, 47, 'NDS', 'Norte de Santander');
INSERT INTO zones VALUES (952, 47, 'PUT', 'Putumayo');
INSERT INTO zones VALUES (953, 47, 'QUI', 'Quindio');
INSERT INTO zones VALUES (954, 47, 'RIS', 'Risaralda');
INSERT INTO zones VALUES (955, 47, 'SAP', 'San Andres y Providencia');
INSERT INTO zones VALUES (956, 47, 'SAN', 'Santander');
INSERT INTO zones VALUES (957, 47, 'SUC', 'Sucre');
INSERT INTO zones VALUES (958, 47, 'TOL', 'Tolima');
INSERT INTO zones VALUES (959, 47, 'VDC', 'Valle del Cauca');
INSERT INTO zones VALUES (960, 47, 'VAU', 'Vaupes');
INSERT INTO zones VALUES (961, 47, 'VIC', 'Vichada');
INSERT INTO zones VALUES (962, 48, 'G', 'Grande Comore');
INSERT INTO zones VALUES (963, 48, 'A', 'Anjouan');
INSERT INTO zones VALUES (964, 48, 'M', 'Moheli');
INSERT INTO zones VALUES (965, 49, 'BO', 'Bouenza');
INSERT INTO zones VALUES (966, 49, 'BR', 'Brazzaville');
INSERT INTO zones VALUES (967, 49, 'CU', 'Cuvette');
INSERT INTO zones VALUES (968, 49, 'CO', 'Cuvette-Ouest');
INSERT INTO zones VALUES (969, 49, 'KO', 'Kouilou');
INSERT INTO zones VALUES (970, 49, 'LE', 'Lekoumou');
INSERT INTO zones VALUES (971, 49, 'LI', 'Likouala');
INSERT INTO zones VALUES (972, 49, 'NI', 'Niari');
INSERT INTO zones VALUES (973, 49, 'PL', 'Plateaux');
INSERT INTO zones VALUES (974, 49, 'PO', 'Pool ');
INSERT INTO zones VALUES (975, 49, 'SA', 'Sangha');
INSERT INTO zones VALUES (976, 50, 'PU', 'Pukapuka');
INSERT INTO zones VALUES (977, 50, 'RK', 'Rakahanga');
INSERT INTO zones VALUES (978, 50, 'MK', 'Manihiki');
INSERT INTO zones VALUES (979, 50, 'PE', 'Penrhyn');
INSERT INTO zones VALUES (980, 50, 'NI', 'Nassau Island');
INSERT INTO zones VALUES (981, 50, 'SU', 'Surwarrow');
INSERT INTO zones VALUES (982, 50, 'PA', 'Palmerston');
INSERT INTO zones VALUES (983, 50, 'AI', 'Aitutaki');
INSERT INTO zones VALUES (984, 50, 'MA', 'Manuae');
INSERT INTO zones VALUES (985, 50, 'TA', 'Takutea');
INSERT INTO zones VALUES (986, 50, 'MT', 'Mitiaro');
INSERT INTO zones VALUES (987, 50, 'AT', 'Atiu');
INSERT INTO zones VALUES (988, 50, 'MU', 'Mauke');
INSERT INTO zones VALUES (989, 50, 'RR', 'Rarotonga');
INSERT INTO zones VALUES (990, 50, 'MG', 'Mangaia');
INSERT INTO zones VALUES (991, 51, 'AL', 'Alajuela');
INSERT INTO zones VALUES (992, 51, 'CA', 'Cartago');
INSERT INTO zones VALUES (993, 51, 'GU', 'Guanacaste');
INSERT INTO zones VALUES (994, 51, 'HE', 'Heredia');
INSERT INTO zones VALUES (995, 51, 'LI', 'Limon');
INSERT INTO zones VALUES (996, 51, 'PU', 'Puntarenas');
INSERT INTO zones VALUES (997, 51, 'SJ', 'San Jose');
INSERT INTO zones VALUES (998, 52, 'ABE', 'Abengourou');
INSERT INTO zones VALUES (999, 52, 'ABI', 'Abidjan');
INSERT INTO zones VALUES (1000, 52, 'ABO', 'Aboisso');
INSERT INTO zones VALUES (1001, 52, 'ADI', 'Adiake');
INSERT INTO zones VALUES (1002, 52, 'ADZ', 'Adzope');
INSERT INTO zones VALUES (1003, 52, 'AGB', 'Agboville');
INSERT INTO zones VALUES (1004, 52, 'AGN', 'Agnibilekrou');
INSERT INTO zones VALUES (1005, 52, 'ALE', 'Alepe');
INSERT INTO zones VALUES (1006, 52, 'BOC', 'Bocanda');
INSERT INTO zones VALUES (1007, 52, 'BAN', 'Bangolo');
INSERT INTO zones VALUES (1008, 52, 'BEO', 'Beoumi');
INSERT INTO zones VALUES (1009, 52, 'BIA', 'Biankouma');
INSERT INTO zones VALUES (1010, 52, 'BDK', 'Bondoukou');
INSERT INTO zones VALUES (1011, 52, 'BGN', 'Bongouanou');
INSERT INTO zones VALUES (1012, 52, 'BFL', 'Bouafle');
INSERT INTO zones VALUES (1013, 52, 'BKE', 'Bouake');
INSERT INTO zones VALUES (1014, 52, 'BNA', 'Bouna');
INSERT INTO zones VALUES (1015, 52, 'BDL', 'Boundiali');
INSERT INTO zones VALUES (1016, 52, 'DKL', 'Dabakala');
INSERT INTO zones VALUES (1017, 52, 'DBU', 'Dabou');
INSERT INTO zones VALUES (1018, 52, 'DAL', 'Daloa');
INSERT INTO zones VALUES (1019, 52, 'DAN', 'Danane');
INSERT INTO zones VALUES (1020, 52, 'DAO', 'Daoukro');
INSERT INTO zones VALUES (1021, 52, 'DIM', 'Dimbokro');
INSERT INTO zones VALUES (1022, 52, 'DIV', 'Divo');
INSERT INTO zones VALUES (1023, 52, 'DUE', 'Duekoue');
INSERT INTO zones VALUES (1024, 52, 'FER', 'Ferkessedougou');
INSERT INTO zones VALUES (1025, 52, 'GAG', 'Gagnoa');
INSERT INTO zones VALUES (1026, 52, 'GBA', 'Grand-Bassam');
INSERT INTO zones VALUES (1027, 52, 'GLA', 'Grand-Lahou');
INSERT INTO zones VALUES (1028, 52, 'GUI', 'Guiglo');
INSERT INTO zones VALUES (1029, 52, 'ISS', 'Issia');
INSERT INTO zones VALUES (1030, 52, 'JAC', 'Jacqueville');
INSERT INTO zones VALUES (1031, 52, 'KAT', 'Katiola');
INSERT INTO zones VALUES (1032, 52, 'KOR', 'Korhogo');
INSERT INTO zones VALUES (1033, 52, 'LAK', 'Lakota');
INSERT INTO zones VALUES (1034, 52, 'MAN', 'Man');
INSERT INTO zones VALUES (1035, 52, 'MKN', 'Mankono');
INSERT INTO zones VALUES (1036, 52, 'MBA', 'Mbahiakro');
INSERT INTO zones VALUES (1037, 52, 'ODI', 'Odienne');
INSERT INTO zones VALUES (1038, 52, 'OUM', 'Oume');
INSERT INTO zones VALUES (1039, 52, 'SAK', 'Sakassou');
INSERT INTO zones VALUES (1040, 52, 'SPE', 'San-Pedro');
INSERT INTO zones VALUES (1041, 52, 'SAS', 'Sassandra');
INSERT INTO zones VALUES (1042, 52, 'SEG', 'Seguela');
INSERT INTO zones VALUES (1043, 52, 'SIN', 'Sinfra');
INSERT INTO zones VALUES (1044, 52, 'SOU', 'Soubre');
INSERT INTO zones VALUES (1045, 52, 'TAB', 'Tabou');
INSERT INTO zones VALUES (1046, 52, 'TAN', 'Tanda');
INSERT INTO zones VALUES (1047, 52, 'TIE', 'Tiebissou');
INSERT INTO zones VALUES (1048, 52, 'TIN', 'Tingrela');
INSERT INTO zones VALUES (1049, 52, 'TIA', 'Tiassale');
INSERT INTO zones VALUES (1050, 52, 'TBA', 'Touba');
INSERT INTO zones VALUES (1051, 52, 'TLP', 'Toulepleu');
INSERT INTO zones VALUES (1052, 52, 'TMD', 'Toumodi');
INSERT INTO zones VALUES (1053, 52, 'VAV', 'Vavoua');
INSERT INTO zones VALUES (1054, 52, 'YAM', 'Yamoussoukro');
INSERT INTO zones VALUES (1055, 52, 'ZUE', 'Zuenoula');
INSERT INTO zones VALUES (1056, 53, 'BB', 'Bjelovar-Bilogora');
INSERT INTO zones VALUES (1057, 53, 'CZ', 'City of Zagreb');
INSERT INTO zones VALUES (1058, 53, 'DN', 'Dubrovnik-Neretva');
INSERT INTO zones VALUES (1059, 53, 'IS', 'Istra');
INSERT INTO zones VALUES (1060, 53, 'KA', 'Karlovac');
INSERT INTO zones VALUES (1061, 53, 'KK', 'Koprivnica-Krizevci');
INSERT INTO zones VALUES (1062, 53, 'KZ', 'Krapina-Zagorje');
INSERT INTO zones VALUES (1063, 53, 'LS', 'Lika-Senj');
INSERT INTO zones VALUES (1064, 53, 'ME', 'Medimurje');
INSERT INTO zones VALUES (1065, 53, 'OB', 'Osijek-Baranja');
INSERT INTO zones VALUES (1066, 53, 'PS', 'Pozega-Slavonia');
INSERT INTO zones VALUES (1067, 53, 'PG', 'Primorje-Gorski Kotar');
INSERT INTO zones VALUES (1068, 53, 'SI', 'Sibenik');
INSERT INTO zones VALUES (1069, 53, 'SM', 'Sisak-Moslavina');
INSERT INTO zones VALUES (1070, 53, 'SB', 'Slavonski Brod-Posavina');
INSERT INTO zones VALUES (1071, 53, 'SD', 'Split-Dalmatia');
INSERT INTO zones VALUES (1072, 53, 'VA', 'Varazdin');
INSERT INTO zones VALUES (1073, 53, 'VP', 'Virovitica-Podravina');
INSERT INTO zones VALUES (1074, 53, 'VS', 'Vukovar-Srijem');
INSERT INTO zones VALUES (1075, 53, 'ZK', 'Zadar-Knin');
INSERT INTO zones VALUES (1076, 53, 'ZA', 'Zagreb');
INSERT INTO zones VALUES (1077, 54, 'CA', 'Camaguey');
INSERT INTO zones VALUES (1078, 54, 'CD', 'Ciego de Avila');
INSERT INTO zones VALUES (1079, 54, 'CI', 'Cienfuegos');
INSERT INTO zones VALUES (1080, 54, 'CH', 'Ciudad de La Habana');
INSERT INTO zones VALUES (1081, 54, 'GR', 'Granma');
INSERT INTO zones VALUES (1082, 54, 'GU', 'Guantanamo');
INSERT INTO zones VALUES (1083, 54, 'HO', 'Holguin');
INSERT INTO zones VALUES (1084, 54, 'IJ', 'Isla de la Juventud');
INSERT INTO zones VALUES (1085, 54, 'LH', 'La Habana');
INSERT INTO zones VALUES (1086, 54, 'LT', 'Las Tunas');
INSERT INTO zones VALUES (1087, 54, 'MA', 'Matanzas');
INSERT INTO zones VALUES (1088, 54, 'PR', 'Pinar del Rio');
INSERT INTO zones VALUES (1089, 54, 'SS', 'Sancti Spiritus');
INSERT INTO zones VALUES (1090, 54, 'SC', 'Santiago de Cuba');
INSERT INTO zones VALUES (1091, 54, 'VC', 'Villa Clara');
INSERT INTO zones VALUES (1092, 55, 'F', 'Famagusta');
INSERT INTO zones VALUES (1093, 55, 'K', 'Kyrenia');
INSERT INTO zones VALUES (1094, 55, 'A', 'Larnaca');
INSERT INTO zones VALUES (1095, 55, 'I', 'Limassol');
INSERT INTO zones VALUES (1096, 55, 'N', 'Nicosia');
INSERT INTO zones VALUES (1097, 55, 'P', 'Paphos');
INSERT INTO zones VALUES (1098, 56, 'U', 'Ustecky');
INSERT INTO zones VALUES (1099, 56, 'C', 'Jihocesky');
INSERT INTO zones VALUES (1100, 56, 'B', 'Jihomoravsky');
INSERT INTO zones VALUES (1101, 56, 'K', 'Karlovarsky');
INSERT INTO zones VALUES (1102, 56, 'H', 'Kralovehradecky');
INSERT INTO zones VALUES (1103, 56, 'L', 'Liberecky');
INSERT INTO zones VALUES (1104, 56, 'T', 'Moravskoslezsky');
INSERT INTO zones VALUES (1105, 56, 'M', 'Olomoucky');
INSERT INTO zones VALUES (1106, 56, 'E', 'Pardubicky');
INSERT INTO zones VALUES (1107, 56, 'P', 'Plzensky');
INSERT INTO zones VALUES (1108, 56, 'A', 'Praha');
INSERT INTO zones VALUES (1109, 56, 'S', 'Stredocesky');
INSERT INTO zones VALUES (1110, 56, 'J', 'Vysocina');
INSERT INTO zones VALUES (1111, 56, 'Z', 'Zlinsky');
INSERT INTO zones VALUES (1112, 57, 'AR', 'Arhus');
INSERT INTO zones VALUES (1113, 57, 'BH', 'Bornholm');
INSERT INTO zones VALUES (1114, 57, 'CO', 'Copenhagen');
INSERT INTO zones VALUES (1115, 57, 'FO', 'Faroe Islands');
INSERT INTO zones VALUES (1116, 57, 'FR', 'Frederiksborg');
INSERT INTO zones VALUES (1117, 57, 'FY', 'Fyn');
INSERT INTO zones VALUES (1118, 57, 'KO', 'Kobenhavn');
INSERT INTO zones VALUES (1119, 57, 'NO', 'Nordjylland');
INSERT INTO zones VALUES (1120, 57, 'RI', 'Ribe');
INSERT INTO zones VALUES (1121, 57, 'RK', 'Ringkobing');
INSERT INTO zones VALUES (1122, 57, 'RO', 'Roskilde');
INSERT INTO zones VALUES (1123, 57, 'SO', 'Sonderjylland');
INSERT INTO zones VALUES (1124, 57, 'ST', 'Storstrom');
INSERT INTO zones VALUES (1125, 57, 'VK', 'Vejle');
INSERT INTO zones VALUES (1126, 57, 'VJ', 'Vestj&aelig;lland');
INSERT INTO zones VALUES (1127, 57, 'VB', 'Viborg');
INSERT INTO zones VALUES (1128, 58, 'S', '''Ali Sabih');
INSERT INTO zones VALUES (1129, 58, 'K', 'Dikhil');
INSERT INTO zones VALUES (1130, 58, 'J', 'Djibouti');
INSERT INTO zones VALUES (1131, 58, 'O', 'Obock');
INSERT INTO zones VALUES (1132, 58, 'T', 'Tadjoura');
INSERT INTO zones VALUES (1133, 59, 'AND', 'Saint Andrew Parish');
INSERT INTO zones VALUES (1134, 59, 'DAV', 'Saint David Parish');
INSERT INTO zones VALUES (1135, 59, 'GEO', 'Saint George Parish');
INSERT INTO zones VALUES (1136, 59, 'JOH', 'Saint John Parish');
INSERT INTO zones VALUES (1137, 59, 'JOS', 'Saint Joseph Parish');
INSERT INTO zones VALUES (1138, 59, 'LUK', 'Saint Luke Parish');
INSERT INTO zones VALUES (1139, 59, 'MAR', 'Saint Mark Parish');
INSERT INTO zones VALUES (1140, 59, 'PAT', 'Saint Patrick Parish');
INSERT INTO zones VALUES (1141, 59, 'PAU', 'Saint Paul Parish');
INSERT INTO zones VALUES (1142, 59, 'PET', 'Saint Peter Parish');
INSERT INTO zones VALUES (1143, 60, 'DN', 'Distrito Nacional');
INSERT INTO zones VALUES (1144, 60, 'AZ', 'Azua');
INSERT INTO zones VALUES (1145, 60, 'BC', 'Baoruco');
INSERT INTO zones VALUES (1146, 60, 'BH', 'Barahona');
INSERT INTO zones VALUES (1147, 60, 'DJ', 'Dajabon');
INSERT INTO zones VALUES (1148, 60, 'DU', 'Duarte');
INSERT INTO zones VALUES (1149, 60, 'EL', 'Elias Pina');
INSERT INTO zones VALUES (1150, 60, 'SY', 'El Seybo');
INSERT INTO zones VALUES (1151, 60, 'ET', 'Espaillat');
INSERT INTO zones VALUES (1152, 60, 'HM', 'Hato Mayor');
INSERT INTO zones VALUES (1153, 60, 'IN', 'Independencia');
INSERT INTO zones VALUES (1154, 60, 'AL', 'La Altagracia');
INSERT INTO zones VALUES (1155, 60, 'RO', 'La Romana');
INSERT INTO zones VALUES (1156, 60, 'VE', 'La Vega');
INSERT INTO zones VALUES (1157, 60, 'MT', 'Maria Trinidad Sanchez');
INSERT INTO zones VALUES (1158, 60, 'MN', 'Monsenor Nouel');
INSERT INTO zones VALUES (1159, 60, 'MC', 'Monte Cristi');
INSERT INTO zones VALUES (1160, 60, 'MP', 'Monte Plata');
INSERT INTO zones VALUES (1161, 60, 'PD', 'Pedernales');
INSERT INTO zones VALUES (1162, 60, 'PR', 'Peravia (Bani)');
INSERT INTO zones VALUES (1163, 60, 'PP', 'Puerto Plata');
INSERT INTO zones VALUES (1164, 60, 'SL', 'Salcedo');
INSERT INTO zones VALUES (1165, 60, 'SM', 'Samana');
INSERT INTO zones VALUES (1166, 60, 'SH', 'Sanchez Ramirez');
INSERT INTO zones VALUES (1167, 60, 'SC', 'San Cristobal');
INSERT INTO zones VALUES (1168, 60, 'JO', 'San Jose de Ocoa');
INSERT INTO zones VALUES (1169, 60, 'SJ', 'San Juan');
INSERT INTO zones VALUES (1170, 60, 'PM', 'San Pedro de Macoris');
INSERT INTO zones VALUES (1171, 60, 'SA', 'Santiago');
INSERT INTO zones VALUES (1172, 60, 'ST', 'Santiago Rodriguez');
INSERT INTO zones VALUES (1173, 60, 'SD', 'Santo Domingo');
INSERT INTO zones VALUES (1174, 60, 'VA', 'Valverde');
INSERT INTO zones VALUES (1175, 61, 'AL', 'Aileu');
INSERT INTO zones VALUES (1176, 61, 'AN', 'Ainaro');
INSERT INTO zones VALUES (1177, 61, 'BA', 'Baucau');
INSERT INTO zones VALUES (1178, 61, 'BO', 'Bobonaro');
INSERT INTO zones VALUES (1179, 61, 'CO', 'Cova Lima');
INSERT INTO zones VALUES (1180, 61, 'DI', 'Dili');
INSERT INTO zones VALUES (1181, 61, 'ER', 'Ermera');
INSERT INTO zones VALUES (1182, 61, 'LA', 'Lautem');
INSERT INTO zones VALUES (1183, 61, 'LI', 'Liquica');
INSERT INTO zones VALUES (1184, 61, 'MT', 'Manatuto');
INSERT INTO zones VALUES (1185, 61, 'MF', 'Manufahi');
INSERT INTO zones VALUES (1186, 61, 'OE', 'Oecussi');
INSERT INTO zones VALUES (1187, 61, 'VI', 'Viqueque');
INSERT INTO zones VALUES (1188, 62, 'AZU', 'Azuay');
INSERT INTO zones VALUES (1189, 62, 'BOL', 'Bolivar');
INSERT INTO zones VALUES (1190, 62, 'CAN', 'Ca&ntilde;ar');
INSERT INTO zones VALUES (1191, 62, 'CAR', 'Carchi');
INSERT INTO zones VALUES (1192, 62, 'CHI', 'Chimborazo');
INSERT INTO zones VALUES (1193, 62, 'COT', 'Cotopaxi');
INSERT INTO zones VALUES (1194, 62, 'EOR', 'El Oro');
INSERT INTO zones VALUES (1195, 62, 'ESM', 'Esmeraldas');
INSERT INTO zones VALUES (1196, 62, 'GPS', 'Gal&aacute;pagos');
INSERT INTO zones VALUES (1197, 62, 'GUA', 'Guayas');
INSERT INTO zones VALUES (1198, 62, 'IMB', 'Imbabura');
INSERT INTO zones VALUES (1199, 62, 'LOJ', 'Loja');
INSERT INTO zones VALUES (1200, 62, 'LRO', 'Los R');
INSERT INTO zones VALUES (1201, 62, 'MAN', 'Manab&iacute;');
INSERT INTO zones VALUES (1202, 62, 'MSA', 'Morona Santiago');
INSERT INTO zones VALUES (1203, 62, 'NAP', 'Napo');
INSERT INTO zones VALUES (1204, 62, 'ORE', 'Orellana');
INSERT INTO zones VALUES (1205, 62, 'PAS', 'Pastaza');
INSERT INTO zones VALUES (1206, 62, 'PIC', 'Pichincha');
INSERT INTO zones VALUES (1207, 62, 'SUC', 'Sucumb&iacute;os');
INSERT INTO zones VALUES (1208, 62, 'TUN', 'Tungurahua');
INSERT INTO zones VALUES (1209, 62, 'ZCH', 'Zamora Chinchipe');
INSERT INTO zones VALUES (1210, 63, 'DHY', 'Ad Daqahliyah');
INSERT INTO zones VALUES (1211, 63, 'BAM', 'Al Bahr al Ahmar');
INSERT INTO zones VALUES (1212, 63, 'BHY', 'Al Buhayrah');
INSERT INTO zones VALUES (1213, 63, 'FYM', 'Al Fayyum');
INSERT INTO zones VALUES (1214, 63, 'GBY', 'Al Gharbiyah');
INSERT INTO zones VALUES (1215, 63, 'IDR', 'Al Iskandariyah');
INSERT INTO zones VALUES (1216, 63, 'IML', 'Al Isma''iliyah');
INSERT INTO zones VALUES (1217, 63, 'JZH', 'Al Jizah');
INSERT INTO zones VALUES (1218, 63, 'MFY', 'Al Minufiyah');
INSERT INTO zones VALUES (1219, 63, 'MNY', 'Al Minya');
INSERT INTO zones VALUES (1220, 63, 'QHR', 'Al Qahirah');
INSERT INTO zones VALUES (1221, 63, 'QLY', 'Al Qalyubiyah');
INSERT INTO zones VALUES (1222, 63, 'WJD', 'Al Wadi al Jadid');
INSERT INTO zones VALUES (1223, 63, 'SHQ', 'Ash Sharqiyah');
INSERT INTO zones VALUES (1224, 63, 'SWY', 'As Suways');
INSERT INTO zones VALUES (1225, 63, 'ASW', 'Aswan');
INSERT INTO zones VALUES (1226, 63, 'ASY', 'Asyut');
INSERT INTO zones VALUES (1227, 63, 'BSW', 'Bani Suwayf');
INSERT INTO zones VALUES (1228, 63, 'BSD', 'Bur Sa''id');
INSERT INTO zones VALUES (1229, 63, 'DMY', 'Dumyat');
INSERT INTO zones VALUES (1230, 63, 'JNS', 'Janub Sina''');
INSERT INTO zones VALUES (1231, 63, 'KSH', 'Kafr ash Shaykh');
INSERT INTO zones VALUES (1232, 63, 'MAT', 'Matruh');
INSERT INTO zones VALUES (1233, 63, 'QIN', 'Qina');
INSERT INTO zones VALUES (1234, 63, 'SHS', 'Shamal Sina''');
INSERT INTO zones VALUES (1235, 63, 'SUH', 'Suhaj');
INSERT INTO zones VALUES (1236, 64, 'AH', 'Ahuachapan');
INSERT INTO zones VALUES (1237, 64, 'CA', 'Cabanas');
INSERT INTO zones VALUES (1238, 64, 'CH', 'Chalatenango');
INSERT INTO zones VALUES (1239, 64, 'CU', 'Cuscatlan');
INSERT INTO zones VALUES (1240, 64, 'LB', 'La Libertad');
INSERT INTO zones VALUES (1241, 64, 'PZ', 'La Paz');
INSERT INTO zones VALUES (1242, 64, 'UN', 'La Union');
INSERT INTO zones VALUES (1243, 64, 'MO', 'Morazan');
INSERT INTO zones VALUES (1244, 64, 'SM', 'San Miguel');
INSERT INTO zones VALUES (1245, 64, 'SS', 'San Salvador');
INSERT INTO zones VALUES (1246, 64, 'SV', 'San Vicente');
INSERT INTO zones VALUES (1247, 64, 'SA', 'Santa Ana');
INSERT INTO zones VALUES (1248, 64, 'SO', 'Sonsonate');
INSERT INTO zones VALUES (1249, 64, 'US', 'Usulutan');
INSERT INTO zones VALUES (1250, 65, 'AN', 'Provincia Annobon');
INSERT INTO zones VALUES (1251, 65, 'BN', 'Provincia Bioko Norte');
INSERT INTO zones VALUES (1252, 65, 'BS', 'Provincia Bioko Sur');
INSERT INTO zones VALUES (1253, 65, 'CS', 'Provincia Centro Sur');
INSERT INTO zones VALUES (1254, 65, 'KN', 'Provincia Kie-Ntem');
INSERT INTO zones VALUES (1255, 65, 'LI', 'Provincia Litoral');
INSERT INTO zones VALUES (1256, 65, 'WN', 'Provincia Wele-Nzas');
INSERT INTO zones VALUES (1257, 66, 'MA', 'Central (Maekel)');
INSERT INTO zones VALUES (1258, 66, 'KE', 'Anseba (Keren)');
INSERT INTO zones VALUES (1259, 66, 'DK', 'Southern Red Sea (Debub-Keih-Bah');
INSERT INTO zones VALUES (1260, 66, 'SK', 'Northern Red Sea (Semien-Keih-Ba');
INSERT INTO zones VALUES (1261, 66, 'DE', 'Southern (Debub)');
INSERT INTO zones VALUES (1262, 66, 'BR', 'Gash-Barka (Barentu)');
INSERT INTO zones VALUES (1263, 67, 'HA', 'Harjumaa (Tallinn)');
INSERT INTO zones VALUES (1264, 67, 'HI', 'Hiiumaa (Kardla)');
INSERT INTO zones VALUES (1265, 67, 'IV', 'Ida-Virumaa (Johvi)');
INSERT INTO zones VALUES (1266, 67, 'JA', 'Jarvamaa (Paide)');
INSERT INTO zones VALUES (1267, 67, 'JO', 'Jogevamaa (Jogeva)');
INSERT INTO zones VALUES (1268, 67, 'LV', 'Laane-Virumaa (Rakvere)');
INSERT INTO zones VALUES (1269, 67, 'LA', 'Laanemaa (Haapsalu)');
INSERT INTO zones VALUES (1270, 67, 'PA', 'Parnumaa (Parnu)');
INSERT INTO zones VALUES (1271, 67, 'PO', 'Polvamaa (Polva)');
INSERT INTO zones VALUES (1272, 67, 'RA', 'Raplamaa (Rapla)');
INSERT INTO zones VALUES (1273, 67, 'SA', 'Saaremaa (Kuessaare)');
INSERT INTO zones VALUES (1274, 67, 'TA', 'Tartumaa (Tartu)');
INSERT INTO zones VALUES (1275, 67, 'VA', 'Valgamaa (Valga)');
INSERT INTO zones VALUES (1276, 67, 'VI', 'Viljandimaa (Viljandi)');
INSERT INTO zones VALUES (1277, 67, 'VO', 'Vorumaa (Voru)');
INSERT INTO zones VALUES (1278, 68, 'AF', 'Afar');
INSERT INTO zones VALUES (1279, 68, 'AH', 'Amhara');
INSERT INTO zones VALUES (1280, 68, 'BG', 'Benishangul-Gumaz');
INSERT INTO zones VALUES (1281, 68, 'GB', 'Gambela');
INSERT INTO zones VALUES (1282, 68, 'HR', 'Hariai');
INSERT INTO zones VALUES (1283, 68, 'OR', 'Oromia');
INSERT INTO zones VALUES (1284, 68, 'SM', 'Somali');
INSERT INTO zones VALUES (1285, 68, 'SN', 'Southern Nations - Nationalities');
INSERT INTO zones VALUES (1286, 68, 'TG', 'Tigray');
INSERT INTO zones VALUES (1287, 68, 'AA', 'Addis Ababa');
INSERT INTO zones VALUES (1288, 68, 'DD', 'Dire Dawa');
INSERT INTO zones VALUES (1289, 71, 'C', 'Central Division');
INSERT INTO zones VALUES (1290, 71, 'N', 'Northern Division');
INSERT INTO zones VALUES (1291, 71, 'E', 'Eastern Division');
INSERT INTO zones VALUES (1292, 71, 'W', 'Western Division');
INSERT INTO zones VALUES (1293, 71, 'R', 'Rotuma');
INSERT INTO zones VALUES (1294, 72, 'AL', 'Ahvenanmaan Laani');
INSERT INTO zones VALUES (1295, 72, 'ES', 'Etela-Suomen Laani');
INSERT INTO zones VALUES (1296, 72, 'IS', 'Ita-Suomen Laani');
INSERT INTO zones VALUES (1297, 72, 'LS', 'Lansi-Suomen Laani');
INSERT INTO zones VALUES (1298, 72, 'LA', 'Lapin Lanani');
INSERT INTO zones VALUES (1299, 72, 'OU', 'Oulun Laani');
INSERT INTO zones VALUES (1300, 73, 'AL', 'Alsace');
INSERT INTO zones VALUES (1301, 73, 'AQ', 'Aquitaine');
INSERT INTO zones VALUES (1302, 73, 'AU', 'Auvergne');
INSERT INTO zones VALUES (1303, 73, 'BR', 'Brittany');
INSERT INTO zones VALUES (1304, 73, 'BU', 'Burgundy');
INSERT INTO zones VALUES (1305, 73, 'CE', 'Center Loire Valley');
INSERT INTO zones VALUES (1306, 73, 'CH', 'Champagne');
INSERT INTO zones VALUES (1307, 73, 'CO', 'Corse');
INSERT INTO zones VALUES (1308, 73, 'FR', 'France Comte');
INSERT INTO zones VALUES (1309, 73, 'LA', 'Languedoc Roussillon');
INSERT INTO zones VALUES (1310, 73, 'LI', 'Limousin');
INSERT INTO zones VALUES (1311, 73, 'LO', 'Lorraine');
INSERT INTO zones VALUES (1312, 73, 'MI', 'Midi Pyrenees');
INSERT INTO zones VALUES (1313, 73, 'NO', 'Nord Pas de Calais');
INSERT INTO zones VALUES (1314, 73, 'NR', 'Normandy');
INSERT INTO zones VALUES (1315, 73, 'PA', 'Paris / Ill de France');
INSERT INTO zones VALUES (1316, 73, 'PI', 'Picardie');
INSERT INTO zones VALUES (1317, 73, 'PO', 'Poitou Charente');
INSERT INTO zones VALUES (1318, 73, 'PR', 'Provence');
INSERT INTO zones VALUES (1319, 73, 'RH', 'Rhone Alps');
INSERT INTO zones VALUES (1320, 73, 'RI', 'Riviera');
INSERT INTO zones VALUES (1321, 73, 'WE', 'Western Loire Valley');
INSERT INTO zones VALUES (1322, 74, 'Et', 'Etranger');
INSERT INTO zones VALUES (1323, 74, '01', 'Ain');
INSERT INTO zones VALUES (1324, 74, '02', 'Aisne');
INSERT INTO zones VALUES (1325, 74, '03', 'Allier');
INSERT INTO zones VALUES (1326, 74, '04', 'Alpes de Haute Provence');
INSERT INTO zones VALUES (1327, 74, '05', 'Hautes-Alpes');
INSERT INTO zones VALUES (1328, 74, '06', 'Alpes Maritimes');
INSERT INTO zones VALUES (1329, 74, '07', 'Ard&egrave;che');
INSERT INTO zones VALUES (1330, 74, '08', 'Ardennes');
INSERT INTO zones VALUES (1331, 74, '09', 'Ari&egrave;ge');
INSERT INTO zones VALUES (1332, 74, '10', 'Aube');
INSERT INTO zones VALUES (1333, 74, '11', 'Aude');
INSERT INTO zones VALUES (1334, 74, '12', 'Aveyron');
INSERT INTO zones VALUES (1335, 74, '13', 'Bouches du Rh&ocirc;ne');
INSERT INTO zones VALUES (1336, 74, '14', 'Calvados');
INSERT INTO zones VALUES (1337, 74, '15', 'Cantal');
INSERT INTO zones VALUES (1338, 74, '16', 'Charente');
INSERT INTO zones VALUES (1339, 74, '17', 'Charente Maritime');
INSERT INTO zones VALUES (1340, 74, '18', 'Cher');
INSERT INTO zones VALUES (1341, 74, '19', 'Corr&egrave;ze');
INSERT INTO zones VALUES (1342, 74, '2A', 'Corse du Sud');
INSERT INTO zones VALUES (1343, 74, '2B', 'Haute Corse');
INSERT INTO zones VALUES (1344, 74, '21', 'C&ocirc;te d''or');
INSERT INTO zones VALUES (1345, 74, '22', 'C&ocirc;tes d''Armor');
INSERT INTO zones VALUES (1346, 74, '23', 'Creuse');
INSERT INTO zones VALUES (1347, 74, '24', 'Dordogne');
INSERT INTO zones VALUES (1348, 74, '25', 'Doubs');
INSERT INTO zones VALUES (1349, 74, '26', 'Dr&ocirc;me');
INSERT INTO zones VALUES (1350, 74, '27', 'Eure');
INSERT INTO zones VALUES (1351, 74, '28', 'Eure et Loir');
INSERT INTO zones VALUES (1352, 74, '29', 'Finist&egrave;re');
INSERT INTO zones VALUES (1353, 74, '30', 'Gard');
INSERT INTO zones VALUES (1354, 74, '31', 'Haute Garonne');
INSERT INTO zones VALUES (1355, 74, '32', 'Gers');
INSERT INTO zones VALUES (1356, 74, '33', 'Gironde');
INSERT INTO zones VALUES (1357, 74, '34', 'H&eacute;rault');
INSERT INTO zones VALUES (1358, 74, '35', 'Ille et Vilaine');
INSERT INTO zones VALUES (1359, 74, '36', 'Indre');
INSERT INTO zones VALUES (1360, 74, '37', 'Indre et Loire');
INSERT INTO zones VALUES (1361, 74, '38', 'Is&eacute;re');
INSERT INTO zones VALUES (1362, 74, '39', 'Jura');
INSERT INTO zones VALUES (1363, 74, '40', 'Landes');
INSERT INTO zones VALUES (1364, 74, '41', 'Loir et Cher');
INSERT INTO zones VALUES (1365, 74, '42', 'Loire');
INSERT INTO zones VALUES (1366, 74, '43', 'Haute Loire');
INSERT INTO zones VALUES (1367, 74, '44', 'Loire Atlantique');
INSERT INTO zones VALUES (1368, 74, '45', 'Loiret');
INSERT INTO zones VALUES (1369, 74, '46', 'Lot');
INSERT INTO zones VALUES (1370, 74, '47', 'Lot et Garonne');
INSERT INTO zones VALUES (1371, 74, '48', 'Loz&egrave;re');
INSERT INTO zones VALUES (1372, 74, '49', 'Maine et Loire');
INSERT INTO zones VALUES (1373, 74, '50', 'Manche');
INSERT INTO zones VALUES (1374, 74, '51', 'Marne');
INSERT INTO zones VALUES (1375, 74, '52', 'Haute Marne');
INSERT INTO zones VALUES (1376, 74, '53', 'Mayenne');
INSERT INTO zones VALUES (1377, 74, '54', 'Meurthe et Moselle');
INSERT INTO zones VALUES (1378, 74, '55', 'Meuse');
INSERT INTO zones VALUES (1379, 74, '56', 'Morbihan');
INSERT INTO zones VALUES (1380, 74, '57', 'Moselle');
INSERT INTO zones VALUES (1381, 74, '58', 'Ni&egrave;vre');
INSERT INTO zones VALUES (1382, 74, '59', 'Nord');
INSERT INTO zones VALUES (1383, 74, '60', 'Oise');
INSERT INTO zones VALUES (1384, 74, '61', 'Orne');
INSERT INTO zones VALUES (1385, 74, '62', 'Pas de Calais');
INSERT INTO zones VALUES (1386, 74, '63', 'Puy de D&ocirc;me');
INSERT INTO zones VALUES (1387, 74, '64', 'Pyr&eacute;n&eacute;es Atlantiqu');
INSERT INTO zones VALUES (1388, 74, '65', 'Hautes Pyr&eacute;n&eacute;es');
INSERT INTO zones VALUES (1389, 74, '66', 'Pyr&eacute;n&eacute;es Orientale');
INSERT INTO zones VALUES (1390, 74, '67', 'Bas Rhin');
INSERT INTO zones VALUES (1391, 74, '68', 'Haut Rhin');
INSERT INTO zones VALUES (1392, 74, '69', 'Rh&ocirc;ne');
INSERT INTO zones VALUES (1393, 74, '70', 'Haute Sa&ocirc;ne');
INSERT INTO zones VALUES (1394, 74, '71', 'Sa&ocirc;ne et Loire');
INSERT INTO zones VALUES (1395, 74, '72', 'Sarthe');
INSERT INTO zones VALUES (1396, 74, '73', 'Savoie');
INSERT INTO zones VALUES (1397, 74, '74', 'Haute Savoie');
INSERT INTO zones VALUES (1398, 74, '75', 'Paris');
INSERT INTO zones VALUES (1399, 74, '76', 'Seine Maritime');
INSERT INTO zones VALUES (1400, 74, '77', 'Seine et Marne');
INSERT INTO zones VALUES (1401, 74, '78', 'Yvelines');
INSERT INTO zones VALUES (1402, 74, '79', 'Deux S&egrave;vres');
INSERT INTO zones VALUES (1403, 74, '80', 'Somme');
INSERT INTO zones VALUES (1404, 74, '81', 'Tarn');
INSERT INTO zones VALUES (1405, 74, '82', 'Tarn et Garonne');
INSERT INTO zones VALUES (1406, 74, '83', 'Var');
INSERT INTO zones VALUES (1407, 74, '84', 'Vaucluse');
INSERT INTO zones VALUES (1408, 74, '85', 'Vend&eacute;e');
INSERT INTO zones VALUES (1409, 74, '86', 'Vienne');
INSERT INTO zones VALUES (1410, 74, '87', 'Haute Vienne');
INSERT INTO zones VALUES (1411, 74, '88', 'Vosges');
INSERT INTO zones VALUES (1412, 74, '89', 'Yonne');
INSERT INTO zones VALUES (1413, 74, '90', 'Territoire de Belfort');
INSERT INTO zones VALUES (1414, 74, '91', 'Essonne');
INSERT INTO zones VALUES (1415, 74, '92', 'Hauts de Seine');
INSERT INTO zones VALUES (1416, 74, '93', 'Seine St-Denis');
INSERT INTO zones VALUES (1417, 74, '94', 'Val de Marne');
INSERT INTO zones VALUES (1418, 74, '95', 'Val d''Oise');
INSERT INTO zones VALUES (1419, 76, 'M', 'Archipel des Marquises');
INSERT INTO zones VALUES (1420, 76, 'T', 'Archipel des Tuamotu');
INSERT INTO zones VALUES (1421, 76, 'I', 'Archipel des Tubuai');
INSERT INTO zones VALUES (1422, 76, 'V', 'Iles du Vent');
INSERT INTO zones VALUES (1423, 76, 'S', 'Iles Sous-le-Vent ');
INSERT INTO zones VALUES (1424, 77, 'C', 'Iles Crozet');
INSERT INTO zones VALUES (1425, 77, 'K', 'Iles Kerguelen');
INSERT INTO zones VALUES (1426, 77, 'A', 'Ile Amsterdam');
INSERT INTO zones VALUES (1427, 77, 'P', 'Ile Saint-Paul');
INSERT INTO zones VALUES (1428, 77, 'D', 'Adelie Land');
INSERT INTO zones VALUES (1429, 78, 'ES', 'Estuaire');
INSERT INTO zones VALUES (1430, 78, 'HO', 'Haut-Ogooue');
INSERT INTO zones VALUES (1431, 78, 'MO', 'Moyen-Ogooue');
INSERT INTO zones VALUES (1432, 78, 'NG', 'Ngounie');
INSERT INTO zones VALUES (1433, 78, 'NY', 'Nyanga');
INSERT INTO zones VALUES (1434, 78, 'OI', 'Ogooue-Ivindo');
INSERT INTO zones VALUES (1435, 78, 'OL', 'Ogooue-Lolo');
INSERT INTO zones VALUES (1436, 78, 'OM', 'Ogooue-Maritime');
INSERT INTO zones VALUES (1437, 78, 'WN', 'Woleu-Ntem');
INSERT INTO zones VALUES (1438, 79, 'BJ', 'Banjul');
INSERT INTO zones VALUES (1439, 79, 'BS', 'Basse');
INSERT INTO zones VALUES (1440, 79, 'BR', 'Brikama');
INSERT INTO zones VALUES (1441, 79, 'JA', 'Janjangbure');
INSERT INTO zones VALUES (1442, 79, 'KA', 'Kanifeng');
INSERT INTO zones VALUES (1443, 79, 'KE', 'Kerewan');
INSERT INTO zones VALUES (1444, 79, 'KU', 'Kuntaur');
INSERT INTO zones VALUES (1445, 79, 'MA', 'Mansakonko');
INSERT INTO zones VALUES (1446, 79, 'LR', 'Lower River');
INSERT INTO zones VALUES (1447, 79, 'CR', 'Central River');
INSERT INTO zones VALUES (1448, 79, 'NB', 'North Bank');
INSERT INTO zones VALUES (1449, 79, 'UR', 'Upper River');
INSERT INTO zones VALUES (1450, 79, 'WE', 'Western');
INSERT INTO zones VALUES (1451, 80, 'AB', 'Abkhazia');
INSERT INTO zones VALUES (1452, 80, 'AJ', 'Ajaria');
INSERT INTO zones VALUES (1453, 80, 'TB', 'Tbilisi');
INSERT INTO zones VALUES (1454, 80, 'GU', 'Guria');
INSERT INTO zones VALUES (1455, 80, 'IM', 'Imereti');
INSERT INTO zones VALUES (1456, 80, 'KA', 'Kakheti');
INSERT INTO zones VALUES (1457, 80, 'KK', 'Kvemo Kartli');
INSERT INTO zones VALUES (1458, 80, 'MM', 'Mtskheta-Mtianeti');
INSERT INTO zones VALUES (1459, 80, 'RL', 'Racha Lechkhumi and Kvemo Svanet');
INSERT INTO zones VALUES (1460, 80, 'SZ', 'Samegrelo-Zemo Svaneti');
INSERT INTO zones VALUES (1461, 80, 'SJ', 'Samtskhe-Javakheti');
INSERT INTO zones VALUES (1462, 80, 'SK', 'Shida Kartli');
INSERT INTO zones VALUES (1463, 82, 'AS', 'Ashanti Region');
INSERT INTO zones VALUES (1464, 82, 'BA', 'Brong-Ahafo Region');
INSERT INTO zones VALUES (1465, 82, 'CE', 'Central Region');
INSERT INTO zones VALUES (1466, 82, 'EA', 'Eastern Region');
INSERT INTO zones VALUES (1467, 82, 'GA', 'Greater Accra Region');
INSERT INTO zones VALUES (1468, 82, 'NO', 'Northern Region');
INSERT INTO zones VALUES (1469, 82, 'UE', 'Upper East Region');
INSERT INTO zones VALUES (1470, 82, 'UW', 'Upper West Region');
INSERT INTO zones VALUES (1471, 82, 'VO', 'Volta Region');
INSERT INTO zones VALUES (1472, 82, 'WE', 'Western Region');
INSERT INTO zones VALUES (1473, 84, 'AT', 'Attica');
INSERT INTO zones VALUES (1474, 84, 'CN', 'Central Greece');
INSERT INTO zones VALUES (1475, 84, 'CM', 'Central Macedonia');
INSERT INTO zones VALUES (1476, 84, 'CR', 'Crete');
INSERT INTO zones VALUES (1477, 84, 'EM', 'East Macedonia and Thrace');
INSERT INTO zones VALUES (1478, 84, 'EP', 'Epirus');
INSERT INTO zones VALUES (1479, 84, 'II', 'Ionian Islands');
INSERT INTO zones VALUES (1480, 84, 'NA', 'North Aegean');
INSERT INTO zones VALUES (1481, 84, 'PP', 'Peloponnesos');
INSERT INTO zones VALUES (1482, 84, 'SA', 'South Aegean');
INSERT INTO zones VALUES (1483, 84, 'TH', 'Thessaly');
INSERT INTO zones VALUES (1484, 84, 'WG', 'West Greece');
INSERT INTO zones VALUES (1485, 84, 'WM', 'West Macedonia');
INSERT INTO zones VALUES (1486, 85, 'A', 'Avannaa');
INSERT INTO zones VALUES (1487, 85, 'T', 'Tunu ');
INSERT INTO zones VALUES (1488, 85, 'K', 'Kitaa');
INSERT INTO zones VALUES (1489, 86, 'A', 'Saint Andrew');
INSERT INTO zones VALUES (1490, 86, 'D', 'Saint David');
INSERT INTO zones VALUES (1491, 86, 'G', 'Saint George');
INSERT INTO zones VALUES (1492, 86, 'J', 'Saint John');
INSERT INTO zones VALUES (1493, 86, 'M', 'Saint Mark');
INSERT INTO zones VALUES (1494, 86, 'P', 'Saint Patrick');
INSERT INTO zones VALUES (1495, 86, 'C', 'Carriacou');
INSERT INTO zones VALUES (1496, 86, 'Q', 'Petit Martinique');
INSERT INTO zones VALUES (1497, 89, 'AV', 'Alta Verapaz');
INSERT INTO zones VALUES (1498, 89, 'BV', 'Baja Verapaz');
INSERT INTO zones VALUES (1499, 89, 'CM', 'Chimaltenango');
INSERT INTO zones VALUES (1500, 89, 'CQ', 'Chiquimula');
INSERT INTO zones VALUES (1501, 89, 'PE', 'El Peten');
INSERT INTO zones VALUES (1502, 89, 'PR', 'El Progreso');
INSERT INTO zones VALUES (1503, 89, 'QC', 'El Quiche');
INSERT INTO zones VALUES (1504, 89, 'ES', 'Escuintla');
INSERT INTO zones VALUES (1505, 89, 'GU', 'Guatemala');
INSERT INTO zones VALUES (1506, 89, 'HU', 'Huehuetenango');
INSERT INTO zones VALUES (1507, 89, 'IZ', 'Izabal');
INSERT INTO zones VALUES (1508, 89, 'JA', 'Jalapa');
INSERT INTO zones VALUES (1509, 89, 'JU', 'Jutiapa');
INSERT INTO zones VALUES (1510, 89, 'QZ', 'Quetzaltenango');
INSERT INTO zones VALUES (1511, 89, 'RE', 'Retalhuleu');
INSERT INTO zones VALUES (1512, 89, 'ST', 'Sacatepequez');
INSERT INTO zones VALUES (1513, 89, 'SM', 'San Marcos');
INSERT INTO zones VALUES (1514, 89, 'SR', 'Santa Rosa');
INSERT INTO zones VALUES (1515, 89, 'SO', 'Solola');
INSERT INTO zones VALUES (1516, 89, 'SU', 'Suchitepequez');
INSERT INTO zones VALUES (1517, 89, 'TO', 'Totonicapan');
INSERT INTO zones VALUES (1518, 89, 'ZA', 'Zacapa');
INSERT INTO zones VALUES (1519, 90, 'CNK', 'Conakry');
INSERT INTO zones VALUES (1520, 90, 'BYL', 'Beyla');
INSERT INTO zones VALUES (1521, 90, 'BFA', 'Boffa');
INSERT INTO zones VALUES (1522, 90, 'BOK', 'Boke');
INSERT INTO zones VALUES (1523, 90, 'COY', 'Coyah');
INSERT INTO zones VALUES (1524, 90, 'DBL', 'Dabola');
INSERT INTO zones VALUES (1525, 90, 'DLB', 'Dalaba');
INSERT INTO zones VALUES (1526, 90, 'DGR', 'Dinguiraye');
INSERT INTO zones VALUES (1527, 90, 'DBR', 'Dubreka');
INSERT INTO zones VALUES (1528, 90, 'FRN', 'Faranah');
INSERT INTO zones VALUES (1529, 90, 'FRC', 'Forecariah');
INSERT INTO zones VALUES (1530, 90, 'FRI', 'Fria');
INSERT INTO zones VALUES (1531, 90, 'GAO', 'Gaoual');
INSERT INTO zones VALUES (1532, 90, 'GCD', 'Gueckedou');
INSERT INTO zones VALUES (1533, 90, 'KNK', 'Kankan');
INSERT INTO zones VALUES (1534, 90, 'KRN', 'Kerouane');
INSERT INTO zones VALUES (1535, 90, 'KND', 'Kindia');
INSERT INTO zones VALUES (1536, 90, 'KSD', 'Kissidougou');
INSERT INTO zones VALUES (1537, 90, 'KBA', 'Koubia');
INSERT INTO zones VALUES (1538, 90, 'KDA', 'Koundara');
INSERT INTO zones VALUES (1539, 90, 'KRA', 'Kouroussa');
INSERT INTO zones VALUES (1540, 90, 'LAB', 'Labe');
INSERT INTO zones VALUES (1541, 90, 'LLM', 'Lelouma');
INSERT INTO zones VALUES (1542, 90, 'LOL', 'Lola');
INSERT INTO zones VALUES (1543, 90, 'MCT', 'Macenta');
INSERT INTO zones VALUES (1544, 90, 'MAL', 'Mali');
INSERT INTO zones VALUES (1545, 90, 'MAM', 'Mamou');
INSERT INTO zones VALUES (1546, 90, 'MAN', 'Mandiana');
INSERT INTO zones VALUES (1547, 90, 'NZR', 'Nzerekore');
INSERT INTO zones VALUES (1548, 90, 'PIT', 'Pita');
INSERT INTO zones VALUES (1549, 90, 'SIG', 'Siguiri');
INSERT INTO zones VALUES (1550, 90, 'TLM', 'Telimele');
INSERT INTO zones VALUES (1551, 90, 'TOG', 'Tougue');
INSERT INTO zones VALUES (1552, 90, 'YOM', 'Yomou');
INSERT INTO zones VALUES (1553, 91, 'BF', 'Bafata Region');
INSERT INTO zones VALUES (1554, 91, 'BB', 'Biombo Region');
INSERT INTO zones VALUES (1555, 91, 'BS', 'Bissau Region');
INSERT INTO zones VALUES (1556, 91, 'BL', 'Bolama Region');
INSERT INTO zones VALUES (1557, 91, 'CA', 'Cacheu Region');
INSERT INTO zones VALUES (1558, 91, 'GA', 'Gabu Region');
INSERT INTO zones VALUES (1559, 91, 'OI', 'Oio Region');
INSERT INTO zones VALUES (1560, 91, 'QU', 'Quinara Region');
INSERT INTO zones VALUES (1561, 91, 'TO', 'Tombali Region');
INSERT INTO zones VALUES (1562, 92, 'BW', 'Barima-Waini');
INSERT INTO zones VALUES (1563, 92, 'CM', 'Cuyuni-Mazaruni');
INSERT INTO zones VALUES (1564, 92, 'DM', 'Demerara-Mahaica');
INSERT INTO zones VALUES (1565, 92, 'EC', 'East Berbice-Corentyne');
INSERT INTO zones VALUES (1566, 92, 'EW', 'Essequibo Islands-West Demerara');
INSERT INTO zones VALUES (1567, 92, 'MB', 'Mahaica-Berbice');
INSERT INTO zones VALUES (1568, 92, 'PM', 'Pomeroon-Supenaam');
INSERT INTO zones VALUES (1569, 92, 'PI', 'Potaro-Siparuni');
INSERT INTO zones VALUES (1570, 92, 'UD', 'Upper Demerara-Berbice');
INSERT INTO zones VALUES (1571, 92, 'UT', 'Upper Takutu-Upper Essequibo');
INSERT INTO zones VALUES (1572, 93, 'AR', 'Artibonite');
INSERT INTO zones VALUES (1573, 93, 'CE', 'Centre');
INSERT INTO zones VALUES (1574, 93, 'GA', 'Grand''Anse');
INSERT INTO zones VALUES (1575, 93, 'ND', 'Nord');
INSERT INTO zones VALUES (1576, 93, 'NE', 'Nord-Est');
INSERT INTO zones VALUES (1577, 93, 'NO', 'Nord-Ouest');
INSERT INTO zones VALUES (1578, 93, 'OU', 'Ouest');
INSERT INTO zones VALUES (1579, 93, 'SD', 'Sud');
INSERT INTO zones VALUES (1580, 93, 'SE', 'Sud-Est');
INSERT INTO zones VALUES (1581, 94, 'F', 'Flat Island');
INSERT INTO zones VALUES (1582, 94, 'M', 'McDonald Island');
INSERT INTO zones VALUES (1583, 94, 'S', 'Shag Island');
INSERT INTO zones VALUES (1584, 94, 'H', 'Heard Island');
INSERT INTO zones VALUES (1585, 95, 'AT', 'Atlantida');
INSERT INTO zones VALUES (1586, 95, 'CH', 'Choluteca');
INSERT INTO zones VALUES (1587, 95, 'CL', 'Colon');
INSERT INTO zones VALUES (1588, 95, 'CM', 'Comayagua');
INSERT INTO zones VALUES (1589, 95, 'CP', 'Copan');
INSERT INTO zones VALUES (1590, 95, 'CR', 'Cortes');
INSERT INTO zones VALUES (1591, 95, 'PA', 'El Paraiso');
INSERT INTO zones VALUES (1592, 95, 'FM', 'Francisco Morazan');
INSERT INTO zones VALUES (1593, 95, 'GD', 'Gracias a Dios');
INSERT INTO zones VALUES (1594, 95, 'IN', 'Intibuca');
INSERT INTO zones VALUES (1595, 95, 'IB', 'Islas de la Bahia (Bay Islands)');
INSERT INTO zones VALUES (1596, 95, 'PZ', 'La Paz');
INSERT INTO zones VALUES (1597, 95, 'LE', 'Lempira');
INSERT INTO zones VALUES (1598, 95, 'OC', 'Ocotepeque');
INSERT INTO zones VALUES (1599, 95, 'OL', 'Olancho');
INSERT INTO zones VALUES (1600, 95, 'SB', 'Santa Barbara');
INSERT INTO zones VALUES (1601, 95, 'VA', 'Valle');
INSERT INTO zones VALUES (1602, 95, 'YO', 'Yoro');
INSERT INTO zones VALUES (1603, 96, 'HCW', 'Central and Western Hong Kong Is');
INSERT INTO zones VALUES (1604, 96, 'HEA', 'Eastern Hong Kong Island');
INSERT INTO zones VALUES (1605, 96, 'HSO', 'Southern Hong Kong Island');
INSERT INTO zones VALUES (1606, 96, 'HWC', 'Wan Chai Hong Kong Island');
INSERT INTO zones VALUES (1607, 96, 'KKC', 'Kowloon City Kowloon');
INSERT INTO zones VALUES (1608, 96, 'KKT', 'Kwun Tong Kowloon');
INSERT INTO zones VALUES (1609, 96, 'KSS', 'Sham Shui Po Kowloon');
INSERT INTO zones VALUES (1610, 96, 'KWT', 'Wong Tai Sin Kowloon');
INSERT INTO zones VALUES (1611, 96, 'KYT', 'Yau Tsim Mong Kowloon');
INSERT INTO zones VALUES (1612, 96, 'NIS', 'Islands New Territories');
INSERT INTO zones VALUES (1613, 96, 'NKT', 'Kwai Tsing New Territories');
INSERT INTO zones VALUES (1614, 96, 'NNO', 'North New Territories');
INSERT INTO zones VALUES (1615, 96, 'NSK', 'Sai Kung New Territories');
INSERT INTO zones VALUES (1616, 96, 'NST', 'Sha Tin New Territories');
INSERT INTO zones VALUES (1617, 96, 'NTP', 'Tai Po New Territories');
INSERT INTO zones VALUES (1618, 96, 'NTW', 'Tsuen Wan New Territories');
INSERT INTO zones VALUES (1619, 96, 'NTM', 'Tuen Mun New Territories');
INSERT INTO zones VALUES (1620, 96, 'NYL', 'Yuen Long New Territories');
INSERT INTO zones VALUES (1621, 97, 'BK', 'Bacs-Kiskun');
INSERT INTO zones VALUES (1622, 97, 'BA', 'Baranya');
INSERT INTO zones VALUES (1623, 97, 'BE', 'Bekes');
INSERT INTO zones VALUES (1624, 97, 'BS', 'Bekescsaba');
INSERT INTO zones VALUES (1625, 97, 'BZ', 'Borsod-Abauj-Zemplen');
INSERT INTO zones VALUES (1626, 97, 'BU', 'Budapest');
INSERT INTO zones VALUES (1627, 97, 'CS', 'Csongrad');
INSERT INTO zones VALUES (1628, 97, 'DE', 'Debrecen');
INSERT INTO zones VALUES (1629, 97, 'DU', 'Dunaujvaros');
INSERT INTO zones VALUES (1630, 97, 'EG', 'Eger');
INSERT INTO zones VALUES (1631, 97, 'FE', 'Fejer');
INSERT INTO zones VALUES (1632, 97, 'GY', 'Gyor');
INSERT INTO zones VALUES (1633, 97, 'GM', 'Gyor-Moson-Sopron');
INSERT INTO zones VALUES (1634, 97, 'HB', 'Hajdu-Bihar');
INSERT INTO zones VALUES (1635, 97, 'HE', 'Heves');
INSERT INTO zones VALUES (1636, 97, 'HO', 'Hodmezovasarhely');
INSERT INTO zones VALUES (1637, 97, 'JN', 'Jasz-Nagykun-Szolnok');
INSERT INTO zones VALUES (1638, 97, 'KA', 'Kaposvar');
INSERT INTO zones VALUES (1639, 97, 'KE', 'Kecskemet');
INSERT INTO zones VALUES (1640, 97, 'KO', 'Komarom-Esztergom');
INSERT INTO zones VALUES (1641, 97, 'MI', 'Miskolc');
INSERT INTO zones VALUES (1642, 97, 'NA', 'Nagykanizsa');
INSERT INTO zones VALUES (1643, 97, 'NO', 'Nograd');
INSERT INTO zones VALUES (1644, 97, 'NY', 'Nyiregyhaza');
INSERT INTO zones VALUES (1645, 97, 'PE', 'Pecs');
INSERT INTO zones VALUES (1646, 97, 'PS', 'Pest');
INSERT INTO zones VALUES (1647, 97, 'SO', 'Somogy');
INSERT INTO zones VALUES (1648, 97, 'SP', 'Sopron');
INSERT INTO zones VALUES (1649, 97, 'SS', 'Szabolcs-Szatmar-Bereg');
INSERT INTO zones VALUES (1650, 97, 'SZ', 'Szeged');
INSERT INTO zones VALUES (1651, 97, 'SE', 'Szekesfehervar');
INSERT INTO zones VALUES (1652, 97, 'SL', 'Szolnok');
INSERT INTO zones VALUES (1653, 97, 'SM', 'Szombathely');
INSERT INTO zones VALUES (1654, 97, 'TA', 'Tatabanya');
INSERT INTO zones VALUES (1655, 97, 'TO', 'Tolna');
INSERT INTO zones VALUES (1656, 97, 'VA', 'Vas');
INSERT INTO zones VALUES (1657, 97, 'VE', 'Veszprem');
INSERT INTO zones VALUES (1658, 97, 'ZA', 'Zala');
INSERT INTO zones VALUES (1659, 97, 'ZZ', 'Zalaegerszeg');
INSERT INTO zones VALUES (1660, 98, 'AL', 'Austurland');
INSERT INTO zones VALUES (1661, 98, 'HF', 'Hofuoborgarsvaeoi');
INSERT INTO zones VALUES (1662, 98, 'NE', 'Norourland eystra');
INSERT INTO zones VALUES (1663, 98, 'NV', 'Norourland vestra');
INSERT INTO zones VALUES (1664, 98, 'SL', 'Suourland');
INSERT INTO zones VALUES (1665, 98, 'SN', 'Suournes');
INSERT INTO zones VALUES (1666, 98, 'VF', 'Vestfiroir');
INSERT INTO zones VALUES (1667, 98, 'VL', 'Vesturland');
INSERT INTO zones VALUES (1668, 99, 'AN', 'Andaman and Nicobar Islands');
INSERT INTO zones VALUES (1669, 99, 'AP', 'Andhra Pradesh');
INSERT INTO zones VALUES (1670, 99, 'AR', 'Arunachal Pradesh');
INSERT INTO zones VALUES (1671, 99, 'AS', 'Assam');
INSERT INTO zones VALUES (1672, 99, 'BI', 'Bihar');
INSERT INTO zones VALUES (1673, 99, 'CH', 'Chandigarh');
INSERT INTO zones VALUES (1674, 99, 'DA', 'Dadra and Nagar Haveli');
INSERT INTO zones VALUES (1675, 99, 'DM', 'Daman and Diu');
INSERT INTO zones VALUES (1676, 99, 'DE', 'Delhi');
INSERT INTO zones VALUES (1677, 99, 'GO', 'Goa');
INSERT INTO zones VALUES (1678, 99, 'GU', 'Gujarat');
INSERT INTO zones VALUES (1679, 99, 'HA', 'Haryana');
INSERT INTO zones VALUES (1680, 99, 'HP', 'Himachal Pradesh');
INSERT INTO zones VALUES (1681, 99, 'JA', 'Jammu and Kashmir');
INSERT INTO zones VALUES (1682, 99, 'KA', 'Karnataka');
INSERT INTO zones VALUES (1683, 99, 'KE', 'Kerala');
INSERT INTO zones VALUES (1684, 99, 'LI', 'Lakshadweep Islands');
INSERT INTO zones VALUES (1685, 99, 'MP', 'Madhya Pradesh');
INSERT INTO zones VALUES (1686, 99, 'MA', 'Maharashtra');
INSERT INTO zones VALUES (1687, 99, 'MN', 'Manipur');
INSERT INTO zones VALUES (1688, 99, 'ME', 'Meghalaya');
INSERT INTO zones VALUES (1689, 99, 'MI', 'Mizoram');
INSERT INTO zones VALUES (1690, 99, 'NA', 'Nagaland');
INSERT INTO zones VALUES (1691, 99, 'OR', 'Orissa');
INSERT INTO zones VALUES (1692, 99, 'PO', 'Pondicherry');
INSERT INTO zones VALUES (1693, 99, 'PU', 'Punjab');
INSERT INTO zones VALUES (1694, 99, 'RA', 'Rajasthan');
INSERT INTO zones VALUES (1695, 99, 'SI', 'Sikkim');
INSERT INTO zones VALUES (1696, 99, 'TN', 'Tamil Nadu');
INSERT INTO zones VALUES (1697, 99, 'TR', 'Tripura');
INSERT INTO zones VALUES (1698, 99, 'UP', 'Uttar Pradesh');
INSERT INTO zones VALUES (1699, 99, 'WB', 'West Bengal');
INSERT INTO zones VALUES (1700, 100, 'AC', 'Aceh');
INSERT INTO zones VALUES (1701, 100, 'BA', 'Bali');
INSERT INTO zones VALUES (1702, 100, 'BT', 'Banten');
INSERT INTO zones VALUES (1703, 100, 'BE', 'Bengkulu');
INSERT INTO zones VALUES (1704, 100, 'BD', 'BoDeTaBek');
INSERT INTO zones VALUES (1705, 100, 'GO', 'Gorontalo');
INSERT INTO zones VALUES (1706, 100, 'JK', 'Jakarta Raya');
INSERT INTO zones VALUES (1707, 100, 'JA', 'Jambi');
INSERT INTO zones VALUES (1708, 100, 'JB', 'Jawa Barat');
INSERT INTO zones VALUES (1709, 100, 'JT', 'Jawa Tengah');
INSERT INTO zones VALUES (1710, 100, 'JI', 'Jawa Timur');
INSERT INTO zones VALUES (1711, 100, 'KB', 'Kalimantan Barat');
INSERT INTO zones VALUES (1712, 100, 'KS', 'Kalimantan Selatan');
INSERT INTO zones VALUES (1713, 100, 'KT', 'Kalimantan Tengah');
INSERT INTO zones VALUES (1714, 100, 'KI', 'Kalimantan Timur');
INSERT INTO zones VALUES (1715, 100, 'BB', 'Kepulauan Bangka Belitung');
INSERT INTO zones VALUES (1716, 100, 'LA', 'Lampung');
INSERT INTO zones VALUES (1717, 100, 'MA', 'Maluku');
INSERT INTO zones VALUES (1718, 100, 'MU', 'Maluku Utara');
INSERT INTO zones VALUES (1719, 100, 'NB', 'Nusa Tenggara Barat');
INSERT INTO zones VALUES (1720, 100, 'NT', 'Nusa Tenggara Timur');
INSERT INTO zones VALUES (1721, 100, 'PA', 'Papua');
INSERT INTO zones VALUES (1722, 100, 'RI', 'Riau');
INSERT INTO zones VALUES (1723, 100, 'SN', 'Sulawesi Selatan');
INSERT INTO zones VALUES (1724, 100, 'ST', 'Sulawesi Tengah');
INSERT INTO zones VALUES (1725, 100, 'SG', 'Sulawesi Tenggara');
INSERT INTO zones VALUES (1726, 100, 'SA', 'Sulawesi Utara');
INSERT INTO zones VALUES (1727, 100, 'SB', 'Sumatera Barat');
INSERT INTO zones VALUES (1728, 100, 'SS', 'Sumatera Selatan');
INSERT INTO zones VALUES (1729, 100, 'SU', 'Sumatera Utara');
INSERT INTO zones VALUES (1730, 100, 'YO', 'Yogyakarta');
INSERT INTO zones VALUES (1731, 101, 'TEH', 'Tehran');
INSERT INTO zones VALUES (1732, 101, 'QOM', 'Qom');
INSERT INTO zones VALUES (1733, 101, 'MKZ', 'Markazi');
INSERT INTO zones VALUES (1734, 101, 'QAZ', 'Qazvin');
INSERT INTO zones VALUES (1735, 101, 'GIL', 'Gilan');
INSERT INTO zones VALUES (1736, 101, 'ARD', 'Ardabil');
INSERT INTO zones VALUES (1737, 101, 'ZAN', 'Zanjan');
INSERT INTO zones VALUES (1738, 101, 'EAZ', 'East Azarbaijan');
INSERT INTO zones VALUES (1739, 101, 'WEZ', 'West Azarbaijan');
INSERT INTO zones VALUES (1740, 101, 'KRD', 'Kurdistan');
INSERT INTO zones VALUES (1741, 101, 'HMD', 'Hamadan');
INSERT INTO zones VALUES (1742, 101, 'KRM', 'Kermanshah');
INSERT INTO zones VALUES (1743, 101, 'ILM', 'Ilam');
INSERT INTO zones VALUES (1744, 101, 'LRS', 'Lorestan');
INSERT INTO zones VALUES (1745, 101, 'KZT', 'Khuzestan');
INSERT INTO zones VALUES (1746, 101, 'CMB', 'Chahar Mahaal and Bakhtiari');
INSERT INTO zones VALUES (1747, 101, 'KBA', 'Kohkiluyeh and Buyer Ahmad');
INSERT INTO zones VALUES (1748, 101, 'BSH', 'Bushehr');
INSERT INTO zones VALUES (1749, 101, 'FAR', 'Fars');
INSERT INTO zones VALUES (1750, 101, 'HRM', 'Hormozgan');
INSERT INTO zones VALUES (1751, 101, 'SBL', 'Sistan and Baluchistan');
INSERT INTO zones VALUES (1752, 101, 'KRB', 'Kerman');
INSERT INTO zones VALUES (1753, 101, 'YZD', 'Yazd');
INSERT INTO zones VALUES (1754, 101, 'EFH', 'Esfahan');
INSERT INTO zones VALUES (1755, 101, 'SMN', 'Semnan');
INSERT INTO zones VALUES (1756, 101, 'MZD', 'Mazandaran');
INSERT INTO zones VALUES (1757, 101, 'GLS', 'Golestan');
INSERT INTO zones VALUES (1758, 101, 'NKH', 'North Khorasan');
INSERT INTO zones VALUES (1759, 101, 'RKH', 'Razavi Khorasan');
INSERT INTO zones VALUES (1760, 101, 'SKH', 'South Khorasan');
INSERT INTO zones VALUES (1761, 102, 'BD', 'Baghdad');
INSERT INTO zones VALUES (1762, 102, 'SD', 'Salah ad Din');
INSERT INTO zones VALUES (1763, 102, 'DY', 'Diyala');
INSERT INTO zones VALUES (1764, 102, 'WS', 'Wasit');
INSERT INTO zones VALUES (1765, 102, 'MY', 'Maysan');
INSERT INTO zones VALUES (1766, 102, 'BA', 'Al Basrah');
INSERT INTO zones VALUES (1767, 102, 'DQ', 'Dhi Qar');
INSERT INTO zones VALUES (1768, 102, 'MU', 'Al Muthanna');
INSERT INTO zones VALUES (1769, 102, 'QA', 'Al Qadisyah');
INSERT INTO zones VALUES (1770, 102, 'BB', 'Babil');
INSERT INTO zones VALUES (1771, 102, 'KB', 'Al Karbala');
INSERT INTO zones VALUES (1772, 102, 'NJ', 'An Najaf');
INSERT INTO zones VALUES (1773, 102, 'AB', 'Al Anbar');
INSERT INTO zones VALUES (1774, 102, 'NN', 'Ninawa');
INSERT INTO zones VALUES (1775, 102, 'DH', 'Dahuk');
INSERT INTO zones VALUES (1776, 102, 'AL', 'Arbil');
INSERT INTO zones VALUES (1777, 102, 'TM', 'At Ta''mim');
INSERT INTO zones VALUES (1778, 102, 'SL', 'As Sulaymaniyah');
INSERT INTO zones VALUES (1779, 103, 'CA', 'Carlow');
INSERT INTO zones VALUES (1780, 103, 'CV', 'Cavan');
INSERT INTO zones VALUES (1781, 103, 'CL', 'Clare');
INSERT INTO zones VALUES (1782, 103, 'CO', 'Cork');
INSERT INTO zones VALUES (1783, 103, 'DO', 'Donegal');
INSERT INTO zones VALUES (1784, 103, 'DU', 'Dublin');
INSERT INTO zones VALUES (1785, 103, 'GA', 'Galway');
INSERT INTO zones VALUES (1786, 103, 'KE', 'Kerry');
INSERT INTO zones VALUES (1787, 103, 'KI', 'Kildare');
INSERT INTO zones VALUES (1788, 103, 'KL', 'Kilkenny');
INSERT INTO zones VALUES (1789, 103, 'LA', 'Laois');
INSERT INTO zones VALUES (1790, 103, 'LE', 'Leitrim');
INSERT INTO zones VALUES (1791, 103, 'LI', 'Limerick');
INSERT INTO zones VALUES (1792, 103, 'LO', 'Longford');
INSERT INTO zones VALUES (1793, 103, 'LU', 'Louth');
INSERT INTO zones VALUES (1794, 103, 'MA', 'Mayo');
INSERT INTO zones VALUES (1795, 103, 'ME', 'Meath');
INSERT INTO zones VALUES (1796, 103, 'MO', 'Monaghan');
INSERT INTO zones VALUES (1797, 103, 'OF', 'Offaly');
INSERT INTO zones VALUES (1798, 103, 'RO', 'Roscommon');
INSERT INTO zones VALUES (1799, 103, 'SL', 'Sligo');
INSERT INTO zones VALUES (1800, 103, 'TI', 'Tipperary');
INSERT INTO zones VALUES (1801, 103, 'WA', 'Waterford');
INSERT INTO zones VALUES (1802, 103, 'WE', 'Westmeath');
INSERT INTO zones VALUES (1803, 103, 'WX', 'Wexford');
INSERT INTO zones VALUES (1804, 103, 'WI', 'Wicklow');
INSERT INTO zones VALUES (1805, 104, 'BS', 'Be''er Sheva');
INSERT INTO zones VALUES (1806, 104, 'BH', 'Bika''at Hayarden');
INSERT INTO zones VALUES (1807, 104, 'EA', 'Eilat and Arava');
INSERT INTO zones VALUES (1808, 104, 'GA', 'Galil');
INSERT INTO zones VALUES (1809, 104, 'HA', 'Haifa');
INSERT INTO zones VALUES (1810, 104, 'JM', 'Jehuda Mountains');
INSERT INTO zones VALUES (1811, 104, 'JE', 'Jerusalem');
INSERT INTO zones VALUES (1812, 104, 'NE', 'Negev');
INSERT INTO zones VALUES (1813, 104, 'SE', 'Semaria');
INSERT INTO zones VALUES (1814, 104, 'SH', 'Sharon');
INSERT INTO zones VALUES (1815, 104, 'TA', 'Tel Aviv (Gosh Dan)');
INSERT INTO zones VALUES (1816, 105, 'AB', 'Abruzzo');
INSERT INTO zones VALUES (1817, 105, 'BA', 'Basilicata');
INSERT INTO zones VALUES (1818, 105, 'CA', 'Calabria');
INSERT INTO zones VALUES (1819, 105, 'CP', 'Campania');
INSERT INTO zones VALUES (1820, 105, 'ER', 'Emilia Romagna');
INSERT INTO zones VALUES (1821, 105, 'FV', 'Friuli-Venezia Giulia');
INSERT INTO zones VALUES (1822, 105, 'LA', 'Lazio (Latium & Rome)');
INSERT INTO zones VALUES (1823, 105, 'TM', 'Le Marche (The Marches)');
INSERT INTO zones VALUES (1824, 105, 'LI', 'Liguria');
INSERT INTO zones VALUES (1825, 105, 'LO', 'Lombardia (Lombardy)');
INSERT INTO zones VALUES (1826, 105, 'MO', 'Molise');
INSERT INTO zones VALUES (1827, 105, 'PI', 'Piemonte (Piedmont)');
INSERT INTO zones VALUES (1828, 105, 'AP', 'Puglia (Apulia)');
INSERT INTO zones VALUES (1829, 105, 'SA', 'Sardegna (Sardinia)');
INSERT INTO zones VALUES (1830, 105, 'SI', 'Sicilia (Sicily)');
INSERT INTO zones VALUES (1831, 105, 'TU', 'Toscana (Tuscany)');
INSERT INTO zones VALUES (1832, 105, 'TR', 'Trentino Alto Adige');
INSERT INTO zones VALUES (1833, 105, 'UM', 'Umbria');
INSERT INTO zones VALUES (1834, 105, 'VA', 'Val d''Aosta');
INSERT INTO zones VALUES (1835, 105, 'VE', 'Veneto');
INSERT INTO zones VALUES (1836, 106, 'CLA', 'Clarendon Parish');
INSERT INTO zones VALUES (1837, 106, 'HAN', 'Hanover Parish');
INSERT INTO zones VALUES (1838, 106, 'KIN', 'Kingston Parish');
INSERT INTO zones VALUES (1839, 106, 'MAN', 'Manchester Parish');
INSERT INTO zones VALUES (1840, 106, 'POR', 'Portland Parish');
INSERT INTO zones VALUES (1841, 106, 'AND', 'Saint Andrew Parish');
INSERT INTO zones VALUES (1842, 106, 'ANN', 'Saint Ann Parish');
INSERT INTO zones VALUES (1843, 106, 'CAT', 'Saint Catherine Parish');
INSERT INTO zones VALUES (1844, 106, 'ELI', 'Saint Elizabeth Parish');
INSERT INTO zones VALUES (1845, 106, 'JAM', 'Saint James Parish');
INSERT INTO zones VALUES (1846, 106, 'MAR', 'Saint Mary Parish');
INSERT INTO zones VALUES (1847, 106, 'THO', 'Saint Thomas Parish');
INSERT INTO zones VALUES (1848, 106, 'TRL', 'Trelawny Parish');
INSERT INTO zones VALUES (1849, 106, 'WML', 'Westmoreland Parish');
INSERT INTO zones VALUES (1850, 107, 'AI', 'Aichi');
INSERT INTO zones VALUES (1851, 107, 'AK', 'Akita');
INSERT INTO zones VALUES (1852, 107, 'AO', 'Aomori');
INSERT INTO zones VALUES (1853, 107, 'CH', 'Chiba');
INSERT INTO zones VALUES (1854, 107, 'EH', 'Ehime');
INSERT INTO zones VALUES (1855, 107, 'FK', 'Fukui');
INSERT INTO zones VALUES (1856, 107, 'FU', 'Fukuoka');
INSERT INTO zones VALUES (1857, 107, 'FS', 'Fukushima');
INSERT INTO zones VALUES (1858, 107, 'GI', 'Gifu');
INSERT INTO zones VALUES (1859, 107, 'GU', 'Gumma');
INSERT INTO zones VALUES (1860, 107, 'HI', 'Hiroshima');
INSERT INTO zones VALUES (1861, 107, 'HO', 'Hokkaido');
INSERT INTO zones VALUES (1862, 107, 'HY', 'Hyogo');
INSERT INTO zones VALUES (1863, 107, 'IB', 'Ibaraki');
INSERT INTO zones VALUES (1864, 107, 'IS', 'Ishikawa');
INSERT INTO zones VALUES (1865, 107, 'IW', 'Iwate');
INSERT INTO zones VALUES (1866, 107, 'KA', 'Kagawa');
INSERT INTO zones VALUES (1867, 107, 'KG', 'Kagoshima');
INSERT INTO zones VALUES (1868, 107, 'KN', 'Kanagawa');
INSERT INTO zones VALUES (1869, 107, 'KO', 'Kochi');
INSERT INTO zones VALUES (1870, 107, 'KU', 'Kumamoto');
INSERT INTO zones VALUES (1871, 107, 'KY', 'Kyoto');
INSERT INTO zones VALUES (1872, 107, 'MI', 'Mie');
INSERT INTO zones VALUES (1873, 107, 'MY', 'Miyagi');
INSERT INTO zones VALUES (1874, 107, 'MZ', 'Miyazaki');
INSERT INTO zones VALUES (1875, 107, 'NA', 'Nagano');
INSERT INTO zones VALUES (1876, 107, 'NG', 'Nagasaki');
INSERT INTO zones VALUES (1877, 107, 'NR', 'Nara');
INSERT INTO zones VALUES (1878, 107, 'NI', 'Niigata');
INSERT INTO zones VALUES (1879, 107, 'OI', 'Oita');
INSERT INTO zones VALUES (1880, 107, 'OK', 'Okayama');
INSERT INTO zones VALUES (1881, 107, 'ON', 'Okinawa');
INSERT INTO zones VALUES (1882, 107, 'OS', 'Osaka');
INSERT INTO zones VALUES (1883, 107, 'SA', 'Saga');
INSERT INTO zones VALUES (1884, 107, 'SI', 'Saitama');
INSERT INTO zones VALUES (1885, 107, 'SH', 'Shiga');
INSERT INTO zones VALUES (1886, 107, 'SM', 'Shimane');
INSERT INTO zones VALUES (1887, 107, 'SZ', 'Shizuoka');
INSERT INTO zones VALUES (1888, 107, 'TO', 'Tochigi');
INSERT INTO zones VALUES (1889, 107, 'TS', 'Tokushima');
INSERT INTO zones VALUES (1890, 107, 'TK', 'Tokyo');
INSERT INTO zones VALUES (1891, 107, 'TT', 'Tottori');
INSERT INTO zones VALUES (1892, 107, 'TY', 'Toyama');
INSERT INTO zones VALUES (1893, 107, 'WA', 'Wakayama');
INSERT INTO zones VALUES (1894, 107, 'YA', 'Yamagata');
INSERT INTO zones VALUES (1895, 107, 'YM', 'Yamaguchi');
INSERT INTO zones VALUES (1896, 107, 'YN', 'Yamanashi');
INSERT INTO zones VALUES (1897, 108, 'AM', '''Amman');
INSERT INTO zones VALUES (1898, 108, 'AJ', 'Ajlun');
INSERT INTO zones VALUES (1899, 108, 'AA', 'Al ''Aqabah');
INSERT INTO zones VALUES (1900, 108, 'AB', 'Al Balqa''');
INSERT INTO zones VALUES (1901, 108, 'AK', 'Al Karak');
INSERT INTO zones VALUES (1902, 108, 'AL', 'Al Mafraq');
INSERT INTO zones VALUES (1903, 108, 'AT', 'At Tafilah');
INSERT INTO zones VALUES (1904, 108, 'AZ', 'Az Zarqa''');
INSERT INTO zones VALUES (1905, 108, 'IR', 'Irbid');
INSERT INTO zones VALUES (1906, 108, 'JA', 'Jarash');
INSERT INTO zones VALUES (1907, 108, 'MA', 'Ma''an');
INSERT INTO zones VALUES (1908, 108, 'MD', 'Madaba');
INSERT INTO zones VALUES (1909, 109, 'AL', 'Almaty');
INSERT INTO zones VALUES (1910, 109, 'AC', 'Almaty City');
INSERT INTO zones VALUES (1911, 109, 'AM', 'Aqmola');
INSERT INTO zones VALUES (1912, 109, 'AQ', 'Aqtobe');
INSERT INTO zones VALUES (1913, 109, 'AS', 'Astana City');
INSERT INTO zones VALUES (1914, 109, 'AT', 'Atyrau');
INSERT INTO zones VALUES (1915, 109, 'BA', 'Batys Qazaqstan');
INSERT INTO zones VALUES (1916, 109, 'BY', 'Bayqongyr City');
INSERT INTO zones VALUES (1917, 109, 'MA', 'Mangghystau');
INSERT INTO zones VALUES (1918, 109, 'ON', 'Ongtustik Qazaqstan');
INSERT INTO zones VALUES (1919, 109, 'PA', 'Pavlodar');
INSERT INTO zones VALUES (1920, 109, 'QA', 'Qaraghandy');
INSERT INTO zones VALUES (1921, 109, 'QO', 'Qostanay');
INSERT INTO zones VALUES (1922, 109, 'QY', 'Qyzylorda');
INSERT INTO zones VALUES (1923, 109, 'SH', 'Shyghys Qazaqstan');
INSERT INTO zones VALUES (1924, 109, 'SO', 'Soltustik Qazaqstan');
INSERT INTO zones VALUES (1925, 109, 'ZH', 'Zhambyl');
INSERT INTO zones VALUES (1926, 110, 'CE', 'Central');
INSERT INTO zones VALUES (1927, 110, 'CO', 'Coast');
INSERT INTO zones VALUES (1928, 110, 'EA', 'Eastern');
INSERT INTO zones VALUES (1929, 110, 'NA', 'Nairobi Area');
INSERT INTO zones VALUES (1930, 110, 'NE', 'North Eastern');
INSERT INTO zones VALUES (1931, 110, 'NY', 'Nyanza');
INSERT INTO zones VALUES (1932, 110, 'RV', 'Rift Valley');
INSERT INTO zones VALUES (1933, 110, 'WE', 'Western');
INSERT INTO zones VALUES (1934, 111, 'AG', 'Abaiang');
INSERT INTO zones VALUES (1935, 111, 'AM', 'Abemama');
INSERT INTO zones VALUES (1936, 111, 'AK', 'Aranuka');
INSERT INTO zones VALUES (1937, 111, 'AO', 'Arorae');
INSERT INTO zones VALUES (1938, 111, 'BA', 'Banaba');
INSERT INTO zones VALUES (1939, 111, 'BE', 'Beru');
INSERT INTO zones VALUES (1940, 111, 'bT', 'Butaritari');
INSERT INTO zones VALUES (1941, 111, 'KA', 'Kanton');
INSERT INTO zones VALUES (1942, 111, 'KR', 'Kiritimati');
INSERT INTO zones VALUES (1943, 111, 'KU', 'Kuria');
INSERT INTO zones VALUES (1944, 111, 'MI', 'Maiana');
INSERT INTO zones VALUES (1945, 111, 'MN', 'Makin');
INSERT INTO zones VALUES (1946, 111, 'ME', 'Marakei');
INSERT INTO zones VALUES (1947, 111, 'NI', 'Nikunau');
INSERT INTO zones VALUES (1948, 111, 'NO', 'Nonouti');
INSERT INTO zones VALUES (1949, 111, 'ON', 'Onotoa');
INSERT INTO zones VALUES (1950, 111, 'TT', 'Tabiteuea');
INSERT INTO zones VALUES (1951, 111, 'TR', 'Tabuaeran');
INSERT INTO zones VALUES (1952, 111, 'TM', 'Tamana');
INSERT INTO zones VALUES (1953, 111, 'TW', 'Tarawa');
INSERT INTO zones VALUES (1954, 111, 'TE', 'Teraina');
INSERT INTO zones VALUES (1955, 112, 'CHA', 'Chagang-do');
INSERT INTO zones VALUES (1956, 112, 'HAB', 'Hamgyong-bukto');
INSERT INTO zones VALUES (1957, 112, 'HAN', 'Hamgyong-namdo');
INSERT INTO zones VALUES (1958, 112, 'HWB', 'Hwanghae-bukto');
INSERT INTO zones VALUES (1959, 112, 'HWN', 'Hwanghae-namdo');
INSERT INTO zones VALUES (1960, 112, 'KAN', 'Kangwon-do');
INSERT INTO zones VALUES (1961, 112, 'PYB', 'P''yongan-bukto');
INSERT INTO zones VALUES (1962, 112, 'PYN', 'P''yongan-namdo');
INSERT INTO zones VALUES (1963, 112, 'YAN', 'Ryanggang-do (Yanggang-do)');
INSERT INTO zones VALUES (1964, 112, 'NAJ', 'Rason Directly Governed City');
INSERT INTO zones VALUES (1965, 112, 'PYO', 'P''yongyang Special City');
INSERT INTO zones VALUES (1966, 113, 'CO', 'Ch''ungch''ong-bukto');
INSERT INTO zones VALUES (1967, 113, 'CH', 'Ch''ungch''ong-namdo');
INSERT INTO zones VALUES (1968, 113, 'CD', 'Cheju-do');
INSERT INTO zones VALUES (1969, 113, 'CB', 'Cholla-bukto');
INSERT INTO zones VALUES (1970, 113, 'CN', 'Cholla-namdo');
INSERT INTO zones VALUES (1971, 113, 'IG', 'Inch''on-gwangyoksi');
INSERT INTO zones VALUES (1972, 113, 'KA', 'Kangwon-do');
INSERT INTO zones VALUES (1973, 113, 'KG', 'Kwangju-gwangyoksi');
INSERT INTO zones VALUES (1974, 113, 'KD', 'Kyonggi-do');
INSERT INTO zones VALUES (1975, 113, 'KB', 'Kyongsang-bukto');
INSERT INTO zones VALUES (1976, 113, 'KN', 'Kyongsang-namdo');
INSERT INTO zones VALUES (1977, 113, 'PG', 'Pusan-gwangyoksi');
INSERT INTO zones VALUES (1978, 113, 'SO', 'Soul-t''ukpyolsi');
INSERT INTO zones VALUES (1979, 113, 'TA', 'Taegu-gwangyoksi');
INSERT INTO zones VALUES (1980, 113, 'TG', 'Taejon-gwangyoksi');
INSERT INTO zones VALUES (1981, 114, 'AL', 'Al ''Asimah');
INSERT INTO zones VALUES (1982, 114, 'AA', 'Al Ahmadi');
INSERT INTO zones VALUES (1983, 114, 'AF', 'Al Farwaniyah');
INSERT INTO zones VALUES (1984, 114, 'AJ', 'Al Jahra''');
INSERT INTO zones VALUES (1985, 114, 'HA', 'Hawalli');
INSERT INTO zones VALUES (1986, 115, 'GB', 'Bishkek');
INSERT INTO zones VALUES (1987, 115, 'B', 'Batken');
INSERT INTO zones VALUES (1988, 115, 'C', 'Chu');
INSERT INTO zones VALUES (1989, 115, 'J', 'Jalal-Abad');
INSERT INTO zones VALUES (1990, 115, 'N', 'Naryn');
INSERT INTO zones VALUES (1991, 115, 'O', 'Osh');
INSERT INTO zones VALUES (1992, 115, 'T', 'Talas');
INSERT INTO zones VALUES (1993, 115, 'Y', 'Ysyk-Kol');
INSERT INTO zones VALUES (1994, 116, 'VT', 'Vientiane');
INSERT INTO zones VALUES (1995, 116, 'AT', 'Attapu');
INSERT INTO zones VALUES (1996, 116, 'BK', 'Bokeo');
INSERT INTO zones VALUES (1997, 116, 'BL', 'Bolikhamxai');
INSERT INTO zones VALUES (1998, 116, 'CH', 'Champasak ');
INSERT INTO zones VALUES (1999, 116, 'HO', 'Houaphan');
INSERT INTO zones VALUES (2000, 116, 'KH', 'Khammouan');
INSERT INTO zones VALUES (2001, 116, 'LM', 'Louang Namtha');
INSERT INTO zones VALUES (2002, 116, 'LP', 'Louangphabang');
INSERT INTO zones VALUES (2003, 116, 'OU', 'Oudomxai');
INSERT INTO zones VALUES (2004, 116, 'PH', 'Phongsali');
INSERT INTO zones VALUES (2005, 116, 'SL', 'Salavan');
INSERT INTO zones VALUES (2006, 116, 'SV', 'Savannakhet');
INSERT INTO zones VALUES (2007, 116, 'VI', 'Vientiane');
INSERT INTO zones VALUES (2008, 116, 'XA', 'Xaignabouli');
INSERT INTO zones VALUES (2009, 116, 'XE', 'Xekong');
INSERT INTO zones VALUES (2010, 116, 'XI', 'Xiangkhoang');
INSERT INTO zones VALUES (2011, 116, 'XN', 'Xaisomboun');
INSERT INTO zones VALUES (2012, 117, 'AIZ', 'Aizkraukles Rajons');
INSERT INTO zones VALUES (2013, 117, 'ALU', 'Aluksnes Rajons');
INSERT INTO zones VALUES (2014, 117, 'BAL', 'Balvu Rajons');
INSERT INTO zones VALUES (2015, 117, 'BAU', 'Bauskas Rajons');
INSERT INTO zones VALUES (2016, 117, 'CES', 'Cesu Rajons');
INSERT INTO zones VALUES (2017, 117, 'DGR', 'Daugavpils Rajons');
INSERT INTO zones VALUES (2018, 117, 'DOB', 'Dobeles Rajons');
INSERT INTO zones VALUES (2019, 117, 'GUL', 'Gulbenes Rajons');
INSERT INTO zones VALUES (2020, 117, 'JEK', 'Jekabpils Rajons');
INSERT INTO zones VALUES (2021, 117, 'JGR', 'Jelgavas Rajons');
INSERT INTO zones VALUES (2022, 117, 'KRA', 'Kraslavas Rajons');
INSERT INTO zones VALUES (2023, 117, 'KUL', 'Kuldigas Rajons');
INSERT INTO zones VALUES (2024, 117, 'LPR', 'Liepajas Rajons');
INSERT INTO zones VALUES (2025, 117, 'LIM', 'Limbazu Rajons');
INSERT INTO zones VALUES (2026, 117, 'LUD', 'Ludzas Rajons');
INSERT INTO zones VALUES (2027, 117, 'MAD', 'Madonas Rajons');
INSERT INTO zones VALUES (2028, 117, 'OGR', 'Ogres Rajons');
INSERT INTO zones VALUES (2029, 117, 'PRE', 'Preilu Rajons');
INSERT INTO zones VALUES (2030, 117, 'RZR', 'Rezeknes Rajons');
INSERT INTO zones VALUES (2031, 117, 'RGR', 'Rigas Rajons');
INSERT INTO zones VALUES (2032, 117, 'SAL', 'Saldus Rajons');
INSERT INTO zones VALUES (2033, 117, 'TAL', 'Talsu Rajons');
INSERT INTO zones VALUES (2034, 117, 'TUK', 'Tukuma Rajons');
INSERT INTO zones VALUES (2035, 117, 'VLK', 'Valkas Rajons');
INSERT INTO zones VALUES (2036, 117, 'VLM', 'Valmieras Rajons');
INSERT INTO zones VALUES (2037, 117, 'VSR', 'Ventspils Rajons');
INSERT INTO zones VALUES (2038, 117, 'DGV', 'Daugavpils');
INSERT INTO zones VALUES (2039, 117, 'JGV', 'Jelgava');
INSERT INTO zones VALUES (2040, 117, 'JUR', 'Jurmala');
INSERT INTO zones VALUES (2041, 117, 'LPK', 'Liepaja');
INSERT INTO zones VALUES (2042, 117, 'RZK', 'Rezekne');
INSERT INTO zones VALUES (2043, 117, 'RGA', 'Riga');
INSERT INTO zones VALUES (2044, 117, 'VSL', 'Ventspils');
INSERT INTO zones VALUES (2045, 119, 'BE', 'Berea');
INSERT INTO zones VALUES (2046, 119, 'BB', 'Butha-Buthe');
INSERT INTO zones VALUES (2047, 119, 'LE', 'Leribe');
INSERT INTO zones VALUES (2048, 119, 'MF', 'Mafeteng');
INSERT INTO zones VALUES (2049, 119, 'MS', 'Maseru');
INSERT INTO zones VALUES (2050, 119, 'MH', 'Mohale''s Hoek');
INSERT INTO zones VALUES (2051, 119, 'MK', 'Mokhotlong');
INSERT INTO zones VALUES (2052, 119, 'QN', 'Qacha''s Nek');
INSERT INTO zones VALUES (2053, 119, 'QT', 'Quthing');
INSERT INTO zones VALUES (2054, 119, 'TT', 'Thaba-Tseka');
INSERT INTO zones VALUES (2055, 120, 'BI', 'Bomi');
INSERT INTO zones VALUES (2056, 120, 'BG', 'Bong');
INSERT INTO zones VALUES (2057, 120, 'GB', 'Grand Bassa');
INSERT INTO zones VALUES (2058, 120, 'CM', 'Grand Cape Mount');
INSERT INTO zones VALUES (2059, 120, 'GG', 'Grand Gedeh');
INSERT INTO zones VALUES (2060, 120, 'GK', 'Grand Kru');
INSERT INTO zones VALUES (2061, 120, 'LO', 'Lofa');
INSERT INTO zones VALUES (2062, 120, 'MG', 'Margibi');
INSERT INTO zones VALUES (2063, 120, 'ML', 'Maryland');
INSERT INTO zones VALUES (2064, 120, 'MS', 'Montserrado');
INSERT INTO zones VALUES (2065, 120, 'NB', 'Nimba');
INSERT INTO zones VALUES (2066, 120, 'RC', 'River Cess');
INSERT INTO zones VALUES (2067, 120, 'SN', 'Sinoe');
INSERT INTO zones VALUES (2068, 121, 'AJ', 'Ajdabiya');
INSERT INTO zones VALUES (2069, 121, 'AZ', 'Al ''Aziziyah');
INSERT INTO zones VALUES (2070, 121, 'FA', 'Al Fatih');
INSERT INTO zones VALUES (2071, 121, 'JA', 'Al Jabal al Akhdar');
INSERT INTO zones VALUES (2072, 121, 'JU', 'Al Jufrah');
INSERT INTO zones VALUES (2073, 121, 'KH', 'Al Khums');
INSERT INTO zones VALUES (2074, 121, 'KU', 'Al Kufrah');
INSERT INTO zones VALUES (2075, 121, 'NK', 'An Nuqat al Khams');
INSERT INTO zones VALUES (2076, 121, 'AS', 'Ash Shati''');
INSERT INTO zones VALUES (2077, 121, 'AW', 'Awbari');
INSERT INTO zones VALUES (2078, 121, 'ZA', 'Az Zawiyah');
INSERT INTO zones VALUES (2079, 121, 'BA', 'Banghazi');
INSERT INTO zones VALUES (2080, 121, 'DA', 'Darnah');
INSERT INTO zones VALUES (2081, 121, 'GD', 'Ghadamis');
INSERT INTO zones VALUES (2082, 121, 'GY', 'Gharyan');
INSERT INTO zones VALUES (2083, 121, 'MI', 'Misratah');
INSERT INTO zones VALUES (2084, 121, 'MZ', 'Murzuq');
INSERT INTO zones VALUES (2085, 121, 'SB', 'Sabha');
INSERT INTO zones VALUES (2086, 121, 'SW', 'Sawfajjin');
INSERT INTO zones VALUES (2087, 121, 'SU', 'Surt');
INSERT INTO zones VALUES (2088, 121, 'TL', 'Tarabulus (Tripoli)');
INSERT INTO zones VALUES (2089, 121, 'TH', 'Tarhunah');
INSERT INTO zones VALUES (2090, 121, 'TU', 'Tubruq');
INSERT INTO zones VALUES (2091, 121, 'YA', 'Yafran');
INSERT INTO zones VALUES (2092, 121, 'ZL', 'Zlitan');
INSERT INTO zones VALUES (2093, 122, 'V', 'Vaduz');
INSERT INTO zones VALUES (2094, 122, 'A', 'Schaan');
INSERT INTO zones VALUES (2095, 122, 'B', 'Balzers');
INSERT INTO zones VALUES (2096, 122, 'N', 'Triesen');
INSERT INTO zones VALUES (2097, 122, 'E', 'Eschen');
INSERT INTO zones VALUES (2098, 122, 'M', 'Mauren');
INSERT INTO zones VALUES (2099, 122, 'T', 'Triesenberg');
INSERT INTO zones VALUES (2100, 122, 'R', 'Ruggell');
INSERT INTO zones VALUES (2101, 122, 'G', 'Gamprin');
INSERT INTO zones VALUES (2102, 122, 'L', 'Schellenberg');
INSERT INTO zones VALUES (2103, 122, 'P', 'Planken');
INSERT INTO zones VALUES (2104, 123, 'AL', 'Alytus');
INSERT INTO zones VALUES (2105, 123, 'KA', 'Kaunas');
INSERT INTO zones VALUES (2106, 123, 'KL', 'Klaipeda');
INSERT INTO zones VALUES (2107, 123, 'MA', 'Marijampole');
INSERT INTO zones VALUES (2108, 123, 'PA', 'Panevezys');
INSERT INTO zones VALUES (2109, 123, 'SI', 'Siauliai');
INSERT INTO zones VALUES (2110, 123, 'TA', 'Taurage');
INSERT INTO zones VALUES (2111, 123, 'TE', 'Telsiai');
INSERT INTO zones VALUES (2112, 123, 'UT', 'Utena');
INSERT INTO zones VALUES (2113, 123, 'VI', 'Vilnius');
INSERT INTO zones VALUES (2114, 124, 'DD', 'Diekirch');
INSERT INTO zones VALUES (2115, 124, 'DC', 'Clervaux');
INSERT INTO zones VALUES (2116, 124, 'DR', 'Redange');
INSERT INTO zones VALUES (2117, 124, 'DV', 'Vianden');
INSERT INTO zones VALUES (2118, 124, 'DW', 'Wiltz');
INSERT INTO zones VALUES (2119, 124, 'GG', 'Grevenmacher');
INSERT INTO zones VALUES (2120, 124, 'GE', 'Echternach');
INSERT INTO zones VALUES (2121, 124, 'GR', 'Remich');
INSERT INTO zones VALUES (2122, 124, 'LL', 'Luxembourg');
INSERT INTO zones VALUES (2123, 124, 'LC', 'Capellen');
INSERT INTO zones VALUES (2124, 124, 'LE', 'Esch-sur-Alzette');
INSERT INTO zones VALUES (2125, 124, 'LM', 'Mersch');
INSERT INTO zones VALUES (2126, 125, 'OLF', 'Our Lady Fatima Parish');
INSERT INTO zones VALUES (2127, 125, 'ANT', 'St. Anthony Parish');
INSERT INTO zones VALUES (2128, 125, 'LAZ', 'St. Lazarus Parish');
INSERT INTO zones VALUES (2129, 125, 'CAT', 'Cathedral Parish');
INSERT INTO zones VALUES (2130, 125, 'LAW', 'St. Lawrence Parish');
INSERT INTO zones VALUES (2131, 127, 'AN', 'Antananarivo');
INSERT INTO zones VALUES (2132, 127, 'AS', 'Antsiranana');
INSERT INTO zones VALUES (2133, 127, 'FN', 'Fianarantsoa');
INSERT INTO zones VALUES (2134, 127, 'MJ', 'Mahajanga');
INSERT INTO zones VALUES (2135, 127, 'TM', 'Toamasina');
INSERT INTO zones VALUES (2136, 127, 'TL', 'Toliara');
INSERT INTO zones VALUES (2137, 128, 'BLK', 'Balaka');
INSERT INTO zones VALUES (2138, 128, 'BLT', 'Blantyre');
INSERT INTO zones VALUES (2139, 128, 'CKW', 'Chikwawa');
INSERT INTO zones VALUES (2140, 128, 'CRD', 'Chiradzulu');
INSERT INTO zones VALUES (2141, 128, 'CTP', 'Chitipa');
INSERT INTO zones VALUES (2142, 128, 'DDZ', 'Dedza');
INSERT INTO zones VALUES (2143, 128, 'DWA', 'Dowa');
INSERT INTO zones VALUES (2144, 128, 'KRG', 'Karonga');
INSERT INTO zones VALUES (2145, 128, 'KSG', 'Kasungu');
INSERT INTO zones VALUES (2146, 128, 'LKM', 'Likoma');
INSERT INTO zones VALUES (2147, 128, 'LLG', 'Lilongwe');
INSERT INTO zones VALUES (2148, 128, 'MCG', 'Machinga');
INSERT INTO zones VALUES (2149, 128, 'MGC', 'Mangochi');
INSERT INTO zones VALUES (2150, 128, 'MCH', 'Mchinji');
INSERT INTO zones VALUES (2151, 128, 'MLJ', 'Mulanje');
INSERT INTO zones VALUES (2152, 128, 'MWZ', 'Mwanza');
INSERT INTO zones VALUES (2153, 128, 'MZM', 'Mzimba');
INSERT INTO zones VALUES (2154, 128, 'NTU', 'Ntcheu');
INSERT INTO zones VALUES (2155, 128, 'NKB', 'Nkhata Bay');
INSERT INTO zones VALUES (2156, 128, 'NKH', 'Nkhotakota');
INSERT INTO zones VALUES (2157, 128, 'NSJ', 'Nsanje');
INSERT INTO zones VALUES (2158, 128, 'NTI', 'Ntchisi');
INSERT INTO zones VALUES (2159, 128, 'PHL', 'Phalombe');
INSERT INTO zones VALUES (2160, 128, 'RMP', 'Rumphi');
INSERT INTO zones VALUES (2161, 128, 'SLM', 'Salima');
INSERT INTO zones VALUES (2162, 128, 'THY', 'Thyolo');
INSERT INTO zones VALUES (2163, 128, 'ZBA', 'Zomba');
INSERT INTO zones VALUES (2164, 129, 'JO', 'Johor');
INSERT INTO zones VALUES (2165, 129, 'KE', 'Kedah');
INSERT INTO zones VALUES (2166, 129, 'KL', 'Kelantan');
INSERT INTO zones VALUES (2167, 129, 'LA', 'Labuan');
INSERT INTO zones VALUES (2168, 129, 'ME', 'Melaka');
INSERT INTO zones VALUES (2169, 129, 'NS', 'Negeri Sembilan');
INSERT INTO zones VALUES (2170, 129, 'PA', 'Pahang');
INSERT INTO zones VALUES (2171, 129, 'PE', 'Perak');
INSERT INTO zones VALUES (2172, 129, 'PR', 'Perlis');
INSERT INTO zones VALUES (2173, 129, 'PP', 'Pulau Pinang');
INSERT INTO zones VALUES (2174, 129, 'SA', 'Sabah');
INSERT INTO zones VALUES (2175, 129, 'SR', 'Sarawak');
INSERT INTO zones VALUES (2176, 129, 'SE', 'Selangor');
INSERT INTO zones VALUES (2177, 129, 'TE', 'Terengganu');
INSERT INTO zones VALUES (2178, 129, 'WP', 'Wilayah Persekutuan');
INSERT INTO zones VALUES (2179, 130, 'THU', 'Thiladhunmathi Uthuru');
INSERT INTO zones VALUES (2180, 130, 'THD', 'Thiladhunmathi Dhekunu');
INSERT INTO zones VALUES (2181, 130, 'MLU', 'Miladhunmadulu Uthuru');
INSERT INTO zones VALUES (2182, 130, 'MLD', 'Miladhunmadulu Dhekunu');
INSERT INTO zones VALUES (2183, 130, 'MAU', 'Maalhosmadulu Uthuru');
INSERT INTO zones VALUES (2184, 130, 'MAD', 'Maalhosmadulu Dhekunu');
INSERT INTO zones VALUES (2185, 130, 'FAA', 'Faadhippolhu');
INSERT INTO zones VALUES (2186, 130, 'MAA', 'Male Atoll');
INSERT INTO zones VALUES (2187, 130, 'AAU', 'Ari Atoll Uthuru');
INSERT INTO zones VALUES (2188, 130, 'AAD', 'Ari Atoll Dheknu');
INSERT INTO zones VALUES (2189, 130, 'FEA', 'Felidhe Atoll');
INSERT INTO zones VALUES (2190, 130, 'MUA', 'Mulaku Atoll');
INSERT INTO zones VALUES (2191, 130, 'NAU', 'Nilandhe Atoll Uthuru');
INSERT INTO zones VALUES (2192, 130, 'NAD', 'Nilandhe Atoll Dhekunu');
INSERT INTO zones VALUES (2193, 130, 'KLH', 'Kolhumadulu');
INSERT INTO zones VALUES (2194, 130, 'HDH', 'Hadhdhunmathi');
INSERT INTO zones VALUES (2195, 130, 'HAU', 'Huvadhu Atoll Uthuru');
INSERT INTO zones VALUES (2196, 130, 'HAD', 'Huvadhu Atoll Dhekunu');
INSERT INTO zones VALUES (2197, 130, 'FMU', 'Fua Mulaku');
INSERT INTO zones VALUES (2198, 130, 'ADD', 'Addu');
INSERT INTO zones VALUES (2199, 131, 'GA', 'Gao');
INSERT INTO zones VALUES (2200, 131, 'KY', 'Kayes');
INSERT INTO zones VALUES (2201, 131, 'KD', 'Kidal');
INSERT INTO zones VALUES (2202, 131, 'KL', 'Koulikoro');
INSERT INTO zones VALUES (2203, 131, 'MP', 'Mopti');
INSERT INTO zones VALUES (2204, 131, 'SG', 'Segou');
INSERT INTO zones VALUES (2205, 131, 'SK', 'Sikasso');
INSERT INTO zones VALUES (2206, 131, 'TB', 'Tombouctou');
INSERT INTO zones VALUES (2207, 131, 'CD', 'Bamako Capital District');
INSERT INTO zones VALUES (2208, 132, 'ATT', 'Attard');
INSERT INTO zones VALUES (2209, 132, 'BAL', 'Balzan');
INSERT INTO zones VALUES (2210, 132, 'BGU', 'Birgu');
INSERT INTO zones VALUES (2211, 132, 'BKK', 'Birkirkara');
INSERT INTO zones VALUES (2212, 132, 'BRZ', 'Birzebbuga');
INSERT INTO zones VALUES (2213, 132, 'BOR', 'Bormla');
INSERT INTO zones VALUES (2214, 132, 'DIN', 'Dingli');
INSERT INTO zones VALUES (2215, 132, 'FGU', 'Fgura');
INSERT INTO zones VALUES (2216, 132, 'FLO', 'Floriana');
INSERT INTO zones VALUES (2217, 132, 'GDJ', 'Gudja');
INSERT INTO zones VALUES (2218, 132, 'GZR', 'Gzira');
INSERT INTO zones VALUES (2219, 132, 'GRG', 'Gargur');
INSERT INTO zones VALUES (2220, 132, 'GXQ', 'Gaxaq');
INSERT INTO zones VALUES (2221, 132, 'HMR', 'Hamrun');
INSERT INTO zones VALUES (2222, 132, 'IKL', 'Iklin');
INSERT INTO zones VALUES (2223, 132, 'ISL', 'Isla');
INSERT INTO zones VALUES (2224, 132, 'KLK', 'Kalkara');
INSERT INTO zones VALUES (2225, 132, 'KRK', 'Kirkop');
INSERT INTO zones VALUES (2226, 132, 'LIJ', 'Lija');
INSERT INTO zones VALUES (2227, 132, 'LUQ', 'Luqa');
INSERT INTO zones VALUES (2228, 132, 'MRS', 'Marsa');
INSERT INTO zones VALUES (2229, 132, 'MKL', 'Marsaskala');
INSERT INTO zones VALUES (2230, 132, 'MXL', 'Marsaxlokk');
INSERT INTO zones VALUES (2231, 132, 'MDN', 'Mdina');
INSERT INTO zones VALUES (2232, 132, 'MEL', 'Melliea');
INSERT INTO zones VALUES (2233, 132, 'MGR', 'Mgarr');
INSERT INTO zones VALUES (2234, 132, 'MST', 'Mosta');
INSERT INTO zones VALUES (2235, 132, 'MQA', 'Mqabba');
INSERT INTO zones VALUES (2236, 132, 'MSI', 'Msida');
INSERT INTO zones VALUES (2237, 132, 'MTF', 'Mtarfa');
INSERT INTO zones VALUES (2238, 132, 'NAX', 'Naxxar');
INSERT INTO zones VALUES (2239, 132, 'PAO', 'Paola');
INSERT INTO zones VALUES (2240, 132, 'PEM', 'Pembroke');
INSERT INTO zones VALUES (2241, 132, 'PIE', 'Pieta');
INSERT INTO zones VALUES (2242, 132, 'QOR', 'Qormi');
INSERT INTO zones VALUES (2243, 132, 'QRE', 'Qrendi');
INSERT INTO zones VALUES (2244, 132, 'RAB', 'Rabat');
INSERT INTO zones VALUES (2245, 132, 'SAF', 'Safi');
INSERT INTO zones VALUES (2246, 132, 'SGI', 'San Giljan');
INSERT INTO zones VALUES (2247, 132, 'SLU', 'Santa Lucija');
INSERT INTO zones VALUES (2248, 132, 'SPB', 'San Pawl il-Bahar');
INSERT INTO zones VALUES (2249, 132, 'SGW', 'San Gwann');
INSERT INTO zones VALUES (2250, 132, 'SVE', 'Santa Venera');
INSERT INTO zones VALUES (2251, 132, 'SIG', 'Siggiewi');
INSERT INTO zones VALUES (2252, 132, 'SLM', 'Sliema');
INSERT INTO zones VALUES (2253, 132, 'SWQ', 'Swieqi');
INSERT INTO zones VALUES (2254, 132, 'TXB', 'Ta Xbiex');
INSERT INTO zones VALUES (2255, 132, 'TRX', 'Tarxien');
INSERT INTO zones VALUES (2256, 132, 'VLT', 'Valletta');
INSERT INTO zones VALUES (2257, 132, 'XGJ', 'Xgajra');
INSERT INTO zones VALUES (2258, 132, 'ZBR', 'Zabbar');
INSERT INTO zones VALUES (2259, 132, 'ZBG', 'Zebbug');
INSERT INTO zones VALUES (2260, 132, 'ZJT', 'Zejtun');
INSERT INTO zones VALUES (2261, 132, 'ZRQ', 'Zurrieq');
INSERT INTO zones VALUES (2262, 132, 'FNT', 'Fontana');
INSERT INTO zones VALUES (2263, 132, 'GHJ', 'Ghajnsielem');
INSERT INTO zones VALUES (2264, 132, 'GHR', 'Gharb');
INSERT INTO zones VALUES (2265, 132, 'GHS', 'Ghasri');
INSERT INTO zones VALUES (2266, 132, 'KRC', 'Kercem');
INSERT INTO zones VALUES (2267, 132, 'MUN', 'Munxar');
INSERT INTO zones VALUES (2268, 132, 'NAD', 'Nadur');
INSERT INTO zones VALUES (2269, 132, 'QAL', 'Qala');
INSERT INTO zones VALUES (2270, 132, 'VIC', 'Victoria');
INSERT INTO zones VALUES (2271, 132, 'SLA', 'San Lawrenz');
INSERT INTO zones VALUES (2272, 132, 'SNT', 'Sannat');
INSERT INTO zones VALUES (2273, 132, 'ZAG', 'Xagra');
INSERT INTO zones VALUES (2274, 132, 'XEW', 'Xewkija');
INSERT INTO zones VALUES (2275, 132, 'ZEB', 'Zebbug');
INSERT INTO zones VALUES (2276, 133, 'ALG', 'Ailinginae');
INSERT INTO zones VALUES (2277, 133, 'ALL', 'Ailinglaplap');
INSERT INTO zones VALUES (2278, 133, 'ALK', 'Ailuk');
INSERT INTO zones VALUES (2279, 133, 'ARN', 'Arno');
INSERT INTO zones VALUES (2280, 133, 'AUR', 'Aur');
INSERT INTO zones VALUES (2281, 133, 'BKR', 'Bikar');
INSERT INTO zones VALUES (2282, 133, 'BKN', 'Bikini');
INSERT INTO zones VALUES (2283, 133, 'BKK', 'Bokak');
INSERT INTO zones VALUES (2284, 133, 'EBN', 'Ebon');
INSERT INTO zones VALUES (2285, 133, 'ENT', 'Enewetak');
INSERT INTO zones VALUES (2286, 133, 'EKB', 'Erikub');
INSERT INTO zones VALUES (2287, 133, 'JBT', 'Jabat');
INSERT INTO zones VALUES (2288, 133, 'JLT', 'Jaluit');
INSERT INTO zones VALUES (2289, 133, 'JEM', 'Jemo');
INSERT INTO zones VALUES (2290, 133, 'KIL', 'Kili');
INSERT INTO zones VALUES (2291, 133, 'KWJ', 'Kwajalein');
INSERT INTO zones VALUES (2292, 133, 'LAE', 'Lae');
INSERT INTO zones VALUES (2293, 133, 'LIB', 'Lib');
INSERT INTO zones VALUES (2294, 133, 'LKP', 'Likiep');
INSERT INTO zones VALUES (2295, 133, 'MJR', 'Majuro');
INSERT INTO zones VALUES (2296, 133, 'MLP', 'Maloelap');
INSERT INTO zones VALUES (2297, 133, 'MJT', 'Mejit');
INSERT INTO zones VALUES (2298, 133, 'MIL', 'Mili');
INSERT INTO zones VALUES (2299, 133, 'NMK', 'Namorik');
INSERT INTO zones VALUES (2300, 133, 'NAM', 'Namu');
INSERT INTO zones VALUES (2301, 133, 'RGL', 'Rongelap');
INSERT INTO zones VALUES (2302, 133, 'RGK', 'Rongrik');
INSERT INTO zones VALUES (2303, 133, 'TOK', 'Toke');
INSERT INTO zones VALUES (2304, 133, 'UJA', 'Ujae');
INSERT INTO zones VALUES (2305, 133, 'UJL', 'Ujelang');
INSERT INTO zones VALUES (2306, 133, 'UTK', 'Utirik');
INSERT INTO zones VALUES (2307, 133, 'WTH', 'Wotho');
INSERT INTO zones VALUES (2308, 133, 'WTJ', 'Wotje');
INSERT INTO zones VALUES (2309, 135, 'AD', 'Adrar');
INSERT INTO zones VALUES (2310, 135, 'AS', 'Assaba');
INSERT INTO zones VALUES (2311, 135, 'BR', 'Brakna');
INSERT INTO zones VALUES (2312, 135, 'DN', 'Dakhlet Nouadhibou');
INSERT INTO zones VALUES (2313, 135, 'GO', 'Gorgol');
INSERT INTO zones VALUES (2314, 135, 'GM', 'Guidimaka');
INSERT INTO zones VALUES (2315, 135, 'HC', 'Hodh Ech Chargui');
INSERT INTO zones VALUES (2316, 135, 'HG', 'Hodh El Gharbi');
INSERT INTO zones VALUES (2317, 135, 'IN', 'Inchiri');
INSERT INTO zones VALUES (2318, 135, 'TA', 'Tagant');
INSERT INTO zones VALUES (2319, 135, 'TZ', 'Tiris Zemmour');
INSERT INTO zones VALUES (2320, 135, 'TR', 'Trarza');
INSERT INTO zones VALUES (2321, 135, 'NO', 'Nouakchott');
INSERT INTO zones VALUES (2322, 136, 'BR', 'Beau Bassin-Rose Hill');
INSERT INTO zones VALUES (2323, 136, 'CU', 'Curepipe');
INSERT INTO zones VALUES (2324, 136, 'PU', 'Port Louis');
INSERT INTO zones VALUES (2325, 136, 'QB', 'Quatre Bornes');
INSERT INTO zones VALUES (2326, 136, 'VP', 'Vacoas-Phoenix');
INSERT INTO zones VALUES (2327, 136, 'AG', 'Agalega Islands');
INSERT INTO zones VALUES (2328, 136, 'CC', 'Cargados Carajos Shoals (Saint B');
INSERT INTO zones VALUES (2329, 136, 'RO', 'Rodrigues');
INSERT INTO zones VALUES (2330, 136, 'BL', 'Black River');
INSERT INTO zones VALUES (2331, 136, 'FL', 'Flacq');
INSERT INTO zones VALUES (2332, 136, 'GP', 'Grand Port');
INSERT INTO zones VALUES (2333, 136, 'MO', 'Moka');
INSERT INTO zones VALUES (2334, 136, 'PA', 'Pamplemousses');
INSERT INTO zones VALUES (2335, 136, 'PW', 'Plaines Wilhems');
INSERT INTO zones VALUES (2336, 136, 'PL', 'Port Louis');
INSERT INTO zones VALUES (2337, 136, 'RR', 'Riviere du Rempart');
INSERT INTO zones VALUES (2338, 136, 'SA', 'Savanne');
INSERT INTO zones VALUES (2339, 138, 'BN', 'Baja California Norte');
INSERT INTO zones VALUES (2340, 138, 'BS', 'Baja California Sur');
INSERT INTO zones VALUES (2341, 138, 'CA', 'Campeche');
INSERT INTO zones VALUES (2342, 138, 'CI', 'Chiapas');
INSERT INTO zones VALUES (2343, 138, 'CH', 'Chihuahua');
INSERT INTO zones VALUES (2344, 138, 'CZ', 'Coahuila de Zaragoza');
INSERT INTO zones VALUES (2345, 138, 'CL', 'Colima');
INSERT INTO zones VALUES (2346, 138, 'DF', 'Distrito Federal');
INSERT INTO zones VALUES (2347, 138, 'DU', 'Durango');
INSERT INTO zones VALUES (2348, 138, 'GA', 'Guanajuato');
INSERT INTO zones VALUES (2349, 138, 'GE', 'Guerrero');
INSERT INTO zones VALUES (2350, 138, 'HI', 'Hidalgo');
INSERT INTO zones VALUES (2351, 138, 'JA', 'Jalisco');
INSERT INTO zones VALUES (2352, 138, 'ME', 'Mexico');
INSERT INTO zones VALUES (2353, 138, 'MI', 'Michoacan de Ocampo');
INSERT INTO zones VALUES (2354, 138, 'MO', 'Morelos');
INSERT INTO zones VALUES (2355, 138, 'NA', 'Nayarit');
INSERT INTO zones VALUES (2356, 138, 'NL', 'Nuevo Leon');
INSERT INTO zones VALUES (2357, 138, 'OA', 'Oaxaca');
INSERT INTO zones VALUES (2358, 138, 'PU', 'Puebla');
INSERT INTO zones VALUES (2359, 138, 'QA', 'Queretaro de Arteaga');
INSERT INTO zones VALUES (2360, 138, 'QR', 'Quintana Roo');
INSERT INTO zones VALUES (2361, 138, 'SA', 'San Luis Potosi');
INSERT INTO zones VALUES (2362, 138, 'SI', 'Sinaloa');
INSERT INTO zones VALUES (2363, 138, 'SO', 'Sonora');
INSERT INTO zones VALUES (2364, 138, 'TB', 'Tabasco');
INSERT INTO zones VALUES (2365, 138, 'TM', 'Tamaulipas');
INSERT INTO zones VALUES (2366, 138, 'TL', 'Tlaxcala');
INSERT INTO zones VALUES (2367, 138, 'VE', 'Veracruz-Llave');
INSERT INTO zones VALUES (2368, 138, 'YU', 'Yucatan');
INSERT INTO zones VALUES (2369, 138, 'ZA', 'Zacatecas');
INSERT INTO zones VALUES (2370, 139, 'C', 'Chuuk');
INSERT INTO zones VALUES (2371, 139, 'K', 'Kosrae');
INSERT INTO zones VALUES (2372, 139, 'P', 'Pohnpei');
INSERT INTO zones VALUES (2373, 139, 'Y', 'Yap');
INSERT INTO zones VALUES (2374, 140, 'GA', 'Gagauzia');
INSERT INTO zones VALUES (2375, 140, 'CU', 'Chisinau');
INSERT INTO zones VALUES (2376, 140, 'BA', 'Balti');
INSERT INTO zones VALUES (2377, 140, 'CA', 'Cahul');
INSERT INTO zones VALUES (2378, 140, 'ED', 'Edinet');
INSERT INTO zones VALUES (2379, 140, 'LA', 'Lapusna');
INSERT INTO zones VALUES (2380, 140, 'OR', 'Orhei');
INSERT INTO zones VALUES (2381, 140, 'SO', 'Soroca');
INSERT INTO zones VALUES (2382, 140, 'TI', 'Tighina');
INSERT INTO zones VALUES (2383, 140, 'UN', 'Ungheni');
INSERT INTO zones VALUES (2384, 140, 'SN', 'St㯧a Nistrului');
INSERT INTO zones VALUES (2385, 141, 'FV', 'Fontvieille');
INSERT INTO zones VALUES (2386, 141, 'LC', 'La Condamine');
INSERT INTO zones VALUES (2387, 141, 'MV', 'Monaco-Ville');
INSERT INTO zones VALUES (2388, 141, 'MC', 'Monte-Carlo');
INSERT INTO zones VALUES (2389, 142, '1', 'Ulanbaatar');
INSERT INTO zones VALUES (2390, 142, '035', 'Orhon');
INSERT INTO zones VALUES (2391, 142, '037', 'Darhan uul');
INSERT INTO zones VALUES (2392, 142, '039', 'Hentiy');
INSERT INTO zones VALUES (2393, 142, '041', 'Hovsgol');
INSERT INTO zones VALUES (2394, 142, '043', 'Hovd');
INSERT INTO zones VALUES (2395, 142, '046', 'Uvs');
INSERT INTO zones VALUES (2396, 142, '047', 'Tov');
INSERT INTO zones VALUES (2397, 142, '049', 'Selenge');
INSERT INTO zones VALUES (2398, 142, '051', 'Suhbaatar');
INSERT INTO zones VALUES (2399, 142, '053', 'Omnogovi');
INSERT INTO zones VALUES (2400, 142, '055', 'Ovorhangay');
INSERT INTO zones VALUES (2401, 142, '057', 'Dzavhan');
INSERT INTO zones VALUES (2402, 142, '059', 'DundgovL');
INSERT INTO zones VALUES (2403, 142, '061', 'Dornod');
INSERT INTO zones VALUES (2404, 142, '063', 'Dornogov');
INSERT INTO zones VALUES (2405, 142, '064', 'Govi-Sumber');
INSERT INTO zones VALUES (2406, 142, '065', 'Govi-Altay');
INSERT INTO zones VALUES (2407, 142, '067', 'Bulgan');
INSERT INTO zones VALUES (2408, 142, '069', 'Bayanhongor');
INSERT INTO zones VALUES (2409, 142, '071', 'Bayan-Olgiy');
INSERT INTO zones VALUES (2410, 142, '073', 'Arhangay');
INSERT INTO zones VALUES (2411, 143, 'A', 'Saint Anthony');
INSERT INTO zones VALUES (2412, 143, 'G', 'Saint Georges');
INSERT INTO zones VALUES (2413, 143, 'P', 'Saint Peter');
INSERT INTO zones VALUES (2414, 144, 'AGD', 'Agadir');
INSERT INTO zones VALUES (2415, 144, 'HOC', 'Al Hoceima');
INSERT INTO zones VALUES (2416, 144, 'AZI', 'Azilal');
INSERT INTO zones VALUES (2417, 144, 'BME', 'Beni Mellal');
INSERT INTO zones VALUES (2418, 144, 'BSL', 'Ben Slimane');
INSERT INTO zones VALUES (2419, 144, 'BLM', 'Boulemane');
INSERT INTO zones VALUES (2420, 144, 'CBL', 'Casablanca');
INSERT INTO zones VALUES (2421, 144, 'CHA', 'Chaouen');
INSERT INTO zones VALUES (2422, 144, 'EJA', 'El Jadida');
INSERT INTO zones VALUES (2423, 144, 'EKS', 'El Kelaa des Sraghna');
INSERT INTO zones VALUES (2424, 144, 'ERA', 'Er Rachidia');
INSERT INTO zones VALUES (2425, 144, 'ESS', 'Essaouira');
INSERT INTO zones VALUES (2426, 144, 'FES', 'Fes');
INSERT INTO zones VALUES (2427, 144, 'FIG', 'Figuig');
INSERT INTO zones VALUES (2428, 144, 'GLM', 'Guelmim');
INSERT INTO zones VALUES (2429, 144, 'IFR', 'Ifrane');
INSERT INTO zones VALUES (2430, 144, 'KEN', 'Kenitra');
INSERT INTO zones VALUES (2431, 144, 'KHM', 'Khemisset');
INSERT INTO zones VALUES (2432, 144, 'KHN', 'Khenifra');
INSERT INTO zones VALUES (2433, 144, 'KHO', 'Khouribga');
INSERT INTO zones VALUES (2434, 144, 'LYN', 'Laayoune');
INSERT INTO zones VALUES (2435, 144, 'LAR', 'Larache');
INSERT INTO zones VALUES (2436, 144, 'MRK', 'Marrakech');
INSERT INTO zones VALUES (2437, 144, 'MKN', 'Meknes');
INSERT INTO zones VALUES (2438, 144, 'NAD', 'Nador');
INSERT INTO zones VALUES (2439, 144, 'ORZ', 'Ouarzazate');
INSERT INTO zones VALUES (2440, 144, 'OUJ', 'Oujda');
INSERT INTO zones VALUES (2441, 144, 'RSA', 'Rabat-Sale');
INSERT INTO zones VALUES (2442, 144, 'SAF', 'Safi');
INSERT INTO zones VALUES (2443, 144, 'SET', 'Settat');
INSERT INTO zones VALUES (2444, 144, 'SKA', 'Sidi Kacem');
INSERT INTO zones VALUES (2445, 144, 'TGR', 'Tangier');
INSERT INTO zones VALUES (2446, 144, 'TAN', 'Tan-Tan');
INSERT INTO zones VALUES (2447, 144, 'TAO', 'Taounate');
INSERT INTO zones VALUES (2448, 144, 'TRD', 'Taroudannt');
INSERT INTO zones VALUES (2449, 144, 'TAT', 'Tata');
INSERT INTO zones VALUES (2450, 144, 'TAZ', 'Taza');
INSERT INTO zones VALUES (2451, 144, 'TET', 'Tetouan');
INSERT INTO zones VALUES (2452, 144, 'TIZ', 'Tiznit');
INSERT INTO zones VALUES (2453, 144, 'ADK', 'Ad Dakhla');
INSERT INTO zones VALUES (2454, 144, 'BJD', 'Boujdour');
INSERT INTO zones VALUES (2455, 144, 'ESM', 'Es Smara');
INSERT INTO zones VALUES (2456, 145, 'CD', 'Cabo Delgado');
INSERT INTO zones VALUES (2457, 145, 'GZ', 'Gaza');
INSERT INTO zones VALUES (2458, 145, 'IN', 'Inhambane');
INSERT INTO zones VALUES (2459, 145, 'MN', 'Manica');
INSERT INTO zones VALUES (2460, 145, 'MC', 'Maputo (city)');
INSERT INTO zones VALUES (2461, 145, 'MP', 'Maputo');
INSERT INTO zones VALUES (2462, 145, 'NA', 'Nampula');
INSERT INTO zones VALUES (2463, 145, 'NI', 'Niassa');
INSERT INTO zones VALUES (2464, 145, 'SO', 'Sofala');
INSERT INTO zones VALUES (2465, 145, 'TE', 'Tete');
INSERT INTO zones VALUES (2466, 145, 'ZA', 'Zambezia');
INSERT INTO zones VALUES (2467, 146, 'AY', 'Ayeyarwady');
INSERT INTO zones VALUES (2468, 146, 'BG', 'Bago');
INSERT INTO zones VALUES (2469, 146, 'MG', 'Magway');
INSERT INTO zones VALUES (2470, 146, 'MD', 'Mandalay');
INSERT INTO zones VALUES (2471, 146, 'SG', 'Sagaing');
INSERT INTO zones VALUES (2472, 146, 'TN', 'Tanintharyi');
INSERT INTO zones VALUES (2473, 146, 'YG', 'Yangon');
INSERT INTO zones VALUES (2474, 146, 'CH', 'Chin State');
INSERT INTO zones VALUES (2475, 146, 'KC', 'Kachin State');
INSERT INTO zones VALUES (2476, 146, 'KH', 'Kayah State');
INSERT INTO zones VALUES (2477, 146, 'KN', 'Kayin State');
INSERT INTO zones VALUES (2478, 146, 'MN', 'Mon State');
INSERT INTO zones VALUES (2479, 146, 'RK', 'Rakhine State');
INSERT INTO zones VALUES (2480, 146, 'SH', 'Shan State');
INSERT INTO zones VALUES (2481, 147, 'CA', 'Caprivi');
INSERT INTO zones VALUES (2482, 147, 'ER', 'Erongo');
INSERT INTO zones VALUES (2483, 147, 'HA', 'Hardap');
INSERT INTO zones VALUES (2484, 147, 'KR', 'Karas');
INSERT INTO zones VALUES (2485, 147, 'KV', 'Kavango');
INSERT INTO zones VALUES (2486, 147, 'KH', 'Khomas');
INSERT INTO zones VALUES (2487, 147, 'KU', 'Kunene');
INSERT INTO zones VALUES (2488, 147, 'OW', 'Ohangwena');
INSERT INTO zones VALUES (2489, 147, 'OK', 'Omaheke');
INSERT INTO zones VALUES (2490, 147, 'OT', 'Omusati');
INSERT INTO zones VALUES (2491, 147, 'ON', 'Oshana');
INSERT INTO zones VALUES (2492, 147, 'OO', 'Oshikoto');
INSERT INTO zones VALUES (2493, 147, 'OJ', 'Otjozondjupa');
INSERT INTO zones VALUES (2494, 148, 'AO', 'Aiwo');
INSERT INTO zones VALUES (2495, 148, 'AA', 'Anabar');
INSERT INTO zones VALUES (2496, 148, 'AT', 'Anetan');
INSERT INTO zones VALUES (2497, 148, 'AI', 'Anibare');
INSERT INTO zones VALUES (2498, 148, 'BA', 'Baiti');
INSERT INTO zones VALUES (2499, 148, 'BO', 'Boe');
INSERT INTO zones VALUES (2500, 148, 'BU', 'Buada');
INSERT INTO zones VALUES (2501, 148, 'DE', 'Denigomodu');
INSERT INTO zones VALUES (2502, 148, 'EW', 'Ewa');
INSERT INTO zones VALUES (2503, 148, 'IJ', 'Ijuw');
INSERT INTO zones VALUES (2504, 148, 'ME', 'Meneng');
INSERT INTO zones VALUES (2505, 148, 'NI', 'Nibok');
INSERT INTO zones VALUES (2506, 148, 'UA', 'Uaboe');
INSERT INTO zones VALUES (2507, 148, 'YA', 'Yaren');
INSERT INTO zones VALUES (2508, 149, 'BA', 'Bagmati');
INSERT INTO zones VALUES (2509, 149, 'BH', 'Bheri');
INSERT INTO zones VALUES (2510, 149, 'DH', 'Dhawalagiri');
INSERT INTO zones VALUES (2511, 149, 'GA', 'Gandaki');
INSERT INTO zones VALUES (2512, 149, 'JA', 'Janakpur');
INSERT INTO zones VALUES (2513, 149, 'KA', 'Karnali');
INSERT INTO zones VALUES (2514, 149, 'KO', 'Kosi');
INSERT INTO zones VALUES (2515, 149, 'LU', 'Lumbini');
INSERT INTO zones VALUES (2516, 149, 'MA', 'Mahakali');
INSERT INTO zones VALUES (2517, 149, 'ME', 'Mechi');
INSERT INTO zones VALUES (2518, 149, 'NA', 'Narayani');
INSERT INTO zones VALUES (2519, 149, 'RA', 'Rapti');
INSERT INTO zones VALUES (2520, 149, 'SA', 'Sagarmatha');
INSERT INTO zones VALUES (2521, 149, 'SE', 'Seti');
INSERT INTO zones VALUES (2522, 150, 'DR', 'Drenthe');
INSERT INTO zones VALUES (2523, 150, 'FL', 'Flevoland');
INSERT INTO zones VALUES (2524, 150, 'FR', 'Friesland');
INSERT INTO zones VALUES (2525, 150, 'GE', 'Gelderland');
INSERT INTO zones VALUES (2526, 150, 'GR', 'Groningen');
INSERT INTO zones VALUES (2527, 150, 'LI', 'Limburg');
INSERT INTO zones VALUES (2528, 150, 'NB', 'Noord Brabant');
INSERT INTO zones VALUES (2529, 150, 'NH', 'Noord Holland');
INSERT INTO zones VALUES (2530, 150, 'OV', 'Overijssel');
INSERT INTO zones VALUES (2531, 150, 'UT', 'Utrecht');
INSERT INTO zones VALUES (2532, 150, 'ZE', 'Zeeland');
INSERT INTO zones VALUES (2533, 150, 'ZH', 'Zuid Holland');
INSERT INTO zones VALUES (2534, 152, 'L', 'Iles Loyaute');
INSERT INTO zones VALUES (2535, 152, 'N', 'Nord');
INSERT INTO zones VALUES (2536, 152, 'S', 'Sud');
INSERT INTO zones VALUES (2537, 153, 'AUK', 'Auckland');
INSERT INTO zones VALUES (2538, 153, 'BOP', 'Bay of Plenty');
INSERT INTO zones VALUES (2539, 153, 'CAN', 'Canterbury');
INSERT INTO zones VALUES (2540, 153, 'COR', 'Coromandel');
INSERT INTO zones VALUES (2541, 153, 'GIS', 'Gisborne');
INSERT INTO zones VALUES (2542, 153, 'FIO', 'Fiordland');
INSERT INTO zones VALUES (2543, 153, 'HKB', 'Hawke''s Bay');
INSERT INTO zones VALUES (2544, 153, 'MBH', 'Marlborough');
INSERT INTO zones VALUES (2545, 153, 'MWT', 'Manawatu-Wanganui');
INSERT INTO zones VALUES (2546, 153, 'MCM', 'Mt Cook-Mackenzie');
INSERT INTO zones VALUES (2547, 153, 'NSN', 'Nelson');
INSERT INTO zones VALUES (2548, 153, 'NTL', 'Northland');
INSERT INTO zones VALUES (2549, 153, 'OTA', 'Otago');
INSERT INTO zones VALUES (2550, 153, 'STL', 'Southland');
INSERT INTO zones VALUES (2551, 153, 'TKI', 'Taranaki');
INSERT INTO zones VALUES (2552, 153, 'WGN', 'Wellington');
INSERT INTO zones VALUES (2553, 153, 'WKO', 'Waikato');
INSERT INTO zones VALUES (2554, 153, 'WAI', 'Wairprarapa');
INSERT INTO zones VALUES (2555, 153, 'WTC', 'West Coast');
INSERT INTO zones VALUES (2556, 154, 'AN', 'Atlantico Norte');
INSERT INTO zones VALUES (2557, 154, 'AS', 'Atlantico Sur');
INSERT INTO zones VALUES (2558, 154, 'BO', 'Boaco');
INSERT INTO zones VALUES (2559, 154, 'CA', 'Carazo');
INSERT INTO zones VALUES (2560, 154, 'CI', 'Chinandega');
INSERT INTO zones VALUES (2561, 154, 'CO', 'Chontales');
INSERT INTO zones VALUES (2562, 154, 'ES', 'Esteli');
INSERT INTO zones VALUES (2563, 154, 'GR', 'Granada');
INSERT INTO zones VALUES (2564, 154, 'JI', 'Jinotega');
INSERT INTO zones VALUES (2565, 154, 'LE', 'Leon');
INSERT INTO zones VALUES (2566, 154, 'MD', 'Madriz');
INSERT INTO zones VALUES (2567, 154, 'MN', 'Managua');
INSERT INTO zones VALUES (2568, 154, 'MS', 'Masaya');
INSERT INTO zones VALUES (2569, 154, 'MT', 'Matagalpa');
INSERT INTO zones VALUES (2570, 154, 'NS', 'Nuevo Segovia');
INSERT INTO zones VALUES (2571, 154, 'RS', 'Rio San Juan');
INSERT INTO zones VALUES (2572, 154, 'RI', 'Rivas');
INSERT INTO zones VALUES (2573, 155, 'AG', 'Agadez');
INSERT INTO zones VALUES (2574, 155, 'DF', 'Diffa');
INSERT INTO zones VALUES (2575, 155, 'DS', 'Dosso');
INSERT INTO zones VALUES (2576, 155, 'MA', 'Maradi');
INSERT INTO zones VALUES (2577, 155, 'NM', 'Niamey');
INSERT INTO zones VALUES (2578, 155, 'TH', 'Tahoua');
INSERT INTO zones VALUES (2579, 155, 'TL', 'Tillaberi');
INSERT INTO zones VALUES (2580, 155, 'ZD', 'Zinder');
INSERT INTO zones VALUES (2581, 156, 'AB', 'Abia');
INSERT INTO zones VALUES (2582, 156, 'CT', 'Abuja Federal Capital Territory');
INSERT INTO zones VALUES (2583, 156, 'AD', 'Adamawa');
INSERT INTO zones VALUES (2584, 156, 'AK', 'Akwa Ibom');
INSERT INTO zones VALUES (2585, 156, 'AN', 'Anambra');
INSERT INTO zones VALUES (2586, 156, 'BC', 'Bauchi');
INSERT INTO zones VALUES (2587, 156, 'BY', 'Bayelsa');
INSERT INTO zones VALUES (2588, 156, 'BN', 'Benue');
INSERT INTO zones VALUES (2589, 156, 'BO', 'Borno');
INSERT INTO zones VALUES (2590, 156, 'CR', 'Cross River');
INSERT INTO zones VALUES (2591, 156, 'DE', 'Delta');
INSERT INTO zones VALUES (2592, 156, 'EB', 'Ebonyi');
INSERT INTO zones VALUES (2593, 156, 'ED', 'Edo');
INSERT INTO zones VALUES (2594, 156, 'EK', 'Ekiti');
INSERT INTO zones VALUES (2595, 156, 'EN', 'Enugu');
INSERT INTO zones VALUES (2596, 156, 'GO', 'Gombe');
INSERT INTO zones VALUES (2597, 156, 'IM', 'Imo');
INSERT INTO zones VALUES (2598, 156, 'JI', 'Jigawa');
INSERT INTO zones VALUES (2599, 156, 'KD', 'Kaduna');
INSERT INTO zones VALUES (2600, 156, 'KN', 'Kano');
INSERT INTO zones VALUES (2601, 156, 'KT', 'Katsina');
INSERT INTO zones VALUES (2602, 156, 'KE', 'Kebbi');
INSERT INTO zones VALUES (2603, 156, 'KO', 'Kogi');
INSERT INTO zones VALUES (2604, 156, 'KW', 'Kwara');
INSERT INTO zones VALUES (2605, 156, 'LA', 'Lagos');
INSERT INTO zones VALUES (2606, 156, 'NA', 'Nassarawa');
INSERT INTO zones VALUES (2607, 156, 'NI', 'Niger');
INSERT INTO zones VALUES (2608, 156, 'OG', 'Ogun');
INSERT INTO zones VALUES (2609, 156, 'ONG', 'Ondo');
INSERT INTO zones VALUES (2610, 156, 'OS', 'Osun');
INSERT INTO zones VALUES (2611, 156, 'OY', 'Oyo');
INSERT INTO zones VALUES (2612, 156, 'PL', 'Plateau');
INSERT INTO zones VALUES (2613, 156, 'RI', 'Rivers');
INSERT INTO zones VALUES (2614, 156, 'SO', 'Sokoto');
INSERT INTO zones VALUES (2615, 156, 'TA', 'Taraba');
INSERT INTO zones VALUES (2616, 156, 'YO', 'Yobe');
INSERT INTO zones VALUES (2617, 156, 'ZA', 'Zamfara');
INSERT INTO zones VALUES (2618, 159, 'N', 'Northern Islands');
INSERT INTO zones VALUES (2619, 159, 'R', 'Rota');
INSERT INTO zones VALUES (2620, 159, 'S', 'Saipan');
INSERT INTO zones VALUES (2621, 159, 'T', 'Tinian');
INSERT INTO zones VALUES (2622, 160, 'AK', 'Akershus');
INSERT INTO zones VALUES (2623, 160, 'AA', 'Aust-Agder');
INSERT INTO zones VALUES (2624, 160, 'BU', 'Buskerud');
INSERT INTO zones VALUES (2625, 160, 'FM', 'Finnmark');
INSERT INTO zones VALUES (2626, 160, 'HM', 'Hedmark');
INSERT INTO zones VALUES (2627, 160, 'HL', 'Hordaland');
INSERT INTO zones VALUES (2628, 160, 'MR', 'More og Romdal');
INSERT INTO zones VALUES (2629, 160, 'NT', 'Nord-Trondelag');
INSERT INTO zones VALUES (2630, 160, 'NL', 'Nordland');
INSERT INTO zones VALUES (2631, 160, 'OF', 'Ostfold');
INSERT INTO zones VALUES (2632, 160, 'OP', 'Oppland');
INSERT INTO zones VALUES (2633, 160, 'OL', 'Oslo');
INSERT INTO zones VALUES (2634, 160, 'RL', 'Rogaland');
INSERT INTO zones VALUES (2635, 160, 'ST', 'Sor-Trondelag');
INSERT INTO zones VALUES (2636, 160, 'SJ', 'Sogn og Fjordane');
INSERT INTO zones VALUES (2637, 160, 'SV', 'Svalbard');
INSERT INTO zones VALUES (2638, 160, 'TM', 'Telemark');
INSERT INTO zones VALUES (2639, 160, 'TR', 'Troms');
INSERT INTO zones VALUES (2640, 160, 'VA', 'Vest-Agder');
INSERT INTO zones VALUES (2641, 160, 'VF', 'Vestfold');
INSERT INTO zones VALUES (2642, 161, 'DA', 'Ad Dakhiliyah');
INSERT INTO zones VALUES (2643, 161, 'BA', 'Al Batinah');
INSERT INTO zones VALUES (2644, 161, 'WU', 'Al Wusta');
INSERT INTO zones VALUES (2645, 161, 'SH', 'Ash Sharqiyah');
INSERT INTO zones VALUES (2646, 161, 'ZA', 'Az Zahirah');
INSERT INTO zones VALUES (2647, 161, 'MA', 'Masqat');
INSERT INTO zones VALUES (2648, 161, 'MU', 'Musandam');
INSERT INTO zones VALUES (2649, 161, 'ZU', 'Zufar');
INSERT INTO zones VALUES (2650, 162, 'B', 'Balochistan');
INSERT INTO zones VALUES (2651, 162, 'T', 'Federally Administered Tribal Ar');
INSERT INTO zones VALUES (2652, 162, 'I', 'Islamabad Capital Territory');
INSERT INTO zones VALUES (2653, 162, 'N', 'North-West Frontier');
INSERT INTO zones VALUES (2654, 162, 'P', 'Punjab');
INSERT INTO zones VALUES (2655, 162, 'S', 'Sindh ');
INSERT INTO zones VALUES (2656, 163, 'AM', 'Aimeliik');
INSERT INTO zones VALUES (2657, 163, 'AR', 'Airai');
INSERT INTO zones VALUES (2658, 163, 'AN', 'Angaur');
INSERT INTO zones VALUES (2659, 163, 'HA', 'Hatohobei');
INSERT INTO zones VALUES (2660, 163, 'KA', 'Kayangel');
INSERT INTO zones VALUES (2661, 163, 'KO', 'Koror');
INSERT INTO zones VALUES (2662, 163, 'ME', 'Melekeok');
INSERT INTO zones VALUES (2663, 163, 'NA', 'Ngaraard');
INSERT INTO zones VALUES (2664, 163, 'NG', 'Ngarchelong');
INSERT INTO zones VALUES (2665, 163, 'ND', 'Ngardmau');
INSERT INTO zones VALUES (2666, 163, 'NT', 'Ngatpang');
INSERT INTO zones VALUES (2667, 163, 'NC', 'Ngchesar');
INSERT INTO zones VALUES (2668, 163, 'NR', 'Ngeremlengui');
INSERT INTO zones VALUES (2669, 163, 'NW', 'Ngiwal');
INSERT INTO zones VALUES (2670, 163, 'PE', 'Peleliu');
INSERT INTO zones VALUES (2671, 163, 'SO', 'Sonsorol');
INSERT INTO zones VALUES (2672, 164, 'BT', 'Bocas del Toro');
INSERT INTO zones VALUES (2673, 164, 'CH', 'Chiriqui');
INSERT INTO zones VALUES (2674, 164, 'CC', 'Cocle');
INSERT INTO zones VALUES (2675, 164, 'CL', 'Colon');
INSERT INTO zones VALUES (2676, 164, 'DA', 'Darien');
INSERT INTO zones VALUES (2677, 164, 'HE', 'Herrera');
INSERT INTO zones VALUES (2678, 164, 'LS', 'Los Santos');
INSERT INTO zones VALUES (2679, 164, 'PA', 'Panama');
INSERT INTO zones VALUES (2680, 164, 'SB', 'San Blas');
INSERT INTO zones VALUES (2681, 164, 'VG', 'Veraguas');
INSERT INTO zones VALUES (2682, 165, 'BV', 'Bougainville');
INSERT INTO zones VALUES (2683, 165, 'CE', 'Central');
INSERT INTO zones VALUES (2684, 165, 'CH', 'Chimbu');
INSERT INTO zones VALUES (2685, 165, 'EH', 'Eastern Highlands');
INSERT INTO zones VALUES (2686, 165, 'EB', 'East New Britain');
INSERT INTO zones VALUES (2687, 165, 'ES', 'East Sepik');
INSERT INTO zones VALUES (2688, 165, 'EN', 'Enga');
INSERT INTO zones VALUES (2689, 165, 'GU', 'Gulf');
INSERT INTO zones VALUES (2690, 165, 'MD', 'Madang');
INSERT INTO zones VALUES (2691, 165, 'MN', 'Manus');
INSERT INTO zones VALUES (2692, 165, 'MB', 'Milne Bay');
INSERT INTO zones VALUES (2693, 165, 'MR', 'Morobe');
INSERT INTO zones VALUES (2694, 165, 'NC', 'National Capital');
INSERT INTO zones VALUES (2695, 165, 'NI', 'New Ireland');
INSERT INTO zones VALUES (2696, 165, 'NO', 'Northern');
INSERT INTO zones VALUES (2697, 165, 'SA', 'Sandaun');
INSERT INTO zones VALUES (2698, 165, 'SH', 'Southern Highlands');
INSERT INTO zones VALUES (2699, 165, 'WE', 'Western');
INSERT INTO zones VALUES (2700, 165, 'WH', 'Western Highlands');
INSERT INTO zones VALUES (2701, 165, 'WB', 'West New Britain');
INSERT INTO zones VALUES (2702, 166, 'AG', 'Alto Paraguay');
INSERT INTO zones VALUES (2703, 166, 'AN', 'Alto Parana');
INSERT INTO zones VALUES (2704, 166, 'AM', 'Amambay');
INSERT INTO zones VALUES (2705, 166, 'AS', 'Asuncion');
INSERT INTO zones VALUES (2706, 166, 'BO', 'Boqueron');
INSERT INTO zones VALUES (2707, 166, 'CG', 'Caaguazu');
INSERT INTO zones VALUES (2708, 166, 'CZ', 'Caazapa');
INSERT INTO zones VALUES (2709, 166, 'CN', 'Canindeyu');
INSERT INTO zones VALUES (2710, 166, 'CE', 'Central');
INSERT INTO zones VALUES (2711, 166, 'CC', 'Concepcion');
INSERT INTO zones VALUES (2712, 166, 'CD', 'Cordillera');
INSERT INTO zones VALUES (2713, 166, 'GU', 'Guaira');
INSERT INTO zones VALUES (2714, 166, 'IT', 'Itapua');
INSERT INTO zones VALUES (2715, 166, 'MI', 'Misiones');
INSERT INTO zones VALUES (2716, 166, 'NE', 'Neembucu');
INSERT INTO zones VALUES (2717, 166, 'PA', 'Paraguari');
INSERT INTO zones VALUES (2718, 166, 'PH', 'Presidente Hayes');
INSERT INTO zones VALUES (2719, 166, 'SP', 'San Pedro');
INSERT INTO zones VALUES (2720, 167, 'AM', 'Amazonas');
INSERT INTO zones VALUES (2721, 167, 'AN', 'Ancash');
INSERT INTO zones VALUES (2722, 167, 'AP', 'Apurimac');
INSERT INTO zones VALUES (2723, 167, 'AR', 'Arequipa');
INSERT INTO zones VALUES (2724, 167, 'AY', 'Ayacucho');
INSERT INTO zones VALUES (2725, 167, 'CJ', 'Cajamarca');
INSERT INTO zones VALUES (2726, 167, 'CL', 'Callao');
INSERT INTO zones VALUES (2727, 167, 'CU', 'Cusco');
INSERT INTO zones VALUES (2728, 167, 'HV', 'Huancavelica');
INSERT INTO zones VALUES (2729, 167, 'HO', 'Huanuco');
INSERT INTO zones VALUES (2730, 167, 'IC', 'Ica');
INSERT INTO zones VALUES (2731, 167, 'JU', 'Junin');
INSERT INTO zones VALUES (2732, 167, 'LD', 'La Libertad');
INSERT INTO zones VALUES (2733, 167, 'LY', 'Lambayeque');
INSERT INTO zones VALUES (2734, 167, 'LI', 'Lima');
INSERT INTO zones VALUES (2735, 167, 'LO', 'Loreto');
INSERT INTO zones VALUES (2736, 167, 'MD', 'Madre de Dios');
INSERT INTO zones VALUES (2737, 167, 'MO', 'Moquegua');
INSERT INTO zones VALUES (2738, 167, 'PA', 'Pasco');
INSERT INTO zones VALUES (2739, 167, 'PI', 'Piura');
INSERT INTO zones VALUES (2740, 167, 'PU', 'Puno');
INSERT INTO zones VALUES (2741, 167, 'SM', 'San Martin');
INSERT INTO zones VALUES (2742, 167, 'TA', 'Tacna');
INSERT INTO zones VALUES (2743, 167, 'TU', 'Tumbes');
INSERT INTO zones VALUES (2744, 167, 'UC', 'Ucayali');
INSERT INTO zones VALUES (2745, 168, 'ABR', 'Abra');
INSERT INTO zones VALUES (2746, 168, 'ANO', 'Agusan del Norte');
INSERT INTO zones VALUES (2747, 168, 'ASU', 'Agusan del Sur');
INSERT INTO zones VALUES (2748, 168, 'AKL', 'Aklan');
INSERT INTO zones VALUES (2749, 168, 'ALB', 'Albay');
INSERT INTO zones VALUES (2750, 168, 'ANT', 'Antique');
INSERT INTO zones VALUES (2751, 168, 'APY', 'Apayao');
INSERT INTO zones VALUES (2752, 168, 'AUR', 'Aurora');
INSERT INTO zones VALUES (2753, 168, 'BAS', 'Basilan');
INSERT INTO zones VALUES (2754, 168, 'BTA', 'Bataan');
INSERT INTO zones VALUES (2755, 168, 'BTE', 'Batanes');
INSERT INTO zones VALUES (2756, 168, 'BTG', 'Batangas');
INSERT INTO zones VALUES (2757, 168, 'BLR', 'Biliran');
INSERT INTO zones VALUES (2758, 168, 'BEN', 'Benguet');
INSERT INTO zones VALUES (2759, 168, 'BOL', 'Bohol');
INSERT INTO zones VALUES (2760, 168, 'BUK', 'Bukidnon');
INSERT INTO zones VALUES (2761, 168, 'BUL', 'Bulacan');
INSERT INTO zones VALUES (2762, 168, 'CAG', 'Cagayan');
INSERT INTO zones VALUES (2763, 168, 'CNO', 'Camarines Norte');
INSERT INTO zones VALUES (2764, 168, 'CSU', 'Camarines Sur');
INSERT INTO zones VALUES (2765, 168, 'CAM', 'Camiguin');
INSERT INTO zones VALUES (2766, 168, 'CAP', 'Capiz');
INSERT INTO zones VALUES (2767, 168, 'CAT', 'Catanduanes');
INSERT INTO zones VALUES (2768, 168, 'CAV', 'Cavite');
INSERT INTO zones VALUES (2769, 168, 'CEB', 'Cebu');
INSERT INTO zones VALUES (2770, 168, 'CMP', 'Compostela');
INSERT INTO zones VALUES (2771, 168, 'DNO', 'Davao del Norte');
INSERT INTO zones VALUES (2772, 168, 'DSU', 'Davao del Sur');
INSERT INTO zones VALUES (2773, 168, 'DOR', 'Davao Oriental');
INSERT INTO zones VALUES (2774, 168, 'ESA', 'Eastern Samar');
INSERT INTO zones VALUES (2775, 168, 'GUI', 'Guimaras');
INSERT INTO zones VALUES (2776, 168, 'IFU', 'Ifugao');
INSERT INTO zones VALUES (2777, 168, 'INO', 'Ilocos Norte');
INSERT INTO zones VALUES (2778, 168, 'ISU', 'Ilocos Sur');
INSERT INTO zones VALUES (2779, 168, 'ILO', 'Iloilo');
INSERT INTO zones VALUES (2780, 168, 'ISA', 'Isabela');
INSERT INTO zones VALUES (2781, 168, 'KAL', 'Kalinga');
INSERT INTO zones VALUES (2782, 168, 'LAG', 'Laguna');
INSERT INTO zones VALUES (2783, 168, 'LNO', 'Lanao del Norte');
INSERT INTO zones VALUES (2784, 168, 'LSU', 'Lanao del Sur');
INSERT INTO zones VALUES (2785, 168, 'UNI', 'La Union');
INSERT INTO zones VALUES (2786, 168, 'LEY', 'Leyte');
INSERT INTO zones VALUES (2787, 168, 'MAG', 'Maguindanao');
INSERT INTO zones VALUES (2788, 168, 'MRN', 'Marinduque');
INSERT INTO zones VALUES (2789, 168, 'MSB', 'Masbate');
INSERT INTO zones VALUES (2790, 168, 'MIC', 'Mindoro Occidental');
INSERT INTO zones VALUES (2791, 168, 'MIR', 'Mindoro Oriental');
INSERT INTO zones VALUES (2792, 168, 'MSC', 'Misamis Occidental');
INSERT INTO zones VALUES (2793, 168, 'MOR', 'Misamis Oriental');
INSERT INTO zones VALUES (2794, 168, 'MOP', 'Mountain');
INSERT INTO zones VALUES (2795, 168, 'NOC', 'Negros Occidental');
INSERT INTO zones VALUES (2796, 168, 'NOR', 'Negros Oriental');
INSERT INTO zones VALUES (2797, 168, 'NCT', 'North Cotabato');
INSERT INTO zones VALUES (2798, 168, 'NSM', 'Northern Samar');
INSERT INTO zones VALUES (2799, 168, 'NEC', 'Nueva Ecija');
INSERT INTO zones VALUES (2800, 168, 'NVZ', 'Nueva Vizcaya');
INSERT INTO zones VALUES (2801, 168, 'PLW', 'Palawan');
INSERT INTO zones VALUES (2802, 168, 'PMP', 'Pampanga');
INSERT INTO zones VALUES (2803, 168, 'PNG', 'Pangasinan');
INSERT INTO zones VALUES (2804, 168, 'QZN', 'Quezon');
INSERT INTO zones VALUES (2805, 168, 'QRN', 'Quirino');
INSERT INTO zones VALUES (2806, 168, 'RIZ', 'Rizal');
INSERT INTO zones VALUES (2807, 168, 'ROM', 'Romblon');
INSERT INTO zones VALUES (2808, 168, 'SMR', 'Samar');
INSERT INTO zones VALUES (2809, 168, 'SRG', 'Sarangani');
INSERT INTO zones VALUES (2810, 168, 'SQJ', 'Siquijor');
INSERT INTO zones VALUES (2811, 168, 'SRS', 'Sorsogon');
INSERT INTO zones VALUES (2812, 168, 'SCO', 'South Cotabato');
INSERT INTO zones VALUES (2813, 168, 'SLE', 'Southern Leyte');
INSERT INTO zones VALUES (2814, 168, 'SKU', 'Sultan Kudarat');
INSERT INTO zones VALUES (2815, 168, 'SLU', 'Sulu');
INSERT INTO zones VALUES (2816, 168, 'SNO', 'Surigao del Norte');
INSERT INTO zones VALUES (2817, 168, 'SSU', 'Surigao del Sur');
INSERT INTO zones VALUES (2818, 168, 'TAR', 'Tarlac');
INSERT INTO zones VALUES (2819, 168, 'TAW', 'Tawi-Tawi');
INSERT INTO zones VALUES (2820, 168, 'ZBL', 'Zambales');
INSERT INTO zones VALUES (2821, 168, 'ZNO', 'Zamboanga del Norte');
INSERT INTO zones VALUES (2822, 168, 'ZSU', 'Zamboanga del Sur');
INSERT INTO zones VALUES (2823, 168, 'ZSI', 'Zamboanga Sibugay');
INSERT INTO zones VALUES (2824, 170, 'DO', 'Dolnoslaskie');
INSERT INTO zones VALUES (2825, 170, 'KP', 'Kujawsko-Pomorskie');
INSERT INTO zones VALUES (2826, 170, 'LO', 'Lodzkie');
INSERT INTO zones VALUES (2827, 170, 'LL', 'Lubelskie');
INSERT INTO zones VALUES (2828, 170, 'LU', 'Lubuskie');
INSERT INTO zones VALUES (2829, 170, 'ML', 'Malopolskie');
INSERT INTO zones VALUES (2830, 170, 'MZ', 'Mazowieckie');
INSERT INTO zones VALUES (2831, 170, 'OP', 'Opolskie');
INSERT INTO zones VALUES (2832, 170, 'PP', 'Podkarpackie');
INSERT INTO zones VALUES (2833, 170, 'PL', 'Podlaskie');
INSERT INTO zones VALUES (2834, 170, 'PM', 'Pomorskie');
INSERT INTO zones VALUES (2835, 170, 'SL', 'Slaskie');
INSERT INTO zones VALUES (2836, 170, 'SW', 'Swietokrzyskie');
INSERT INTO zones VALUES (2837, 170, 'WM', 'Warminsko-Mazurskie');
INSERT INTO zones VALUES (2838, 170, 'WP', 'Wielkopolskie');
INSERT INTO zones VALUES (2839, 170, 'ZA', 'Zachodniopomorskie');
INSERT INTO zones VALUES (2840, 198, 'P', 'Saint Pierre');
INSERT INTO zones VALUES (2841, 198, 'M', 'Miquelon');
INSERT INTO zones VALUES (2842, 171, 'AC', 'A&ccedil;ores');
INSERT INTO zones VALUES (2843, 171, 'AV', 'Aveiro');
INSERT INTO zones VALUES (2844, 171, 'BE', 'Beja');
INSERT INTO zones VALUES (2845, 171, 'BR', 'Braga');
INSERT INTO zones VALUES (2846, 171, 'BA', 'Bragan&ccedil;a');
INSERT INTO zones VALUES (2847, 171, 'CB', 'Castelo Branco');
INSERT INTO zones VALUES (2848, 171, 'CO', 'Coimbra');
INSERT INTO zones VALUES (2849, 171, 'EV', '&Eacute;vora');
INSERT INTO zones VALUES (2850, 171, 'FA', 'Faro');
INSERT INTO zones VALUES (2851, 171, 'GU', 'Guarda');
INSERT INTO zones VALUES (2852, 171, 'LE', 'Leiria');
INSERT INTO zones VALUES (2853, 171, 'LI', 'Lisboa');
INSERT INTO zones VALUES (2854, 171, 'ME', 'Madeira');
INSERT INTO zones VALUES (2855, 171, 'PO', 'Portalegre');
INSERT INTO zones VALUES (2856, 171, 'PR', 'Porto');
INSERT INTO zones VALUES (2857, 171, 'SA', 'Santar&eacute;m');
INSERT INTO zones VALUES (2858, 171, 'SE', 'Set&uacute;bal');
INSERT INTO zones VALUES (2859, 171, 'VC', 'Viana do Castelo');
INSERT INTO zones VALUES (2860, 171, 'VR', 'Vila Real');
INSERT INTO zones VALUES (2861, 171, 'VI', 'Viseu');
INSERT INTO zones VALUES (2862, 173, 'DW', 'Ad Dawhah');
INSERT INTO zones VALUES (2863, 173, 'GW', 'Al Ghuwayriyah');
INSERT INTO zones VALUES (2864, 173, 'JM', 'Al Jumayliyah');
INSERT INTO zones VALUES (2865, 173, 'KR', 'Al Khawr');
INSERT INTO zones VALUES (2866, 173, 'WK', 'Al Wakrah');
INSERT INTO zones VALUES (2867, 173, 'RN', 'Ar Rayyan');
INSERT INTO zones VALUES (2868, 173, 'JB', 'Jarayan al Batinah');
INSERT INTO zones VALUES (2869, 173, 'MS', 'Madinat ash Shamal');
INSERT INTO zones VALUES (2870, 173, 'UD', 'Umm Sa''id');
INSERT INTO zones VALUES (2871, 173, 'UL', 'Umm Salal');
INSERT INTO zones VALUES (2872, 175, 'AB', 'Alba');
INSERT INTO zones VALUES (2873, 175, 'AR', 'Arad');
INSERT INTO zones VALUES (2874, 175, 'AG', 'Arges');
INSERT INTO zones VALUES (2875, 175, 'BC', 'Bacau');
INSERT INTO zones VALUES (2876, 175, 'BH', 'Bihor');
INSERT INTO zones VALUES (2877, 175, 'BN', 'Bistrita-Nasaud');
INSERT INTO zones VALUES (2878, 175, 'BT', 'Botosani');
INSERT INTO zones VALUES (2879, 175, 'BV', 'Brasov');
INSERT INTO zones VALUES (2880, 175, 'BR', 'Braila');
INSERT INTO zones VALUES (2881, 175, 'B', 'Bucuresti');
INSERT INTO zones VALUES (2882, 175, 'BZ', 'Buzau');
INSERT INTO zones VALUES (2883, 175, 'CS', 'Caras-Severin');
INSERT INTO zones VALUES (2884, 175, 'CL', 'Calarasi');
INSERT INTO zones VALUES (2885, 175, 'CJ', 'Cluj');
INSERT INTO zones VALUES (2886, 175, 'CT', 'Constanta');
INSERT INTO zones VALUES (2887, 175, 'CV', 'Covasna');
INSERT INTO zones VALUES (2888, 175, 'DB', 'Dimbovita');
INSERT INTO zones VALUES (2889, 175, 'DJ', 'Dolj');
INSERT INTO zones VALUES (2890, 175, 'GL', 'Galati');
INSERT INTO zones VALUES (2891, 175, 'GR', 'Giurgiu');
INSERT INTO zones VALUES (2892, 175, 'GJ', 'Gorj');
INSERT INTO zones VALUES (2893, 175, 'HR', 'Harghita');
INSERT INTO zones VALUES (2894, 175, 'HD', 'Hunedoara');
INSERT INTO zones VALUES (2895, 175, 'IL', 'Ialomita');
INSERT INTO zones VALUES (2896, 175, 'IS', 'Iasi');
INSERT INTO zones VALUES (2897, 175, 'IF', 'Ilfov');
INSERT INTO zones VALUES (2898, 175, 'MM', 'Maramures');
INSERT INTO zones VALUES (2899, 175, 'MH', 'Mehedinti');
INSERT INTO zones VALUES (2900, 175, 'MS', 'Mures');
INSERT INTO zones VALUES (2901, 175, 'NT', 'Neamt');
INSERT INTO zones VALUES (2902, 175, 'OT', 'Olt');
INSERT INTO zones VALUES (2903, 175, 'PH', 'Prahova');
INSERT INTO zones VALUES (2904, 175, 'SM', 'Satu-Mare');
INSERT INTO zones VALUES (2905, 175, 'SJ', 'Salaj');
INSERT INTO zones VALUES (2906, 175, 'SB', 'Sibiu');
INSERT INTO zones VALUES (2907, 175, 'SV', 'Suceava');
INSERT INTO zones VALUES (2908, 175, 'TR', 'Teleorman');
INSERT INTO zones VALUES (2909, 175, 'TM', 'Timis');
INSERT INTO zones VALUES (2910, 175, 'TL', 'Tulcea');
INSERT INTO zones VALUES (2911, 175, 'VS', 'Vaslui');
INSERT INTO zones VALUES (2912, 175, 'VL', 'Valcea');
INSERT INTO zones VALUES (2913, 175, 'VN', 'Vrancea');
INSERT INTO zones VALUES (2914, 176, 'AB', 'Abakan');
INSERT INTO zones VALUES (2915, 176, 'AG', 'Aginskoye');
INSERT INTO zones VALUES (2916, 176, 'AN', 'Anadyr');
INSERT INTO zones VALUES (2917, 176, 'AR', 'Arkahangelsk');
INSERT INTO zones VALUES (2918, 176, 'AS', 'Astrakhan');
INSERT INTO zones VALUES (2919, 176, 'BA', 'Barnaul');
INSERT INTO zones VALUES (2920, 176, 'BE', 'Belgorod');
INSERT INTO zones VALUES (2921, 176, 'BI', 'Birobidzhan');
INSERT INTO zones VALUES (2922, 176, 'BL', 'Blagoveshchensk');
INSERT INTO zones VALUES (2923, 176, 'BR', 'Bryansk');
INSERT INTO zones VALUES (2924, 176, 'CH', 'Cheboksary');
INSERT INTO zones VALUES (2925, 176, 'CL', 'Chelyabinsk');
INSERT INTO zones VALUES (2926, 176, 'CR', 'Cherkessk');
INSERT INTO zones VALUES (2927, 176, 'CI', 'Chita');
INSERT INTO zones VALUES (2928, 176, 'DU', 'Dudinka');
INSERT INTO zones VALUES (2929, 176, 'EL', 'Elista');
INSERT INTO zones VALUES (2930, 176, 'GO', 'Gomo-Altaysk');
INSERT INTO zones VALUES (2931, 176, 'GA', 'Gorno-Altaysk');
INSERT INTO zones VALUES (2932, 176, 'GR', 'Groznyy');
INSERT INTO zones VALUES (2933, 176, 'IR', 'Irkutsk');
INSERT INTO zones VALUES (2934, 176, 'IV', 'Ivanovo');
INSERT INTO zones VALUES (2935, 176, 'IZ', 'Izhevsk');
INSERT INTO zones VALUES (2936, 176, 'KA', 'Kalinigrad');
INSERT INTO zones VALUES (2937, 176, 'KL', 'Kaluga');
INSERT INTO zones VALUES (2938, 176, 'KS', 'Kasnodar');
INSERT INTO zones VALUES (2939, 176, 'KZ', 'Kazan');
INSERT INTO zones VALUES (2940, 176, 'KE', 'Kemerovo');
INSERT INTO zones VALUES (2941, 176, 'KH', 'Khabarovsk');
INSERT INTO zones VALUES (2942, 176, 'KM', 'Khanty-Mansiysk');
INSERT INTO zones VALUES (2943, 176, 'KO', 'Kostroma');
INSERT INTO zones VALUES (2944, 176, 'KR', 'Krasnodar');
INSERT INTO zones VALUES (2945, 176, 'KN', 'Krasnoyarsk');
INSERT INTO zones VALUES (2946, 176, 'KU', 'Kudymkar');
INSERT INTO zones VALUES (2947, 176, 'KG', 'Kurgan');
INSERT INTO zones VALUES (2948, 176, 'KK', 'Kursk');
INSERT INTO zones VALUES (2949, 176, 'KY', 'Kyzyl');
INSERT INTO zones VALUES (2950, 176, 'LI', 'Lipetsk');
INSERT INTO zones VALUES (2951, 176, 'MA', 'Magadan');
INSERT INTO zones VALUES (2952, 176, 'MK', 'Makhachkala');
INSERT INTO zones VALUES (2953, 176, 'MY', 'Maykop');
INSERT INTO zones VALUES (2954, 176, 'MO', 'Moscow');
INSERT INTO zones VALUES (2955, 176, 'MU', 'Murmansk');
INSERT INTO zones VALUES (2956, 176, 'NA', 'Nalchik');
INSERT INTO zones VALUES (2957, 176, 'NR', 'Naryan Mar');
INSERT INTO zones VALUES (2958, 176, 'NZ', 'Nazran');
INSERT INTO zones VALUES (2959, 176, 'NI', 'Nizhniy Novgorod');
INSERT INTO zones VALUES (2960, 176, 'NO', 'Novgorod');
INSERT INTO zones VALUES (2961, 176, 'NV', 'Novosibirsk');
INSERT INTO zones VALUES (2962, 176, 'OM', 'Omsk');
INSERT INTO zones VALUES (2963, 176, 'OR', 'Orel');
INSERT INTO zones VALUES (2964, 176, 'OE', 'Orenburg');
INSERT INTO zones VALUES (2965, 176, 'PA', 'Palana');
INSERT INTO zones VALUES (2966, 176, 'PE', 'Penza');
INSERT INTO zones VALUES (2967, 176, 'PR', 'Perm');
INSERT INTO zones VALUES (2968, 176, 'PK', 'Petropavlovsk-Kamchatskiy');
INSERT INTO zones VALUES (2969, 176, 'PT', 'Petrozavodsk');
INSERT INTO zones VALUES (2970, 176, 'PS', 'Pskov');
INSERT INTO zones VALUES (2971, 176, 'RO', 'Rostov-na-Donu');
INSERT INTO zones VALUES (2972, 176, 'RY', 'Ryazan');
INSERT INTO zones VALUES (2973, 176, 'SL', 'Salekhard');
INSERT INTO zones VALUES (2974, 176, 'SA', 'Samara');
INSERT INTO zones VALUES (2975, 176, 'SR', 'Saransk');
INSERT INTO zones VALUES (2976, 176, 'SV', 'Saratov');
INSERT INTO zones VALUES (2977, 176, 'SM', 'Smolensk');
INSERT INTO zones VALUES (2978, 176, 'SP', 'St. Petersburg');
INSERT INTO zones VALUES (2979, 176, 'ST', 'Stavropol');
INSERT INTO zones VALUES (2980, 176, 'SY', 'Syktyvkar');
INSERT INTO zones VALUES (2981, 176, 'TA', 'Tambov');
INSERT INTO zones VALUES (2982, 176, 'TO', 'Tomsk');
INSERT INTO zones VALUES (2983, 176, 'TU', 'Tula');
INSERT INTO zones VALUES (2984, 176, 'TR', 'Tura');
INSERT INTO zones VALUES (2985, 176, 'TV', 'Tver');
INSERT INTO zones VALUES (2986, 176, 'TY', 'Tyumen');
INSERT INTO zones VALUES (2987, 176, 'UF', 'Ufa');
INSERT INTO zones VALUES (2988, 176, 'UL', 'Ul''yanovsk');
INSERT INTO zones VALUES (2989, 176, 'UU', 'Ulan-Ude');
INSERT INTO zones VALUES (2990, 176, 'US', 'Ust''-Ordynskiy');
INSERT INTO zones VALUES (2991, 176, 'VL', 'Vladikavkaz');
INSERT INTO zones VALUES (2992, 176, 'VA', 'Vladimir');
INSERT INTO zones VALUES (2993, 176, 'VV', 'Vladivostok');
INSERT INTO zones VALUES (2994, 176, 'VG', 'Volgograd');
INSERT INTO zones VALUES (2995, 176, 'VD', 'Vologda');
INSERT INTO zones VALUES (2996, 176, 'VO', 'Voronezh');
INSERT INTO zones VALUES (2997, 176, 'VY', 'Vyatka');
INSERT INTO zones VALUES (2998, 176, 'YA', 'Yakutsk');
INSERT INTO zones VALUES (2999, 176, 'YR', 'Yaroslavl');
INSERT INTO zones VALUES (3000, 176, 'YE', 'Yekaterinburg');
INSERT INTO zones VALUES (3001, 176, 'YO', 'Yoshkar-Ola');
INSERT INTO zones VALUES (3002, 177, 'BU', 'Butare');
INSERT INTO zones VALUES (3003, 177, 'BY', 'Byumba');
INSERT INTO zones VALUES (3004, 177, 'CY', 'Cyangugu');
INSERT INTO zones VALUES (3005, 177, 'GK', 'Gikongoro');
INSERT INTO zones VALUES (3006, 177, 'GS', 'Gisenyi');
INSERT INTO zones VALUES (3007, 177, 'GT', 'Gitarama');
INSERT INTO zones VALUES (3008, 177, 'KG', 'Kibungo');
INSERT INTO zones VALUES (3009, 177, 'KY', 'Kibuye');
INSERT INTO zones VALUES (3010, 177, 'KR', 'Kigali Rurale');
INSERT INTO zones VALUES (3011, 177, 'KV', 'Kigali-ville');
INSERT INTO zones VALUES (3012, 177, 'RU', 'Ruhengeri');
INSERT INTO zones VALUES (3013, 177, 'UM', 'Umutara');
INSERT INTO zones VALUES (3014, 178, 'CCN', 'Christ Church Nichola Town');
INSERT INTO zones VALUES (3015, 178, 'SAS', 'Saint Anne Sandy Point');
INSERT INTO zones VALUES (3016, 178, 'SGB', 'Saint George Basseterre');
INSERT INTO zones VALUES (3017, 178, 'SGG', 'Saint George Gingerland');
INSERT INTO zones VALUES (3018, 178, 'SJW', 'Saint James Windward');
INSERT INTO zones VALUES (3019, 178, 'SJC', 'Saint John Capesterre');
INSERT INTO zones VALUES (3020, 178, 'SJF', 'Saint John Figtree');
INSERT INTO zones VALUES (3021, 178, 'SMC', 'Saint Mary Cayon');
INSERT INTO zones VALUES (3022, 178, 'CAP', 'Saint Paul Capesterre');
INSERT INTO zones VALUES (3023, 178, 'CHA', 'Saint Paul Charlestown');
INSERT INTO zones VALUES (3024, 178, 'SPB', 'Saint Peter Basseterre');
INSERT INTO zones VALUES (3025, 178, 'STL', 'Saint Thomas Lowland');
INSERT INTO zones VALUES (3026, 178, 'STM', 'Saint Thomas Middle Island');
INSERT INTO zones VALUES (3027, 178, 'TPP', 'Trinity Palmetto Point');
INSERT INTO zones VALUES (3028, 179, 'AR', 'Anse-la-Raye');
INSERT INTO zones VALUES (3029, 179, 'CA', 'Castries');
INSERT INTO zones VALUES (3030, 179, 'CH', 'Choiseul');
INSERT INTO zones VALUES (3031, 179, 'DA', 'Dauphin');
INSERT INTO zones VALUES (3032, 179, 'DE', 'Dennery');
INSERT INTO zones VALUES (3033, 179, 'GI', 'Gros-Islet');
INSERT INTO zones VALUES (3034, 179, 'LA', 'Laborie');
INSERT INTO zones VALUES (3035, 179, 'MI', 'Micoud');
INSERT INTO zones VALUES (3036, 179, 'PR', 'Praslin');
INSERT INTO zones VALUES (3037, 179, 'SO', 'Soufriere');
INSERT INTO zones VALUES (3038, 179, 'VF', 'Vieux-Fort');
INSERT INTO zones VALUES (3039, 180, 'C', 'Charlotte');
INSERT INTO zones VALUES (3040, 180, 'R', 'Grenadines');
INSERT INTO zones VALUES (3041, 180, 'A', 'Saint Andrew');
INSERT INTO zones VALUES (3042, 180, 'D', 'Saint David');
INSERT INTO zones VALUES (3043, 180, 'G', 'Saint George');
INSERT INTO zones VALUES (3044, 180, 'P', 'Saint Patrick');
INSERT INTO zones VALUES (3045, 181, 'AN', 'A''ana');
INSERT INTO zones VALUES (3046, 181, 'AI', 'Aiga-i-le-Tai');
INSERT INTO zones VALUES (3047, 181, 'AT', 'Atua');
INSERT INTO zones VALUES (3048, 181, 'FA', 'Fa''asaleleaga');
INSERT INTO zones VALUES (3049, 181, 'GE', 'Gaga''emauga');
INSERT INTO zones VALUES (3050, 181, 'GF', 'Gagaifomauga');
INSERT INTO zones VALUES (3051, 181, 'PA', 'Palauli');
INSERT INTO zones VALUES (3052, 181, 'SA', 'Satupa''itea');
INSERT INTO zones VALUES (3053, 181, 'TU', 'Tuamasaga');
INSERT INTO zones VALUES (3054, 181, 'VF', 'Va''a-o-Fonoti');
INSERT INTO zones VALUES (3055, 181, 'VS', 'Vaisigano');
INSERT INTO zones VALUES (3056, 182, 'AC', 'Acquaviva');
INSERT INTO zones VALUES (3057, 182, 'BM', 'Borgo Maggiore');
INSERT INTO zones VALUES (3058, 182, 'CH', 'Chiesanuova');
INSERT INTO zones VALUES (3059, 182, 'DO', 'Domagnano');
INSERT INTO zones VALUES (3060, 182, 'FA', 'Faetano');
INSERT INTO zones VALUES (3061, 182, 'FI', 'Fiorentino');
INSERT INTO zones VALUES (3062, 182, 'MO', 'Montegiardino');
INSERT INTO zones VALUES (3063, 182, 'SM', 'Citta di San Marino');
INSERT INTO zones VALUES (3064, 182, 'SE', 'Serravalle');
INSERT INTO zones VALUES (3065, 183, 'S', 'Sao Tome');
INSERT INTO zones VALUES (3066, 183, 'P', 'Principe');
INSERT INTO zones VALUES (3067, 184, 'BH', 'Al Bahah');
INSERT INTO zones VALUES (3068, 184, 'HS', 'Al Hudud ash Shamaliyah');
INSERT INTO zones VALUES (3069, 184, 'JF', 'Al Jawf');
INSERT INTO zones VALUES (3070, 184, 'MD', 'Al Madinah');
INSERT INTO zones VALUES (3071, 184, 'QS', 'Al Qasim');
INSERT INTO zones VALUES (3072, 184, 'RD', 'Ar Riyad');
INSERT INTO zones VALUES (3073, 184, 'AQ', 'Ash Sharqiyah (Eastern)');
INSERT INTO zones VALUES (3074, 184, 'AS', '''Asir');
INSERT INTO zones VALUES (3075, 184, 'HL', 'Ha''il');
INSERT INTO zones VALUES (3076, 184, 'JZ', 'Jizan');
INSERT INTO zones VALUES (3077, 184, 'ML', 'Makkah');
INSERT INTO zones VALUES (3078, 184, 'NR', 'Najran');
INSERT INTO zones VALUES (3079, 184, 'TB', 'Tabuk');
INSERT INTO zones VALUES (3080, 185, 'DA', 'Dakar');
INSERT INTO zones VALUES (3081, 185, 'DI', 'Diourbel');
INSERT INTO zones VALUES (3082, 185, 'FA', 'Fatick');
INSERT INTO zones VALUES (3083, 185, 'KA', 'Kaolack');
INSERT INTO zones VALUES (3084, 185, 'KO', 'Kolda');
INSERT INTO zones VALUES (3085, 185, 'LO', 'Louga');
INSERT INTO zones VALUES (3086, 185, 'MA', 'Matam');
INSERT INTO zones VALUES (3087, 185, 'SL', 'Saint-Louis');
INSERT INTO zones VALUES (3088, 185, 'TA', 'Tambacounda');
INSERT INTO zones VALUES (3089, 185, 'TH', 'Thies ');
INSERT INTO zones VALUES (3090, 185, 'ZI', 'Ziguinchor');
INSERT INTO zones VALUES (3091, 186, 'AP', 'Anse aux Pins');
INSERT INTO zones VALUES (3092, 186, 'AB', 'Anse Boileau');
INSERT INTO zones VALUES (3093, 186, 'AE', 'Anse Etoile');
INSERT INTO zones VALUES (3094, 186, 'AL', 'Anse Louis');
INSERT INTO zones VALUES (3095, 186, 'AR', 'Anse Royale');
INSERT INTO zones VALUES (3096, 186, 'BL', 'Baie Lazare');
INSERT INTO zones VALUES (3097, 186, 'BS', 'Baie Sainte Anne');
INSERT INTO zones VALUES (3098, 186, 'BV', 'Beau Vallon');
INSERT INTO zones VALUES (3099, 186, 'BA', 'Bel Air');
INSERT INTO zones VALUES (3100, 186, 'BO', 'Bel Ombre');
INSERT INTO zones VALUES (3101, 186, 'CA', 'Cascade');
INSERT INTO zones VALUES (3102, 186, 'GL', 'Glacis');
INSERT INTO zones VALUES (3103, 186, 'GM', 'Grand'' Anse (on Mahe)');
INSERT INTO zones VALUES (3104, 186, 'GP', 'Grand'' Anse (on Praslin)');
INSERT INTO zones VALUES (3105, 186, 'DG', 'La Digue');
INSERT INTO zones VALUES (3106, 186, 'RA', 'La Riviere Anglaise');
INSERT INTO zones VALUES (3107, 186, 'MB', 'Mont Buxton');
INSERT INTO zones VALUES (3108, 186, 'MF', 'Mont Fleuri');
INSERT INTO zones VALUES (3109, 186, 'PL', 'Plaisance');
INSERT INTO zones VALUES (3110, 186, 'PR', 'Pointe La Rue');
INSERT INTO zones VALUES (3111, 186, 'PG', 'Port Glaud');
INSERT INTO zones VALUES (3112, 186, 'SL', 'Saint Louis');
INSERT INTO zones VALUES (3113, 186, 'TA', 'Takamaka');
INSERT INTO zones VALUES (3114, 187, 'E', 'Eastern');
INSERT INTO zones VALUES (3115, 187, 'N', 'Northern');
INSERT INTO zones VALUES (3116, 187, 'S', 'Southern');
INSERT INTO zones VALUES (3117, 187, 'W', 'Western');
INSERT INTO zones VALUES (3118, 189, 'BA', 'Banskobystricky');
INSERT INTO zones VALUES (3119, 189, 'BR', 'Bratislavsky');
INSERT INTO zones VALUES (3120, 189, 'KO', 'Kosicky');
INSERT INTO zones VALUES (3121, 189, 'NI', 'Nitriansky');
INSERT INTO zones VALUES (3122, 189, 'PR', 'Presovsky');
INSERT INTO zones VALUES (3123, 189, 'TC', 'Trenciansky');
INSERT INTO zones VALUES (3124, 189, 'TV', 'Trnavsky');
INSERT INTO zones VALUES (3125, 189, 'ZI', 'Zilinsky');
INSERT INTO zones VALUES (3126, 191, 'CE', 'Central');
INSERT INTO zones VALUES (3127, 191, 'CH', 'Choiseul');
INSERT INTO zones VALUES (3128, 191, 'GC', 'Guadalcanal');
INSERT INTO zones VALUES (3129, 191, 'HO', 'Honiara');
INSERT INTO zones VALUES (3130, 191, 'IS', 'Isabel');
INSERT INTO zones VALUES (3131, 191, 'MK', 'Makira');
INSERT INTO zones VALUES (3132, 191, 'ML', 'Malaita');
INSERT INTO zones VALUES (3133, 191, 'RB', 'Rennell and Bellona');
INSERT INTO zones VALUES (3134, 191, 'TM', 'Temotu');
INSERT INTO zones VALUES (3135, 191, 'WE', 'Western');
INSERT INTO zones VALUES (3136, 192, 'AW', 'Awdal');
INSERT INTO zones VALUES (3137, 192, 'BK', 'Bakool');
INSERT INTO zones VALUES (3138, 192, 'BN', 'Banaadir');
INSERT INTO zones VALUES (3139, 192, 'BR', 'Bari');
INSERT INTO zones VALUES (3140, 192, 'BY', 'Bay');
INSERT INTO zones VALUES (3141, 192, 'GA', 'Galguduud');
INSERT INTO zones VALUES (3142, 192, 'GE', 'Gedo');
INSERT INTO zones VALUES (3143, 192, 'HI', 'Hiiraan');
INSERT INTO zones VALUES (3144, 192, 'JD', 'Jubbada Dhexe');
INSERT INTO zones VALUES (3145, 192, 'JH', 'Jubbada Hoose');
INSERT INTO zones VALUES (3146, 192, 'MU', 'Mudug');
INSERT INTO zones VALUES (3147, 192, 'NU', 'Nugaal');
INSERT INTO zones VALUES (3148, 192, 'SA', 'Sanaag');
INSERT INTO zones VALUES (3149, 192, 'SD', 'Shabeellaha Dhexe');
INSERT INTO zones VALUES (3150, 192, 'SH', 'Shabeellaha Hoose');
INSERT INTO zones VALUES (3151, 192, 'SL', 'Sool');
INSERT INTO zones VALUES (3152, 192, 'TO', 'Togdheer');
INSERT INTO zones VALUES (3153, 192, 'WG', 'Woqooyi Galbeed');
INSERT INTO zones VALUES (3154, 193, 'EC', 'Eastern Cape');
INSERT INTO zones VALUES (3155, 193, 'FS', 'Free State');
INSERT INTO zones VALUES (3156, 193, 'GT', 'Gauteng');
INSERT INTO zones VALUES (3157, 193, 'KN', 'KwaZulu-Natal');
INSERT INTO zones VALUES (3158, 193, 'LP', 'Limpopo');
INSERT INTO zones VALUES (3159, 193, 'MP', 'Mpumalanga');
INSERT INTO zones VALUES (3160, 193, 'NW', 'North West');
INSERT INTO zones VALUES (3161, 193, 'NC', 'Northern Cape');
INSERT INTO zones VALUES (3162, 193, 'WC', 'Western Cape');
INSERT INTO zones VALUES (3163, 196, 'CE', 'Central');
INSERT INTO zones VALUES (3164, 196, 'EA', 'Eastern');
INSERT INTO zones VALUES (3165, 196, 'NC', 'North Central');
INSERT INTO zones VALUES (3166, 196, 'NO', 'Northern');
INSERT INTO zones VALUES (3167, 196, 'NW', 'North Western');
INSERT INTO zones VALUES (3168, 196, 'SA', 'Sabaragamuwa');
INSERT INTO zones VALUES (3169, 196, 'SO', 'Southern');
INSERT INTO zones VALUES (3170, 196, 'UV', 'Uva');
INSERT INTO zones VALUES (3171, 196, 'WE', 'Western');
INSERT INTO zones VALUES (3172, 197, 'A', 'Ascension');
INSERT INTO zones VALUES (3173, 197, 'S', 'Saint Helena');
INSERT INTO zones VALUES (3174, 197, 'T', 'Tristan da Cunha');
INSERT INTO zones VALUES (3175, 199, 'ANL', 'A''ali an Nil');
INSERT INTO zones VALUES (3176, 199, 'BAM', 'Al Bahr al Ahmar');
INSERT INTO zones VALUES (3177, 199, 'BRT', 'Al Buhayrat');
INSERT INTO zones VALUES (3178, 199, 'JZR', 'Al Jazirah');
INSERT INTO zones VALUES (3179, 199, 'KRT', 'Al Khartum');
INSERT INTO zones VALUES (3180, 199, 'QDR', 'Al Qadarif');
INSERT INTO zones VALUES (3181, 199, 'WDH', 'Al Wahdah');
INSERT INTO zones VALUES (3182, 199, 'ANB', 'An Nil al Abyad');
INSERT INTO zones VALUES (3183, 199, 'ANZ', 'An Nil al Azraq');
INSERT INTO zones VALUES (3184, 199, 'ASH', 'Ash Shamaliyah');
INSERT INTO zones VALUES (3185, 199, 'BJA', 'Bahr al Jabal');
INSERT INTO zones VALUES (3186, 199, 'GIS', 'Gharb al Istiwa''iyah');
INSERT INTO zones VALUES (3187, 199, 'GBG', 'Gharb Bahr al Ghazal');
INSERT INTO zones VALUES (3188, 199, 'GDA', 'Gharb Darfur');
INSERT INTO zones VALUES (3189, 199, 'GKU', 'Gharb Kurdufan');
INSERT INTO zones VALUES (3190, 199, 'JDA', 'Janub Darfur');
INSERT INTO zones VALUES (3191, 199, 'JKU', 'Janub Kurdufan');
INSERT INTO zones VALUES (3192, 199, 'JQL', 'Junqali');
INSERT INTO zones VALUES (3193, 199, 'KSL', 'Kassala');
INSERT INTO zones VALUES (3194, 199, 'NNL', 'Nahr an Nil');
INSERT INTO zones VALUES (3195, 199, 'SBG', 'Shamal Bahr al Ghazal');
INSERT INTO zones VALUES (3196, 199, 'SDA', 'Shamal Darfur');
INSERT INTO zones VALUES (3197, 199, 'SKU', 'Shamal Kurdufan');
INSERT INTO zones VALUES (3198, 199, 'SIS', 'Sharq al Istiwa''iyah');
INSERT INTO zones VALUES (3199, 199, 'SNR', 'Sinnar');
INSERT INTO zones VALUES (3200, 199, 'WRB', 'Warab');
INSERT INTO zones VALUES (3201, 200, 'BR', 'Brokopondo');
INSERT INTO zones VALUES (3202, 200, 'CM', 'Commewijne');
INSERT INTO zones VALUES (3203, 200, 'CR', 'Coronie');
INSERT INTO zones VALUES (3204, 200, 'MA', 'Marowijne');
INSERT INTO zones VALUES (3205, 200, 'NI', 'Nickerie');
INSERT INTO zones VALUES (3206, 200, 'PA', 'Para');
INSERT INTO zones VALUES (3207, 200, 'PM', 'Paramaribo');
INSERT INTO zones VALUES (3208, 200, 'SA', 'Saramacca');
INSERT INTO zones VALUES (3209, 200, 'SI', 'Sipaliwini');
INSERT INTO zones VALUES (3210, 200, 'WA', 'Wanica');
INSERT INTO zones VALUES (3211, 202, 'H', 'Hhohho');
INSERT INTO zones VALUES (3212, 202, 'L', 'Lubombo');
INSERT INTO zones VALUES (3213, 202, 'M', 'Manzini');
INSERT INTO zones VALUES (3214, 202, 'S', 'Shishelweni');
INSERT INTO zones VALUES (3215, 203, 'K', 'Blekinge');
INSERT INTO zones VALUES (3216, 203, 'W', 'Dalama');
INSERT INTO zones VALUES (3217, 203, 'X', 'G&auml;vleborg');
INSERT INTO zones VALUES (3218, 203, 'I', 'Gotland');
INSERT INTO zones VALUES (3219, 203, 'N', 'Halland');
INSERT INTO zones VALUES (3220, 203, 'Z', 'J&auml;mtland');
INSERT INTO zones VALUES (3221, 203, 'F', 'J&ouml;nkping');
INSERT INTO zones VALUES (3222, 203, 'H', 'Kalmar');
INSERT INTO zones VALUES (3223, 203, 'G', 'Kronoberg');
INSERT INTO zones VALUES (3224, 203, 'BD', 'Norrbotten');
INSERT INTO zones VALUES (3225, 203, 'T', '&Ouml;rebro');
INSERT INTO zones VALUES (3226, 203, 'E', '&Ouml;sterg&ouml;tland');
INSERT INTO zones VALUES (3227, 203, 'M', 'Sk&aring;ne');
INSERT INTO zones VALUES (3228, 203, 'D', 'S&ouml;dermanland');
INSERT INTO zones VALUES (3229, 203, 'AB', 'Stockholm');
INSERT INTO zones VALUES (3230, 203, 'C', 'Uppsala');
INSERT INTO zones VALUES (3231, 203, 'S', 'V&auml;rmland');
INSERT INTO zones VALUES (3232, 203, 'AC', 'V&auml;sterbotten');
INSERT INTO zones VALUES (3233, 203, 'Y', 'V&auml;sternorrland');
INSERT INTO zones VALUES (3234, 203, 'U', 'V&auml;stmanland');
INSERT INTO zones VALUES (3235, 203, 'O', 'V&auml;stra G&ouml;taland');
INSERT INTO zones VALUES (3236, 205, 'HA', 'Al Hasakah');
INSERT INTO zones VALUES (3237, 205, 'LA', 'Al Ladhiqiyah');
INSERT INTO zones VALUES (3238, 205, 'QU', 'Al Qunaytirah');
INSERT INTO zones VALUES (3239, 205, 'RQ', 'Ar Raqqah');
INSERT INTO zones VALUES (3240, 205, 'SU', 'As Suwayda');
INSERT INTO zones VALUES (3241, 205, 'DA', 'Dara');
INSERT INTO zones VALUES (3242, 205, 'DZ', 'Dayr az Zawr');
INSERT INTO zones VALUES (3243, 205, 'DI', 'Dimashq');
INSERT INTO zones VALUES (3244, 205, 'HL', 'Halab');
INSERT INTO zones VALUES (3245, 205, 'HM', 'Hamah');
INSERT INTO zones VALUES (3246, 205, 'HI', 'Hims');
INSERT INTO zones VALUES (3247, 205, 'ID', 'Idlib');
INSERT INTO zones VALUES (3248, 205, 'RD', 'Rif Dimashq');
INSERT INTO zones VALUES (3249, 205, 'TA', 'Tartus');
INSERT INTO zones VALUES (3250, 207, 'GB', 'Gorno-Badakhstan');
INSERT INTO zones VALUES (3251, 207, 'KT', 'Khatlon');
INSERT INTO zones VALUES (3252, 207, 'SU', 'Sughd');
INSERT INTO zones VALUES (3253, 208, 'AR', 'Arusha');
INSERT INTO zones VALUES (3254, 208, 'DS', 'Dar es Salaam');
INSERT INTO zones VALUES (3255, 208, 'DO', 'Dodoma');
INSERT INTO zones VALUES (3256, 208, 'IR', 'Iringa');
INSERT INTO zones VALUES (3257, 208, 'KA', 'Kagera');
INSERT INTO zones VALUES (3258, 208, 'KI', 'Kigoma');
INSERT INTO zones VALUES (3259, 208, 'KJ', 'Kilimanjaro');
INSERT INTO zones VALUES (3260, 208, 'LN', 'Lindi');
INSERT INTO zones VALUES (3261, 208, 'MY', 'Manyara');
INSERT INTO zones VALUES (3262, 208, 'MR', 'Mara');
INSERT INTO zones VALUES (3263, 208, 'MB', 'Mbeya');
INSERT INTO zones VALUES (3264, 208, 'MO', 'Morogoro');
INSERT INTO zones VALUES (3265, 208, 'MT', 'Mtwara');
INSERT INTO zones VALUES (3266, 208, 'MW', 'Mwanza');
INSERT INTO zones VALUES (3267, 208, 'PN', 'Pemba North');
INSERT INTO zones VALUES (3268, 208, 'PS', 'Pemba South');
INSERT INTO zones VALUES (3269, 208, 'PW', 'Pwani');
INSERT INTO zones VALUES (3270, 208, 'RK', 'Rukwa');
INSERT INTO zones VALUES (3271, 208, 'RV', 'Ruvuma');
INSERT INTO zones VALUES (3272, 208, 'SH', 'Shinyanga');
INSERT INTO zones VALUES (3273, 208, 'SI', 'Singida');
INSERT INTO zones VALUES (3274, 208, 'TB', 'Tabora');
INSERT INTO zones VALUES (3275, 208, 'TN', 'Tanga');
INSERT INTO zones VALUES (3276, 208, 'ZC', 'Zanzibar Central/South');
INSERT INTO zones VALUES (3277, 208, 'ZN', 'Zanzibar North');
INSERT INTO zones VALUES (3278, 208, 'ZU', 'Zanzibar Urban/West');
INSERT INTO zones VALUES (3279, 209, 'Amnat Charoen', 'Amnat Charoen');
INSERT INTO zones VALUES (3280, 209, 'Ang Thong', 'Ang Thong');
INSERT INTO zones VALUES (3281, 209, 'Ayutthaya', 'Ayutthaya');
INSERT INTO zones VALUES (3282, 209, 'Bangkok', 'Bangkok');
INSERT INTO zones VALUES (3283, 209, 'Buriram', 'Buriram');
INSERT INTO zones VALUES (3284, 209, 'Chachoengsao', 'Chachoengsao');
INSERT INTO zones VALUES (3285, 209, 'Chai Nat', 'Chai Nat');
INSERT INTO zones VALUES (3286, 209, 'Chaiyaphum', 'Chaiyaphum');
INSERT INTO zones VALUES (3287, 209, 'Chanthaburi', 'Chanthaburi');
INSERT INTO zones VALUES (3288, 209, 'Chiang Mai', 'Chiang Mai');
INSERT INTO zones VALUES (3289, 209, 'Chiang Rai', 'Chiang Rai');
INSERT INTO zones VALUES (3290, 209, 'Chon Buri', 'Chon Buri');
INSERT INTO zones VALUES (3291, 209, 'Chumphon', 'Chumphon');
INSERT INTO zones VALUES (3292, 209, 'Kalasin', 'Kalasin');
INSERT INTO zones VALUES (3293, 209, 'Kamphaeng Phet', 'Kamphaeng Phet');
INSERT INTO zones VALUES (3294, 209, 'Kanchanaburi', 'Kanchanaburi');
INSERT INTO zones VALUES (3295, 209, 'Khon Kaen', 'Khon Kaen');
INSERT INTO zones VALUES (3296, 209, 'Krabi', 'Krabi');
INSERT INTO zones VALUES (3297, 209, 'Lampang', 'Lampang');
INSERT INTO zones VALUES (3298, 209, 'Lamphun', 'Lamphun');
INSERT INTO zones VALUES (3299, 209, 'Loei', 'Loei');
INSERT INTO zones VALUES (3300, 209, 'Lop Buri', 'Lop Buri');
INSERT INTO zones VALUES (3301, 209, 'Mae Hong Son', 'Mae Hong Son');
INSERT INTO zones VALUES (3302, 209, 'Maha Sarakham', 'Maha Sarakham');
INSERT INTO zones VALUES (3303, 209, 'Mukdahan', 'Mukdahan');
INSERT INTO zones VALUES (3304, 209, 'Nakhon Nayok', 'Nakhon Nayok');
INSERT INTO zones VALUES (3305, 209, 'Nakhon Pathom', 'Nakhon Pathom');
INSERT INTO zones VALUES (3306, 209, 'Nakhon Phanom', 'Nakhon Phanom');
INSERT INTO zones VALUES (3307, 209, 'Nakhon Ratchasima', 'Nakhon Ratchasima');
INSERT INTO zones VALUES (3308, 209, 'Nakhon Sawan', 'Nakhon Sawan');
INSERT INTO zones VALUES (3309, 209, 'Nakhon Si Thammarat', 'Nakhon Si Thammarat');
INSERT INTO zones VALUES (3310, 209, 'Nan', 'Nan');
INSERT INTO zones VALUES (3311, 209, 'Narathiwat', 'Narathiwat');
INSERT INTO zones VALUES (3312, 209, 'Nong Bua Lamphu', 'Nong Bua Lamphu');
INSERT INTO zones VALUES (3313, 209, 'Nong Khai', 'Nong Khai');
INSERT INTO zones VALUES (3314, 209, 'Nonthaburi', 'Nonthaburi');
INSERT INTO zones VALUES (3315, 209, 'Pathum Thani', 'Pathum Thani');
INSERT INTO zones VALUES (3316, 209, 'Pattani', 'Pattani');
INSERT INTO zones VALUES (3317, 209, 'Phangnga', 'Phangnga');
INSERT INTO zones VALUES (3318, 209, 'Phatthalung', 'Phatthalung');
INSERT INTO zones VALUES (3319, 209, 'Phayao', 'Phayao');
INSERT INTO zones VALUES (3320, 209, 'Phetchabun', 'Phetchabun');
INSERT INTO zones VALUES (3321, 209, 'Phetchaburi', 'Phetchaburi');
INSERT INTO zones VALUES (3322, 209, 'Phichit', 'Phichit');
INSERT INTO zones VALUES (3323, 209, 'Phitsanulok', 'Phitsanulok');
INSERT INTO zones VALUES (3324, 209, 'Phrae', 'Phrae');
INSERT INTO zones VALUES (3325, 209, 'Phuket', 'Phuket');
INSERT INTO zones VALUES (3326, 209, 'Prachin Buri', 'Prachin Buri');
INSERT INTO zones VALUES (3327, 209, 'Prachuap Khiri Khan', 'Prachuap Khiri Khan');
INSERT INTO zones VALUES (3328, 209, 'Ranong', 'Ranong');
INSERT INTO zones VALUES (3329, 209, 'Ratchaburi', 'Ratchaburi');
INSERT INTO zones VALUES (3330, 209, 'Rayong', 'Rayong');
INSERT INTO zones VALUES (3331, 209, 'Roi Et', 'Roi Et');
INSERT INTO zones VALUES (3332, 209, 'Sa Kaeo', 'Sa Kaeo');
INSERT INTO zones VALUES (3333, 209, 'Sakon Nakhon', 'Sakon Nakhon');
INSERT INTO zones VALUES (3334, 209, 'Samut Prakan', 'Samut Prakan');
INSERT INTO zones VALUES (3335, 209, 'Samut Sakhon', 'Samut Sakhon');
INSERT INTO zones VALUES (3336, 209, 'Samut Songkhram', 'Samut Songkhram');
INSERT INTO zones VALUES (3337, 209, 'Sara Buri', 'Sara Buri');
INSERT INTO zones VALUES (3338, 209, 'Satun', 'Satun');
INSERT INTO zones VALUES (3339, 209, 'Sing Buri', 'Sing Buri');
INSERT INTO zones VALUES (3340, 209, 'Sisaket', 'Sisaket');
INSERT INTO zones VALUES (3341, 209, 'Songkhla', 'Songkhla');
INSERT INTO zones VALUES (3342, 209, 'Sukhothai', 'Sukhothai');
INSERT INTO zones VALUES (3343, 209, 'Suphan Buri', 'Suphan Buri');
INSERT INTO zones VALUES (3344, 209, 'Surat Thani', 'Surat Thani');
INSERT INTO zones VALUES (3345, 209, 'Surin', 'Surin');
INSERT INTO zones VALUES (3346, 209, 'Tak', 'Tak');
INSERT INTO zones VALUES (3347, 209, 'Trang', 'Trang');
INSERT INTO zones VALUES (3348, 209, 'Trat', 'Trat');
INSERT INTO zones VALUES (3349, 209, 'Ubon Ratchathani', 'Ubon Ratchathani');
INSERT INTO zones VALUES (3350, 209, 'Udon Thani', 'Udon Thani');
INSERT INTO zones VALUES (3351, 209, 'Uthai Thani', 'Uthai Thani');
INSERT INTO zones VALUES (3352, 209, 'Uttaradit', 'Uttaradit');
INSERT INTO zones VALUES (3353, 209, 'Yala', 'Yala');
INSERT INTO zones VALUES (3354, 209, 'Yasothon', 'Yasothon');
INSERT INTO zones VALUES (3355, 210, 'K', 'Kara');
INSERT INTO zones VALUES (3356, 210, 'P', 'Plateaux');
INSERT INTO zones VALUES (3357, 210, 'S', 'Savanes');
INSERT INTO zones VALUES (3358, 210, 'C', 'Centrale');
INSERT INTO zones VALUES (3359, 210, 'M', 'Maritime');
INSERT INTO zones VALUES (3360, 211, 'A', 'Atafu');
INSERT INTO zones VALUES (3361, 211, 'F', 'Fakaofo');
INSERT INTO zones VALUES (3362, 211, 'N', 'Nukunonu');
INSERT INTO zones VALUES (3363, 212, 'H', 'Ha''apai');
INSERT INTO zones VALUES (3364, 212, 'T', 'Tongatapu');
INSERT INTO zones VALUES (3365, 212, 'V', 'Vava''u');
INSERT INTO zones VALUES (3366, 213, 'CT', 'Couva/Tabaquite/Talparo');
INSERT INTO zones VALUES (3367, 213, 'DM', 'Diego Martin');
INSERT INTO zones VALUES (3368, 213, 'MR', 'Mayaro/Rio Claro');
INSERT INTO zones VALUES (3369, 213, 'PD', 'Penal/Debe');
INSERT INTO zones VALUES (3370, 213, 'PT', 'Princes Town');
INSERT INTO zones VALUES (3371, 213, 'SG', 'Sangre Grande');
INSERT INTO zones VALUES (3372, 213, 'SL', 'San Juan/Laventille');
INSERT INTO zones VALUES (3373, 213, 'SI', 'Siparia');
INSERT INTO zones VALUES (3374, 213, 'TP', 'Tunapuna/Piarco');
INSERT INTO zones VALUES (3375, 213, 'PS', 'Port of Spain');
INSERT INTO zones VALUES (3376, 213, 'SF', 'San Fernando');
INSERT INTO zones VALUES (3377, 213, 'AR', 'Arima');
INSERT INTO zones VALUES (3378, 213, 'PF', 'Point Fortin');
INSERT INTO zones VALUES (3379, 213, 'CH', 'Chaguanas');
INSERT INTO zones VALUES (3380, 213, 'TO', 'Tobago');
INSERT INTO zones VALUES (3381, 214, 'AR', 'Ariana');
INSERT INTO zones VALUES (3382, 214, 'BJ', 'Beja');
INSERT INTO zones VALUES (3383, 214, 'BA', 'Ben Arous');
INSERT INTO zones VALUES (3384, 214, 'BI', 'Bizerte');
INSERT INTO zones VALUES (3385, 214, 'GB', 'Gabes');
INSERT INTO zones VALUES (3386, 214, 'GF', 'Gafsa');
INSERT INTO zones VALUES (3387, 214, 'JE', 'Jendouba');
INSERT INTO zones VALUES (3388, 214, 'KR', 'Kairouan');
INSERT INTO zones VALUES (3389, 214, 'KS', 'Kasserine');
INSERT INTO zones VALUES (3390, 214, 'KB', 'Kebili');
INSERT INTO zones VALUES (3391, 214, 'KF', 'Kef');
INSERT INTO zones VALUES (3392, 214, 'MH', 'Mahdia');
INSERT INTO zones VALUES (3393, 214, 'MN', 'Manouba');
INSERT INTO zones VALUES (3394, 214, 'ME', 'Medenine');
INSERT INTO zones VALUES (3395, 214, 'MO', 'Monastir');
INSERT INTO zones VALUES (3396, 214, 'NA', 'Nabeul');
INSERT INTO zones VALUES (3397, 214, 'SF', 'Sfax');
INSERT INTO zones VALUES (3398, 214, 'SD', 'Sidi');
INSERT INTO zones VALUES (3399, 214, 'SL', 'Siliana');
INSERT INTO zones VALUES (3400, 214, 'SO', 'Sousse');
INSERT INTO zones VALUES (3401, 214, 'TA', 'Tataouine');
INSERT INTO zones VALUES (3402, 214, 'TO', 'Tozeur');
INSERT INTO zones VALUES (3403, 214, 'TU', 'Tunis');
INSERT INTO zones VALUES (3404, 214, 'ZA', 'Zaghouan');
INSERT INTO zones VALUES (3405, 215, 'ADA', 'Adana');
INSERT INTO zones VALUES (3406, 215, 'ADI', 'Adiyaman');
INSERT INTO zones VALUES (3407, 215, 'AFY', 'Afyonkarahisar');
INSERT INTO zones VALUES (3408, 215, 'AGR', 'Agri');
INSERT INTO zones VALUES (3409, 215, 'AKS', 'Aksaray');
INSERT INTO zones VALUES (3410, 215, 'AMA', 'Amasya');
INSERT INTO zones VALUES (3411, 215, 'ANK', 'Ankara');
INSERT INTO zones VALUES (3412, 215, 'ANT', 'Antalya');
INSERT INTO zones VALUES (3413, 215, 'ARD', 'Ardahan');
INSERT INTO zones VALUES (3414, 215, 'ART', 'Artvin');
INSERT INTO zones VALUES (3415, 215, 'AYI', 'Aydin');
INSERT INTO zones VALUES (3416, 215, 'BAL', 'Balikesir');
INSERT INTO zones VALUES (3417, 215, 'BAR', 'Bartin');
INSERT INTO zones VALUES (3418, 215, 'BAT', 'Batman');
INSERT INTO zones VALUES (3419, 215, 'BAY', 'Bayburt');
INSERT INTO zones VALUES (3420, 215, 'BIL', 'Bilecik');
INSERT INTO zones VALUES (3421, 215, 'BIN', 'Bingol');
INSERT INTO zones VALUES (3422, 215, 'BIT', 'Bitlis');
INSERT INTO zones VALUES (3423, 215, 'BOL', 'Bolu');
INSERT INTO zones VALUES (3424, 215, 'BRD', 'Burdur');
INSERT INTO zones VALUES (3425, 215, 'BRS', 'Bursa');
INSERT INTO zones VALUES (3426, 215, 'CKL', 'Canakkale');
INSERT INTO zones VALUES (3427, 215, 'CKR', 'Cankiri');
INSERT INTO zones VALUES (3428, 215, 'COR', 'Corum');
INSERT INTO zones VALUES (3429, 215, 'DEN', 'Denizli');
INSERT INTO zones VALUES (3430, 215, 'DIY', 'Diyarbakir');
INSERT INTO zones VALUES (3431, 215, 'DUZ', 'Duzce');
INSERT INTO zones VALUES (3432, 215, 'EDI', 'Edirne');
INSERT INTO zones VALUES (3433, 215, 'ELA', 'Elazig');
INSERT INTO zones VALUES (3434, 215, 'EZC', 'Erzincan');
INSERT INTO zones VALUES (3435, 215, 'EZR', 'Erzurum');
INSERT INTO zones VALUES (3436, 215, 'ESK', 'Eskisehir');
INSERT INTO zones VALUES (3437, 215, 'GAZ', 'Gaziantep');
INSERT INTO zones VALUES (3438, 215, 'GIR', 'Giresun');
INSERT INTO zones VALUES (3439, 215, 'GMS', 'Gumushane');
INSERT INTO zones VALUES (3440, 215, 'HKR', 'Hakkari');
INSERT INTO zones VALUES (3441, 215, 'HTY', 'Hatay');
INSERT INTO zones VALUES (3442, 215, 'IGD', 'Igdir');
INSERT INTO zones VALUES (3443, 215, 'ISP', 'Isparta');
INSERT INTO zones VALUES (3444, 215, 'IST', 'Istanbul');
INSERT INTO zones VALUES (3445, 215, 'IZM', 'Izmir');
INSERT INTO zones VALUES (3446, 215, 'KAH', 'Kahramanmaras');
INSERT INTO zones VALUES (3447, 215, 'KRB', 'Karabuk');
INSERT INTO zones VALUES (3448, 215, 'KRM', 'Karaman');
INSERT INTO zones VALUES (3449, 215, 'KRS', 'Kars');
INSERT INTO zones VALUES (3450, 215, 'KAS', 'Kastamonu');
INSERT INTO zones VALUES (3451, 215, 'KAY', 'Kayseri');
INSERT INTO zones VALUES (3452, 215, 'KLS', 'Kilis');
INSERT INTO zones VALUES (3453, 215, 'KRK', 'Kirikkale');
INSERT INTO zones VALUES (3454, 215, 'KLR', 'Kirklareli');
INSERT INTO zones VALUES (3455, 215, 'KRH', 'Kirsehir');
INSERT INTO zones VALUES (3456, 215, 'KOC', 'Kocaeli');
INSERT INTO zones VALUES (3457, 215, 'KON', 'Konya');
INSERT INTO zones VALUES (3458, 215, 'KUT', 'Kutahya');
INSERT INTO zones VALUES (3459, 215, 'MAL', 'Malatya');
INSERT INTO zones VALUES (3460, 215, 'MAN', 'Manisa');
INSERT INTO zones VALUES (3461, 215, 'MAR', 'Mardin');
INSERT INTO zones VALUES (3462, 215, 'MER', 'Mersin');
INSERT INTO zones VALUES (3463, 215, 'MUG', 'Mugla');
INSERT INTO zones VALUES (3464, 215, 'MUS', 'Mus');
INSERT INTO zones VALUES (3465, 215, 'NEV', 'Nevsehir');
INSERT INTO zones VALUES (3466, 215, 'NIG', 'Nigde');
INSERT INTO zones VALUES (3467, 215, 'ORD', 'Ordu');
INSERT INTO zones VALUES (3468, 215, 'OSM', 'Osmaniye');
INSERT INTO zones VALUES (3469, 215, 'RIZ', 'Rize');
INSERT INTO zones VALUES (3470, 215, 'SAK', 'Sakarya');
INSERT INTO zones VALUES (3471, 215, 'SAM', 'Samsun');
INSERT INTO zones VALUES (3472, 215, 'SAN', 'Sanliurfa');
INSERT INTO zones VALUES (3473, 215, 'SII', 'Siirt');
INSERT INTO zones VALUES (3474, 215, 'SIN', 'Sinop');
INSERT INTO zones VALUES (3475, 215, 'SIR', 'Sirnak');
INSERT INTO zones VALUES (3476, 215, 'SIV', 'Sivas');
INSERT INTO zones VALUES (3477, 215, 'TEL', 'Tekirdag');
INSERT INTO zones VALUES (3478, 215, 'TOK', 'Tokat');
INSERT INTO zones VALUES (3479, 215, 'TRA', 'Trabzon');
INSERT INTO zones VALUES (3480, 215, 'TUN', 'Tunceli');
INSERT INTO zones VALUES (3481, 215, 'USK', 'Usak');
INSERT INTO zones VALUES (3482, 215, 'VAN', 'Van');
INSERT INTO zones VALUES (3483, 215, 'YAL', 'Yalova');
INSERT INTO zones VALUES (3484, 215, 'YOZ', 'Yozgat');
INSERT INTO zones VALUES (3485, 215, 'ZON', 'Zonguldak');
INSERT INTO zones VALUES (3486, 216, 'A', 'Ahal Welayaty');
INSERT INTO zones VALUES (3487, 216, 'B', 'Balkan Welayaty ');
INSERT INTO zones VALUES (3488, 216, 'D', 'Dashhowuz Welayaty');
INSERT INTO zones VALUES (3489, 216, 'L', 'Lebap Welayaty');
INSERT INTO zones VALUES (3490, 216, 'M', 'Mary Welayaty');
INSERT INTO zones VALUES (3491, 217, 'AC', 'Ambergris Cays');
INSERT INTO zones VALUES (3492, 217, 'DC', 'Dellis Cay');
INSERT INTO zones VALUES (3493, 217, 'FC', 'French Cay');
INSERT INTO zones VALUES (3494, 217, 'LW', 'Little Water Cay');
INSERT INTO zones VALUES (3495, 217, 'RC', 'Parrot Cay');
INSERT INTO zones VALUES (3496, 217, 'PN', 'Pine Cay');
INSERT INTO zones VALUES (3497, 217, 'SL', 'Salt Cay');
INSERT INTO zones VALUES (3498, 217, 'GT', 'Grand Turk');
INSERT INTO zones VALUES (3499, 217, 'SC', 'South Caicos');
INSERT INTO zones VALUES (3500, 217, 'EC', 'East Caicos');
INSERT INTO zones VALUES (3501, 217, 'MC', 'Middle Caicos');
INSERT INTO zones VALUES (3502, 217, 'NC', 'North Caicos');
INSERT INTO zones VALUES (3503, 217, 'PR', 'Providenciales');
INSERT INTO zones VALUES (3504, 217, 'WC', 'West Caicos');
INSERT INTO zones VALUES (3505, 218, 'NMG', 'Nanumanga');
INSERT INTO zones VALUES (3506, 218, 'NLK', 'Niulakita');
INSERT INTO zones VALUES (3507, 218, 'NTO', 'Niutao');
INSERT INTO zones VALUES (3508, 218, 'FUN', 'Funafuti');
INSERT INTO zones VALUES (3509, 218, 'NME', 'Nanumea');
INSERT INTO zones VALUES (3510, 218, 'NUI', 'Nui');
INSERT INTO zones VALUES (3511, 218, 'NFT', 'Nukufetau');
INSERT INTO zones VALUES (3512, 218, 'NLL', 'Nukulaelae');
INSERT INTO zones VALUES (3513, 218, 'VAI', 'Vaitupu');
INSERT INTO zones VALUES (3514, 219, 'KAL', 'Kalangala');
INSERT INTO zones VALUES (3515, 219, 'KMP', 'Kampala');
INSERT INTO zones VALUES (3516, 219, 'KAY', 'Kayunga');
INSERT INTO zones VALUES (3517, 219, 'KIB', 'Kiboga');
INSERT INTO zones VALUES (3518, 219, 'LUW', 'Luwero');
INSERT INTO zones VALUES (3519, 219, 'MAS', 'Masaka');
INSERT INTO zones VALUES (3520, 219, 'MPI', 'Mpigi');
INSERT INTO zones VALUES (3521, 219, 'MUB', 'Mubende');
INSERT INTO zones VALUES (3522, 219, 'MUK', 'Mukono');
INSERT INTO zones VALUES (3523, 219, 'NKS', 'Nakasongola');
INSERT INTO zones VALUES (3524, 219, 'RAK', 'Rakai');
INSERT INTO zones VALUES (3525, 219, 'SEM', 'Sembabule');
INSERT INTO zones VALUES (3526, 219, 'WAK', 'Wakiso');
INSERT INTO zones VALUES (3527, 219, 'BUG', 'Bugiri');
INSERT INTO zones VALUES (3528, 219, 'BUS', 'Busia');
INSERT INTO zones VALUES (3529, 219, 'IGA', 'Iganga');
INSERT INTO zones VALUES (3530, 219, 'JIN', 'Jinja');
INSERT INTO zones VALUES (3531, 219, 'KAB', 'Kaberamaido');
INSERT INTO zones VALUES (3532, 219, 'KML', 'Kamuli');
INSERT INTO zones VALUES (3533, 219, 'KPC', 'Kapchorwa');
INSERT INTO zones VALUES (3534, 219, 'KTK', 'Katakwi');
INSERT INTO zones VALUES (3535, 219, 'KUM', 'Kumi');
INSERT INTO zones VALUES (3536, 219, 'MAY', 'Mayuge');
INSERT INTO zones VALUES (3537, 219, 'MBA', 'Mbale');
INSERT INTO zones VALUES (3538, 219, 'PAL', 'Pallisa');
INSERT INTO zones VALUES (3539, 219, 'SIR', 'Sironko');
INSERT INTO zones VALUES (3540, 219, 'SOR', 'Soroti');
INSERT INTO zones VALUES (3541, 219, 'TOR', 'Tororo');
INSERT INTO zones VALUES (3542, 219, 'ADJ', 'Adjumani');
INSERT INTO zones VALUES (3543, 219, 'APC', 'Apac');
INSERT INTO zones VALUES (3544, 219, 'ARU', 'Arua');
INSERT INTO zones VALUES (3545, 219, 'GUL', 'Gulu');
INSERT INTO zones VALUES (3546, 219, 'KIT', 'Kitgum');
INSERT INTO zones VALUES (3547, 219, 'KOT', 'Kotido');
INSERT INTO zones VALUES (3548, 219, 'LIR', 'Lira');
INSERT INTO zones VALUES (3549, 219, 'MRT', 'Moroto');
INSERT INTO zones VALUES (3550, 219, 'MOY', 'Moyo');
INSERT INTO zones VALUES (3551, 219, 'NAK', 'Nakapiripirit');
INSERT INTO zones VALUES (3552, 219, 'NEB', 'Nebbi');
INSERT INTO zones VALUES (3553, 219, 'PAD', 'Pader');
INSERT INTO zones VALUES (3554, 219, 'YUM', 'Yumbe');
INSERT INTO zones VALUES (3555, 219, 'BUN', 'Bundibugyo');
INSERT INTO zones VALUES (3556, 219, 'BSH', 'Bushenyi');
INSERT INTO zones VALUES (3557, 219, 'HOI', 'Hoima');
INSERT INTO zones VALUES (3558, 219, 'KBL', 'Kabale');
INSERT INTO zones VALUES (3559, 219, 'KAR', 'Kabarole');
INSERT INTO zones VALUES (3560, 219, 'KAM', 'Kamwenge');
INSERT INTO zones VALUES (3561, 219, 'KAN', 'Kanungu');
INSERT INTO zones VALUES (3562, 219, 'KAS', 'Kasese');
INSERT INTO zones VALUES (3563, 219, 'KBA', 'Kibaale');
INSERT INTO zones VALUES (3564, 219, 'KIS', 'Kisoro');
INSERT INTO zones VALUES (3565, 219, 'KYE', 'Kyenjojo');
INSERT INTO zones VALUES (3566, 219, 'MSN', 'Masindi');
INSERT INTO zones VALUES (3567, 219, 'MBR', 'Mbarara');
INSERT INTO zones VALUES (3568, 219, 'NTU', 'Ntungamo');
INSERT INTO zones VALUES (3569, 219, 'RUK', 'Rukungiri');
INSERT INTO zones VALUES (3570, 220, 'CK', 'Cherkasy');
INSERT INTO zones VALUES (3571, 220, 'CH', 'Chernihiv');
INSERT INTO zones VALUES (3572, 220, 'CV', 'Chernivtsi');
INSERT INTO zones VALUES (3573, 220, 'CR', 'Crimea');
INSERT INTO zones VALUES (3574, 220, 'DN', 'Dnipropetrovs''k');
INSERT INTO zones VALUES (3575, 220, 'DO', 'Donets''k');
INSERT INTO zones VALUES (3576, 220, 'IV', 'Ivano-Frankivs''k');
INSERT INTO zones VALUES (3577, 220, 'KL', 'Kharkiv Kherson');
INSERT INTO zones VALUES (3578, 220, 'KM', 'Khmel''nyts''kyy');
INSERT INTO zones VALUES (3579, 220, 'KR', 'Kirovohrad');
INSERT INTO zones VALUES (3580, 220, 'KV', 'Kiev');
INSERT INTO zones VALUES (3581, 220, 'KY', 'Kyyiv');
INSERT INTO zones VALUES (3582, 220, 'LU', 'Luhans''k');
INSERT INTO zones VALUES (3583, 220, 'LV', 'L''viv');
INSERT INTO zones VALUES (3584, 220, 'MY', 'Mykolayiv');
INSERT INTO zones VALUES (3585, 220, 'OD', 'Odesa');
INSERT INTO zones VALUES (3586, 220, 'PO', 'Poltava');
INSERT INTO zones VALUES (3587, 220, 'RI', 'Rivne');
INSERT INTO zones VALUES (3588, 220, 'SE', 'Sevastopol');
INSERT INTO zones VALUES (3589, 220, 'SU', 'Sumy');
INSERT INTO zones VALUES (3590, 220, 'TE', 'Ternopil''');
INSERT INTO zones VALUES (3591, 220, 'VI', 'Vinnytsya');
INSERT INTO zones VALUES (3592, 220, 'VO', 'Volyn''');
INSERT INTO zones VALUES (3593, 220, 'ZK', 'Zakarpattya');
INSERT INTO zones VALUES (3594, 220, 'ZA', 'Zaporizhzhya');
INSERT INTO zones VALUES (3595, 220, 'ZH', 'Zhytomyr');
INSERT INTO zones VALUES (3596, 221, 'AZ', 'Abu Zaby');
INSERT INTO zones VALUES (3597, 221, 'AJ', '''Ajman');
INSERT INTO zones VALUES (3598, 221, 'FU', 'Al Fujayrah');
INSERT INTO zones VALUES (3599, 221, 'SH', 'Ash Shariqah');
INSERT INTO zones VALUES (3600, 221, 'DU', 'Dubayy');
INSERT INTO zones VALUES (3601, 221, 'RK', 'R''as al Khaymah');
INSERT INTO zones VALUES (3602, 221, 'UQ', 'Umm al Qaywayn');
INSERT INTO zones VALUES (3603, 222, 'ABN', 'Aberdeen');
INSERT INTO zones VALUES (3604, 222, 'ABNS', 'Aberdeenshire');
INSERT INTO zones VALUES (3605, 222, 'ANG', 'Anglesey');
INSERT INTO zones VALUES (3606, 222, 'AGS', 'Angus');
INSERT INTO zones VALUES (3607, 222, 'ARY', 'Argyll and Bute');
INSERT INTO zones VALUES (3608, 222, 'BEDS', 'Bedfordshire');
INSERT INTO zones VALUES (3609, 222, 'BERKS', 'Berkshire');
INSERT INTO zones VALUES (3610, 222, 'BLA', 'Blaenau Gwent');
INSERT INTO zones VALUES (3611, 222, 'BRI', 'Bridgend');
INSERT INTO zones VALUES (3612, 222, 'BSTL', 'Bristol');
INSERT INTO zones VALUES (3613, 222, 'BUCKS', 'Buckinghamshire');
INSERT INTO zones VALUES (3614, 222, 'CAE', 'Caerphilly');
INSERT INTO zones VALUES (3615, 222, 'CAMBS', 'Cambridgeshire');
INSERT INTO zones VALUES (3616, 222, 'CDF', 'Cardiff');
INSERT INTO zones VALUES (3617, 222, 'CARM', 'Carmarthenshire');
INSERT INTO zones VALUES (3618, 222, 'CDGN', 'Ceredigion');
INSERT INTO zones VALUES (3619, 222, 'CHES', 'Cheshire');
INSERT INTO zones VALUES (3620, 222, 'CLACK', 'Clackmannanshire');
INSERT INTO zones VALUES (3621, 222, 'CON', 'Conwy');
INSERT INTO zones VALUES (3622, 222, 'CORN', 'Cornwall');
INSERT INTO zones VALUES (3623, 222, 'DNBG', 'Denbighshire');
INSERT INTO zones VALUES (3624, 222, 'DERBY', 'Derbyshire');
INSERT INTO zones VALUES (3625, 222, 'DVN', 'Devon');
INSERT INTO zones VALUES (3626, 222, 'DOR', 'Dorset');
INSERT INTO zones VALUES (3627, 222, 'DGL', 'Dumfries and Galloway');
INSERT INTO zones VALUES (3628, 222, 'DUND', 'Dundee');
INSERT INTO zones VALUES (3629, 222, 'DHM', 'Durham');
INSERT INTO zones VALUES (3630, 222, 'ARYE', 'East Ayrshire');
INSERT INTO zones VALUES (3631, 222, 'DUNBE', 'East Dunbartonshire');
INSERT INTO zones VALUES (3632, 222, 'LOTE', 'East Lothian');
INSERT INTO zones VALUES (3633, 222, 'RENE', 'East Renfrewshire');
INSERT INTO zones VALUES (3634, 222, 'ERYS', 'East Riding of Yorkshire');
INSERT INTO zones VALUES (3635, 222, 'SXE', 'East Sussex');
INSERT INTO zones VALUES (3636, 222, 'EDIN', 'Edinburgh');
INSERT INTO zones VALUES (3637, 222, 'ESX', 'Essex');
INSERT INTO zones VALUES (3638, 222, 'FALK', 'Falkirk');
INSERT INTO zones VALUES (3639, 222, 'FFE', 'Fife');
INSERT INTO zones VALUES (3640, 222, 'FLINT', 'Flintshire');
INSERT INTO zones VALUES (3641, 222, 'GLAS', 'Glasgow');
INSERT INTO zones VALUES (3642, 222, 'GLOS', 'Gloucestershire');
INSERT INTO zones VALUES (3643, 222, 'LDN', 'Greater London');
INSERT INTO zones VALUES (3644, 222, 'MCH', 'Greater Manchester');
INSERT INTO zones VALUES (3645, 222, 'GDD', 'Gwynedd');
INSERT INTO zones VALUES (3646, 222, 'HANTS', 'Hampshire');
INSERT INTO zones VALUES (3647, 222, 'HWR', 'Herefordshire');
INSERT INTO zones VALUES (3648, 222, 'HERTS', 'Hertfordshire');
INSERT INTO zones VALUES (3649, 222, 'HLD', 'Highlands');
INSERT INTO zones VALUES (3650, 222, 'IVER', 'Inverclyde');
INSERT INTO zones VALUES (3651, 222, 'IOW', 'Isle of Wight');
INSERT INTO zones VALUES (3652, 222, 'KNT', 'Kent');
INSERT INTO zones VALUES (3653, 222, 'LANCS', 'Lancashire');
INSERT INTO zones VALUES (3654, 222, 'LEICS', 'Leicestershire');
INSERT INTO zones VALUES (3655, 222, 'LINCS', 'Lincolnshire');
INSERT INTO zones VALUES (3656, 222, 'MSY', 'Merseyside');
INSERT INTO zones VALUES (3657, 222, 'MERT', 'Merthyr Tydfil');
INSERT INTO zones VALUES (3658, 222, 'MLOT', 'Midlothian');
INSERT INTO zones VALUES (3659, 222, 'MMOUTH', 'Monmouthshire');
INSERT INTO zones VALUES (3660, 222, 'MORAY', 'Moray');
INSERT INTO zones VALUES (3661, 222, 'NPRTAL', 'Neath Port Talbot');
INSERT INTO zones VALUES (3662, 222, 'NEWPT', 'Newport');
INSERT INTO zones VALUES (3663, 222, 'NOR', 'Norfolk');
INSERT INTO zones VALUES (3664, 222, 'ARYN', 'North Ayrshire');
INSERT INTO zones VALUES (3665, 222, 'LANN', 'North Lanarkshire');
INSERT INTO zones VALUES (3666, 222, 'YSN', 'North Yorkshire');
INSERT INTO zones VALUES (3667, 222, 'NHM', 'Northamptonshire');
INSERT INTO zones VALUES (3668, 222, 'NLD', 'Northumberland');
INSERT INTO zones VALUES (3669, 222, 'NOT', 'Nottinghamshire');
INSERT INTO zones VALUES (3670, 222, 'ORK', 'Orkney Islands');
INSERT INTO zones VALUES (3671, 222, 'OFE', 'Oxfordshire');
INSERT INTO zones VALUES (3672, 222, 'PEM', 'Pembrokeshire');
INSERT INTO zones VALUES (3673, 222, 'PERTH', 'Perth and Kinross');
INSERT INTO zones VALUES (3674, 222, 'PWS', 'Powys');
INSERT INTO zones VALUES (3675, 222, 'REN', 'Renfrewshire');
INSERT INTO zones VALUES (3676, 222, 'RHON', 'Rhondda Cynon Taff');
INSERT INTO zones VALUES (3677, 222, 'RUT', 'Rutland');
INSERT INTO zones VALUES (3678, 222, 'BOR', 'Scottish Borders');
INSERT INTO zones VALUES (3679, 222, 'SHET', 'Shetland Islands');
INSERT INTO zones VALUES (3680, 222, 'SPE', 'Shropshire');
INSERT INTO zones VALUES (3681, 222, 'SOM', 'Somerset');
INSERT INTO zones VALUES (3682, 222, 'ARYS', 'South Ayrshire');
INSERT INTO zones VALUES (3683, 222, 'LANS', 'South Lanarkshire');
INSERT INTO zones VALUES (3684, 222, 'YSS', 'South Yorkshire');
INSERT INTO zones VALUES (3685, 222, 'SFD', 'Staffordshire');
INSERT INTO zones VALUES (3686, 222, 'STIR', 'Stirling');
INSERT INTO zones VALUES (3687, 222, 'SFK', 'Suffolk');
INSERT INTO zones VALUES (3688, 222, 'SRY', 'Surrey');
INSERT INTO zones VALUES (3689, 222, 'SWAN', 'Swansea');
INSERT INTO zones VALUES (3690, 222, 'TORF', 'Torfaen');
INSERT INTO zones VALUES (3691, 222, 'TWR', 'Tyne and Wear');
INSERT INTO zones VALUES (3692, 222, 'VGLAM', 'Vale of Glamorgan');
INSERT INTO zones VALUES (3693, 222, 'WARKS', 'Warwickshire');
INSERT INTO zones VALUES (3694, 222, 'WDUN', 'West Dunbartonshire');
INSERT INTO zones VALUES (3695, 222, 'WLOT', 'West Lothian');
INSERT INTO zones VALUES (3696, 222, 'WMD', 'West Midlands');
INSERT INTO zones VALUES (3697, 222, 'SXW', 'West Sussex');
INSERT INTO zones VALUES (3698, 222, 'YSW', 'West Yorkshire');
INSERT INTO zones VALUES (3699, 222, 'WIL', 'Western Isles');
INSERT INTO zones VALUES (3700, 222, 'WLT', 'Wiltshire');
INSERT INTO zones VALUES (3701, 222, 'WORCS', 'Worcestershire');
INSERT INTO zones VALUES (3702, 222, 'WRX', 'Wrexham');
INSERT INTO zones VALUES (3703, 224, 'BI', 'Baker Island');
INSERT INTO zones VALUES (3704, 224, 'HI', 'Howland Island');
INSERT INTO zones VALUES (3705, 224, 'JI', 'Jarvis Island');
INSERT INTO zones VALUES (3706, 224, 'JA', 'Johnston Atoll');
INSERT INTO zones VALUES (3707, 224, 'KR', 'Kingman Reef');
INSERT INTO zones VALUES (3708, 224, 'MA', 'Midway Atoll');
INSERT INTO zones VALUES (3709, 224, 'NI', 'Navassa Island');
INSERT INTO zones VALUES (3710, 224, 'PA', 'Palmyra Atoll');
INSERT INTO zones VALUES (3711, 224, 'WI', 'Wake Island');
INSERT INTO zones VALUES (3712, 225, 'AR', 'Artigas');
INSERT INTO zones VALUES (3713, 225, 'CA', 'Canelones');
INSERT INTO zones VALUES (3714, 225, 'CL', 'Cerro Largo');
INSERT INTO zones VALUES (3715, 225, 'CO', 'Colonia');
INSERT INTO zones VALUES (3716, 225, 'DU', 'Durazno');
INSERT INTO zones VALUES (3717, 225, 'FS', 'Flores');
INSERT INTO zones VALUES (3718, 225, 'FA', 'Florida');
INSERT INTO zones VALUES (3719, 225, 'LA', 'Lavalleja');
INSERT INTO zones VALUES (3720, 225, 'MA', 'Maldonado');
INSERT INTO zones VALUES (3721, 225, 'MO', 'Montevideo');
INSERT INTO zones VALUES (3722, 225, 'PA', 'Paysandu');
INSERT INTO zones VALUES (3723, 225, 'RN', 'Rio Negro');
INSERT INTO zones VALUES (3724, 225, 'RV', 'Rivera');
INSERT INTO zones VALUES (3725, 225, 'RO', 'Rocha');
INSERT INTO zones VALUES (3726, 225, 'SL', 'Salto');
INSERT INTO zones VALUES (3727, 225, 'SJ', 'San Jose');
INSERT INTO zones VALUES (3728, 225, 'SO', 'Soriano');
INSERT INTO zones VALUES (3729, 225, 'TA', 'Tacuarembo');
INSERT INTO zones VALUES (3730, 225, 'TT', 'Treinta y Tres');
INSERT INTO zones VALUES (3731, 226, 'AN', 'Andijon');
INSERT INTO zones VALUES (3732, 226, 'BU', 'Buxoro');
INSERT INTO zones VALUES (3733, 226, 'FA', 'Farg''ona');
INSERT INTO zones VALUES (3734, 226, 'JI', 'Jizzax');
INSERT INTO zones VALUES (3735, 226, 'NG', 'Namangan');
INSERT INTO zones VALUES (3736, 226, 'NW', 'Navoiy');
INSERT INTO zones VALUES (3737, 226, 'QA', 'Qashqadaryo');
INSERT INTO zones VALUES (3738, 226, 'QR', 'Qoraqalpog''iston Republikasi');
INSERT INTO zones VALUES (3739, 226, 'SA', 'Samarqand');
INSERT INTO zones VALUES (3740, 226, 'SI', 'Sirdaryo');
INSERT INTO zones VALUES (3741, 226, 'SU', 'Surxondaryo');
INSERT INTO zones VALUES (3742, 226, 'TK', 'Toshkent City');
INSERT INTO zones VALUES (3743, 226, 'TO', 'Toshkent Region');
INSERT INTO zones VALUES (3744, 226, 'XO', 'Xorazm');
INSERT INTO zones VALUES (3745, 227, 'MA', 'Malampa');
INSERT INTO zones VALUES (3746, 227, 'PE', 'Penama');
INSERT INTO zones VALUES (3747, 227, 'SA', 'Sanma');
INSERT INTO zones VALUES (3748, 227, 'SH', 'Shefa');
INSERT INTO zones VALUES (3749, 227, 'TA', 'Tafea');
INSERT INTO zones VALUES (3750, 227, 'TO', 'Torba');
INSERT INTO zones VALUES (3751, 229, 'AM', 'Amazonas');
INSERT INTO zones VALUES (3752, 229, 'AN', 'Anzoategui');
INSERT INTO zones VALUES (3753, 229, 'AP', 'Apure');
INSERT INTO zones VALUES (3754, 229, 'AR', 'Aragua');
INSERT INTO zones VALUES (3755, 229, 'BA', 'Barinas');
INSERT INTO zones VALUES (3756, 229, 'BO', 'Bolivar');
INSERT INTO zones VALUES (3757, 229, 'CA', 'Carabobo');
INSERT INTO zones VALUES (3758, 229, 'CO', 'Cojedes');
INSERT INTO zones VALUES (3759, 229, 'DA', 'Delta Amacuro');
INSERT INTO zones VALUES (3760, 229, 'DF', 'Dependencias Federales');
INSERT INTO zones VALUES (3761, 229, 'DI', 'Distrito Federal');
INSERT INTO zones VALUES (3762, 229, 'FA', 'Falcon');
INSERT INTO zones VALUES (3763, 229, 'GU', 'Guarico');
INSERT INTO zones VALUES (3764, 229, 'LA', 'Lara');
INSERT INTO zones VALUES (3765, 229, 'ME', 'Merida');
INSERT INTO zones VALUES (3766, 229, 'MI', 'Miranda');
INSERT INTO zones VALUES (3767, 229, 'MO', 'Monagas');
INSERT INTO zones VALUES (3768, 229, 'NE', 'Nueva Esparta');
INSERT INTO zones VALUES (3769, 229, 'PO', 'Portuguesa');
INSERT INTO zones VALUES (3770, 229, 'SU', 'Sucre');
INSERT INTO zones VALUES (3771, 229, 'TA', 'Tachira');
INSERT INTO zones VALUES (3772, 229, 'TR', 'Trujillo');
INSERT INTO zones VALUES (3773, 229, 'VA', 'Vargas');
INSERT INTO zones VALUES (3774, 229, 'YA', 'Yaracuy');
INSERT INTO zones VALUES (3775, 229, 'ZU', 'Zulia');
INSERT INTO zones VALUES (3776, 230, 'AG', 'An Giang');
INSERT INTO zones VALUES (3777, 230, 'BG', 'Bac Giang');
INSERT INTO zones VALUES (3778, 230, 'BK', 'Bac Kan');
INSERT INTO zones VALUES (3779, 230, 'BL', 'Bac Lieu');
INSERT INTO zones VALUES (3780, 230, 'BC', 'Bac Ninh');
INSERT INTO zones VALUES (3781, 230, 'BR', 'Ba Ria-Vung Tau');
INSERT INTO zones VALUES (3782, 230, 'BN', 'Ben Tre');
INSERT INTO zones VALUES (3783, 230, 'BH', 'Binh Dinh');
INSERT INTO zones VALUES (3784, 230, 'BU', 'Binh Duong');
INSERT INTO zones VALUES (3785, 230, 'BP', 'Binh Phuoc');
INSERT INTO zones VALUES (3786, 230, 'BT', 'Binh Thuan');
INSERT INTO zones VALUES (3787, 230, 'CM', 'Ca Mau');
INSERT INTO zones VALUES (3788, 230, 'CT', 'Can Tho');
INSERT INTO zones VALUES (3789, 230, 'CB', 'Cao Bang');
INSERT INTO zones VALUES (3790, 230, 'DL', 'Dak Lak');
INSERT INTO zones VALUES (3791, 230, 'DG', 'Dak Nong');
INSERT INTO zones VALUES (3792, 230, 'DN', 'Da Nang');
INSERT INTO zones VALUES (3793, 230, 'DB', 'Dien Bien');
INSERT INTO zones VALUES (3794, 230, 'DI', 'Dong Nai');
INSERT INTO zones VALUES (3795, 230, 'DT', 'Dong Thap');
INSERT INTO zones VALUES (3796, 230, 'GL', 'Gia Lai');
INSERT INTO zones VALUES (3797, 230, 'HG', 'Ha Giang');
INSERT INTO zones VALUES (3798, 230, 'HD', 'Hai Duong');
INSERT INTO zones VALUES (3799, 230, 'HP', 'Hai Phong');
INSERT INTO zones VALUES (3800, 230, 'HM', 'Ha Nam');
INSERT INTO zones VALUES (3801, 230, 'HI', 'Ha Noi');
INSERT INTO zones VALUES (3802, 230, 'HT', 'Ha Tay');
INSERT INTO zones VALUES (3803, 230, 'HH', 'Ha Tinh');
INSERT INTO zones VALUES (3804, 230, 'HB', 'Hoa Binh');
INSERT INTO zones VALUES (3805, 230, 'HC', 'Ho Chin Minh');
INSERT INTO zones VALUES (3806, 230, 'HU', 'Hau Giang');
INSERT INTO zones VALUES (3807, 230, 'HY', 'Hung Yen');
INSERT INTO zones VALUES (3808, 232, 'C', 'Saint Croix');
INSERT INTO zones VALUES (3809, 232, 'J', 'Saint John');
INSERT INTO zones VALUES (3810, 232, 'T', 'Saint Thomas');
INSERT INTO zones VALUES (3811, 233, 'A', 'Alo');
INSERT INTO zones VALUES (3812, 233, 'S', 'Sigave');
INSERT INTO zones VALUES (3813, 233, 'W', 'Wallis');
INSERT INTO zones VALUES (3814, 235, 'AB', 'Abyan');
INSERT INTO zones VALUES (3815, 235, 'AD', 'Adan');
INSERT INTO zones VALUES (3816, 235, 'AM', 'Amran');
INSERT INTO zones VALUES (3817, 235, 'BA', 'Al Bayda');
INSERT INTO zones VALUES (3818, 235, 'DA', 'Ad Dali');
INSERT INTO zones VALUES (3819, 235, 'DH', 'Dhamar');
INSERT INTO zones VALUES (3820, 235, 'HD', 'Hadramawt');
INSERT INTO zones VALUES (3821, 235, 'HJ', 'Hajjah');
INSERT INTO zones VALUES (3822, 235, 'HU', 'Al Hudaydah');
INSERT INTO zones VALUES (3823, 235, 'IB', 'Ibb');
INSERT INTO zones VALUES (3824, 235, 'JA', 'Al Jawf');
INSERT INTO zones VALUES (3825, 235, 'LA', 'Lahij');
INSERT INTO zones VALUES (3826, 235, 'MA', 'Ma''rib');
INSERT INTO zones VALUES (3827, 235, 'MR', 'Al Mahrah');
INSERT INTO zones VALUES (3828, 235, 'MW', 'Al Mahwit');
INSERT INTO zones VALUES (3829, 235, 'SD', 'Sa''dah');
INSERT INTO zones VALUES (3830, 235, 'SN', 'San''a');
INSERT INTO zones VALUES (3831, 235, 'SH', 'Shabwah');
INSERT INTO zones VALUES (3832, 235, 'TA', 'Ta''izz');
INSERT INTO zones VALUES (3833, 236, 'KOS', 'Kosovo');
INSERT INTO zones VALUES (3834, 236, 'MON', 'Montenegro');
INSERT INTO zones VALUES (3835, 236, 'SER', 'Serbia');
INSERT INTO zones VALUES (3836, 236, 'VOJ', 'Vojvodina');
INSERT INTO zones VALUES (3837, 237, 'BC', 'Bas-Congo');
INSERT INTO zones VALUES (3838, 237, 'BN', 'Bandundu');
INSERT INTO zones VALUES (3839, 237, 'EQ', 'Equateur');
INSERT INTO zones VALUES (3840, 237, 'KA', 'Katanga');
INSERT INTO zones VALUES (3841, 237, 'KE', 'Kasai-Oriental');
INSERT INTO zones VALUES (3842, 237, 'KN', 'Kinshasa');
INSERT INTO zones VALUES (3843, 237, 'KW', 'Kasai-Occidental');
INSERT INTO zones VALUES (3844, 237, 'MA', 'Maniema');
INSERT INTO zones VALUES (3845, 237, 'NK', 'Nord-Kivu');
INSERT INTO zones VALUES (3846, 237, 'OR', 'Orientale');
INSERT INTO zones VALUES (3847, 237, 'SK', 'Sud-Kivu');
INSERT INTO zones VALUES (3848, 238, 'CE', 'Central');
INSERT INTO zones VALUES (3849, 238, 'CB', 'Copperbelt');
INSERT INTO zones VALUES (3850, 238, 'EA', 'Eastern');
INSERT INTO zones VALUES (3851, 238, 'LP', 'Luapula');
INSERT INTO zones VALUES (3852, 238, 'LK', 'Lusaka');
INSERT INTO zones VALUES (3853, 238, 'NO', 'Northern');
INSERT INTO zones VALUES (3854, 238, 'NW', 'North-Western');
INSERT INTO zones VALUES (3855, 238, 'SO', 'Southern');
INSERT INTO zones VALUES (3856, 238, 'WE', 'Western');
INSERT INTO zones VALUES (3857, 239, 'BU', 'Bulawayo');
INSERT INTO zones VALUES (3858, 239, 'HA', 'Harare');
INSERT INTO zones VALUES (3859, 239, 'ML', 'Manicaland');
INSERT INTO zones VALUES (3860, 239, 'MC', 'Mashonaland Central');
INSERT INTO zones VALUES (3861, 239, 'ME', 'Mashonaland East');
INSERT INTO zones VALUES (3862, 239, 'MW', 'Mashonaland West');
INSERT INTO zones VALUES (3863, 239, 'MV', 'Masvingo');
INSERT INTO zones VALUES (3864, 239, 'MN', 'Matabeleland North');
INSERT INTO zones VALUES (3865, 239, 'MS', 'Matabeleland South');
INSERT INTO zones VALUES (3866, 239, 'MD', 'Midlands');

-- --------------------------------------------------------

-- 
-- 資料表格式： 'zones_to_geo_zones'
-- 

DROP TABLE IF EXISTS zones_to_geo_zones;
CREATE TABLE zones_to_geo_zones (
  association_id int(11) NOT NULL auto_increment,
  zone_country_id int(11) NOT NULL default '0',
  zone_id int(11) default NULL,
  geo_zone_id int(11) default NULL,
  last_modified datetime default NULL,
  date_added datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (association_id)
);

INSERT INTO zones_to_geo_zones VALUES (2, 206, 189, 2, '2006-11-28 13:51:14', '2004-11-18 11:59:35');
INSERT INTO zones_to_geo_zones VALUES (3, 206, 190, 2, '2006-11-28 13:51:23', '2004-11-18 11:59:42');
INSERT INTO zones_to_geo_zones VALUES (52, 206, 202, 7, NULL, '2005-12-07 14:09:32');
INSERT INTO zones_to_geo_zones VALUES (53, 206, 203, 7, NULL, '2005-12-07 14:10:37');
INSERT INTO zones_to_geo_zones VALUES (6, 206, 201, 3, NULL, '2004-11-18 12:00:51');
INSERT INTO zones_to_geo_zones VALUES (7, 206, 205, 4, NULL, '2004-11-18 12:01:47');
INSERT INTO zones_to_geo_zones VALUES (8, 206, 206, 4, NULL, '2004-11-18 12:01:56');
INSERT INTO zones_to_geo_zones VALUES (9, 206, 204, 4, NULL, '2004-11-18 12:02:05');
INSERT INTO zones_to_geo_zones VALUES (10, 206, 189, 5, NULL, '2004-11-18 12:03:09');
INSERT INTO zones_to_geo_zones VALUES (11, 206, 190, 5, NULL, '2004-11-18 12:03:18');
INSERT INTO zones_to_geo_zones VALUES (12, 206, 182, 5, NULL, '2004-11-18 12:03:25');
INSERT INTO zones_to_geo_zones VALUES (13, 206, 183, 5, NULL, '2004-11-18 12:03:39');
INSERT INTO zones_to_geo_zones VALUES (14, 206, 196, 5, NULL, '2004-11-18 12:03:52');
INSERT INTO zones_to_geo_zones VALUES (15, 206, 197, 5, NULL, '2004-11-18 12:04:07');
INSERT INTO zones_to_geo_zones VALUES (54, 206, 200, 7, NULL, '2005-12-07 14:11:03');
INSERT INTO zones_to_geo_zones VALUES (17, 206, 192, 5, NULL, '2004-11-18 12:04:42');
INSERT INTO zones_to_geo_zones VALUES (18, 206, 188, 5, NULL, '2004-11-18 12:04:55');
INSERT INTO zones_to_geo_zones VALUES (19, 206, 185, 5, NULL, '2004-11-18 12:05:05');
INSERT INTO zones_to_geo_zones VALUES (20, 206, 184, 5, NULL, '2004-11-18 12:05:18');
INSERT INTO zones_to_geo_zones VALUES (21, 206, 198, 5, NULL, '2004-11-18 12:05:30');
INSERT INTO zones_to_geo_zones VALUES (22, 206, 199, 5, NULL, '2004-11-18 12:05:39');
INSERT INTO zones_to_geo_zones VALUES (23, 206, 193, 5, NULL, '2004-11-18 12:05:52');
INSERT INTO zones_to_geo_zones VALUES (24, 206, 186, 5, NULL, '2004-11-18 12:06:01');
INSERT INTO zones_to_geo_zones VALUES (25, 206, 187, 5, NULL, '2004-11-18 12:06:09');
INSERT INTO zones_to_geo_zones VALUES (26, 206, 191, 5, NULL, '2004-11-18 12:06:20');
INSERT INTO zones_to_geo_zones VALUES (27, 206, 194, 5, NULL, '2004-11-18 12:06:30');
INSERT INTO zones_to_geo_zones VALUES (28, 206, 195, 5, NULL, '2004-11-18 12:06:46');
INSERT INTO zones_to_geo_zones VALUES (29, 206, 189, 6, NULL, '2004-11-18 13:23:16');
INSERT INTO zones_to_geo_zones VALUES (30, 206, 190, 6, NULL, '2004-11-18 13:23:25');
INSERT INTO zones_to_geo_zones VALUES (31, 206, 182, 6, NULL, '2004-11-18 13:23:33');
INSERT INTO zones_to_geo_zones VALUES (32, 206, 183, 6, NULL, '2004-11-18 13:23:43');
INSERT INTO zones_to_geo_zones VALUES (33, 206, 201, 6, NULL, '2004-11-18 13:24:00');
INSERT INTO zones_to_geo_zones VALUES (34, 206, 196, 6, NULL, '2004-11-18 13:24:08');
INSERT INTO zones_to_geo_zones VALUES (35, 206, 197, 6, NULL, '2004-11-18 13:24:17');
INSERT INTO zones_to_geo_zones VALUES (36, 206, 203, 6, NULL, '2004-11-18 13:24:29');
INSERT INTO zones_to_geo_zones VALUES (37, 206, 202, 6, NULL, '2004-11-18 13:24:43');
INSERT INTO zones_to_geo_zones VALUES (38, 206, 200, 6, NULL, '2004-11-18 13:25:21');
INSERT INTO zones_to_geo_zones VALUES (39, 206, 192, 6, NULL, '2004-11-18 13:25:38');
INSERT INTO zones_to_geo_zones VALUES (40, 206, 188, 6, NULL, '2004-11-18 13:25:51');
INSERT INTO zones_to_geo_zones VALUES (41, 206, 185, 6, NULL, '2004-11-18 13:26:02');
INSERT INTO zones_to_geo_zones VALUES (42, 206, 184, 6, NULL, '2004-11-18 13:27:09');
INSERT INTO zones_to_geo_zones VALUES (43, 206, 198, 6, NULL, '2004-11-18 13:27:19');
INSERT INTO zones_to_geo_zones VALUES (44, 206, 199, 6, NULL, '2004-11-18 13:27:28');
INSERT INTO zones_to_geo_zones VALUES (45, 206, 193, 6, NULL, '2004-11-18 13:27:43');
INSERT INTO zones_to_geo_zones VALUES (46, 206, 186, 6, NULL, '2004-11-18 13:27:52');
INSERT INTO zones_to_geo_zones VALUES (47, 206, 187, 6, NULL, '2004-11-18 13:28:02');
INSERT INTO zones_to_geo_zones VALUES (48, 206, 191, 6, NULL, '2004-11-18 13:28:16');
INSERT INTO zones_to_geo_zones VALUES (49, 206, 194, 6, NULL, '2004-11-18 13:28:25');
INSERT INTO zones_to_geo_zones VALUES (50, 206, 195, 6, NULL, '2004-11-18 13:28:40');
INSERT INTO zones_to_geo_zones VALUES (51, 206, 0, 1, NULL, '2005-12-07 14:06:29');
INSERT INTO zones_to_geo_zones VALUES (56, 206, 202, 8, NULL, '2005-12-07 14:22:31');
